
                include forthasm.inc

; ( HeaderAddr BufSize RecSize UpLimit LowLimit TmpDrive --> SuccessFlag )
b_open:         db      5,'&OPEN',0
                dw      0
                pop     word ptr [time_t]       ; Temporary Disk Drive
                pop     dx                      ; LLIMIT
                pop     cx                      ; ULIMIT
                pop     ax                      ; RECSIZE
                pop     di                      ; BUFFSIZE
                pop     bx                      ; HEADER
                mov     word ptr [bx+2],di
                mov     word ptr [bx+4],ax
                mov     word ptr [bx+14],cx
                mov     word ptr [bx+16],dx
                mov     word ptr [bx+6],di
                mov     word ptr [bx+8],0
                mov     word ptr [bx+18],0
                mov     word ptr [bx+20],0
                mov     word ptr [bx+22],0
                mov     word ptr [bx+24],0
                cmp     byte ptr [time_t],0
                jz      b_use_cur
                mov     al,byte ptr [time_t]
                add     al,'@'
                mov     ah,':'
                mov     word ptr [bx+26],ax
                mov     word ptr [bx+46],ax
                mov     ax,'\'
                mov     word ptr [bx+28],ax
                mov     word ptr [bx+48],ax
                jmp     short b_start_open
                b_use_cur:
                mov     ax,'\'
                mov     word ptr [bx+26],ax
                mov     word ptr [bx+46],ax
                b_start_open:
                mov     byte ptr [bx+66],0      ; SUMCOUNT = 0
                mov     word ptr [time_x],bx
                mov     bx,word ptr [bx+2]
                mov     cl,4
                shr     bx,cl
                or      bx,bx
                jz      b_full_segment
                inc     bx
                jmp     short b_no_full_seg
                b_full_segment:
                mov     bx,4096
                b_no_full_seg:
                mov     ah,48h
                push    si
                push    bp
                int     21h
                pop     bp
                pop     si
                mov     bx,word ptr [time_x]
                mov     word ptr [bx],ax
                jc      b_open_err
                lea     dx,word ptr [bx+26]
                xor     cx,cx
                mov     ah,5ah
                push    si
                push    bp
                int     21h
                pop     bp
                pop     si
                mov     bx,word ptr [time_x]
                mov     word ptr [bx+10],ax
                jc      b_open_err
                lea     dx,word ptr [bx+46]
                xor     cx,cx
                mov     ah,5ah
                push    si
                push    bp
                int     21h
                pop     bp
                pop     si
                mov     bx,word ptr [time_x]
                mov     word ptr [bx+12],ax
                jc      b_open_err
                mov     ax,0ffffh
                push    ax
                next
                b_open_err:
                mov     word ptr [errcode],ax
                xor     ax,ax
                push    ax
                next

; ( Header --> Flag )
b_close:        db      6,'&CLOSE',0
                dj      b_open
                pop     bx
                mov     word ptr [time_x],bx
                mov     es,word ptr [bx]
                mov     word ptr [bx],0
                mov     ah,49h
                push    si
                push    bp
                int     21h
                pop     bp
                pop     si
                jc      b_close_err
                mov     bx,word ptr [time_x]
                mov     bx,word ptr [bx+10]
                mov     ah,3eh
                int     21h
                jc      b_close_err
                mov     bx,word ptr [time_x]
                mov     bx,word ptr [bx+12]
                mov     ah,3eh
                int     21h
                jc      b_close_err
                mov     bx,word ptr [time_x]
                lea     dx,word ptr [bx+26]
                mov     ah,41h
                push    si
                push    bp
                int     21h
                pop     bp
                pop     si
                jc      b_close_err
                mov     bx,word ptr [time_x]
                lea     dx,word ptr [bx+46]
                mov     ah,41h
                push    si
                push    bp
                int     21h
                pop     bp
                pop     si
                jc      b_close_err
                mov     ax,0ffffh
                push    ax
                next
                b_close_err:
                mov     word ptr [errcode],ax
                xor     ax,ax
                push    ax
                next

; ( LastRecOff SrcSeg DestOff DestSeg RecCount RecSize --> )
b_invert:       db      7,'&INVERT',0
                dj      b_close
                pop     dx
                pop     ax
                pop     es
                pop     di
                mov     word ptr [time_x],si
                pop     ds
                pop     si
                b_inv_loop:
                mov     cx,dx
                rep     movsb
                sub     si,dx
                sub     si,dx
                dec     ax
                jnz     b_inv_loop
                push    cs
                pop     ds
                mov     si,word ptr [time_x]
                next

; ( FirstRecOff FirstRecSeg RecCount RecSize *SUMCOUNT --> )
sum_add:        db      4,'&ADD',0
                dj      b_invert
                pop     bx
                mov     al,byte ptr [bx]
                xor     ah,ah
                mov     word ptr [time_y],ax    ; SUMCOUNT
                pop     word ptr [err_sp]       ; RECSIZE
                pop     word ptr [time_t]       ; RECCOUNT
                pop     es                      ; FirstRecSeg
                pop     word ptr [time_z]       ; FirstRecOff
                cmp     word ptr [time_y],0
                jnz     add_loopx
                next
                add_loopx:
                inc     bx
                add_loop0:
                mov     di,word ptr [time_z]
                add     di,word ptr [bx]
                mov     dl,byte ptr [bx+2]
                xor     dh,dh
                mov     ax,word ptr [err_sp]
                sub     ax,dx
                mov     word ptr [time_x],ax
                mov     ah,4
                sub     ah,dl
                mov     cx,word ptr [time_t]
                add     bx,3
                add_loop1:
                mov     dh,dl
                clc
                add_loop2:
                mov     al,byte ptr es:[di]
                inc     di
                adc     byte ptr [bx],al
                inc     bx
                dec     dh
                jnz     add_loop2
                mov     dh,ah
                inc     dh
                dec     dh
                jz      add_loop4
                add_loop3:
                adc     byte ptr [bx],0
                inc     bx
                dec     dh
                jnz     add_loop3
                add_loop4:
                sub     bx,4
                add     di,word ptr [time_x]
                loop    add_loop1
                add     bx,4
                dec     word ptr [time_y]
                jnz     add_loop0
                next

; ( FirstRecOff FirstRecSeg RecCount RecSize *SUMCOUNT --> )
sum_sub:        db      4,'&SUB',0
                dj      sum_add
                pop     bx
                mov     al,byte ptr [bx]
                xor     ah,ah
                mov     word ptr [time_y],ax    ; SUMCOUNT
                pop     word ptr [err_sp]       ; RECSIZE
                pop     word ptr [time_t]       ; RECCOUNT
                pop     es                      ; FirstRecSeg
                pop     word ptr [time_z]       ; FirstRecOff
                cmp     word ptr [time_y],0
                jnz     sub_loopx
                next
                sub_loopx:
                inc     bx
                sub_loop0:
                mov     di,word ptr [time_z]
                add     di,word ptr [bx]
                mov     dl,byte ptr [bx+2]
                xor     dh,dh
                mov     ax,word ptr [err_sp]
                sub     ax,dx
                mov     word ptr [time_x],ax
                mov     ah,4
                sub     ah,dl
                mov     cx,word ptr [time_t]
                add     bx,3
                sub_loop1:
                mov     dh,dl
                clc
                sub_loop2:
                mov     al,byte ptr es:[di]
                inc     di
                sbb     byte ptr [bx],al
                inc     bx
                dec     dh
                jnz     sub_loop2
                mov     dh,ah
                inc     dh
                dec     dh
                jz      sub_loop4
                sub_loop3:
                sbb     byte ptr [bx],0
                inc     bx
                dec     dh
                jnz     sub_loop3
                sub_loop4:
                sub     bx,4
                add     di,word ptr [time_x]
                loop    sub_loop1
                add     bx,4
                dec     word ptr [time_y]
                jnz     sub_loop0
                next

init:           db      1,' ',0
                dj      sum_sub
                next

                dw      100h
                dw      (offset init-100h)
                include vers.inc
                dw      1231h

                end     module
