; Forth crt module

include fasm.inc

code            segment
                assume          cs:code,ds:code,es:code,ss:code
                org             100h

module:

; ( Source Dest StartPos Length --> )
delete_:        db      7,'DELETE*',0
        dw      0
        _delete:
        pop     cx
        pop     dx
        pop     di
        pop     ax
        push    si
        mov     si,ax
        xor     bx,bx
        push    cs
        pop     es
        del_1:
        cmp     bx,dx
        jz      del_3
        inc     bx
        lodsb
        stosb
        cmp     al,0
        jnz     del_1
        del_2:
        pop     si
        next
        del_3:
        jcxz    del_4
        lodsb
        dec     cx
        cmp     al,0
        jnz     del_3
        stosb
        jmp     del_2
        del_4:
        lodsb
        stosb
        cmp     al,0
        jnz     del_4
        jmp     del_2

; ( Source Dest StartPos Length --> )
copy_:  db      5,'COPY*',0
        dk      delete_
        _copy:
        pop     cx
        pop     dx
        pop     di
        pop     ax
        push    si
        mov     si,ax
        xor     bx,bx
        push    cs
        pop     es
        copy_1:
        cmp     bx,dx
        jz      copy_3
        inc     bx
        lodsb
        cmp     al,0
        jnz     copy_1
        copy_2:
        pop     si
        next
        copy_3:
        jcxz    copy_4
        dec     cx
        lodsb
        stosb
        cmp     al,0
        jnz     copy_3
        jmp     copy_2
        copy_4:
        mov     al,0
        stosb
        jmp     copy_2

; ( Souce Dest InsString StartPos --> )
insert_:        db      7,'INSERT*',0
        dk      copy_
        _insert:
        xor     cx,cx
        push    cs
        pop     es
        pop     dx
        pop     bx
        pop     di
        pop     ax
        push    si
        mov     si,ax
        cmp     ax,di
        jz      insert_2
        ins_1:
        cmp     cx,dx
        jz      ins_3
        inc     cx
        lodsb
        stosb
        cmp     al,0
        jnz     ins_1
        ins_2:
        pop     si
        next
        ins_3:
        xchg    bx,si
        ins_4:
        lodsb
        stosb
        cmp     al,0
        jnz     ins_4
        xchg    bx,si
        ins_5:
        lodsb
        stosb
        cmp     al,0
        jnz     ins_5
        jmp     ins_2
        insert_2:
        ins_1a:
        cmp     cx,dx
        jz      ins_3a
        inc     cx
        lodsb
        cmp     al,0
        jnz     ins_1a
        jmp     ins_2
        ins_3a:
        xor     dx,dx
        ins_4a:
        cmp     byte ptr [bx],0
        jz      ins_5a
        inc     bx
        inc     dx
        jmp     ins_4a
        ins_5a:
        xor     cx,cx
        dec     bx
        ins_6a:
        lodsb
        inc     cx
        cmp     al,0
        jnz     ins_6a
        dec     si
        mov     di,si
        add     di,dx
        std
        rep     movsb
        mov     si,bx
        mov     cx,dx
        jcxz    ins_2
        rep     movsb
        jmp     ins_2

; ( Asciiz1 Asciiz2 --> Asciiz1-Asciiz2 )
compare_:       db      8,'COMPARE*',0
        dk      insert_
        _compare:
        pop     di
        pop     ax
        push    si
        mov     si,ax
        push    cs
        pop     es
        xor     cx,cx
        mov     ah,ch
        comp_1:
        lodsb
        scasb
        jnz     comp_no_equal
        cmp     al,0
        jnz     comp_1
        xor     ax,ax
        comp_2:
        pop     si
        push    ax
        next
        comp_no_equal:
        sub     al,byte ptr [di-1]
        cbw
        jmp     comp_2

; ( First Second Dest --> )
concat_:        db      7,'CONCAT*',0
        dk      compare_
        _concat:
        pop     di
        pop     bx
        pop     ax
        push    si
        mov     si,ax
        push    cs
        pop     es
        cat_1:
        lodsb
        cmp     al,0
        jz      cat_3
        stosb
        jmp     cat_1
        cat_3:
        mov     si,bx
        cat_2:
        lodsb
        stosb
        cmp     al,0
        jnz     cat_2
        pop     si
        next

; ( Where What StartPos --> Pos(Or-1) )
pos_:   db      4,'POS*',0
        dk      concat_
        _pos:
        pop     cx
        pop     di
        pop     ax
        mov     dx,ax
        push    si
        mov     si,ax
        push    cs
        pop     es
        pos_1:
        jcxz    start_pos
        dec     cx
        lodsb
        cmp     al,0
        jnz     pos_1
        pos_2:
        mov     ax,0ffffh
        end_pos:
        pop     si
        push    ax
        next
        pos_again:
        cmp     byte ptr [di-1],0
        jz      pos_found
        pop     di
        pop     si
        cmp     al,0
        jz      pos_2
        inc     si
        start_pos:
        push    si
        push    di
        pos_3:
        lodsb
        scasb
        jnz     pos_again
        cmp     al,0
        jnz     pos_3
        pos_found:
        pop     di
        pop     si
        sub     si,dx
        mov     ax,si
        jmp     end_pos


; ( ASCIIz --> Length )
asc_len_:       db      9,'ASCIIZLEN',0
        dk      pos_
        _asc_len:
        pop     bx
        xor     cx,cx
        asc_l1:
        cmp     byte ptr [bx],0
        jz      exit_al
        inc     bx
        inc     cx
        jmp     short asc_l1
        exit_al:
        push    cx
        next


; ( Character Attribute X Y --> )
putchar_:       db              7,'PUTCHAR',0
                dk      asc_len_
                _putchar:
                pop             bx
                mov             ax,160
                mul             bx
                pop             bx
                shl             bx,1
                add             bx,ax
                ldax            vram
                mov             es,ax
                pop             cx
                pop             ax
                mov             ah,cl
                mov             word ptr es:[bx],ax
                next

; ( X Y --> Character Attribute )
getchar_:       db              7,'GETCHAR',0
                dk              putchar_
                _getchar:
                pop             bx
                mov             ax,160
                mul             bx
                pop             bx
                shl             bx,1
                add             bx,ax
                ldax            vram
                mov             es,ax
                mov             ax,word ptr es:[bx]
                xor             cx,cx
                xchg            ah,cl
                push            ax
                push            cx
                next

; ( X Y Count Attribute --> )
highlight_:     db              9,'HIGHLIGHT',0
                dk              getchar_
                _highlight:
                pop             dx
                pop             cx
                mov             ch,0
                pop             bx
                mov             ax,160
        push    dx
                mul             bx
        pop     dx
                pop             bx
                shl             bx,1
                add             bx,ax
                inc             bx
                ldax            vram
                mov             es,ax
                high_loop:
                mov             byte ptr es:[bx],dl
                inc             bx
                inc             bx
                loop            high_loop
                next

; ( x1 y1 x2 y2 --> )
setact_:        db              9,'SETWINDOW',0
                dk              highlight_
                _setact:
                pop             cx
                pop             ax
                mov             ah,cl
                stax            x2y2
                pop             cx
                pop             ax
                mov             ah,cl
                stax            x1y1
                next

; ( --> x1 y1 x2 y2 )
getact_:        db              9,'GETWINDOW',0
                dk              setact_
                _getact:
                mov             ah,0
                ldal            x1y1
                push            ax
                ldal            x1y1+1
                push            ax
                ldal            x2y2
                push            ax
                ldal            x2y2+1
                push            ax
                next

; ( Text Back --> )
color_:         db              5,'COLOR',0
                dk              getact_
                _color:
                pop             ax
                mov             cl,4
                shl             ax,cl
                pop             cx
                and             cx,15
                or              ax,cx
                stal            curattr
                next

getcolor_:      db      8,'GETCOLOR',0
        dk      color_
        _getcolor:
        ldal    curattr
        mov     bx,ax
        and     ax,15
        mov     cl,4
        shr     bx,cl
        and     bx,15
        push    ax
        push    bx
        next

vram_:          db              4,'VRAM',0
                dk              getcolor_
                _vram:
                mov             ax,vram
                push            ax
                next

; ( x1 y1 x2 y2 --> )
push_w_:
                db              10,'PUSHWINDOW',0
                dk              vram_
                _push_w:
                pop             cx
                pop             dx
                pop             ax
                pop             bx
                sub             cx,ax
                inc             cx
                sub             dx,bx
                inc             dx
                mov             ch,dl
                mov             dx,160
                mul             dx
                shl             bx,1
                add             bx,ax
                mov             di,sp
                ldax            ssp
                mov             sp,ax
                ldax            vram
                mov             ds,ax
                mov             dx,cx
                mov             ax,bx
                push_1:
                mov             ch,dh
                push_2:
                push            word ptr [bx]
                inc             bx
                inc             bx
                dec             ch
                jnz             push_2
                add             ax,160
                mov             bx,ax
                dec             cl
                jnz             push_1
                xor             cx,cx
                xchg            dh,cl
                push            cx
                push            dx
                mov             ax,1232h
                push            ax
                push            cs
                pop             ds
                mov             ax,sp
                stax            ssp
                mov             sp,di
                next

; ( x1 y1 --> )
pop_w_:
                db              9,'POPWINDOW',0
                dk              push_w_
                _pop_w:
                pop             bx
                pop             cx
                ldax            ssp
                mov             di,sp
                mov             sp,ax
                ldax            vram
                mov             ds,ax
                pop             ax
                cmp             ax,1232h
                jnz             exit_pop
                pop             dx
                pop             ax
                add             bx,dx
                dec             bx
                add             cx,ax
                dec             cx
                mov             ah,dl
                push            ax
                mov             ax,160
                mul             bx
                mov             bx,ax
                pop             ax
                add             bx,cx
                add             bx,cx
                mov             cx,ax
                mov             dx,bx
                pop_1:
                mov             cl,al
                pop_2:
                pop             word ptr [bx]
                dec             bx
                dec             bx
                dec             cl
                jnz             pop_2
                sub             dx,160
                mov             bx,dx
                dec             ch
                jnz             pop_1
                mov             ax,sp
                db              2eh
                stax            ssp
                exit_pop:
                mov             sp,di
                push            cs
                pop             ds
                next

; ( x1 y1 --> )
ch_w_:
                db              14,'EXCHANGEWINDOW',0
                dk              pop_w_
                _ch_w:
                cli
                pop             bx
                pop             cx
                push            bp
                ldax            ssp
                mov             bp,ax
                ldax            vram
                mov             ds,ax
                mov             ax,word ptr [bp]
                inc             bp
                inc             bp
                cmp             ax,1232h
                jnz             exit_ch
                mov             dx,word ptr [bp]
                inc             bp
                inc             bp
                mov             ax,word ptr [bp]
                inc             bp
                inc             bp
                add             bx,dx
                dec             bx
                add             cx,ax
                dec             cx
                mov             ah,dl
                push            ax
                mov             ax,160
                mul             bx
                mov             bx,ax
                pop             ax
                add             bx,cx
                add             bx,cx
                mov             cx,ax
                mov             dx,bx
                ch_1:
                mov             cl,al
                ch_2:
                push            word ptr [bx]
                push            word ptr [bp]
                pop             word ptr [bx]
                pop             word ptr [bp]
                inc             bp
                inc             bp
                dec             bx
                dec             bx
                dec             cl
                jnz             ch_2
                sub             dx,160
                mov             bx,dx
                dec             ch
                jnz             ch_1
                exit_ch:
                push            cs
                pop             ds
                pop             bp
                sti
                next

; ( x1 y1 x2 y2 LenStr Attribute --> )
border_:        db              6,'BORDER',0
                dk              ch_w_
                _border:
                pop             ax
                mov             ah,al
                pop             bx
                pop             dx
                pop             cx
                pop             di
                sub             dx,di
                dec             dx
                mov             al,dl
                pop             dx
                sub             cx,dx
                dec             cx
                mov             ch,al
                push            ax
                push            dx
                mov             ax,160
                mul             di
                pop             dx
                shl             dx,1
                mov             di,dx
                add             di,ax
                ldax            vram
                mov             es,ax
                pop             ax
                mov             dx,cx
                mov             ch,0
                mov             al,byte ptr [bx+1]
                stosw
                mov             cl,dl
                mov             al,byte ptr [bx+2]
                rep             stosw
                mov             al,byte ptr [bx+3]
                stosw
                mov             al,byte ptr [bx+5]
                mov             cl,dh
                bord_1:
                add             di,158
                stosw
                loop            bord_1
                std
                add             di,158
                mov             al,byte ptr [bx+8]
                stosw
                mov             al,byte ptr [bx+7]
                mov             cl,dl
                rep             stosw
                mov             al,byte ptr [bx+6]
                stosw
                mov             al,byte ptr [bx+4]
                mov             cl,dh
                bord_2:
                sub             di,158
                stosw
                loop            bord_2
                next

wherex_:        db      6,'WHEREX',0
        dk      border_
        _wherex:
        ldal    crx
        mov     ah,0
        push    ax
        next

wherey_:        db      6,'WHEREY',0
        dk      wherex_
        _wherey:
        ldal    cry
        mov     ah,0
        push    ax
        next

emit_:          db              4,'EMIT',0
                dk              wherey_
                _emit:
                call            flag
                db              0
                flag:
                pop             bx
                mov             al,byte ptr [bx]
                cmp             al,0
                jnz             test_for_char
                jmp             exec_emit
                test_for_char:
                cmp             al,1
                jnz             no_com_wait
                pop             ax
                and             al,5fh
                sub             al,'A'
                cmp             al,7
                jna             func_num_ok
                jmp             ex_emit2
                func_num_ok:
                call            com_tbl
                db              2               ; A - Set characters attributes
                db              3               ; B - change Cursor attributes
                db              4               ; C - Set Cursor type
                db              5               ; D - Shift Window (UDLR)
                db              6               ; E - Extended functions
                db              7               ; F - Display extra character
                db              8               ; G - GotoXY (absolute)
                db              10              ; H - Move Cursor (UDLR)
                com_tbl:
                pop             di
                mov             ah,0
                add             di,ax
                mov             al,byte ptr cs:[di]
                mov             byte ptr [bx],al
                jmp             short exit_emit
                no_com_wait:
                cmp             al,2
                jnz             no_set_char_attr
                pop             ax
                stal            curattr
                mov             byte ptr [bx],0
                exit_emit:
                next
                no_set_char_attr:
                cmp             al,3
                jnz             no_cursor_attr
                mov             byte ptr [bx],0
                pop             bx
                ldal            cursortype
                cmp             al,0
                jz              exit_emit
                cmp             al,4
                jnc             exit_emit
                cmp             al,3
                jz              change_crs_attr_bios
                cmp             al,1
                jnz             ch_crs_attr_really
                ldax            port
                mov             dx,ax
                mov             al,10
                mov             ah,bl
                mov             cl,4
                shr             ah,cl
                out             dx,ax
                inc             al
                mov             ah,bl
                and             ah,15
                out             dx,ax
                jmp             exit_emit
                change_crs_attr_bios:
                mov             ch,bl
                mov             cl,4
                shr             ch,cl
                mov             cl,bl
                and             cx,0f0fh
                mov             ah,1
                int             10h
                jmp             exit_emit
                ch_crs_attr_really:
                call            get_vram_addr   ; to ES:DI
                inc             di
                mov             byte ptr [di],bl
                mov             al,bl
                stal            cursorattr
                jmp             exit_emit
                no_cursor_attr:
                cmp             al,4
                jnz             no_cursor_type
                mov             byte ptr [bx],0
                call            unlocate
                pop             ax
                and             al,3
                stal            cursortype
                call            locate
                jmp             exit_emit
                no_cursor_type:
                cmp             al,5
                jz              shift_window
                jmp             no_shift_window
                shift_window:
                mov             byte ptr [bx],0
                call            unlocate
                pop             ax
                and             al,5fh
                cmp             al,'E'
                jnz             no_erase_window
                ldal            cursortype
                cmp             al,3
                jnz             non_bios_erase
                call            erase_bios
                jmp             no_right_shift
                non_bios_erase:
                ldax            x2y2
                mov             cx,ax
                ldax            x1y1
                sub             cx,ax
                call            get_vr_addr
                add             cx,101h
                cld
                ldal            curattr
                mov             ah,al
                mov             al,' '
                erase_wind_1:
                push            cx
                push            di
                mov             ch,0
                rep             stosw
                pop             di
                pop             cx
                add             di,160
                dec             ch
                jnz             erase_wind_1
                jmp             no_right_shift
                no_erase_window:
                cmp             al,'U'
                jnz             no_up_shift
                call            shift_up
                jmp             no_right_shift
                no_up_shift:
                cmp             al,'D'
                jnz             no_down_shift
                ldal            cursortype
                cmp             al,3
                jnz             non_bios_shift
                call            shift_down_bios
                jmp             no_right_shift
                non_bios_shift:
                push            si
                ldax            x1y1
                mov             cx,ax
                ldax            x2y2
                push            ax
                call            get_vr_addr
                push            es
                pop             ds
                pop             ax
                sub             ax,cx
                mov             cx,101h
                add             cx,ax
                std
                sh_dn_1:
                dec             ch
                jz              end_sh_dn
                mov             si,di
                sub             si,160
                push            cx
                push            di
                mov             ch,0
                rep             movsw
                pop             di
                pop             cx
                sub             di,160
                jmp             short sh_dn_1
                end_sh_dn:
                mov             ch,0
                db              2eh
                ldal            curattr
                mov             ah,al
                mov             al,' '
                rep             stosw
                pop             si
                push            cs
                pop             ds
                jmp             no_right_shift
                no_down_shift:
                cmp             al,'L'
                jnz             no_left_shift
                push            si
                ldax            x2y2
                mov             cx,ax
                ldax            x1y1
                push            ax
                call            get_vr_addr
                push            es
                pop             ds
                pop             ax
                sub             cx,ax
                inc             ch
                db              2eh
                ldal            curattr
                mov             ah,al
                mov             al,' '
                cld
                sh_left_1:
                mov             si,di
                inc             si
                inc             si
                push            cx
                push            di
                mov             ch,0
                jcxz            sh_left_2
                rep             movsw
                sh_left_2:
                stosw
                pop             di
                pop             cx
                add             di,160
                dec             ch
                jnz             sh_left_1
                pop             si
                push            cs
                pop             ds
                jmp             no_right_shift
                no_left_shift:
                cmp             al,'R'
                jnz             no_right_shift
                push            si
                ldax            x1y1
                mov             cx,ax
                ldax            x2y2
                push            ax
                call            get_vr_addr
                push            es
                pop             ds
                pop             ax
                sub             ax,cx
                mov             cx,ax
                inc             ch
                db              2eh
                ldal            curattr
                mov             ah,al
                mov             al,' '
                std
                sh_right_1:
                mov             si,di
                dec             si
                dec             si
                push            cx
                push            di
                mov             ch,0
                jcxz            sh_right_2
                rep             movsw
                sh_right_2:
                stosw
                pop             di
                pop             cx
                sub             di,160
                dec             ch
                jnz             sh_right_1
                pop             si
                push            cs
                pop             ds
                no_right_shift:
                call            locate
                jmp             exit_emit
                no_shift_window:
                cmp             al,6
                jz              extended_functions
                jmp             no_extended_functions
                extended_functions:
                mov             byte ptr [bx],0
                pop             ax
                and             al,5fh
                cmp             al,'S'
                jnz             no_save_state
                mov             di,sp
                ldax            ssp
                mov             sp,ax
                ldax            x1y1
                push            ax
                ldax            x2y2
                push            ax
                ldax            curattr
                push            ax
                ldax            cursorattr
                push            ax
                ldax            vram
                push            ax
                ldax            crx
                push            ax
                ldax            port
                push            ax
                mov             ax,1233h
                push            ax
                mov             ax,sp
                stax            ssp
                mov             sp,di
                jmp             exit_emit
                no_save_state:
                cmp             al,'L'
                jnz             no_load_state
                call            unlocate
                mov             di,sp
                ldax            ssp
                mov             sp,ax
                pop             ax
                cmp             ax,1233h
                jz              load_stt_ok
                push            ax
                mov             sp,di
                jmp             exit_emit
                load_stt_ok:
                pop             ax
                stax            port
                pop             ax
                stax            crx
                pop             ax
                stax            vram
                pop             ax
                stax            cursorattr
                pop             ax
                stax            curattr
                pop             ax
                stax            x2y2
                pop             ax
                stax            x1y1
                no_load_stt:
                mov             ax,sp
                stax            ssp
                mov             sp,di
                call            locate
                jmp             exit_emit
                no_load_state:
                jmp             exit_emit
                no_extended_functions:
                cmp             al,7
                jnz             no_extra_char
                mov             byte ptr [bx],0
                pop             ax
                jmp             no_control_chars
                no_extra_char:
                cmp             al,8
                jnz             no_x_wait
                inc             byte ptr [bx]
                call            unlocate
                pop             ax
                stal            crx
                jmp             exit_emit
                no_x_wait:
                cmp             al,9
                jnz             no_y_wait
                mov             byte ptr [bx],0
                pop             ax
                stal            cry
                call            locate
                no_y_wait:
                cmp             al,10
                jnz             no_move_cursor
                mov             byte ptr [bx],0
                call            unlocate
                pop             ax
                and             al,5fh
                cmp             al,'U'
                jnz             no_up_move
                ldal            cry
                dec             al
                stal            cry
                jmp             short no_right_move
                no_up_move:
                cmp             al,'D'
                jnz             no_down_move
                ldal            cry
                inc             al
                stal            cry
                jmp             short no_right_move
                no_down_move:
                cmp             al,'L'
                jnz             no_left_move
                ldal            crx
                dec             al
                stal            crx
                jmp             short no_right_move
                no_left_move:
                cmp             al,'R'
                jnz             no_right_move
                ldal            crx
                inc             al
                stal            crx
                no_right_move:
                call            xy_to_range
                call            locate
                jmp             exit_emit
                no_move_cursor:
                mov             byte ptr [bx],0
                jmp             exit_emit

                shift_up:
                ldal            cursortype
                cmp             al,3
                jz              shift_up_bios
                push            si
                ldax            x2y2
                mov             cx,ax
                ldax            x1y1
                push            ax
                call            get_vr_addr
                push            es
                pop             ds
                pop             ax
                sub             cx,ax
                add             cx,101h
                cld
                sh_up_1:
                dec             ch
                jz              end_sh_up
                mov             si,di
                add             si,160
                push            cx
                push            di
                mov             ch,0
                rep             movsw
                pop             di
                pop             cx
                add             di,160
                jmp             short sh_up_1
                end_sh_up:
                mov             ch,0
                db              2eh
                ldal            curattr
                mov             ah,al
                mov             al,' '
                rep             stosw
                pop             si
                push            cs
                pop             ds
                ret
                erase_bios:
                mov             ax,600h
                jmp             short shift_bios
                shift_down_bios:
                mov             ax,701h
                jmp             short shift_bios
                shift_up_bios:
                mov             ax,601h
                shift_bios:
                push            ax
                ldax            x1y1
                mov             cx,ax
                ldax            x2y2
                mov             dx,ax
                ldal            curattr
                mov             bh,al
                pop             ax
                push            bp
                push            si
                int             10h
                pop             si
                pop             bp
                ret

                unlocate:
                ldal            cursortype
                cmp             al,2
                jz              unlocate_plus
                ldax            port
                mov             dx,ax
                mov             ax,0a0eh
                out             dx,ax
                ret
                unlocate_plus:
                call            get_vram_addr   ; to ES:DI
                ldal            undercursor
                inc             di
                stosb
                ret

                locate:
                push            ax
                push            bx
                push            es
                ldax            crx
                xor             bx,bx
                mov             es,bx
                mov             word ptr es:[450h],ax
                pop             es
                pop             bx
                pop             ax
                ldal            cursortype
                cmp             al,0
                jnz             locate_plus
                ret
                locate_plus:
                cmp             al,3
                jnz             no_bios_loc
                ldax            crx
                mov             dx,ax
                mov             ah,2
                mov             bh,0
                push            bp
                push            si
                int             10h
                pop             si
                pop             bp
                ret
                no_bios_loc:
                jc              loc_plus
                ret
                loc_plus:
                push            ax
                call            get_vram_addr   ; to ES:DI
                pop             ax
                cmp             al,2
                jnz             no_attr_loc
                inc             di
                ldal            cursorattr
                xchg            al,byte ptr es:[di]
                stal            undercursor
                ret
                no_attr_loc:
                shr             di,1
                ldax            port
                mov             dx,ax
                mov             ax,di
                mov             ah,15
                xchg            ah,al
                out             dx,ax
                mov             ax,di
                mov             al,14
                out             dx,ax
                ret

                get_vram_addr:  ; to ES:DI
                ldax            crx
                get_vr_addr:
                mov             di,ax
                mov             ah,0
                shl             ax,1
                push            ax
                mov             ax,di
                mov             al,ah
                mov             ah,0
                mov             di,160
                push            dx
                mul             di
                pop             dx
                pop             di
                add             di,ax
                ldax            vram
                mov             es,ax
                ret
                xy_to_range:
                ldax            x1y1
                mov             dx,ax
                ldax            x2y2
                mov             cx,ax
                ldax            crx
                cmp             al,cl
                jna             x2_correct
                mov             al,dl
                x2_correct:
                cmp             al,dl
                jnc             x1_correct
                mov             al,cl
                x1_correct:
                cmp             ah,ch
                jna             y2_correct
                mov             ah,dh
                y2_correct:
                cmp             ah,dh
                jnc             y1_correct
                mov             ah,ch
                y1_correct:
                stax            crx
                ret

                ; ********************************************************
                exec_emit:
                pop             ax
                ex_emit2:
                cmp             al,27
                jnz             no_esc
                mov             byte ptr [bx],1
                next
                no_esc:
                cmp             al,' '
                jnc             no_control_chars
                cmp             al,13
                jnz             no_cret
                call            unlocate
                ldal            x1y1
                stal            crx
                call            locate
                next
                no_cret:
                cmp             al,10
                jnz             no_lf
                call            unlocate
                ldal            x2y2+1
                mov             cl,al
                ldal            cry
                cmp             al,cl
                jnc             lf_with_scroll
                inc             al
                stal            cry
                call            locate
                next
                lf_with_scroll:
                call            shift_up
                call            locate
                next
                no_lf:
                cmp             al,8
                jnz             no_back_space
                call            unlocate
                ldax            x1y1
                mov             cx,ax
                ldax            crx
                cmp             ax,cx
                jz              no_back
                cmp             cl,al
                jnc             back_up
                dec             al
                stal            crx
                no_back:
                call            locate
                next
                back_up:
                dec             ah
                ldal            x2y2
                stax            crx
                jmp             short no_back
                no_back_space:
                cmp             al,12
                jnz             no_page
                call            unlocate
                ldax            x1y1
                stax            crx
                call            locate
                next
                no_page:
                no_control_chars:
                push            ax
                call            unlocate
                ldal            cursortype
                cmp             al,3
                jz              bios_emit
                jnc             exit_2_emit
                call            get_vram_addr   ; to ES:DI
                ldal            curattr
                mov             cl,al
                pop             ax
                mov             ah,cl
                stosw
                end_emit:
                ldax            x2y2
                mov             cx,ax
                ldax            crx
                cmp             al,cl
                jnc             end_of_window
                inc             al
                stal            crx
                call            locate
                next
                exit_2_emit:
                pop             ax
                next
                bios_emit:
                ldal            curattr
                mov             bl,al
                mov             bh,0
                pop             ax
                mov             cx,1
                mov             ah,9
                push            bp
                push            si
                int             10h
                pop             si
                pop             bp
                jmp             end_emit
                end_of_window:
                cmp             ah,ch
                jnc             end_of_screen
                ldal            x1y1
                stal            crx
                ldal            cry
                inc             al
                stal            cry
                call            locate
                next
                end_of_screen:
                call            shift_up
                ldal            x1y1
                stal            crx
                call            locate
                next

key_:   db      3,'KEY',0
        dk      emit_
        _key:
        mov     ah,0
        push    bp
        push    si
        int     16h
        pop     si
        pop     bp
        cmp     al,0
        jz      no_ah_to0
        mov     ah,0
        no_ah_to0:
        push    ax
        next

; ( BufOff BufSeg BufStartXShow BufStartYShow BufXsize
; WindowX WindowY SizeX SizeY --> )
show_:  db      4,'SHOW',0
        dk      key_
        _show:
        ldax    vram
        mov     es,ax
        pop     ax
        pop     cx
        mov     ch,al
        pop     ax
        mov     di,160
        mul     di
        pop     di
        shl     di,1
        add     di,ax
        pop     ax
        shl     ax,1
        mov     dx,ax
        pop     bx
        push    dx
        mul     bx
        pop     dx
        pop     bx
        shl     bx,1
        add     bx,ax
        pop     ds
        pop     ax
        add     bx,ax
        push    si
        mov     si,bx
        show_loop:
        push    cx
        push    si
        push    di
        mov     ch,0
        rep     movsw
        pop     di
        pop     si
        pop     cx
        add     di,160
        add     si,dx
        dec     ch
        jnz     show_loop
        pop     si
        push    cs
        pop     ds
        next

; ( BufOff BufSeg BufStartXShow BufStartYShow BufXsize
; WindowX WindowY SizeX SizeY Attribute --> )
showtext_:      db      8,'SHOWTEXT',0
        dk      show_
        _showtext:
        ldax    vram
        mov     es,ax
        pop     ax
        stal    errcode
        pop     ax
        pop     cx
        mov     ch,al
        pop     ax
        mov     di,160
        mul     di
        pop     di
        shl     di,1
        add     di,ax
        pop     ax
        mov     dx,ax
        pop     bx
        push    dx
        mul     bx
        pop     dx
        pop     bx
        add     bx,ax
        pop     ds
        pop     ax
        add     bx,ax
        push    si
        mov     si,bx
        db      2eh
        ldal    errcode
        mov     ah,al
        showtext_loop:
        push    cx
        push    si
        push    di
        mov     ch,0
        shtxt_lp2:
        lodsb
        stosw
        loop    shtxt_lp2
        pop     di
        pop     si
        pop     cx
        add     di,160
        add     si,dx
        dec     ch
        jnz     showtext_loop
        pop     si
        push    cs
        pop     ds
        next

ifkey_: db      4,'?KEY',0
        dk      showtext_
        _ifkey:
        push    bp
        push    si
        mov     ah,1
        int     16h
        pop     si
        pop     bp
        jnz     no_clearax
        xor     ax,ax
        push    ax
        next
        no_clearax:
        push    bp
        push    si
        mov     ah,0
        int     16h
        pop     si
        pop     bp
        cmp     al,0
        jz      no_clear_ah__
        mov     ah,0
        no_clear_ah__:
        push    ax
        mov     ax,0ffffh
        push    ax
        next

; ( Char Attr X1 Y1 X2 Y2 --> )
fillscr_:       db      10,'FILLWINDOW',0
        dk      ifkey_
        _fillscr:
        pop     cx
        pop     bx
        pop     ax
        sub     cx,ax
        inc     cx
        mov     dx,160
        mul     dx
        pop     di
        mov     dx,di
        shl     di,1
        add     di,ax
        sub     bx,dx
        inc     bx
        ldax    vram
        mov     es,ax
        pop     dx
        pop     ax
        xchg    ah,dl
        fs1_:
        push    bx
        push    di
        fs2_:
        stosw
        dec     bx
        jnz     fs2_
        pop     di
        pop     bx
        add     di,160
        loop    fs1_
        next

init_:          db              9,'(INITCRT)',32
                dk              fillscr_
                _init:
                push            bp
                push            si
                mov             ah,15
                int             10h
                stal            drivetype
                cmp             al,7
                jz              mono_mode
                mov             ax,0b800h
                mov             bx,3d4h
                jmp             short store_vram
                mono_mode:
                mov             ax,0b000h
                mov             bx,3b4h
                store_vram:
                stax            vram
                mov             ax,bx
                stax            port
                mov             al,1
                stal            cursortype
                mov             al,7
                stal            curattr
                mov             al,70h
                stal            cursorattr
        mov     dx,bx
        mov     al,14
        out     dx,al
        inc     dx
        in      al,dx
        mov     ah,al
        dec     dx
        mov     al,15
        out     dx,al
        inc     dx
        in      al,dx
        xor     dx,dx
        mov     cx,80
        div     cx
        stal    cry
        mov     al,dl
        stal    crx
                pop             si
                pop             bp
                next

                dw              100h
                dw              init_-100h
                include         vers.inc
                dw              1231h

code            ends
                end             module
