
Use ds.frl
Use bio.frl

67 Constant &HEADERSIZE \ Buffer header size (in code segment) see GNF.DOC
                        \ (Without SUMDATA fields)

2Variable &POS
2Variable &RECCOUNT
 Variable &BHEADER
 Variable &INVBUFF
 Variable &HANDLE

 Variable TIMEX
 Variable TIMEY

: ?ERR
   If
      False ErrNo !
   Else
      r> Drop False
   Then
;

: &TRUNCATE ( Handle --> Flag )
   Here CodeSegment 0 FWrite
   ?Err
   0=
   ?Err
;

: &BUFFSEG &BHEADER @ ;
: &BUFFSIZE &BHEADER @ 2+ ; : &RECSIZE &BHEADER @ 2+ 2+ ;
: &UPOINTER &BHEADER @ 6 + ; : &LPOINTER &BHEADER @ 8 + ;
: &UHANDLE &BHEADER @ 10 + ; : &LHANDLE &BHEADER @ 12 + ;
: &ULIMIT &BHEADER @ 14 + ; : &LLIMIT &BHEADER @ 16 + ;
: &UCOUNT &BHEADER @ 18 + ; : &LCOUNT &BHEADER @ 22 + ;
: &UNAME &BHEADER @ 26 + ; : &LNAME &BHEADER @ 46 + ;

: &GETUP ( --> N )
   &BuffSize @ &UPointer @ - &RecSize @ U/
;

: &GETLOW ( --> N )
   &LPointer @ &RecSize @ U/
;

: &GETFREE ( --> N )
   &Upointer @ &LPointer @ - &RecSize @ U/
;

: &FLASHLOW ( --> Flag )
   &LPointer @
   If
      &LHandle @ 0 &BuffSeg @ &LPointer @ FWrite
      ?Err
      &LPointer @ =
      ?Err
      &LPointer 0!
   Then
   True
;

: &LOADUP ( RecCount --> Flag )
   ?Dup IfNot True Exit Then
   TimeX !
   &UHandle @ 1 TimeX @ &RecSize @ M* DNegate FSeek
   ?Err 2Drop
   &UHandle @ 0 &InvBuff @ TimeX @ &RecSize @ * FRead
   ?Err
   TimeX @ &RecSize @ * =
   ?Err
   &UHandle @ 1 TimeX @ &RecSize @ M* DNegate FSeek
   ?Err 2Drop
   &UPointer @ &BuffSeg @ Over TimeX @ &RecSize @ * - Over
   &BuffSize @ &UPointer @ - ACmove
   TimeX @ 1- &RecSize @ * &InvBuff @
   &BuffSize @ TimeX @ &RecSize @ * - &BuffSeg @
   TimeX @ &RecSize @ &Invert
   TimeX @ &RecSize @ * &UPointer -!
   True
;

: &FILLUP ( --> Flag )
   &GetFree
   If
      &UCount 2@ &GetUp 0 D-
      If
         Drop
         &GetFree
      Else
         &GetFree UMin
      Then
      ?Dup
      If
         &LoadUp
         ?Err
      Then
   Then
   True
;

: &NORMAL ( --> Flag )
   &GetUp &ULimit @ <
   If
      &UCount 2@ &GetUp 0 D- Or
      If
         &Ulimit @ &GetUp - &GetFree <
         If
            &FlashLow
            ?Err
         Then
         &FillUp
         ?Err
      Then
   Then
   True
;

: &LOADLOW ( RecCount --> Flag )
   ?Dup IfNot True Exit Then
   TimeX !
   &LHandle @ 1 TimeX @ &RecSize @ M* DNegate FSeek
   ?Err 2Drop
   &LHandle @ 0 &InvBuff @ TimeX @ &RecSize @ * FRead
   ?Err
   TimeX @ &RecSize @ * =
   ?Err
   &LHandle @ 1 TimeX @ &RecSize @ M* DNegate FSeek
   ?Err 2Drop
   &LPointer @
   If
      0 &BuffSeg @ TimeX @ &RecSize @ * Over &LPointer @ ACMove>
   Then
   0 &InvBuff @ 0 &BuffSeg @ TimeX @ &RecSize @ * ACmove
   TimeX @ &RecSize @ * &LPointer +!
   True
;

: &SAVEUP ( RecCount --> Flag )
   ?Dup IfNot True Exit Then
   TimeX !
   &BuffSize @ &RecSize @ - &BuffSeg @
   0 &InvBuff @
   TimeX @ &RecSize @ &Invert
   &UHandle @ 0 &InvBuff @ TimeX @ &RecSize @ * FWrite
   ?Err
   TimeX @ &RecSize @ * =
   ?Err
   &GetUp TimeX @ =
   IfNot
      &UPointer @ &BuffSeg @ Over TimeX @ &RecSize @ * + Over
      &BuffSize @ &UPointer @ - TimeX @ &RecSize @ * - ACMove>
   Then
   TimeX @ &RecSize @ * &UPointer +!
   True
;

: &FLASHUP ( --> Flag )
   &GetUp ?Dup
   If
      &SaveUp
      ?Err
   Then
   True
;

: &FILLLOW ( --> Flag )
   &GetLow
   IfNot
      &GetFree &LLimit @ <
      If
         &LLimit @ &GetFree - &SaveUp
         ?Err
      Then
      &LCount 2@
      If
         Drop
         &LLimit @
      Else
         &LLimit @ UMin
      Then
      ?Dup
      If
         &LoadLow
         ?Err
      Then
   Then
   True
;

: &QFORWARD ( --> )
   &RecCount 2@
   If
      Drop
      &GetUp
   Else
      &GetUp UMin
   Then
   ?Dup
   If
      Dup >r
      &RecSize @ * >r
      &UPointer @ &BuffSeg @ 1 RPick &RecSize @ &BHeader @ 66 + &Add
      &UPointer @ &BuffSeg @ &LPointer @ Over r@ ACmove
      r@ &UPointer +! r> &LPointer +!
      r> 0 2Dup 2Dup &RecCount 2@ 2Swap D- &RecCount 2!
      &UCount 2@ 2Swap D- &UCount 2!
      &LCount 2@ D+ &LCount 2!
   Else
      Beep
   Then
;

: &QBACKWARD ( --> )
   &RecCount 2@
   If
      Drop
      &GetLow
   Else
      &GetLow UMin
   Then
   Dup TimeX !
   If
      &LPointer @ TimeX @ &RecSize @ * - &BuffSeg @
      &UPointer @ TimeX @ &RecSize @ * - Over
      TimeX @ &RecSize @ * ACmove>
      TimeX @ &RecSize @ * Dup &UPointer -! &LPointer -!
      &RecCount 2@ TimeX @ 0 D- &RecCount 2!
      &UCount 2@ TimeX @ 0 D+ &UCount 2!
      &LCount 2@ TimeX @ 0 D- &LCount 2!
      &UPointer @ &BuffSeg @ TimeX @ &RecSize @ &BHeader @ 66 + &Sub
   Else
      Beep
   Then
;

: &TELL ( Header --> [d]Position )
   &BHeader !
   &LCount 2@
;

: &USE ( Header SrcHandle [d]RecCount --> Flag )
   &RecCount 2! &Handle ! &BHeader !
   &Handle @ FTell
   ?Err &Pos 2!
   &FlashLow
   ?Err
   Begin
      &RecCount 2@ Or
   While
      &FlashUp
      ?Err
      &RecCount 2@
      If
         Drop
         &GetFree
      Else
         &GetFree UMin
      Then
      TimeY !
      &RecCount 2@ TimeY @ 0 D- &RecSize @ DS*
      &Pos 2@ D+ &Handle @ 0 2Swap FSeek
      ?Err 2Drop
      &Handle @ &UPointer @ TimeY @ &RecSize @ * - &BuffSeg @
      TimeY @ &RecSize @ * FRead
      ?Err
      TimeY @ &RecSize @ * =
      ?Err
      TimeY @ &RecSize @ * &UPointer -!
      &UCount 2@ TimeY @ 0 D+ &UCount 2!
      &RecCount 2@ TimeY @ 0 D- &RecCount 2!
   Repeat
   &Normal
   ?Err
   True
;

: &FLASH ( Header DestHandle [d]RecCount --> Flag )
   &RecCount 2! &Handle ! &BHeader !
   &FlashLow
   ?Err
   Begin
      &RecCount 2@ Or
   While
      &FillUp
      ?Err
      &RecCount 2@
      If
         Drop
         &GetUp
      Else
         &GetUp UMin
      Then
      TimeY !
      &Handle @ &UPointer @ &BuffSeg @ TimeY @ &RecSize @ * FWrite
      ?Err
      TimeY @ &RecSize @ * =
      ?Err
      &RecCount 2@ TimeY @ 0 D- &RecCount 2!
      TimeY @ &RecSize @ * &UPointer +!
      &UCount 2@ TimeY @ 0 D- &UCount 2!
   Repeat
   &Normal
   ?Err
   True
;

: &SAVE ( Header DestHandle [d]RecCount --> Flag )
   &RecCount 2! &Handle ! &BHeader !
   Begin
      &RecCount 2@ Or
   While
      &FlashLow
      ?Err
      &FillUp
      ?Err
      &RecCount 2@
      If
         Drop
         &GetUp
      Else
         &GetUp UMin
      Then
      TimeY !
      &Handle @ &UPointer @ &BuffSeg @ TimeY @ &RecSize @ * FWrite
      ?Err
      TimeY @ &RecSize @ * =
      ?Err
      &QForward
   Repeat
   &Normal
   ?Err
   True
;

: &FORWARD ( Header [d]RecCount --> Flag )
   &RecCount 2! &BHeader !
	&RecCount 2@ &UCount 2@ D>
	If
		444 ErrNo !
        False
        Exit
	Then
   Begin
      &RecCount 2@ Or
   While
      &QForward
      &RecCount 2@ Or
      If
         &FlashLow
         ?Err
         &FillUp
         ?Err
      Then
   Repeat
   &Normal
   ?Err
   True
;

: &BACKWARD ( Header [d]RecCount --> Flag )
   &RecCount 2! &BHeader !
   &LCount 2@ &RecCount 2@ D<
   If
      444 ErrNo !
      False
      Exit
   Then
   Begin
      &RecCount 2@ Or
   While
      &QBackward
      &RecCount 2@ Or
      If
         &FlashUp
         ?Err
         &FillLow
         ?Err
      Then
   Repeat
   &Normal
   ?Err
   True
;

: &LOCATE ( Header [d]RecNo RecDepth --> FirstRecOff FiresRecSeg True )
                               ( ... --> False )
   TimeY ! &Pos 2! &BHeader !
   &Pos 2@ &BHeader @ &Tell D<
   If
      &BHeader @ &BHeader @ &Tell &Pos 2@ D- &Backward
      ?Err
   Else
      &Pos 2@ &BHeader @ &Tell D>
      If
         &BHeader @ &Pos 2@ &BHeader @ &Tell D- &Forward
         ?Err
      Then
   Then
   &GetUp TimeY @ <
   If
      &UCount 2@ &GetUp 0 D- Or
      If
         TimeY @ &GetUp - &GetFree >
         If
            &FlashLow
            ?Err
         Then
         &FillUp
         ?Err
      Then
   Then
   &UPointer @ &BuffSeg @
   True
;

\ *****************************************************************************

: &CURRENT ( Header --> Offset Segment )
   &BHeader !
   &UPointer @ &BuffSeg @
;

: &TOTAL ( Header --> [d]TotalRecords )
   &BHeader !
   &UCount 2@ &LCount 2@ D+
;

: &GETSUM ( Header SumNo --> [d]Sum )
   TimeX ! Dup &BHeader !
   66 + c@ TimeX @ >
   If
      &BHeader @ 70 + TimeX @ 7 * + 2@ Swap
   Else
      0 0
   Then
;

: &INSERT ( Header SrcOff SrcSeg RecCount --> SuccessFlag )
   TimeY ! &Pos 2! &BHeader !
   &GetFree TimeY @ <
   If
      &FlashLow
      ?Err
   Then
   &GetFree TimeY @ <
   If
      &FlashUp
      ?Err
   Then
   &GetFree TimeY @ < Not ?Err
   TimeY @ &RecSize @ * &UPointer -!
   TimeY @ 0 &UCount 2@ D+ &UCount 2!
   &Pos 2@ &UPointer @ &BuffSeg @ TimeY @ &RecSize @ * ACMove
   &Normal
   ?Err
   True
;

: &DELETE ( Header RecCount --> Flag )
   TimeY ! &BHeader !
   &GetUp TimeY @ <
   If
      &FillUp
      ?Err
   Then
   TimeY @ &RecSize @ * &UPointer +!
   &UCount 2@ TimeY @ 0 D- &UCount 2!
   &Normal
   ?Err
   True
;

: &CLEARSUMS ( Header --> )
   &BHeader !
   &BHeader @ 66 + c@ ?Dup
   If
      0 Do
         0 0 i 7 * 70 + &BHeader @ + 2!
      Loop
   Then
;

\ *****************************************************************************
\ Run time library interface

: OPENRTL ( ASCIIz --> LibSeg True  )
          ( ...    --> False )
   Dup >r 31 Here FindFirst
   If
      Here 26 + 2@ Swap
      If
         r> 2Drop False
      Else
         Dup DPL !
         u2/ u2/ u2/ u2/ 2+ Malloc
         If
            r> Swap >r
            0 FOpen
            If
               r@ Over >r 0 Swap DPL @ FRead
               r> FClose Drop
               If
                  DPL @ =
                  If
                     r> True
                  Else
                     r> Drop False
                  Then
               Else
                  r> Drop False
               Then
            Else
               r> MFree Drop False
            Then
         Else
            r> Drop False
         Then
      Then
   Else
      r> Drop False
   Then
;

: CLOSERTL ( LibSeg --> SuccessFlag )
   MFree
;

: EXECRTL ( {InputParams} LibSeg FuncNo --> {OutputParams} )
   Swap 7 Over a@ Swap 16 - FarCall
;

: INSTALLRTL ( ASCIIzName RTLVariable --> SuccessFlag )
   >r
   OpenRTL
   If
      Dup r> !
      Dup >r 0 Swap 0 ExecRTL
      If
         r> Drop True
      Else
         r> CloseRTL Drop
         False
      Then
   Else
      r> Drop False
   Then
;

\ *****************************************************************************
: INIT
   ." \rGP-Forth DOS I/O module : Loaded Ok\r\n"
   " FORGET INIT" Load
;

Smudge TIMEX
Smudge TIMEY

MakeUnit Dos.frl
