
include fasm.inc

code            segment
                assume          cs:code,ds:code,es:code,ss:code
                org             100h

module:

; ( NameStr Attribute --> Handele ErrFlag )
fcreate_:       db              7,'FCREATE',0
                dw              0
                _fcreate:
                mov             ah,3ch
                pop             cx
                pop             dx
                int             21h
                storeerr
                jc              cr_err
                push            ax
                mov             ax,0ffffh
                jmp             short cr_end
                cr_err:
                xor             ax,ax
                cr_end:
                push            ax
                next

; ( NameStr Mode --> ... ... )
fopen_:         db              5,'FOPEN',0
                dk              fcreate_
                _fopen:
                pop             ax
                mov             ah,3dh
                pop             dx
                int             21h
                storeerr
                jc              op_err
                push            ax
                mov             ax,0ffffh
                jmp             short op_end
                op_err:
                xor             ax,ax
                op_end:
                push            ax
                next

; ( Handle --> ErrFlag )
fclose_:        db              6,'FCLOSE',0
                dk              fopen_
                _fclose:
                pop             bx
                mov             ah,3eh
                int             21h
                storeerr
                jc              cl_err
                mov             ax,0ffffh
                jmp             short cl_end
                cl_err:
                xor             ax,ax
                cl_end:
                push            ax
                next

; ( Handle StartPosType LowOff HighOff --> LowOff HighOff ErrFlag )
fseek_:         db              5,'FSEEK',0
                dk              fclose_
                _fseek:
                pop             cx
                pop             dx
                pop             ax
                mov             ah,42h
                pop             bx
                int             21h
                storeerr
                jc              sk_err
                push            ax
                push            dx
                mov             ax,0ffffh
                jmp             short sk_end
                sk_err:
                xor             ax,ax
                sk_end:
                push            ax
                next

; ( Handle Offset Segment Count --> Count ErrFlag )
fread_:         db              5,'FREAD',0
                dk              fseek_
                _fread:
                pop             cx
                pop             ds
                pop             dx
                pop             bx
                mov             ah,3fh
                int             21h
                db              2eh
                storeerr
                push            cs
                pop             ds
                jc              rd_err
                push            ax
                mov             ax,0ffffh
                jmp             short rd_end
                rd_err:
                xor             ax,ax
                rd_end:
                push            ax
                next

; ( Handle Offset Segment Count --> Count ErrFlag )
fwrite_:        db              6,'FWRITE',0
                dk              fread_
                _fwrite:
                pop             cx
                pop             ds
                pop             dx
                pop             bx
                mov             ah,40h
                int             21h
                db              2eh
                storeerr
                push            cs
                pop             ds
                jc              wr_err
                push            ax
                mov             ax,0ffffh
                jmp             short wr_end
                wr_err:
                xor             ax,ax
                wr_end:
                push            ax
                next

; ( ASCIIzName Attributes OffsetBuffer --> FoundFlag )
find_first_:
                db              9,'FINDFIRST',0
                dk              fwrite_
                _find_first:
                pop             dx
                mov             ah,1ah
                push            si
                push            bp
                int             21h
                pop             bp
                pop             si
                pop             cx
                pop             dx
                mov             ah,4eh
                push            si
                push            bp
                int             21h
                storeerr
                pop             bp
                pop             si
                jc              not_found_first
                mov             ax,0ffffh
                exit_first:
                push            ax
                next
                not_found_first:
                xor             ax,ax
                jmp             short exit_first

; ( OffsetBuffer --> FoundFlag )
find_next_:
                db              8,'FINDNEXT',0
                dk              find_first_
                _find_next:
                pop             dx
                mov             ah,4fh
                push            si
                push            bp
                int             21h
                storeerr
                pop             bp
                pop             si
                jc              not_found_next
                mov             ax,0ffffh
                exit_next:
                push            ax
                next
                not_found_next:
                xor             ax,ax
                jmp             short exit_next

; ( OldASCIIz NewASCIIZ --> ErrFlag )
frename_:       db              7,'FRENAME',0
                dk              find_next_
                _frename:
                pop             di
                pop             dx
                mov             ah,56h
                push            si
                push            bp
                push            cs
                pop             es
                int             21h
                storeerr
                pop             bp
                pop             si
                jc              err_rename
                mov             ax,0ffffh
                end_rename:
                push            ax
                next
                err_rename:
                xor             ax,ax
                jmp             short end_rename

; ( ASCIIzName --> ErrFlag )
fdelete_:       db              7,'FDELETE',0
                dk              frename_
                _fdelete:
                pop             dx
                push            bp
                push            si
                mov             ah,41h
                int             21h
                storeerr
                pop             si
                pop             bp
                jc              err_delete
                mov             ax,0ffffh
                end_delete:
                push            ax
                next
                err_delete:
                xor             ax,ax
                jmp             short end_delete

; ( ASCIIzName Attributes --> ErrFlag )
fset_attr_:     db              8,'FSETATTR',0
                dk              fdelete_
                _fset_attr:
                pop             cx
                pop             dx
                push            bp
                push            si
                mov             ax,4301h
                int             21h
                storeerr
                pop             si
                pop             bp
                jc              fset_err
                mov             ax,0ffffh
                fset_end:
                push            ax
                next
                fset_err:
                xor             ax,ax
                jmp             short fset_end

; ( ASCIIzName --> Attributes ErrFlag )
fget_attr_:     db              8,'FGETATTR',0
                dk              fset_attr_
                _fget_attr:
                pop             dx
                push            bp
                push            si
                mov             ax,4300h
                xor             cx,cx
                int             21h
                storeerr
                pop             si
                pop             bp
                jc              fget_err
                push            cx
                mov             ax,0ffffh
                fget_end:
                push            ax
                next
                fget_err:
                xor             ax,ax
                jmp             short fget_end

; ( ASCIIzName --> ErrFlag )
makedir_:       db              7,'MAKEDIR',0
                dk              fget_attr_
                _makedir:
                pop             dx
                mov             ah,39h
                push            bp
                push            si
                int             21h
                storeerr
                pop             si
                pop             bp
                jc              err_makedir
                mov             ax,0ffffh
                end_makedir:
                push            ax
                next
                err_makedir:
                xor             ax,ax
                jmp             short end_makedir

; ( ASCIIzName --> ErrFlag )
removedir_:     db              9,'REMOVEDIR',0
                dk              makedir_
                _removedir:
                pop             dx
                mov             ah,3ah
                push            bp
                push            si
                int             21h
                storeerr
                pop             si
                pop             bp
                jc              err_removedir
                mov             ax,0ffffh
                end_removedir:
                push            ax
                next
                err_removedir:
                xor             ax,ax
                jmp             short end_removedir

; ( ASCIIzName --> ErrFlag )
changedir_:     db              9,'CHANGEDIR',0
                dk              removedir_
                _changedir:
                pop             dx
                push            bp
                push            si
                mov             ah,3bh
                int             21h
                storeerr
                pop             si
                pop             bp
                jc              err_cd
                mov             ax,0ffffh
                end_cd:
                push            ax
                next
                err_cd:
                xor             ax,ax
                jmp             short end_cd

; ( Buffer --> ErrFlag )
getcurrentdir_: db              13,'GETCURRENTDIR',0
                dk              changedir_
                _getcurrentdir:
                mov             dl,0
                mov             ah,47h
                pop             bx
                push            si
                push            bp
                mov             si,bx
                int             21h
                storeerr
                pop             bp
                pop             si
                jc              getdir_err
                mov             ax,0ffffh
                end_getdir:
                push            ax
                next
                getdir_err:
                xor             ax,ax
                jmp             short end_getdir

; ( --> CurrentDisk(0=A) )
getcurdisk_:    db              14,'GETCURRENTDISK',0
                dk              getcurrentdir_
                _getcurdisk:
                mov             ah,19h
                push            bp
                push            si
                int             21h
                storeerr
                pop             si
                pop             bp
                mov             ah,0
                push            ax
                next

; ( ASCIIzName LenStrCommandLine(+1Char) EnvironmentSegment --> ErrFlag )
exec_prog_:     db              4,'EXEC',0
                dk              getcurdisk_
                _exec_prog:
                push            cs
                pop             es
                call            parablock
                db              16 dup (0)
                parablock:
                pop             bx
                pop             word ptr [bx]
                mov             word ptr [bx+4],cs
                mov             word ptr [bx+8],cs
                mov             word ptr [bx+12],cs
                call            exec_fcb
                db              0,'           ',0,0,0,0
                exec_fcb:
                pop             ax
                mov             word ptr [bx+6],ax
                mov             word ptr [bx+10],ax
                pop             ax
                push            si
                mov             si,ax
                ldax            upvoc
                mov             di,ax
                mov             word ptr [bx+2],di
                cld
                lodsb
                stosb
                mov             ah,0
                mov             cx,ax
                jcxz            no_move_ex
                rep             movsb
                no_move_ex:
                mov             al,13
                stosb
                pop             si
                pop             dx
                push            si
                push            bp
                mov             ax,sp
                storeerr
                sub             sp,64
                mov             ax,4b00h
                int             21h
                cli
                mov             bx,ax
                db              2eh,0a1h
                dw              12bh
                mov             sp,ax
                mov             ax,bx
                db              2eh
                storeerr
                mov             bx,cs
                mov             ss,word ptr cs:[146h]
                sti
                push            cs
                pop             ds
                pop             bp
                pop             si
                jc              exec_err
                mov             ax,0ffffh
                exec_end:
                push            ax
                next
                exec_err:
                xor             ax,ax
                jmp             short exec_end

; ( Handle --> ErrFlag )
ftell_:         db              5,'FTELL',0
                dk              exec_prog_
                _ftell:
                pop             bx
                xor             cx,cx
                xor             dx,dx
                mov             ax,4201h
                push            bp
                push            si
                int             21h
                pop             si
                pop             bp
                storeerr
                jc              bad_ftell
                push            ax
                push            dx
                mov             ax,0ffffh
                push            ax
                next
                bad_ftell:
                xor             ax,ax
                push            ax
                next

; ( ProcOffset ProcSegment --> )
farcall_:       db              7,'FARCALL',0
                dk              ftell_
                call            fc0
                fc1:
                db              0eah
                dw              ?
                dw              ?
                fc0:
                pop             bx
                pop             word ptr [bx+3]
                pop             word ptr [bx+1]
                push            cs
                call            fc1
                next

init_:          db              1,' ',0
                dk              farcall_
                next

                dw              100h
                dw              init_-100h
                include         vers.inc
                dw              1231h

code            ends
                end             module
