
                .387

                include forthasm.inc

; ( A --> )
fload_:         db      3,'>ST',0
                dw      0
                mov     bx,sp
                fwait
                fild    word ptr ss:[bx]
                fwait
                add     sp,2
                next

; ( --> A )
fstore_:        db      3,'ST>',0
                dj      fload_
                sub     sp,2
                mov     bx,sp
                fwait
                fistp   word ptr ss:[bx]
                fwait
                next

; ( --> )
finit_:         db      6,'FRESET',0
                dj      fstore_
                finit
                fwait
                mov word ptr [time_x],0000011100000000b
                fldcw   word ptr [time_x]
                next

; ( --> )
fdrop_:         db      5,'FDROP',0
                dj      finit_
                fwait
                fincstp
                fwait
                next

; ( --> )
fswap_:         db      5,'FSWAP',0
                dj      fdrop_
                sub     sp,20
                mov     bx,sp
                fwait
                fstp    tbyte ptr ss:[bx]
                fwait
                fstp    tbyte ptr ss:[bx+10]
                fwait
                fld     tbyte ptr ss:[bx]
                fwait
                fld     tbyte ptr ss:[bx+10]
                fwait
                add     sp,20
                next

; ( --> )
frot_:          db      4,'FROT',0
                dj      fswap_
                sub     sp,30
                mov     bx,sp
                fwait
                fstp    tbyte ptr ss:[bx]
                fwait
                fstp    tbyte ptr ss:[bx+10]
                fwait
                fstp    tbyte ptr ss:[bx+20]
                fwait
                fld     tbyte ptr ss:[bx+10]
                fwait
                fld     tbyte ptr ss:[bx]
                fwait
                fld     tbyte ptr ss:[bx+20]
                fwait
                add     sp,30
                next

; ( --> )
fover_:         db      5,'FOVER',0
                dj      frot_
                sub     sp,20
                mov     bx,sp
                fwait
                fstp    tbyte ptr ss:[bx]
                fwait
                fstp    tbyte ptr ss:[bx+10]
                fwait
                fld     tbyte ptr ss:[bx+10]
                fwait
                fld     tbyte ptr ss:[bx]
                fwait
                fld     tbyte ptr ss:[bx+10]
                fwait
                add     sp,20
                next

; ( --> )
fplus_:         db      2,'F+',0
                dj      fover_
                fwait
                faddp   st(1),st
                next

; ( --> )
fminus_:        db      2,'F-',0
                dj      fplus_
                fwait
                fsubp   st(1),st
                next

; ( --> )
fmult_:         db      2,'F*',0
                dj      fminus_
                fwait
                fmulp   st(1),st
                next

; ( --> )
fdiv_:          db      2,'F/',0
                dj      fmult_
                fwait
                fdivp   st(1),st
                next

fsqrt_:         db      5,'FSQRT',0
                dj      fdiv_
                fwait
                fsqrt
                next

fdup_:          db      4,'FDUP',0
                dj      fsqrt_
                sub     sp,10
                mov     bx,sp
                fwait
                fstp    tbyte ptr ss:[bx]
                fwait
                fld     tbyte ptr ss:[bx]
                fwait
                fld     tbyte ptr ss:[bx]
                fwait
                add     sp,10
                next

fnegate_:       db      7,'FNEGATE',0
                dj      fdup_
                fwait
                fchs
                next

fabs_:          db      4,'FABS',0
                dj      fnegate_
                fwait
                fabs
                next

; ( --> )
fint_:          db      4,'FINT',0
                dj      fnegate_
                fwait
                frndint
                next

fmod_:          db      4,'FMOD',0
                dj      fint_
                sub     sp,20
                mov     bx,sp
                fwait
                fstp    tbyte ptr ss:[bx]
                fwait
                fstp    tbyte ptr ss:[bx+10]
                fwait
                fld     tbyte ptr ss:[bx]
                fwait
                fld     tbyte ptr ss:[bx+10]
                fwait
                add     sp,20
                fprem
                sub     sp,10
                mov     bx,sp
                fwait
                fstp    tbyte ptr ss:[bx]
                fwait
                fincstp
                fwait
                fld     tbyte ptr ss:[bx]
                fwait
                add     sp,10
                next

fsin_:          db      4,'FSIN',0
                dj      fmod_
                fwait
                fsin
                next

fcos_:          db      4,'FCOS',0
                dj      fsin_
                fwait
                fcos
                next

fpi_:           db      3,'FPI',0
                dj      fcos_
                fwait
                fldpi
                next

f_lower_:       db      2,'F<',0
                dj      fpi_
                fwait
                fcompp
                fwait
                fstsw   ax
                and     ah,45h
                cmp     ah,0
                jz      f_lw_true_
                xor     ax,ax
                push    ax
                next
                f_lw_true_:
                mov     ax,0ffffh
                push    ax
                next

f_greater_:     db      2,'F>',0
                dj      f_lower_
                fwait
                fcompp
                fwait
                fstsw   ax
                and     ah,45h
                cmp     ah,1
                jz      f_gr_true_
                xor     ax,ax
                push    ax
                next
                f_gr_true_:
                mov     ax,0ffffh
                push    ax
                next

f_equal_:       db      2,'F=',0
                dj      f_greater_
                fwait
                fcompp
                fwait
                fstsw   ax
                and     ah,45h
                cmp     ah,40h
                jz      f_eq_true_
                xor     ax,ax
                push    ax
                next
                f_eq_true_:
                mov     ax,0ffffh
                push    ax
                next

; ( --> FSP )
f_storesw_:     db      4,'FSP@',0
                dj      f_equal_
                fwait
                fstsw	ax
                mov	cl,11
                shr	ax,cl
                and	al,7
                push	ax
                next

; ( --> )
flit_:		db	4,'FLIT',6
		dj	f_storesw_
		mov	ah,0
		lodsb
		fwait
                fld     tbyte ptr [si]
                fwait
		add	si,ax
		next

; ( --> )
fcompile_:	db	2,'F,',0
		dj	flit_
		mov	bx,word ptr [upvoc]
		add	word ptr [upvoc],10
		fwait
                fstp    tbyte ptr [bx]
                fwait
		next

; ( Addr --> )
f_raz_:		db	2,'F@',0
                dj      fcompile_
		pop	bx
		fld	tbyte ptr [bx]
		fwait
		next

; ( Addr --> )
f_prisv_:	db	2,'F!',0
		dj	f_raz_
		pop	bx
		fwait
		fstp	tbyte ptr [bx]
		fwait
		next

init_:          db      1,' ',0
                dj      f_prisv_
                db      50 dup (90h)
                next

                dw      100h
                dw      init_-100h
                include vers.inc
                dw      1231h

                end     module
