
		page		57

dj              macro           adrs__

                dw              adrs__-$-2

                endm

                dk              macro           adrs__

                dw              adrs__-$-2

                endm

do              macro

                call            callr

                endm

savebpspsi      macro

                mov             word ptr [err_bp_],bp
                mov             word ptr [err_sp_],sp
                mov             word ptr [err_si_],si

                endm


                ; Vocabulary format :
                ;               - Name
                ;               - Attribute
                ;               - Link
                ;               - Code
                ;               - Parameters

num_out         equ             5eh

                model           tiny

                .code

                org             100h

label100:       jmp             start           ; 100

vers:                                           ; 103
                include         vers.inc

ent:            dw              next            ; 105
restart:        dw              forth           ; 107

upvoc:          dw              end_label       ; 109
lastword:       dw              udm__           ; 10B

up2:            dw              0               ; 10D
last2:          dw              0               ; 10F

st_size:        dw              1024            ; 111 Stack size in bytes
rs_size:        dw              128             ; 113 Return stack size
m_size:         dw              65535           ; 115 Dynamic memory size

base:           dw              10              ; 117
state:          dw              0               ; 119
span:           dw              0               ; 11B
dpl:            dw              0               ; 11D

s0:             dw              ?               ; 11F
r0:             dw              ?               ; 121

tibadr:         dw              128             ; 123
maxpos:         dw              0               ; 125
inpos:          dw              0               ; 127

maxchar:        dw              0               ; 129

errcode:        dw              0               ; 12B
system:         dw              0               ; 12D

x1:             db              0               ; 12F
y1:             db              0               ; 130
x2:             db              79              ; 131
y2:             db              24              ; 132
curattr:        db              7               ; 133
cursortype:     db              3               ; 134
drivetype:      db              0               ; 135
cursorattr:     db              67h             ; 136
undercursor:    db              0               ; 137
vram:           dw              0b800h          ; 138
ss0:            dw              0               ; 13A
ssp:            dw              0               ; 13C
ss_size:        dw              5000            ; 13E - Screen stack size
crx:            db              0               ; 140 - Cursor X
cry:            db              0               ; 141 - Cursor Y
port:           dw              3dah            ; 142

debug:          dw              0               ; 144

stack_seg:      dw              0               ; 146

regpnt:         dw              0               ; 148

time_x:         dw              0               ; 14a
time_y:         dw              0               ; 14c
time_z:         dw              0               ; 14e
time_t:         dw              0               ; 150

messages:       dw              0ffffh          ; 152

err_bp_:        dw              0               ; 154
err_sp_:        dw              0               ; 156
err_si_:        dw              0               ; 158

active_task:    dw              ?               ; 15A
task_list:      dw              ?               ; 15C
calls_left:     dw              ?               ; 15E
ticks_left:     dw              ?               ; 160

xoverlay:       dw              0               ; 162

link_si:
charcount:      db              0
signflag:       db              0
link_bp:        dw              0

wcount:         dw              0
tseg:           dw              0

comp_seg:       dw              0

bufpnt:         dw              0
bufseg:         dw              0
maxbuf:         dw              0
handle:         dw              0
lines:          dw              0

jmp_far_:       mov             bx,word ptr [regpnt]
                jmp             dword ptr [bx+38]

forth_call_:    do
first_:         dw              _exit
second_:        dw              _exit

no_mem_text:    db              13,10,'Out of memory',13,10,'$'

error:          mov             bp,word ptr cs:[err_bp_]
                mov             sp,word ptr cs:[err_sp_]
                mov             si,word ptr cs:[err_si_]
error__:        cmp             word ptr [system],0
                jz              do_error_
                jmp             word ptr [system]
                do_error_:
                jmp             word ptr [ent]
no_forth_mem:   push            cs
                pop             ds
                mov             dx,offset no_mem_text
                mov             ah,9
                int             21h
                cmp             word ptr [system],0
                jz              bye
                jmp             word ptr [ent]
bye:            push            cs
                pop             ds
                push            cs
                pop             es
                mov             ah,4ch
                int             21h

putchar:        mov             dl,al
                mov             ah,2
                push            bp
                push            si
                int             21h
                pop             si
                pop             bp
                ret

getchar:        mov             ah,8
                push            bp
                push            si
                int             21h
                pop             si
                pop             bp
                ret

getstat:        mov             ah,6
                mov             dl,0ffh
                push            bp
                push            si
                int             21h
                pop             si
                pop             bp
                ret

start:          mov             ax,cs
                mov             ds,ax
                mov             ax,word ptr [upvoc]
                mov             word ptr [up2],ax
                mov             ax,word ptr [lastword]
                mov             word ptr [last2],ax
                call            install
                jnc             inst_ok
                mov             word ptr [system],0
                jmp             no_forth_mem
                inst_ok:
                mov             sp,word ptr [s0]
                mov             bp,word ptr [r0]
                mov             ss,word ptr [stack_seg]
                mov             word ptr [state],0
                mov             word ptr [base],10
                mov             word ptr [tibadr],129
                mov             al,byte ptr ds:[128]
                mov             ah,0
                mov             word ptr[maxpos],ax
                mov             word ptr [inpos],0
                sti
                jmp             word ptr [restart]

install:        ; Sets a folowing varables:
                ; stack_seg, regpnt, s0, r0, ss0, ssp=ss0
                ; es=cs
                ; Corrects forth memory block size
                ; Returns DX=forth mem block size in paragraphs
                ; Returns CF=1 if not enough memory
                mov             ax,word ptr [m_size]
                cmp             ax,65535
                jz              no_add_up
                add             ax,word ptr [upvoc]
                jc              inst_err
                no_add_up:
                mov             word ptr [regpnt],ax
                mov             cl,4
                shr             ax,cl
                inc             ax      ; *********** add ax,8
                mov             bx,cs
                mov             es,bx
                push            ax
                add             bx,ax
                mov             word ptr [stack_seg],bx
                pop             bx
                mov             ax,word ptr [ss_size]
                mov             word ptr [ss0],ax
                mov             word ptr [ssp],ax
                add             ax,word ptr [st_size]
                jc              inst_err
                mov             word ptr [s0],ax
                cmp             word ptr [rs_size],ax
                jz              set_ret_all_
                add             ax,word ptr [rs_size]
                jc              inst_err
                set_r0:
                mov             word ptr [r0],ax
                mov             cl,4
                shr             ax,cl
                add             bx,ax
                inc             bx      ; ************ add bx,8
                push            bx
                mov             ah,4ah
                int             21h
                pop             dx
                jc              inst_err
inst_err:       ret
                set_ret_all_:
                mov             ax,65535
                jmp             set_r0

doesadr:        dw              0

callr:          dec             bp
                dec             bp
                mov             word ptr [bp],si
                pop             si

next:           cld
                lodsw
                jmp             ax

; *****************************************************************************

mess_table_:
                dw              err0
                dw              err1
                dw              err2
                dw              err3
                dw              err4
                dw              err5
                dw              err6
                dw              err7
                dw              err8
                dw              err9
                dw              err10
                dw              err11
                dw              err12
                dw              err13
                dw              err14
                dw              err15
                dw              err16
                dw              err17
                dw              err18
                dw              err19
                dw              err20
                dw              err21
                dw              err22
                dw              err23
                dw              err24

err0:           db              'Division by zero',13,10,0
err1:           db              'Invalid number or syntax error',13,10,0
err2:           db              'Stack underflow',13,10,0
err3:           db              'Wrong use of control construction',13,10,0
err4:           db              'Stack error',13,10,0
err5:           db              'This word requared EXECUTION mode',13,10,0
err6:           db              'This word requared COMPILATION mode',13,10,0
err7:           db              'No word to define',13,10,0
err8:           db              'Overflow: number too large',13,10,0
err9:           db              'Not enough memory',13,10,0
err10:          db              'Missing file name',13,10,0
err11:          db              'The code is corrupted',13,10,0
err12:          db              'Disk or directory full',13,10,0
err13:          db              'Missing decimal point',13,10,0
err14:          db              'Cannot read library',13,10,0
err15:          db              'Invalid library format',13,10,0
err16:          db              'Non-compartable compiler version',13,10,0
err17:          db              'Cannot make empty unit',13,10,0
err18:          db              'Wrong use of long number',13,10,0
err19:          db              'Cannot RENAME. Lengths of words are not equal',13,10,0
err20:          db              'Cannot compile',13,10,0
err21:          db              'File not found',13,10,0
err22:          db              'You try to use corrupted compiler',13,10,0
err23:          db              'File read error',13,10,0
err24:          db              'Cannot decompile Non-Forth word',13,10,0

; *****************************************************************************
blstr:          db              1,' '

int_20:         mov             es,word ptr cs:[bufseg]
                mov             ah,49h
                int             21h
                mov             dx,word ptr cs:[rip20]
                mov             ds,word ptr cs:[rcs20]
                mov             ax,2520h
                int             21h
                push            cs
                pop             ds
                push            cs
                pop             es
                db              0eah
                rip20:          dw              0
                rcs20:          dw              0

ctrlbreak:      iret

text:           db              13,10
                db              '             Forth compiler   Version 94.7'
                db              13,10
cpr:            db              'Copyright (C), 1990-94 by The '
passtext:       db              'Golden Porcupine Software'
passlen         equ             25
                db              13,10,'                  * * * * * * * * * *',13,10,13,10,'$'
usage:          db              'Usage : forth filename.ext',13,10,'$'
cant_open_com:  db              'Cannot open source file :$'
text_fm:        db              'Not enough memory to process'
cret_text:      db              13,10,'$'
text_proc:      db              'Processing file :$'
cant_loc:       db              'Cannot locate file : $'
no_date_text:   db              'Invalid file : $'

file1:          db              'FRLVIEW.COM',0,'$'
file2:          db              'CRT.FRL',0,'$'
file3:          db              'DOS.FRL',0,'$'
file4:          db              'GRAPH.FRL',0,'$'
file5:          db              'MUSIC.FRL',0,'$'
file6:          db              'MOUSE.FRL',0,'$'
file7:          db              'RANDOM.FRL',0,'$'
file8:          db              'FORTH.DOC',0,'$'
file9:          db              'FORTHASM.INC',0,'$'
file10:         db              'FS.FRT',0,'$'
file11:         db              'KBDCODES.FRL',0,'$'
file12:         db              'OPT.COM',0,'$'
file13:         db              '256.COM',0,'$'
file14:         db              '256COLOR.FRL',0,'$'
file15:         db              'QUATTRO.FRL',0,'$'
file16:         db              '4TH.COM',0,'$'
file17:         db              'MTASK.FRL',0,'$'
file18:         db              'PAS.COM',0,'$'
file19:         db              'PAS.DOC',0,'$'
file20:         db              'PC.BAT',0,'$'
file21:         db              'FLOAT87.FRL',0,'$'

test_4_exists:  push            dx
                mov             si,word ptr [upvoc]
                cld
                chk_1:
                lodsb
                cmp             al,0
                jnz             chk_1
                std
                chk_2:
                lodsb
                cmp             al,':'
                jz              chk_3
                cmp             al,'\'
                jz              chk_3
                cmp             si,word ptr [upvoc]
                jnc             chk_2
                chk_3:
                cld
                inc             si
                inc             si
                mov             di,si
                push            cs
                pop             es
                mov             si,dx
                chk_4:
                lodsb
                stosb
                cmp             al,0
                jnz             chk_4

                mov             dx,word ptr [upvoc]
                mov             cx,39
                mov             ah,4eh
                int             21h

                pop             dx
;                jc              exit_444

;                push            ax
;                push            bx
;                push            ds

;                push            cs
;                pop             ds
;                mov             ax,word ptr cs:[time_t]
;                mov             bx,word ptr [upvoc]

;                cmp             ax,word ptr [bx+224]
;                jz              date_ok_co
;                or              ax,ax
;                jnz             no_date_co
;                mov             ax,word ptr [bx+224]
;                mov             word ptr cs:[time_t],ax

;                date_ok_co:
;                pop             ds
;                pop             bx
;                pop             ax

                exit_444:
                ret

                no_date_co:

                push            dx
                mov             dx,offset no_date_text
                mov             ah,9
                int             21h
                pop             dx
                mov             ah,9
                int             21h
                mov             dx,offset cret_text
                mov             ah,9
                int             21h
                int             20h

forth:          push            bp

                mov             ah,1ah
                mov             dx,word ptr [upvoc]
                add             dx,200
                int             21h

                mov             ds,word ptr ds:[2ch]
                xor             si,si
                mov             cx,32767
                env_search:
                lodsw
                cmp             ax,0
                jz              zero_found
                dec             si
                loop            short env_search
                jmp             no_test
                zero_found:
                lodsw
                cmp             ax,1
                jz              one_found
                jmp             no_test
                one_found:
                push            cs
                pop             es
                cld
                mov             di,word ptr cs:[upvoc]
                env_1:
                lodsb
                stosb
                or              al,al
                jnz             env_1
                push            cs
                pop             ds
                jmp             short env_2

                no_exists:
                push            dx
                mov             dx,offset cant_loc
                mov             ah,9
                int             21h
                pop             dx
                mov             ah,9
                int             21h
                mov             dx,offset cret_text
                mov             ah,9
                int             21h
                int             20h

                env_2:
                mov             word ptr cs:[time_t],0
                mov             dx,offset file1
                call            test_4_exists
                jc              no_exists
                mov             dx,offset file2
                call            test_4_exists
                jc              no_exists
                mov             dx,offset file3
                call            test_4_exists
                jc              no_exists
                mov             dx,offset file4
                call            test_4_exists
                jc              no_exists
                mov             dx,offset file5
                call            test_4_exists
                jc              no_exists
                mov             dx,offset file6
                call            test_4_exists
                jc              no_exists
                mov             dx,offset file7
                call            test_4_exists
                jc              no_exists
                mov             dx,offset file8
                call            test_4_exists
                jc              no_exists
                mov             dx,offset file9
                call            test_4_exists
                jc              no_exists
                mov             dx,offset file10
                call            test_4_exists
                jc              no_exists
                mov             dx,offset file11
                call            test_4_exists
                jc              no_exists
                mov             dx,offset file12
                call            test_4_exists
                jc              no_exists
                mov             dx,offset file13
                call            test_4_exists
                jnc             ex13___
                jmp             no_exists
                ex13___:
                mov             dx,offset file14
                call            test_4_exists
                jnc             ex14___
                jmp             no_exists
                ex14___:
                mov             dx,offset file15
                call            test_4_exists
                jnc             ex15___
                jmp             no_exists
                ex15___:
                mov             dx,offset file16
                call            test_4_exists
                jnc             ex16___
                jmp             no_exists
                ex16___:
                mov             dx,offset file17
                call            test_4_exists
                jnc             ex17___
                jmp             no_exists
                ex17___:
                mov             dx,offset file18
                call            test_4_exists
                jnc             ex18___
                jmp             no_exists
                ex18___:
                mov             dx,offset file19
                call            test_4_exists
                jnc             ex19___
                jmp             no_exists
                ex19___:
                mov             dx,offset file20
                call            test_4_exists
                jnc             ex20___
                jmp             no_exists
                ex20___:
                mov             dx,offset file21
                call            test_4_exists
                jnc             ex21___
                jmp             no_exists
                ex21___:

                no_test:
                push            cs
                pop             ds

                mov             dx,offset text
                mov             ah,9
                int             21h
                mov             word ptr [restart],offset f0001
                mov             bx,128
                cmp             byte ptr [bx],0
                jnz             file_present_com
                mov             dx,offset usage
                mov             ah,9
                int             21h
                jmp             bye
                file_present_com:
                mov             al,byte ptr [bx]
                mov             ah,0
                inc             ax
                add             bx,ax
                mov             byte ptr [bx],0
                mov             byte ptr [bx+1],13
                mov             byte ptr [bx+2],10
                mov             byte ptr [bx+3],'$'
                mov             bx,128
                skip_sp:
                inc             bx
                cmp             byte ptr [bx],' '
                jz              skip_sp
                mov             dx,bx
                mov             ax,3d00h
                int             21h
                jnc             file_com_ok
                mov             dx,offset cant_open_com
                mov             ah,9
                int             21h
                mov             dx,129
                mov             ah,9
                int             21h
                jmp             bye
                file_com_ok:
                mov             word ptr [handle],ax
                mov             bx,301h
                mov             ah,48h
                int             21h

                mov             bx,101h
                mov             ah,48h
                int             21h
                jnc             ok_file_mem
                out_of_memory:
                mov             ah,9
                mov             dx,offset text_fm
                int             21h
                jmp             bye
                ok_file_mem:
                mov             word ptr [bufseg],ax
                mov             word ptr [maxbuf],4096
                mov             word ptr [bufpnt],4096
                mov             ax,3520h
                int             21h
                mov             word ptr [rip20],bx
                mov             word ptr [rcs20],es
                mov             dx,offset int_20
                mov             ax,2520h
                int             21h
                mov             dx,offset ctrlbreak
                mov             ax,2523h
                int             21h
                mov             dx,offset text_proc
                mov             ah,9
                int             21h
                mov             dx,129
                mov             ah,9
                int             21h
                mov             word ptr [lines],0
                pop             bp

f0001:          do
f0001a:         dw              _number
                dw              maxbuf
                dw              _raz
                dw              _number
                dw              5000
                dw              _equal
                dw              _fbranch
                dj              fx_01
                dw              _typeasc22
                db              13,10,'Compilation complete',13,10,0
                dw              _bye
                fx_01:
                dw              _number
                dw              lines
                dw              _raz
                dw              _number
                dw              16
                dw              _mod
                dw              _eq0
                dw              _fbranch
                dj              no_out_line_n_

                dw              _number
                dw              lines
                dw              _raz
                dw              _wprn

                dw              _typeasc
                db              ' Line(s) processed',13,0

                no_out_line_n_:
                dw              _getstring
                dw              _number
                dw              lines
                dw              _prisv_p1
                dw              _interpret
                dw              _branch
                dj              f0001a


emit_:          db              4,'EMIT',0
                dw              0
                _emit:
                pop             ax
                mov             dx,offset putchar
                call            dx
                jmp             word ptr [ent]

emit22_:        db              5,'EEMIT',0
                dk              emit_
                _emit22:
                pop             ax
                mov             dx,offset putchar
                call            dx
                jmp             word ptr [ent]

query_:         db              5,'QUERY',0
                dk              emit22_
                _getstring:
                mov             di,word ptr [bufpnt]
                mov             es,word ptr [bufseg]
                mov             bx,128
                xor             cx,cx
                getstr:
                cmp             di,word ptr [maxbuf]
                jnz             getc1
                cmp             di,4096
                jz              read_block
                final:
                push            bx
                push            cx
                mov             bx,word ptr [handle]
                mov             ah,3eh
                push            bp
                push            si
                int             21h
                pop             si
                pop             bp
                pop             cx
                pop             bx
                mov             word ptr [maxbuf],5000
                end_get:
                mov             byte ptr [bx],0
                mov             word ptr [bufpnt],di

                mov             word ptr [maxpos],cx
                mov             word ptr [inpos],0
                mov             word ptr [tibadr],128

                jmp             word ptr [ent]
                getc1:
                mov             al,byte ptr es:[di]
                inc             di
                cmp             al,10
                jz              getstr
                cmp             al,13
                jz              end_get
                cmp             al,1ah
                jz              end_get
                cmp             al,9
                jnz             no_tab
                mov             al,' '
                no_tab:
                inc             cx
                mov             byte ptr [bx],al
                inc             bx
                cmp             cx,126
                jz              end_get
                jmp             getstr
                read_block:
                mov             ah,3fh
                push            bx
                push            cx
                mov             bx,word ptr [handle]
                mov             cx,4096
                xor             dx,dx
                push            es
                pop             ds
                push            bp
                push            si
                int             21h
                pop             si
                pop             bp
                pop             cx
                pop             bx
                push            cs
                pop             ds
                mov             word ptr [maxbuf],ax
                xor             di,di
                jmp             getstr


wprn_:          db              1,' ',1
                dk              query_
                _wprn:
                do
                dw              _number
                dw              10000
                dw              _div_mod
                dw              _number
                dw              48
                dw              _plus
                dw              _emit

                dw              _number
                dw              1000
                dw              _div_mod
                dw              _number
                dw              48
                dw              _plus
                dw              _emit

                dw              _number
                dw              100
                dw              _div_mod
                dw              _number
                dw              48
                dw              _plus
                dw              _emit

                dw              _number
                dw              10
                dw              _div_mod
                dw              _number
                dw              48
                dw              _plus
                dw              _emit

                dw              _number
                dw              48
                dw              _plus
                dw              _emit

                dw              _exit

key_:
                db              3,'KEY',0
                dk              wprn_
                _key:
                mov             bx,offset getchar
                call            bx
                mov             ah,0
                push            ax
                jmp             word ptr [ent]
stod_:
                db              3,'S>D',0
                dk              key_
                _stod:
                pop             ax
                cwd
                push            ax
                push            dx
                jmp             word ptr [ent]

exit_:
                db              4,'EXIT',0
                dk              stod_
                _exit:
                mov             si,word ptr [bp]
                inc             bp
                inc             bp
                jmp             word ptr [ent]

branch_:
                db              6,'BRANCH',0+14
                dk              exit_
                _branch:
                lodsw
                add             si,ax
                jmp             word ptr [ent]

fbranch_:
                db              7,'?BRANCH',0+14
                dk              branch_
                _fbranch:
                lodsw
                pop             bx
                or              bh,bl
                jnz             nobr_false
                add             si,ax
                nobr_false:
                jmp             word ptr [ent]

typeasc_:       db              9,'(.ASCIIZ)',1+8
                dk              fbranch_
                _typeasc:
                do
                tpasc:
                dw              _rraz
                dw              _craz
                dw              _frr
                dw              _plus_1
                dw              _tor
                dw              _dup
                dw              _fbranch
                dj              ex_tpasc
                dw              _emit
                dw              _branch
                dj              tpasc
                ex_tpasc:
                dw              _drop
                dw              _exit

typeasc22_:     db              1,' ',1+8
                dk              typeasc_
                _typeasc22:
                do
                tpasc22:
                dw              _rraz
                dw              _craz
                dw              _frr
                dw              _plus_1
                dw              _tor
                dw              _dup
                dw              _fbranch
                dj              ex_tpasc22
                dw              _emit22
                dw              _branch
                dj              tpasc22
                ex_tpasc22:
                dw              _drop
                dw              _exit

typeasc222_:    db              6,'EPRINT',1
                dk              typeasc22_
                _typeasc222:
                do
                tpasc222:
                dw              _dup
                dw              _craz
                dw              _dup
                dw              _fbranch
                dj              ex_tpasc222
                dw              _emit22
                dw              _plus_1
                dw              _branch
                dj              tpasc222
                ex_tpasc222:
                dw              _drop
                dw              _drop
                dw              _exit

expect_:
                db              6,'EXPECT',0
                dk              typeasc222_
                _expect:
                pop             cx
                pop             bx
                push            bp
                push            si

                getstring:
                xor             di,di
                getstr1:
                push            bx
                push            cx
                push            di
                mov             dx,offset getchar
                call            dx
                pop             di
                pop             cx
                pop             bx
                cmp             al,13
                jnz             getstr_no13
                cr_get_all:
                pop             si
                pop             bp
                mov             word ptr [span],di
                jmp             word ptr [ent]
                getstr_no13:
                cmp             al,10
                jz              cr_get_all
                cmp             al,8
                jnz             getstr_no8
                cmp             di,0
                jz              getstr_err
                dec             bx
                dec             di
                push            bx
                push            di
                push            cx
                mov             dx,offset putchar
                push            dx
                call            dx
                pop             dx
                mov             al,' '
                call            dx
                mov             al,8
                getstr_put:
                mov             dx,offset putchar
                call            dx
                pop             cx
                pop             di
                pop             bx
                jmp             getstr1
                getstr_no8:
                cmp             cx,di
                jz              getstr_err
                mov             byte ptr [bx],al
                inc             bx
                inc             di
                getstr_chr:
                push            bx
                push            di
                push            cx
                jmp             getstr_put
                getstr_err:
                push            bx
                push            di
                push            cx
                mov             al,7
                jmp             getstr_put

plus_:
                db              1,'+',0
                dk              expect_
                _plus:
                pop             ax
                pop             bx
                add             ax,bx
                push            ax
                jmp             word ptr [ent]

mines_:
                db              1,'-',0
                dk              plus_
                _mines:
                pop             bx
                pop             ax
                sub             ax,bx
                push            ax
                jmp             word ptr [ent]

true_:
                db              4,'TRUE',0
                dk              mines_
                _true:
                mov             ax,0ffffh
                push            ax
                jmp             word ptr [ent]

false_:
                db              5,'FALSE',0
                dk              true_
                _false:
                xor             ax,ax
                push            ax
                jmp             word ptr [ent]

min_:
                db              4,'UMIN',0
                dk              false_
                _min:
                pop             ax
                pop             bx
                cmp             ax,bx
                jc              axmin
                push            bx
                jmp             word ptr [ent]
                axmin:
                push            ax
                jmp             word ptr [ent]

max_:
                db              4,'UMAX',0
                dk              min_
                _max:
                pop             ax
                pop             bx
                cmp             bx,ax
                jc              axmax
                push            bx
                jmp             word ptr [ent]
                axmax:
                push            ax
                jmp             word ptr [ent]

equal_:
                db              1,'=',0
                dk              max_
                _equal:
                pop             ax
                pop             bx
                cmp             ax,bx
                jz              eqok
                xor             ax,ax
                push            ax
                jmp             word ptr [ent]
                eqok:
                mov             ax,0ffffh
                push            ax
                jmp             word ptr [ent]

men0_:
                db              2,'0<',0
                dk              equal_
                _men0:
                pop             ax
                test            ah,128
                jz              nomen0
                mov             ax,0ffffh
                push            ax
                jmp             word ptr [ent]
                nomen0:
                xor             ax,ax
                push            ax
                jmp             word ptr [ent]

bol0_:
                db              2,'0>',0
                dk              men0_
                _bol0:
                pop             ax
                test            ah,128
                jnz             nobol0
                cmp             ax,0
                jz              nobol0
                mov             ax,0ffffh
                push            ax
                jmp             word ptr [ent]
                nobol0:
                xor             ax,ax
                push            ax
                jmp             word ptr [ent]

eq0_:
                db              2,'0=',0
                dk              bol0_
                _eq0:
                pop             ax
                or              ah,al
                jnz             noeq0
                mov             ax,0ffffh
                push            ax
                jmp             word ptr [ent]
                noeq0:
                xor             ax,ax
                push            ax
                jmp             word ptr [ent]

men_:
                db              1,'<',1
                dk              eq0_
                _men:
                do
                dw              _mines
                dw              _men0
                dw              _exit

bol_:
                db              1,'>',1
                dk              men_
                _bol:
                do
                dw              _mines
                dw              _bol0
                dw              _exit

umen_:          db              2,'U<',0
                dk              bol_
                _umen:
                pop             ax
                pop             bx
                cmp             bx,ax
                jc              um_pushtr
                xor             ax,ax
                um_exit_:
                push            ax
                jmp             word ptr [ent]
                um_pushtr:
                mov             ax,0ffffh
                jmp             short um_exit_


ubol_:          db              2,'U>',0
                dk              umen_
                _ubol:
                pop             ax
                pop             bx
                cmp             bx,ax
                ja              ub_pushtr
                xor             ax,ax
                ub_exit_:
                push            ax
                jmp             word ptr [ent]
                ub_pushtr:
                mov             ax,0ffffh
                jmp             short ub_exit_

here_:
                db              4,'HERE',0
                dk              ubol_
                _here:
                push            word ptr [upvoc]
                jmp             word ptr [ent]

allot_:
                db              5,'ALLOT',0
                dk              here_
                _allot:
                pop             cx
;                mov             di,word ptr [upvoc]
;                push            cs
;                pop             es
;                xor             al,al
                add             word ptr [upvoc],cx
;                rep             stosb
                jmp             word ptr [ent]

raz_:
                db              1,'@',0
                dk              allot_
                _raz:
                pop             bx
                push            word ptr [bx]
                jmp             word ptr [ent]

craz_:
                db              2,'C@',0
                dk              raz_
                _craz:
                pop             bx
                mov             al,byte ptr [bx]
                mov             ah,0
                push            ax
                jmp             word ptr [ent]

prisv_:
                db              1,'!',0
                dk              craz_
                _prisv:
                pop             bx
                pop             word ptr [bx]
                jmp             word ptr [ent]

cprisv_:
                db              2,'C!',0
                dk              prisv_
                _cprisv:
                pop             bx
                pop             ax
                mov             byte ptr [bx],al
                jmp             word ptr [ent]

number_:
                db              3,'LIT',0+2
                dk              cprisv_
                _number:
                lodsw
                push            ax
                jmp             word ptr [ent]

number2_:
                db              4,'DLIT',0+4
                dk              number_
                _number2:
                lodsw
                mov             bx,ax
                lodsw
                push            ax
                push            bx
                jmp             word ptr [ent]

dup_:
                db              3,'DUP',0
                dk              number2_
                _dup:
                pop             ax
                push            ax
                push            ax
                jmp             word ptr [ent]

drop_:
                db              4,'DROP',0
                dk              dup_
                _drop:
                pop             ax
                jmp             word ptr [ent]

swap_:
                db              4,'SWAP',0
                dk              drop_
                _swap:
                pop             ax
                pop             bx
                push            ax
                push            bx
                jmp             word ptr [ent]

over_:
                db              4,'OVER',0
                dk              swap_
                _over:
                pop             ax
                pop             bx
                push            bx
                push            ax
                push            bx
                jmp             word ptr [ent]

press_:
                db              5,'PRESS',0
                dk              over_
                _press:
                pop             ax
                pop             bx
                push            ax
                jmp             word ptr [ent]

rot_:
                db              3,'ROT',0
                dk              press_
                _rot:
                pop             ax
                pop             bx
                pop             cx
                push            bx
                push            ax
                push            cx
                jmp             word ptr [ent]

dup2_:
                db              4,'2DUP',0
                dk              rot_
                _dup2:
                pop             ax
                pop             bx
                push            bx
                push            ax
                push            bx
                push            ax
                jmp             word ptr [ent]

drop2_:
                db              5,'2DROP',0
                dk              dup2_
                _drop2:
                pop             ax
                pop             ax
                jmp             word ptr [ent]

swap2_:
                db              5,'2SWAP',0
                dk              drop2_
                _swap2:
                pop             ax
                pop             bx
                pop             cx
                pop             dx
                push            bx
                push            ax
                push            dx
                push            cx
                jmp             word ptr [ent]

over2_:
                db              5,'2OVER',0
                dk              swap2_
                _over2:
                pop             ax
                pop             bx
                pop             cx
                pop             dx
                push            dx
                push            cx
                push            bx
                push            ax
                push            dx
                push            cx
                jmp             word ptr [ent]

press2_:
                db              6,'2PRESS',0
                dk              over2_
                _press2:
                pop             ax
                pop             bx
                pop             cx
                pop             cx
                push            bx
                push            ax
                jmp             word ptr [ent]

mult_:
                db              1,'*',0
                dk              press2_
                _mult:
                pop             ax
                pop             cx
                imul            cx
                push            ax
                jmp             word ptr [ent]

mmult_:
                db              2,'M*',0
                dk              mult_
                _mmult:
                pop             ax
                pop             cx
                imul            cx
                push            ax
                push            dx
                jmp             word ptr [ent]

div_:
                db              1,'/',0
                dk              mmult_
                _div:
                pop             bx
                pop             ax
                cwd
                cmp             bx,0
                jz              div_zero_1
                idiv            bx
                push            ax
                jmp             word ptr [ent]
                div_zero_1:
                mov             word ptr [errcode],0
                mov             ax,offset error__
                jmp             ax

mod_:
                db              3,'MOD',0
                dk              div_
                _mod:
                pop             bx
                pop             ax
                cwd
                cmp             bx,0
                jz              div_zero_2
                idiv            bx
                push            dx
                jmp             word ptr [ent]
                div_zero_2:
                mov             word ptr [errcode],0
                mov             ax,offset error__
                jmp             ax

tor_:
                db              2,'>R',0
                dk              mod_
                _tor:
                dec             bp
                dec             bp
                pop             word ptr [bp]
                jmp             word ptr [ent]

frr_:
                db              2,'R>',0
                dk              tor_
                _frr:
                push            word ptr [bp]
                inc             bp
                inc             bp
                jmp             word ptr [ent]

rraz_:
                db              2,'R@',0
                dk              frr_
                _rraz:
                push            word ptr [bp]
                jmp             word ptr [ent]

base_:
                db              4,'BASE',0
                dk              rraz_
                _base:
                mov             bx,offset base
                push            bx
                jmp             word ptr [ent]

state_:
                db              5,'STATE',0
                dk              base_
                _state:
                mov             ax,offset state
                push            ax
                jmp             word ptr [ent]

span_:
                db              4,'SPAN',0
                dk              state_
                _span:
                mov             bx,offset span
                push            bx
                jmp             word ptr [ent]

negate_:
                db              6,'NEGATE',0
                dk              span_
                _negate:
                pop             ax
                neg             ax
                push            ax
                jmp             word ptr [ent]

not_:
                db              3,'NOT',0
                dk              negate_
                _not:
                pop             ax
                not             ax
                push            ax
                jmp             word ptr [ent]

abs_:
                db              3,'ABS',1
                dk              not_
                _abs:
                do
                dw              _dup
                dw              _men0
                dw              _fbranch
                dj              abs0
                dw              _negate
                abs0:
                dw              _exit

and_:
                db              3,'AND',0
                dk              abs_
                _and:
                pop             ax
                pop             bx
                and             ax,bx
                push            ax
                jmp             word ptr [ent]

or_:
                db              2,'OR',0
                dk              and_
                _or:
                pop             ax
                pop             bx
                or              ax,bx
                push            ax
                jmp             word ptr [ent]

xor_:
                db              3,'XOR',0
                dk              or_
                _xor:
                pop             ax
                pop             bx
                xor             ax,bx
                push            ax
                jmp             word ptr [ent]

word_:
                db              4,'WORD',0
                dk              xor_
                _word:
                pop             ax
                mov             ah,al
                mov             di,word ptr [upvoc]
                add             di,256
                push            di
                push            si

                push            cs
                pop             es
                mov             bx,di
                cld
                mov             si,word ptr cs:[tibadr]
                mov             dx,word ptr cs:[inpos]
                add             si,dx
                mov             cl,0
                fw3:
                cmp             dx,word ptr cs:[maxpos]
                jz              wrdend
                lodsb
                inc             dx
                cmp             ah,al
                jz              fw3
                fw4:
                inc             di
                mov             byte ptr cs:[di],al
                inc             cl
                cmp             dx,word ptr cs:[maxpos]
                jz              wrdend
                inc             dx
                lodsb
                cmp             ah,al
                jnz             fw4
                wrdend:
                mov             word ptr cs:[inpos],dx
                mov             byte ptr cs:[bx],cl

                pop             si
                jmp             word ptr [ent]

find_:
                db              4,'FIND',0
                dk              word_
                _find:
                pop             di

                push            di
                push            cs
                pop             es
                call            find_next
                cmp             ax,0
                jnz             word_found
                pop             di
                push            di
                mov             cl,byte ptr [di]
                w_toup:
                inc             di
                cmp             cl,0
                jz              wend_toup
                dec             cl
                mov             al,byte ptr [di]
                cmp             al,'a'
                jc              w_toup
                cmp             al,'z'
                ja              w_toup
                and             byte ptr [di],5fh
                jmp             w_toup
                wend_toup:
                pop             di
                push            di
                call            find_next
                cmp             ax,0
                jnz             word_found
                push            ax
                jmp             word ptr [ent]
                find_next:
                push            si
                mov             si,word ptr [lastword]
                cmp             word ptr [state],0
                jz              no_skip_first
                push            ax
                lodsb
                mov             ah,0
                add             si,ax
                inc             si
                lodsw
                add             si,ax
                pop             ax
                no_skip_first:
                word_find_0:
                mov             cl,byte ptr [si]
                mov             ch,0
                inc             cx
                push            di
                push            si
                repe            cmpsb
                pop             si
                pop             di
                jnz             word_find_1
                lodsb
                mov             ah,0
                add             ax,si
                add             ax,3
                mov             si,ax
                pop             si
                ret
                word_find_1:
                lodsb
                mov             ah,0
                add             si,ax
                inc             si
                lodsw
                cmp             ax,0
                jz              word_find_end
                add             si,ax
                jmp             word_find_0
                word_find_end:
                pop             si
                ret
                word_found:
                pop             di
                push            ax
                mov             bx,ax
                sub             bx,3
                test            byte ptr [bx],128
                jnz             immed_found
                mov             ax,0ffffh
                push            ax
                jmp             word ptr [ent]
                immed_found:
                mov             ax,1
                push            ax
                jmp             word ptr [ent]

type_:
                db              4,'TYPE',1
                dk              find_
                _type:
                do
                dw              _dup
                dw              _eq0
                dw              _fbranch
                dj              no_zero_type
                dw              _drop2
                dw              _exit
                no_zero_type:
                dw              _false
                dw              _do_x
                dw              0
                type_loop:
                dw              _dup
                dw              _i
                dw              _plus
                dw              _craz
                dw              _emit
                dw              _loop_x
                dj              type_loop
                dw              _drop
                dw              _exit

count_:
                db              5,'COUNT',0
                dk              type_
                _count:
                pop             bx
                mov             al,byte ptr [bx]
                mov             ah,0
                inc             bx
                push            bx
                push            ax
                jmp             word ptr [ent]

print_:
                db              5,'PRINT',1
                dk              count_
                _print:
                do
                dw              _count
                dw              _type
                dw              _exit

bl_:
                db              2,'BL',0
                dk              print_
                _bl:
                mov             ax,32
                push            ax
                jmp             word ptr [ent]

cr_:
                db              2,'CR',1
                dk              bl_
                _cr:
                do
                dw              _typeasc
                db              13,10,0
                dw              _exit

comp_:
                db              1,',',1
                dk              cr_
                _comp:
                do
                dw              _here
                dw              _prisv
                dw              _number
                dw              2
                dw              _allot
                dw              _exit

ccomp_:
                db              2,'C,',1
                dk              comp_
                _ccomp:
                do
                dw              _here
                dw              _cprisv
                dw              _number
                dw              1
                dw              _allot
                dw              _exit

beep_:
                db              4,'BEEP',1
                dk              ccomp_
                _beep:
                do
                dw              _number
                dw              7
                dw              _emit
                dw              _exit

execute_:
                db              7,'EXECUTE',0
                dk              beep_
                _execute:
                pop             ax
                jmp             ax

interpret_:
                db              9,'INTERPRET',1
                dk              execute_
                _interpret:
                do
                int_001:
                dw              _bl
                dw              _word
                dw              _dup
                dw              _craz
                dw              _eq0
                dw              _fbranch
                dj              int_002
                dw              _drop
                dw              _exit
                int_002:
                dw              _find
                dw              _dup
                dw              _number
                dw              1
                dw              _equal
                dw              _fbranch
                dj              int_004
                dw              _drop
                int_003:
                dw              _execute
                dw              _iferror2
                dw              _branch
                dj              int_001
                int_004:
                dw              _fbranch
                dj              int_005
                dw              _state
                dw              _raz
                dw              _fbranch
                dj              int_003
                dw              _comp
                dw              _branch
                dj              int_001
                int_005:
                dw              _val
                dw              _fbranch
                dj              int_006
                dw              _state
                dw              _raz
                dw              _fbranch
                dj              int_007
                dw              _dpl
                dw              _raz
                dw              _plus_1
                dw              _eq0
                dw              _fbranch
                dj              int_008
                dw              _putword
                dw              _number
                dw              _comp
                dw              _drop
                dw              _comp
                dw              _branch
                dj              int_001
                int_008:
                dw              _putword
                dw              _number2
                dw              _comp
                dw              _comp
                dw              _comp
                dw              _branch
                dj              int_001
                int_007:
                dw              _dpl
                dw              _raz
                dw              _true
                dw              _equal
                dw              _fbranch
                dj              int_001
                dw              _drop
                dw              _branch
                dj              int_001
                int_006:
                dw              _dup
                dw              _true
                dw              _equal
                dw              _fbranch
                dj              int_009
                dw              _number
                dw              2
                dw              _error
                dw              _exit
                int_009:
                dw              _dup
                dw              _number
                dw              0fffeh
                dw              _equal
                dw              _fbranch
                dj              int_010
                dw              _number
                dw              27
                dw              _error
                dw              _exit
                int_010:
                dw              _number
                dw              0fffdh
                dw              _equal
                dw              _fbranch
                dj              int_011
                dw              _number
                dw              13
                dw              _error
                dw              _exit
                int_011:
                dw              _number
                dw              1
                dw              _error
                dw              _exit

bye_:
                db              3,'BYE',0
                dk              interpret_
                _bye:
                mov             bx,offset bye
                jmp             bx
stc_:
                db              1,']',0
                dk              bye_
                _stc:
                mov             word ptr [state],0ffffh
                jmp             word ptr [ent]

ste_:
                db              1,'[',0+128
                dk              stc_
                _ste:
                mov             word ptr [state],0
                jmp             word ptr [ent]

hex_:
                db              3,'HEX',0
                dk              ste_
                _hex:
                mov             word ptr [base],16
                jmp             word ptr [ent]

decimal_:
                db              7,'DECIMAL',0
                dk              hex_
                _decimal:
                mov             word ptr [base],10
                jmp             word ptr [ent]

strcomp_:
                db              2,',"',0
                dk              decimal_
                _strcomp:
                pop             bx
                mov             di,word ptr [upvoc]
                cmp             byte ptr [bx],0
                jnz             st_comp_ok
                mov             al,0
                stosb
                inc             word ptr [upvoc]
                jmp             word ptr [ent]
                st_comp_ok:
                push            cs
                pop             es
                mov             cl,byte ptr [bx]
                mov             ch,0
                mov             byte ptr [di],cl
                mov             word ptr [time_x],di
                inc             di
                inc             bx
                mov             dl,0
                strcomp_0:
                mov             al,byte ptr [bx]
                call            strcomp_1
                inc             bx
                loop            strcomp_0
                mov             word ptr [upvoc],di
                jmp             word ptr [ent]
                strcomp_1:
                cmp             dl,0
                jnz             strcomp_2
                cmp             al,'\'
                jnz             strcomp_1a
                mov             dx,0ffh
                ret
                strcomp_1a:
                mov             byte ptr [di],al
                inc             di
                ret
                strcomp_2:
                push            di
                mov             di,word ptr [time_x]
                dec             byte ptr [di]
                pop             di
                mov             dl,0
                cmp             al,'\'
                jz              strcomp_1a
                mov             ah,al
                and             al,5fh
                cmp             al,'N'
                jnz             strcomp_no_n
                mov             al,10
                jmp             strcomp_1a
                strcomp_no_n:
                cmp             al,'R'
                jnz             strcomp_no_r
                mov             al,13
                jmp             strcomp_1a
                strcomp_no_r:
                cmp             al,'T'
                jnz             strcomp_no_t
                mov             al,9
                jmp             strcomp_1a
                strcomp_no_t:
                cmp             al,'B'
                jnz             strcomp_no_b
                mov             al,8
                jmp             strcomp_1a
                strcomp_no_b:
                cmp             al,'E'
                jnz             strcomp_no_esc
                mov             al,27
                jmp             strcomp_1a
                strcomp_no_esc:
                cmp             ah,';'
                jnz             strcomp_no_e
                mov             al,dh
                jmp             strcomp_1a
                strcomp_no_e:
                sub             ah,'0'
                push            ax
                mov             al,10
                mul             dh
                mov             dh,al
                pop             ax
                add             dh,ah
                mov             dl,0ffh
                ret

next_:
                db              4,'NEXT',0
                dk              strcomp_
                _next:
                mov             ax,offset next
                push            ax
                jmp             ax

empty_0_:
                db              1,' ',0
                dk              next_
                _empty_0:
                pop             bx
                pop             ax
                sub             ax,bx
                dec             ax
                dec             ax
                mov             word ptr [bx],ax
                jmp             word ptr [ent]

create_:
                db              6,'CREATE',1
                dk              empty_0_
                _create:
                do
                dw              _bl
                dw              _word
                dw              _dup
                dw              _craz
                dw              _fbranch
                dj              create_err
                dw              _here
                dw              _swap
                dw              _strcomp
                dw              _number
                dw              1
                dw              _ccomp

                dw              _number
                dw              lastword
                dw              _raz
                dw              _here
                dw              _false
                dw              _comp
                dw              _empty_0

                dw              _number
                dw              lastword
                dw              _prisv
                dw              _number

                dw              0e8h
                dw              _ccomp

                dw              _here
                dw              _number
                dw              doesadr
                dw              _prisv

                dw              _false
                dw              _comp

                dw              _next
                dw              _number
                dw              doesadr
                dw              _raz
                dw              _empty_0
                dw              _exit
                create_err:
                dw              _number
                dw              7
                dw              _number
                dw              errcode
                dw              _prisv
                dw              _abort

variable_:
                db              8,'VARIABLE',1
                dk              create_
                _variable:
                do
                dw              _create
                dw              _false
                dw              _comp
                dw              _exit

call_:
                db              4,'CALL',0
                dk              variable_
                _call:
                mov             ax,offset callr
                push            ax
                jmp             word ptr [ent]

define_:
                db              1,':',1+128
                dk              call_
                _define:
                do
                dw              _ifexec
                dw              _create
                dw              _call
                dw              _number
                dw              doesadr
                dw              _raz
                dw              _empty_0
                dw              _stc
                dw              _number
                dw              1239h
                dw              _exit

putword_:
                db              3,'[',27h,']',0
                dk              define_
                _putword:
                lodsw
                push            ax
                jmp             word ptr [ent]

enddef_:
                db              1,';',1+128
                dk              putword_
                _enddef:
                do
                dw              _ifcomp
                dw              _putword
                dw              _exit
                dw              _comp
                dw              _ste
                dw              _number
                dw              1239h
                dw              _ifpairs
                dw              _exit

val_:
                db              3,'VAL',0
                dk              enddef_
                _val:
                mov             word ptr [time_x],si
                pop             si
                push            si
                mov             cl,byte ptr [si]
                mov             ch,0
                inc             si
                cmp             cl,0
                jnz             no_err_nodef
                err_nodef:
                xor             ax,ax
                push            ax
                end_val:
                push            ax
                mov             si,word ptr [time_x]
                jmp             word ptr [ent]
                val_no_mines:
                cmp             byte ptr [si],'+'
                jz              val_plus
                jmp             short val_begin
                no_err_nodef:
                mov             byte ptr [signflag],0
                cmp             byte ptr [si],'-'
                jnz             val_no_mines
                mov             byte ptr [signflag],0ffh
                val_plus:
                inc             si
                dec             cl
                cmp             cl,0
                jz              err_nodef
                val_begin:
                xor             di,di
                xor             bx,bx
                mov             word ptr [dpl],0ffffh
                cld
                val_loop:
                lodsb
                dec             cl
                cmp             al,'.'
                jnz             no_dpl_found
                cmp             word ptr [dpl],0ffffh
                jz              dpl_found_ok
                mov             ax,0fffeh
                push            ax
                xor             ax,ax
                jmp             end_val
                dpl_found_ok:
                mov             word ptr [dpl],cx
                cmp             cl,0
                jz              end_val_loop
                jmp             val_loop
                no_dpl_found:
                sub             al,'0'
                jnc             val_001_ok
                val_err_dig:
                pop             si
                push            si
                lodsb
                sub             al,cl
                mov             ah,0
                push            ax
                xor             ax,ax
                jmp             end_val

                val_001_ok:
                cmp             al,9
                jna             val_002_ok
                add             al,'0'
                and             al,5fh
                sub             al,'A'
                jc              val_err_dig
                add             al,10

                val_002_ok:
                mov             ah,0
                cmp             ax,word ptr [base]
                jnc             val_err_dig
                push            ax

                mov             ax,bx
                mul             word ptr [base]
                push            dx
                xchg            ax,bx
                mov             ax,di
                mul             word ptr [base]
                cmp             dx,0
                pop             dx
                jz              val_mul_ok
                pop             ax
                mov             ax,0ffffh
                push            ax
                inc             ax
                jmp             end_val
                val_mul_ok:
                add             ax,dx
                mov             di,ax

                pop             ax
                add             bx,ax
                adc             di,0
                cmp             cl,0
                jz              end_val_loop
                jmp             val_loop
                end_val_loop:
                cmp             di,0
                jz              no_err_over
                cmp             word ptr [dpl],0ffffh
                jnz             no_err_over
                mov             ax,0fffdh
                push            ax
                xor             ax,ax
                jmp             end_val
                no_err_over:
                pop             si
                cmp             byte ptr [signflag],0
                jz              val_plus_get
                not             di
                not             bx
                add             bx,1
                adc             di,0
                val_plus_get:
                push            bx
                push            di
                mov             ax,0ffffh
                jmp             end_val

dpl_:
                db              3,'DPL',0
                dk              val_
                _dpl:
                mov             bx,offset dpl
                push            bx
                jmp             word ptr [ent]

abort_:
                db              5,'ABORT',1
                dk              dpl_
                _abort:
                do
                dw              _errno
                dw              _raz
                dw              _error
                dw              _exit

quit_:
                db              4,'QUIT',0
                dk              abort_
                _quit:
                mov             bp,word ptr [r0]
                mov             word ptr [state],0
                jmp             word ptr [restart]

plus_1_:
                db              2,'1+',0
                dk              quit_
                _plus_1:
                pop             ax
                inc             ax
                push            ax
                jmp             word ptr [ent]

plus_2_:
                db              2,'2+',0
                dk              plus_1_
                _plus_2:
                pop             ax
                inc             ax
                inc             ax
                push            ax
                jmp             word ptr [ent]

mines_1_:
                db              2,'1-',0
                dk              plus_2_
                _mines_1:
                pop             ax
                dec             ax
                push            ax
                jmp             word ptr [ent]

mines_2_:
                db              2,'2-',0
                dk              mines_1_
                _mines_2:
                pop             ax
                dec             ax
                dec             ax
                push            ax
                jmp             word ptr [ent]

prisv_p1_:
                db              3,'1+!',0
                dk              mines_2_
                _prisv_p1:
                pop             bx
                inc             word ptr [bx]
                jmp             word ptr [ent]

prisv_m1_:
                db              3,'1-!',0
                dk              prisv_p1_
                _prisv_m1:
                pop             bx
                dec             word ptr [bx]
                jmp             word ptr [ent]

prisv_p2_:
                db              3,'2+!',0
                dk              prisv_m1_
                _prisv_p2:
                pop             bx
                inc             word ptr [bx]
                inc             word ptr [bx]
                jmp             word ptr [ent]

prisv_m2_:
                db              3,'2-!',0
                dk              prisv_p2_
                _prisv_m2:
                pop             bx
                dec             word ptr [bx]
                dec             word ptr [bx]
                jmp             word ptr [ent]

raz2_:
                db              2,'2@',0
                dk              prisv_m2_
                _raz2:
                pop             bx
                push            word ptr [bx+2]
                push            word ptr [bx]
                jmp             word ptr [ent]

prisv2_:
                db              2,'2!',0
                dk              raz2_
                _prisv2:
                pop             bx
                pop             word ptr [bx]
                pop             word ptr [bx+2]
                jmp             word ptr [ent]

araz_:
                db              2,'A@',0
                dk              prisv2_
                _araz:
                pop             es
                pop             bx
                push            word ptr es:[bx]
                jmp             word ptr [ent]

acraz_:
                db              3,'AC@',0
                dk              araz_
                _acraz:
                pop             es
                pop             bx
                mov             al,byte ptr es:[bx]
                mov             ah,0
                push            ax
                jmp             word ptr [ent]

aprisv_:
                db              2,'A!',0
                dk              acraz_
                _aprisv:
                pop             es
                pop             bx
                pop             word ptr es:[bx]
                jmp             word ptr [ent]

acprisv_:
                db              3,'AC!',0
                dk              aprisv_
                _acprisv:
                pop             es
                pop             bx
                pop             ax
                mov             byte ptr es:[bx],al
                jmp             word ptr [ent]

sp_:
                db              3,'SP@',0
                dk              acprisv_
                _sp:
                mov             ax,sp
                push            ax
                jmp             word ptr [ent]

ifstack_:
                db              6,'?STACK',1
                dk              sp_
                _ifstack:
                do
                dw              _number
                dw              s0
                dw              _raz
                dw              _sp
                dw              _bol
                dw              _fbranch
                dj              stack_err
                dw              _exit
                stack_err:
                dw              _number
                dw              2
                dw              _number
                dw              errcode
                dw              _prisv
                dw              _abort

ifexec_:
                db              5,'?EXEC',1
                dk              ifstack_
                _ifexec:
                do
                dw              _state
                dw              _raz
                dw              _fbranch
                dj              no_exec_err
                dw              _number
                dw              5
                dw              _number
                dw              errcode
                dw              _prisv
                dw              _abort
                no_exec_err:
                dw              _exit

ifcomp_:
                db              5,'?COMP',1
                dk              ifexec_
                _ifcomp:
                do
                dw              _state
                dw              _raz
                dw              _eq0
                dw              _fbranch
                dj              no_comp_err
                dw              _number
                dw              6
                dw              _number
                dw              errcode
                dw              _prisv
                dw              _abort
                no_comp_err:
                dw              _exit

cmove_:
                db              6,'ACMOVE',0
                dk              ifcomp_
                _cmove:
                mov             bx,si
                pop             cx
                pop             es
                pop             di
                pop             ds
                pop             si
                rep             movsb
                mov             si,bx
                push            cs
                pop             ds
                jmp             word ptr [ent]

lcmove_:
                db              7,'ACMOVE>',0
                dk              cmove_
                _lcmove:
                mov             bx,si
                pop             cx
                pop             es
                pop             di
                pop             ds
                pop             si
                add             si,cx
                add             di,cx
                dec             si
                dec             di
                std
                rep             movsb
                mov             si,bx
                push            cs
                pop             ds
                jmp             word ptr [ent]

cscmove_:
                db              5,'CMOVE',0
                dk              lcmove_
                _cscmove:
                mov             bx,si
                pop             cx
                pop             di
                pop             si
                push            cs
                pop             es
                rep             movsb
                mov             si,bx
                jmp             word ptr [ent]

cs_:
                db              11,'CODESEGMENT',0
                dk              cscmove_
                _cs:
                push            cs
                jmp             word ptr [ent]

rp_:
                db              3,'RP@',0
                dk              cs_
                _rp:
                push            bp
                jmp             word ptr [ent]

initvar_:
                db              7,'INITVAR',1
                dk              rp_
                _initvar:
                do
                dw              _create
                dw              _comp
                dw              _exit

does_0_:
                db              7,'(DOES>)',1
                dk              initvar_
                _does_0:
                do
                dw              _frr
                dw              _number
                dw              5
                dw              _plus
                dw              _number
                dw              doesadr
                dw              _raz
                dw              _empty_0
                dw              _exit

ifpairs_:
                db              6,'?PAIRS',1
                dk              does_0_
                _ifpairs:
                do
                dw              _dup2
                dw              _equal
                dw              _eq0
                dw              _fbranch
                dj              ok_pairs
                dw              _dup2
                dw              _mines
                dw              _abs
                dw              _number
                dw              5
                dw              _bol
                dw              _eq0
                dw              _fbranch
                dj              no_ps_err
                dw              _number
                dw              3
                dw              _number
                dw              errcode
                dw              _prisv
                dw              _abort
                ok_pairs:
                dw              _drop2
                dw              _exit
                no_ps_err:
                dw              _number
                dw              4
                dw              _number
                dw              errcode
                dw              _prisv
                dw              _abort

does_:
                db              5,'DOES>',1+128
                dk              ifpairs_
                _does:
                do
                dw              _ifcomp

                dw              _number
                dw              1239h
                dw              _ifpairs

                dw              _false
                dw              _prisv_p1

                dw              _putword
                dw              _does_0
                dw              _comp

                dw              _here

                dw              _number
                dw              blstr
                dw              _strcomp

                dw              _number
                dw              1
                dw              _ccomp

                dw              _number
                dw              lastword
                dw              _raz
                dw              _here
                dw              _false
                dw              _comp
                dw              _empty_0

                dw              _number
                dw              lastword
                dw              _prisv

                dw              _number
                dw              0e8h
                dw              _ccomp

                dw              _here
                dw              _number
                dw              doesadr
                dw              _prisv

                dw              _false
                dw              _comp

                dw              _call
                dw              _number
                dw              doesadr
                dw              _raz
                dw              _empty_0

                dw              _number
                dw              1239h
                dw              _exit

begin_:
                db              5,'BEGIN',1+128
                dk              does_
                _begin:
                do
                dw              _ifcomp
                dw              _here
                dw              _number
                dw              123ah
                dw              _exit

again_:
                db              5,'AGAIN',1+128
                dk              begin_
                _again:
                do
                dw              _ifcomp
                dw              _number
                dw              123ah
                dw              _ifpairs
                dw              _putword
                dw              _branch
                dw              _comp
                dw              _here
                dw              _false
                dw              _comp
                dw              _empty_0
                dw              _exit

until_:
                db              5,'UNTIL',1+128
                dk              again_
                _until:
                do
                dw              _ifcomp
                dw              _number
                dw              123ah
                dw              _ifpairs
                dw              _putword
                dw              _fbranch
                dw              _comp
                dw              _here
                dw              _false
                dw              _comp
                dw              _empty_0
                dw              _exit

while_:
                db              5,'WHILE',1+128
                dk              until_
                _while:
                do
                dw              _ifcomp
                dw              _number
                dw              123ah
                dw              _ifpairs
                dw              _putword
                dw              _fbranch
                dw              _comp
                dw              _here
                dw              _false
                dw              _comp
                dw              _number
                dw              123bh
                dw              _exit

repeat_:
                db              6,'REPEAT',1+128
                dk              while_
                _repeat:
                do
                dw              _ifcomp
                dw              _number
                dw              123bh
                dw              _ifpairs
                dw              _swap
                dw              _putword
                dw              _branch
                dw              _comp
                dw              _here
                dw              _false
                dw              _comp
                dw              _empty_0
                dw              _here
                dw              _swap
                dw              _empty_0
                dw              _exit

if_:            db              2,'IF',1+128
                dk              repeat_
                _if:
                do
                dw              _ifcomp
                dw              _putword
                dw              _fbranch
                dw              _comp
                dw              _here
                dw              _false
                dw              _comp
                dw              _number
                dw              123ch
                dw              _exit

else_:
                db              4,'ELSE',1+128
                dk              if_
                _else:
                do
                dw              _ifcomp
                dw              _number
                dw              123ch
                dw              _ifpairs
                dw              _putword
                dw              _branch
                dw              _comp
                dw              _here
                dw              _false
                dw              _comp
                dw              _swap
                dw              _here
                dw              _swap
                dw              _empty_0
                dw              _number
                dw              123ch
                dw              _exit

then_:
                db              4,'THEN',1+128
                dk              else_
                _then:
                do
                dw              _ifcomp
                dw              _number
                dw              123ch
                dw              _ifpairs
                dw              _here
                dw              _swap
                dw              _empty_0
                dw              _exit

attp_:
                db              3,'(")',1+6
                dk              then_
                _attp:
                do
                dw              _frr
                dw              _dup
                dw              _dup
                dw              _craz
                dw              _plus
                dw              _plus_1
                dw              _tor
                dw              _exit

st_:
                db              1,'"',1+128
                dk              attp_
                _st:
                do
                dw              _number
                dw              34
                dw              _word
                dw              _state
                dw              _raz
                dw              _fbranch
                dj              no_strcomp
                dw              _putword
                dw              _attp
                dw              _comp
                dw              _strcomp
                dw              _exit
                no_strcomp:
                dw              _dup
                dw              _craz
                dw              _plus_1
                dw              _tor
                dw              _cs
                dw              _here
                dw              _number
                dw              30
                dw              _plus
                dw              _cs
                dw              _frr
                dw              _cmove
                dw              _here
                dw              _number
                dw              30
                dw              _plus
                dw              _exit

toupper_:
                db              3,'>UP',0
                dk              st_
                _toupper:
                pop             bx
                mov             cl,byte ptr [bx]
                mov             ch,0
                toup0:
                inc             bx
                jcxz            toupend
                mov             al,byte ptr [bx]
                dec             cx
                cmp             al,'a'
                jc              toup0
                cmp             al,'z'
                ja              toup0
                and             byte ptr [bx],5fh
                jmp             short toup0
                toupend:
                jmp             word ptr [ent]

empty_2_:       db              6,'(SAVE)',0
                dk              toupper_
                _empty_2:
                savebpspsi
                pop             dx
                mov             bx,dx
                cmp             byte ptr [bx],0
                jnz             all_found_s
                no_name_s:
                mov             word ptr [errcode],10
                mov             ax,offset error
                jmp             ax
                all_found_s:
                mov             ah,3ch
                xor             cx,cx
                push            bp
                push            si
                int             21h
                pop             si
                pop             bp
                jnc             ok_create_s
                cant_save:
                mov             word ptr [errcode],12
                mov             ax,offset error
                jmp             ax
                ok_create_s:
                mov             bx,ax
                push            bx
                mov             cx,word ptr [upvoc]
                dec             ch
                mov             dx,100h
                mov             ah,40h
                push            cx
                push            bp
                push            si
                push            word ptr [restart]
                cmp             word ptr [restart],offset f0001
                jnz             do_save_a
                mov             word ptr [restart],offset forth
                push            ax
                mov             ax,word ptr [upvoc]
                mov             word ptr [up2],ax
                mov             ax,word ptr [lastword]
                mov             word ptr [last2],ax
                pop             ax
                do_save_a:
                int             21h
                pop             word ptr [restart]
                pop             si
                pop             bp
                pop             cx
                pop             bx
                jc              cant_save
                cmp             ax,cx
                jnz             cant_save
                mov             ah,3eh
                push            bp
                push            si
                int             21h
                pop             si
                pop             bp
                jc              cant_save
                jmp             word ptr [ent]

save_:          db              4,'SAVE',1
                dk              empty_2_
                _save:
                do
                dw              _bl
                dw              _word
                dw              _dup
                dw              _toupper
                dw              _dup
                dw              _toasciiz
                dw              _empty_2
                dw              _exit

restart_:       db              7,'RESTART',1
                dk              save_
                _restart:
                do
                dw              _bl
                dw              _word
                dw              _find
                dw              _fbranch
                dj              no_f_rest
                found_rest:
                dw              _number
                dw              restart
                dw              _prisv
                dw              _exit
                no_f_rest:
                dw              _dup
                dw              _toupper
                dw              _find
                dw              _fbranch
                dj              no_word_rest
                dw              _branch
                dj              found_rest
                no_word_rest:
                dw              _number
                dw              1
                dw              _number
                dw              errcode
                dw              _prisv
                dw              _abort

toasciiz_:      db              7,'>ASCIIZ',0
                dk              restart_
                _toasciiz:
                mov             bx,si
                pop             si
                mov             di,si
                mov             cl,byte ptr [si]
                inc             si
                mov             ch,0
                push            ds
                pop             es
                jcxz            no_toasc
                rep             movsb
                no_toasc:
                xor             al,al
                stosb
                mov             si,bx
                jmp             word ptr [ent]

empty_3_:       db              7,'(BUILD)',0
                dk              toasciiz_
                _empty_3:
                xor             ax,ax
                mov             es,ax
                mov             word ptr [tseg],ax
                pop             word ptr [time_x]
                mov             bx,word ptr [time_x]
                cmp             byte ptr [bx],0
                jnz             name_build_present
                mov             ax,10
                jmp             link_error
                name_build_present:
                mov             word ptr [link_si],si
                mov             word ptr [link_bp],bp
                pop             bp
                mov             cl,4
                mov             bx,word ptr [upvoc]
                shr             bx,cl
                add             bx,10h
                mov             ah,48h
                int             21h
                jnc             ok_prog_mem
                mov             ax,9
                jmp             link_error
                ok_prog_mem:
                cld
                push            ax
                call            lset_count

                push            es
                push            ds
                push            si
                push            di
                push            ax

                push            cs
                pop             ds
                push            cs
                pop             es
                mov             di,word ptr [upvoc]
                cld
                mov             ax,2001h
                stosw
                mov             ax,0e801h
                stosw
                mov             ax,offset callr
                sub             ax,di
                dec             ax
                dec             ax
                stosw
                mov             dx,7
                mov             si,word ptr [lastword]
                comp_init_words:
                lodsb
                mov             ah,0
                add             si,ax
                test            byte ptr [si],32
                jz              no_save_init
                mov             ax,si
                add             ax,3
                stosw
                inc             dx
                inc             dx
                no_save_init:
                inc             si
                lodsw
                add             si,ax
                cmp             ax,0
                jnz             comp_init_words
                mov             si,word ptr [lastword]
                lodsb
                mov             ah,0
                add             ax,si
                add             ax,3
                stosw
                mov             ax,word ptr cs:[0feh]
                stosw

                pop             ax
                pop             di
                pop             si
                pop             ds
                pop             es

                call            lset_tbl
                pop             es
                mov             di,100h
                mov             cx,offset blstr
                cmp             word ptr cs:[messages],0
                jnz             no_change_flen_
                mov             cx,offset mess_table_
                no_change_flen_:
                dec             ch
                mov             si,di
                push            cs
                pop             ds
                rep             movsb
                mov             word ptr es:[lastword],0

                mov             si,word ptr [upvoc]
                add             si,3

;               mov             si,word ptr [lastword]
;               lodsb
;               mov             ah,0
;               inc             ax
;               inc             ax
;               inc             ax
;               add             si,ax
                call            lcomp_word

                push            cx
                push            bx
                push            si
                mov             bx,2
                mov             cx,word ptr cs:[wcount]
                comp_name_words:
                mov             ds,word ptr cs:[tseg]
                mov             si,word ptr [bx]
                test            byte ptr cs:[si-3],16
                jz              next_word_test
                push            bx
                push            cx
                push            cs
                pop             ds
                call            lcomp_word
                pop             cx
                pop             bx
                next_word_test:
                add             bx,8
                loop            comp_name_words

                cmp             word ptr cs:[system],0
                jz              no_compile_error_proc
                mov             ds,word ptr cs:[tseg]
                mov             si,word ptr cs:[system]
                push            si
                push            bx
                push            cx
                push            cs
                pop             ds
                call            lcomp_word
                pop             cx
                pop             bx
                pop             ax
                call            lfind_word
                mov             word ptr es:[system],ax
                no_compile_error_proc:

                pop             si
                pop             bx
                pop             cx

; *****************************************************************************
;  ᫮,    ᪨ 㪠⥫
; *****************************************************************************
                push            ax
                push            cx
                push            dx
                push            bx
                push            bp
                push            si
                push            ds

                mov             ax,word ptr cs:[comp_seg]
                cmp             ax,0
                mov             ds,ax
                jz              no_comp_spnt_
                xor             si,si

                comp_spnt_loop_:
                cld
                lodsb
                cmp             al,255
                jz              no_comp_spnt_
                lodsw
                push            ds
                push            si
                call            comp_spnt_
                pop             si
                pop             ds
                jmp             short comp_spnt_loop_

                no_comp_spnt_:
; ****************************************** ୠ   ࠢ
                push            cs
                pop             ds
                cmp             byte ptr [cpr],'C'
                jnz             nopass_need
                cmp             byte ptr [cpr+1],'o'
                jnz             nopass_need
                mov             bx,offset passtext
                mov             cx,passlen
                mov             si,offset chk_pass
                mov             ah,54
                cld
                pass_chk_loop:
                lodsb
                sub             al,ah
                cmp             al,byte ptr [bx]
                jnz             pass_wrong
                inc             ah
                inc             bx
                loop            pass_chk_loop
                jmp             short nopass_need
; ********************************************************** ࠢ 襭 !!!
                pass_wrong:
                mov             ax,31
                sub             ax,9
                jmp             link_error
                nopass_need:
; *****************************************************************************
                pop             ds
                pop             si
                pop             bp
                pop             bx
                pop             dx
                pop             cx
                pop             ax
; *****************************************************************************

                mov             word ptr es:[upvoc],di
                mov             word ptr es:[comp_seg],0
                mov             word ptr es:[lines],0ffffh
                mov             ds,word ptr cs:[tseg]
                mov             ax,word ptr [bx+2]
                mov             word ptr es:[restart],ax
                push            es

                call            make_map_file

                mov             es,word ptr cs:[tseg]
                mov             word ptr cs:[tseg],di
                cmp             word ptr cs:[xoverlay],0
                jz              cont_free_tseg
                mov             word ptr cs:[xoverlay],es

                push            word ptr [lastword]
                pop             word ptr [last2]
                push            word ptr [upvoc]
                pop             word ptr [up2]

                jmp             short skip_free_tseg
                cont_free_tseg:
                call            free_m_build
                skip_free_tseg:
                push            cs
                pop             ds
                mov             dx,word ptr [time_x]
                xor             cx,cx
                mov             ah,3ch
                int             21h
                pop             es
                jnc             lok_create_f
lwr_error:      mov             ax,12
                jmp             link_error
                lok_create_f:
                push            es
                pop             ds
                push            ax
                mov             bx,ax
                mov             cx,word ptr cs:[tseg]
                dec             ch
                mov             dx,100h
                mov             ah,40h
                push            ds
                int             21h
                pop             es
                pop             bx
                jc              lwr_error
                mov             ah,3eh
                push            es
                int             21h
                pop             es
                call            free_m_build
                push            cs
                pop             ds
                mov             si,word ptr [link_si]
                mov             bp,word ptr [link_bp]
                jmp             word ptr [ent]

comp_spnt_:     ret


lcomp_addr:     ; ******************************************  
                cmp             ax,0
                jz              no_comp_addr
                sub             ax,di
                dec             ax
                dec             ax
                no_comp_addr:
                stosw
                ret

lset_count:     ; *******************************  ᫠ ᫮  ᫮
                xor             cx,cx
                push            cs
                pop             ds
                mov             si,word ptr cs:[lastword]
                lset_c_loop:
                inc             cx
                lodsb
                mov             ah,0
                add             si,ax
                inc             si
                lodsw
                add             si,ax
                cmp             ax,0
                jnz             lset_c_loop
                mov             word ptr [wcount],cx
                ret

lset_tbl:       ; **************************** ନ஢ ⠡ 樨
                mov             bx,word ptr cs:[wcount]
                shr             bx,1
                inc             bx
                inc             bx
                mov             ah,48h
                push            dx
                int             21h
                pop             dx
                jnc             loc_tbl_mem
                mov             ax,9
                jmp             link_error
                loc_tbl_mem:
                mov             word ptr cs:[tseg],ax
                mov             es,ax
                xor             di,di
                mov             si,word ptr cs:[lastword]
                mov             bx,word ptr cs:[upvoc]
                mov             ax,bx
                stosw
                add             ax,3
                stosw
                xor             ax,ax
                stosw
                mov             ax,dx
                stosw
                lset_tbl_loop:
                mov             ax,si
                stosw
                mov             cx,si
                lodsb
                mov             ah,0
                add             si,ax
                inc             si
                mov             ax,si
                inc             ax
                inc             ax
                stosw
                sub             bx,ax
                xor             ax,ax
                stosw
                mov             ax,bx
                stosw
                mov             bx,cx
                lodsw
                add             si,ax
                cmp             ax,0
                jnz             lset_tbl_loop
                stosw                           ; ⮩  ⠡
                stosw                           ;  ࠡ  ૥ﬨ
                stosw
                stosw
                inc             word ptr cs:[wcount]
                ret

lfind_word:     ; ****************************  ᫮  ⠡ 樨
                push            ds
                push            bx
                mov             bx,2
                mov             ds,word ptr cs:[tseg]
                mov             cx,word ptr cs:[wcount]
                lfind_loop:
                cmp             ax,word ptr [bx]
                jz              lfound_word
                add             bx,8
                loop            lfind_loop
                mov             ax,11
                jmp             link_error
                lfound_word:
                mov             ax,word ptr [bx+2]
                pop             bx
                pop             ds
                cmp             ax,0
                jnz             lno_zero_found
                mov             ax,11
                jmp             link_error
                lno_zero_found:
                ret

lget_length:    ; ************************************** 祭  墮
                push            bx
                mov             bx,ax
                mov             al,byte ptr cs:[bx-3]
                pop             bx
                shr             al,1
                and             al,7
                jnz             l_present
                no_tail:
                xor             cx,cx
                ret
                l_present:
                cmp             word ptr cs:[si-4],bp
                jz              no_tail
                cmp             al,1
                jnz             no_2_len
                mov             cx,2
                ret
                no_2_len:
                cmp             al,2
                jnz             no_4_len
                mov             cx,4
                ret
                no_4_len:
                cmp             al,3
                jnz             no_str_len
                mov             cl,byte ptr cs:[si]
                mov             ch,0
                inc             cx
                ret
                no_str_len:
                cmp             al,4
                jnz             no_asciiz_len
                push            si
                push            ds
                push            cs
                pop             ds
                xor             cx,cx
                asc_l_1:
                inc             cx
                lodsb
                cmp             al,0
                jnz             asc_l_1
                pop             ds
                pop             si
                ret
                no_asciiz_len:
                cmp             al,5
                jnz             no_long_len
                mov             cx,word ptr cs:[si]
                inc             cx
                inc             cx
                ret
                no_long_len:
                cmp             al,6
                jnz             no_byte_len
                mov             cx,1
                ret
                no_byte_len:
                mov             cx,2
                ret

lcomp_name:     ; ***********************   (  室 )
                test            byte ptr cs:[si-3],16
                jnz             name_plus_c
                cmp             word ptr cs:[debug],0
                jnz             name_plus_c
                ret
                name_plus_c:
;                and             byte ptr cs:[si-3],239
                push            ds
                mov             ds,word ptr cs:[tseg]
                mov             si,word ptr [bx-2]
                push            di
                push            cx
                mov             cl,byte ptr cs:[si]
                mov             ch,0
                inc             cx
                inc             cx
                push            cs
                pop             ds
                rep             movsb
                pop             cx
                push            ax
                mov             ax,word ptr es:[lastword]
                call            lcomp_addr
                pop             ax
                pop             word ptr es:[lastword]
                mov             ds,word ptr cs:[tseg]
                inc             si
                inc             si
                cmp             si,word ptr [bx]
                pop             ds
                jz              name_c_ok
                dec             si
                dec             si
                push            ds
                push            ax
                mov             ax,word ptr cs:[upvoc]
                mov             ds,word ptr cs:[tseg]
                cmp             ax,word ptr [bx-2]
                pop             ax
                pop             ds
                jz              name_c_ok
                mov             ax,11
                jmp             link_error
                name_c_ok:
                ret

lc01:           ; *********************** 樠 । 樥 ᫮
                mov             cx,word ptr cs:[wcount]
                mov             bx,2
                mov             ds,word ptr cs:[tseg]
                lc02:
                cmp             si,word ptr [bx]
                jz              found_word_c01
                add             bx,8
                loop            lc02
                mov             ax,11
                jmp             link_error
                found_word_c01:
                ret

lzero_word:     ; ***************************  ᫮ 㫥 浪
                push            ds
                call            lcomp_name
                mov             ds,word ptr cs:[tseg]
                mov             word ptr [bx+2],di

                mov             cx,word ptr [bx]
                sub             cx,3
                xchg            cx,bx
                push            word ptr cs:[bx]
                xchg            cx,bx
                pop             cx
                test            cl,64
                jz              no_para_word
                para_word:
                test            di,15
                jz              no_para_word
                mov             byte ptr es:[di],90h
                inc             di
                jmp             short para_word
                no_para_word:

                mov             cx,word ptr [bx+4]
                push            cs
                pop             ds
                rep             movsb
                pop             ds
                ret

lnext_word:     ; ***************************************  NEXT-᫮
                push            ds
                call            lcomp_name
                mov             ds,word ptr cs:[tseg]
                mov             word ptr [bx+2],di
                mov             al,0e8h
                stosb
                inc             si
                inc             si
                inc             si
                mov             ax,word ptr es:[ent]
                call            lcomp_addr
                mov             cx,word ptr [bx+4]
                dec             cx
                dec             cx
                dec             cx
                push            cs
                pop             ds
                rep             movsb
                pop             ds
                ret

lcomp_word:     ; ********************************************  ᫮
                call            lc01
                cmp             byte ptr cs:[si],0e9h
                jnz             no_jmp
                mov             ax,word ptr cs:[si+1]
                inc             ax
                inc             ax
                inc             ax
                add             si,ax
                jmp             lcomp_word
                no_jmp:
                cmp             word ptr [bx+2],0
                jz              do_comp_l
                ret
                do_comp_l:
                mov             al,byte ptr cs:[si-3]
                and             al,01000001b
                cmp             al,01000001b
                jnz             comp_1_ok
                mov             ax,20
                jmp             link_error
                comp_1_ok:
                test            byte ptr cs:[si-3],1
                jnz             no_zero_comp
                jmp             lzero_word
                no_zero_comp:
                push            cs
                pop             ds
                lodsb
                cmp             al,0e8h
                jz              ok_e8_found
                mov             ax,11
                jmp             link_error
                ok_e8_found:
                lodsw
                add             ax,si
                dec             si
                dec             si
                dec             si
                cmp             ax,offset next
                jnz             no_next_comp
                jmp             lnext_word
                no_next_comp:
                cmp             ax,offset callr
                jz              call_word_comp
                push            ax
                push            bx
                add             si,word ptr cs:[si+1]
                inc             si
                inc             si
                inc             si
                call            lcomp_word
                pop             bx
                mov             ds,word ptr cs:[tseg]
                mov             si,word ptr [bx]
                call            lcomp_name
                mov             word ptr [bx+2],di
                mov             al,0e8h
                stosb
                pop             ax
                call            lfind_word
                call            lcomp_addr
                inc             si
                inc             si
                inc             si
                mov             ds,word ptr cs:[tseg]
                mov             cx,word ptr [bx+4]
                dec             cx
                dec             cx
                dec             cx
                push            cs
                pop             ds
                rep             movsb
                ret
                call_word_comp:
                mov             ds,word ptr cs:[tseg]
                mov             dx,word ptr [bx+4]
                dec             dx
                dec             dx
                dec             dx
                inc             si
                inc             si
                inc             si
                push            cs
                pop             ds
                push            bx
pass1_loop:     lodsw
                dec             dx
                dec             dx
                pop             bx
                push            bx
                push            ds
                mov             ds,word ptr cs:[tseg]
                cmp             ax,word ptr [bx]
                pop             ds
                jz              no_pass
                push            si
                push            dx
                push            ax
                mov             si,ax
                call            lcomp_word
                pop             ax
                pop             dx
                pop             si
                no_pass:
                push            cs
                pop             ds
                call            lget_length
                push            cs
                pop             ds
                sub             dx,cx
                add             si,cx
                mov             ax,dx
                sub             ax,1
                jnc             pass1_loop
                pop             bx
                mov             ds,word ptr cs:[tseg]
                mov             si,word ptr [bx]
                call            lcomp_name
                mov             ds,word ptr cs:[tseg]
                mov             dx,word ptr [bx+4]
                mov             word ptr [bx+2],di
                mov             al,0e8h
                stosb
                inc             si
                inc             si
                inc             si
                mov             ax,offset callr
                call            lcomp_addr
                dec             dx
                dec             dx
                dec             dx
                push            cs
                pop             ds
pass2_loop:     lodsw
                xchg            ax,si
                cmp             byte ptr [si],0e9h
                jnz             cont_pass2
                push            ax
                mov             ax,word ptr [si+1]
                inc             ax
                inc             ax
                inc             ax
                add             si,ax
                pop             ax
                cont_pass2:
                xchg            ax,si
                push            ax
                call            lfind_word
                stosw
                pop             ax
                dec             dx
                dec             dx
                call            lget_length
                push            cs
                pop             ds
                jcxz            no_comp_len
                sub             dx,cx
                rep             movsb
no_comp_len:    mov             ax,dx
                sub             ax,1
                jnc             pass2_loop
                ret

link_error:     ; ********************************** 訡  ६ 
                mov             word ptr cs:[errcode],ax
                mov             ax,es
                cmp             ax,0
                jz              no_free_es
                call            free_m_build
                no_free_es:
                mov             ax,word ptr cs:[tseg]
                cmp             ax,0
                jz              no_free_t
                mov             es,ax
                call            free_m_build
                no_free_t:
                push            cs
                pop             ds
                mov             si,word ptr [link_si]
                mov             bp,word ptr [link_bp]
                mov             bx,offset error
                jmp             bx
                free_m_build:
                mov             ah,49h
                int             21h
                ret

chk_pass:       db              'G'+54
                db              'o'+55
                db              'l'+56
                db              'd'+57
                db              'e'+58
                db              'n'+59
                db              ' '+60
                db              'P'+61
                db              'o'+62
                db              'r'+63
                db              'c'+64
                db              'u'+65
                db              'p'+66
                db              'i'+67
                db              'n'+68
                db              'e'+69
                db              ' '+70
                db              'S'+71
                db              'o'+72
                db              'f'+73
                db              't'+74
                db              'w'+75
                db              'a'+76
                db              'r'+77
                db              'e'+78

make_map_file:  ; ****************************** ନ஢ 䠩- 
                push            ax
                push            cx
                push            dx
                push            bx
                push            bp
                push            si
                push            di
                push            ds
                push            es

                push            cs
                pop             ds
                mov             dx,word ptr [time_t]
                mov             bx,dx
                cmp             byte ptr [bx],0
                jnz             map_present
                jmp             end_map

                map_present:
                mov             ah,3ch
                xor             cx,cx
                int             21h
                jnc             map_opened
                jmp             end_map
                map_opened:
                mov             word ptr cs:[time_z],ax
                mov             bx,ax
                call            map_title
                db              ' Word              CFA   Length Type  ',13,10
                db              '======================================',13,10
                map_title:
                pop             dx
                mov             cx,80
                mov             ah,40h
                int             21h

                xor             dx,dx           ; CFA min

map_again:      mov             cx,word ptr [wcount]
                xor             di,di           ; Best CFA
                xor             si,si           ; Best Word Index
                mov             ds,word ptr cs:[tseg]
                mov             bx,4
map_loop:       cmp             word ptr [bx],0
                jz              next_word_map
                cmp             dx,word ptr [bx]
                jnc             next_word_map
                cmp             di,0
                jz              store_word_map
                cmp             word ptr [bx],di
                jnc             next_word_map
                store_word_map:
                push            bx
                mov             bx,word ptr [bx-4]
                mov             al,byte ptr cs:[bx+1]
                pop             bx
                cmp             al,' '
                jz              next_word_map
                mov             si,bx
                mov             di,word ptr [bx]
next_word_map:  add             bx,8
                loop            map_loop
                cmp             si,0
                jz              close_map

                push            di
                call            map_string
                pop             dx

                jmp             map_again

end_map:        pop             es
                pop             ds
                pop             di
                pop             si
                pop             bp
                pop             bx
                pop             dx
                pop             cx
                pop             ax
                ret

close_map:      mov             bx,word ptr cs:[time_z]
                mov             ah,3eh
                int             21h
                jmp             end_map

map_string:     ; ****************************** ନ஢ ப .MAP-䠩
                mov             bx,si
                push            cs
                pop             es
                mov             ds,word ptr cs:[tseg]
                call            map_string_buffer
                db              40 dup (0)
                map_string_buffer:
                pop             di
                cld
                mov             al,' '
                stosb
                mov             si,word ptr [si-4]
                mov             cl,byte ptr cs:[si]
                cmp             cl,17
                jc              no_correct_l
                mov             cl,16
                no_correct_l:
                mov             ch,0
                push            cx
                push            cs
                pop             ds
                inc             si
                rep             movsb
                pop             ax
                mov             cx,18
                sub             cx,ax
                mov             al,' '
                rep             stosb
                mov             ds,word ptr cs:[tseg]
                mov             ax,word ptr [bx]
                call            out_code
                mov             ax,2020h
                stosw
                mov             si,di

                mov             ax,word ptr [bx+2]
                mov             cx,10000
                xor             dx,dx
                div             cx
                add             al,'0'
                stosb
                mov             ax,dx
                mov             cx,1000
                xor             dx,dx
                div             cx
                add             al,'0'
                stosb
                mov             ax,dx
                mov             cx,100
                xor             dx,dx
                div             cx
                add             al,'0'
                stosb
                mov             ax,dx
                mov             cx,10
                xor             dx,dx
                div             cx
                add             al,'0'
                stosb
                mov             ax,dx
                add             al,'0'
                stosb

                mov             cx,4
bl_zero_loop:   cmp             byte ptr es:[si],'0'
                jnz             exit_bl_z
                mov             byte ptr es:[si],' '
                inc             si
                loop            bl_zero_loop
                exit_bl_z:

                mov             ax,2020h
                stosw

                mov             bx,word ptr [bx-2]
                push            cs
                pop             ds
                test            byte ptr [bx-3],1
                jz              code_word
                mov             ax,6f46h
                stosw
                mov             ax,7472h
                stosw
                mov             ax,2068h
                stosw
                jmp             short forth_word
code_word:      mov             ax,6f43h
                stosw
                mov             ax,6564h
                stosw
                mov             ax,2020h
                stosw

forth_word:     mov             ax,0a0dh
                stosw

                mov             dx,di
                mov             cx,40
                sub             dx,cx
                mov             ah,40h
                mov             bx,word ptr [time_z]
                int             21h
                ret

out_code:       push            ax
                mov             al,ah
                call            out_code_byte
                pop             ax
out_code_byte:  push            ax
                shr             al,1
                shr             al,1
                shr             al,1
                shr             al,1
                call            out_code_dig
                pop             ax
out_code_dig:   and             al,15
                cmp             al,10
                jc              no_add_7_out
                add             al,7
                no_add_7_out:
                add             al,'0'
                stosb
                ret

build_:         db              5,'BUILD',1
                dk              empty_3_
                _build:
                do
                dw              _putword
                dw              _bye
                dw              _number
                dw              0feh
                dw              _prisv
                dw              _putword
                dw              _putword
                dw              _bl
                dw              _word
                dw              _dup
                dw              _toupper
                dw              _dup
                dw              _toasciiz
                dw              _number
                dw              100
                dw              _allot
                dw              _bl
                dw              _word
                dw              _dup
                dw              _toupper
                dw              _dup
                dw              _toasciiz
                dw              _number
                dw              time_t
                dw              _prisv
                dw              _number
                dw              -100
                dw              _allot
                dw              _empty_3
                dw              _st_com
                dw              _exit

system_:        db              9,'ERRORPROC',0
                dk              build_
                _system:
                mov             ax,offset system
                push            ax
                jmp             word ptr [ent]

latest_:        db              6,'LATEST',0
                dk              system_
                _latest:
                push            word ptr [lastword]
                jmp             word ptr [ent]

frasciiz_:      db              7,'ASCIIZ>',0
                dk              latest_
                _frasciiz:
                xor             cx,cx
                pop             bx
                push            si
                mov             si,bx
                l1_fr:
                lodsb
                cmp             al,0
                jz              l2_fr
                inc             cx
                jmp             l1_fr
                l2_fr:
                cmp             cl,0
                jz              l3_fr
                cmp             ch,0
                jnz             l3_fr
                dec             si
                mov             di,si
                push            cs
                pop             es
                dec             si
                std
                push            cx
                jcxz            no_frasc
                rep             movsb
                no_frasc:
                pop             cx
                mov             byte ptr [di],cl
                l3_fr:
                pop             si
                jmp             word ptr [ent]

space_:         db              5,'SPACE',1
                dk              frasciiz_
                _space:
                do
                dw              _bl
                dw              _emit
                dw              _exit

spaces_:        db              6,'SPACES',1
                dk              space_
                _spaces:
                do
                sp_1:
                dw              _space
                dw              _mines_1
                dw              _dup
                dw              _eq0
                dw              _fbranch
                dj              sp_1
                dw              _drop
                dw              _exit

setinit_:       db              8,'SETSTART',1
                dk              spaces_
                _setinit:
                do
                dw              _bl
                dw              _word
                dw              _find
                dw              _fbranch
                dj              wnf_setin
                dw              _mines_1
                dw              _mines_2
                dw              _dup
                dw              _craz
                dw              _number
                dw              32
                dw              _or
                dw              _swap
                dw              _cprisv
                dw              _exit
                wnf_setin:
                dw              _number
                dw              1
                dw              _number
                dw              errcode
                dw              _prisv
                dw              _abort

setpara_:       db              7,'SETPARA',1
                dk              setinit_
                _setpara:
                do
                dw              _bl
                dw              _word
                dw              _find
                dw              _fbranch
                dj              wnf_setin
                dw              _mines_1
                dw              _mines_2
                dw              _dup
                dw              _craz
                dw              _number
                dw              64
                dw              _or
                dw              _swap
                dw              _cprisv
                dw              _exit
                wnf_setpa:
                dw              _number
                dw              1
                dw              _number
                dw              errcode
                dw              _prisv
                dw              _abort

setname_:       db              7,'SETNAME',1
                dk              setpara_
                _setname:
                do
                dw              _bl
                dw              _word
                dw              _find
                dw              _fbranch
                dj              wnf_set
                dw              _mines_1
                dw              _mines_2
                dw              _dup
                dw              _craz
                dw              _number
                dw              16
                dw              _or
                dw              _swap
                dw              _cprisv
                dw              _exit
                wnf_set:
                dw              _number
                dw              1
                dw              _number
                dw              errcode
                dw              _prisv
                dw              _abort

clearname_:     db              9,'CLEARNAME',1
                dk              setname_
                _clearname:
                do
                dw              _bl
                dw              _word
                dw              _find
                dw              _fbranch
                dj              wnf_clear
                dw              _mines_1
                dw              _mines_2
                dw              _dup
                dw              _craz
                dw              _number
                dw              239
                dw              _and
                dw              _swap
                dw              _cprisv
                dw              _exit
                wnf_clear:
                dw              _number
                dw              1
                dw              _number
                dw              errcode
                dw              _prisv
                dw              _abort

setstream_:     db              4,'LOAD',1
                dk              clearname_
                _setstream:
                do
                dw              _number
                dw              tibadr
                dw              _raz
                dw              _tor
                dw              _number
                dw              maxpos
                dw              _raz
                dw              _tor
                dw              _number
                dw              inpos
                dw              _raz
                dw              _tor
                dw              _dup
                dw              _plus_1
                dw              _number
                dw              tibadr
                dw              _prisv
                dw              _craz
                dw              _number
                dw              maxpos
                dw              _prisv
                dw              _false
                dw              _number
                dw              inpos
                dw              _prisv
                dw              _interpret
                dw              _frr
                dw              _number
                dw              inpos
                dw              _prisv
                dw              _frr
                dw              _number
                dw              maxpos
                dw              _prisv
                dw              _frr
                dw              _number
                dw              tibadr
                dw              _prisv
                dw              _exit

immediate_:     db              9,'IMMEDIATE',0
                dk              setstream_
                _immediate:
                mov             bx,word ptr [lastword]
                mov             al,byte ptr [bx]
                mov             ah,0
                add             bx,ax
                inc             bx
                or              byte ptr [bx],128
                jmp             word ptr [ent]

apostr_:        db              1,27h,1
                dk              immediate_
                _apostr:
                do
                dw              _bl
                dw              _word
                dw              _find
                dw              _fbranch
                dj              apostr_not_found
                dw              _exit
                apostr_not_found:
                dw              _number
                dw              1
                dw              _number
                dw              errcode
                dw              _prisv
                dw              _abort

compile_:       db              7,'COMPILE',1+128
                dk              apostr_
                _compile:
                do
                dw              _putword
                dw              _putword
                dw              _comp
                dw              _apostr
                dw              _comp
                dw              _putword
                dw              _comp
                dw              _comp
                dw              _exit

imcompile_:     db              9,'[COMPILE]',1+128
                dk              compile_
                _imcompile:
                do
                dw              _bl
                dw              _word
                dw              _find
                dw              _fbranch
                dj              imcomp_err
                dw              _comp
                dw              _exit
                imcomp_err:
                dw              _number
                dw              1
                dw              _number
                dw              errcode
                dw              _prisv
                dw              _abort

toname_:        db              5,'>NAME',0
                dk              imcompile_
                _toname:
                pop             bx
                dec             bx
                dec             bx
                dec             bx
                xor             cx,cx
                name_1_search:
                dec             bx
                cmp             byte ptr [bx],cl
                jz              name_already_f
                inc             cx
                jmp             name_1_search
                name_already_f:
                push            bx
                jmp             word ptr [ent]

frname_:        db              5,'NAME>',0
                dk              toname_
                _frname:
                pop             bx
                mov             al,byte ptr [bx]
                mov             ah,0
                add             ax,4
                add             ax,bx
                push            ax
                jmp             word ptr [ent]

forget_:        db              6,'FORGET',1
                dk              frname_
                _forget:
                do
                dw              _bl
                dw              _word
                dw              _find
                dw              _fbranch
                dj              forget_1
                dw              _dup
                dw              _tor
                dw              _mines_2
                dw              _raz
                dw              _rraz
                dw              _plus
                dw              _number
                dw              lastword
                dw              _prisv
                dw              _frr
                dw              _toname
                dw              _number
                dw              upvoc
                dw              _prisv
                dw              _exit
                forget_1:
                dw              _number
                dw              1
                dw              _number
                dw              errcode
                dw              _prisv
                dw              _abort

do_use_:        db              5,'(USE)',0
                dk              forget_
                _do_use:
                savebpspsi
                pop             dx
                pop             word ptr [errcode]
                mov             bx,dx
                cmp             byte ptr [bx],0
                jnz             name_present
                mov             word ptr [errcode],1
                mov             bx,offset error
                jmp             bx
                name_present:
                mov             ax,3d00h
                int             21h
                jnc             use_open_ok
                mov             word ptr [errcode],21
                mov             bx,offset error
                jmp             bx
                use_error:
                mov             word ptr [errcode],14
                mov             bx,offset error
                jmp             bx
                use_open_ok:
                push            ax
                mov             bx,ax
                mov             ah,3fh
                mov             dx,word ptr [upvoc]
                mov             cx,32767
                int             21h
                jc              use_error
                pop             bx
                push            ax
                mov             ah,3eh
                int             21h
                pop             bx
                cmp             bx,16384
                jz              use_bad

                push            bx
                mov             dx,bx
                add             bx,word ptr [upvoc]
                mov             cx,bx
                sub             cx,8
                cmp             word ptr [bx-2],1231h
                jz              use_pass_ok
                use_bad:
                mov             word ptr [errcode],15
                mov             bx,offset error
                jmp             bx
                use_pass_ok:
                mov             ax,word ptr [bx-4]
                cmp             ax,word ptr [vers]
                jz              use_vers_ok
                mov             word ptr [errcode],16
                mov             bx,offset error
                jmp             bx
                use_vers_ok:
                mov             di,word ptr [bx-8]
                add             dx,di
                sub             dx,8
                mov             bx,word ptr [bx-6]
                add             bx,word ptr [upvoc]
                push            bx
                use_process:
                push            bx
                mov             al,byte ptr[bx]
                mov             ah,0
                add             bx,ax
                add             bx,4
                push            bx
                call            use_linker
                pop             bx
                pop             cx
                mov             ax,word ptr [bx-2]
                add             bx,ax
                cmp             ax,0
                jnz             use_process
                mov             ax,word ptr [lastword]
                pop             word ptr [lastword]
                sub             ax,bx
                mov             word ptr [bx-2],ax
                pop             ax
                sub             ax,8
                add             word ptr [upvoc],ax
                jmp             word ptr [ent]

                use_linker:
                test            byte ptr [bx-3],1
                jnz             use_no_zero
                ret
                use_no_zero:
                cmp             byte ptr [bx],0f4h
                jnz             no_pass_callr
                mov             byte ptr [bx],0e8h
                mov             ax,offset callr
                add             bx,3
                jmp             short use_call_word
                no_pass_callr:
                cmp             byte ptr [bx],0e8h
                jz              use_e8_found
                mov             word ptr [errcode],11
                mov             bx,offset error
                jmp             bx
                use_e8_found:
                mov             ax,word ptr [bx+1]
                add             bx,3
                add             ax,bx
                add             ax,di
                sub             ax,word ptr [upvoc]
                cmp             ax,offset callr
                jz              use_call_word
                cmp             ax,offset next
                jz              use_next_word
                ;********************************************
                push            ax
                sub             ax,bx
                mov             word ptr [bx-2],ax
                pop             ax
                ;********************************************
                ret
                use_next_word:
                sub             ax,bx
                mov             word ptr [bx-2],ax
                ret
                use_call_word:
                sub             ax,bx
                mov             word ptr [bx-2],ax
                use_call_loop:
                mov             ax,word ptr [bx]
                inc             bx
                inc             bx
                cmp             ax,0
                jnz             no_exit_pass
                mov             ax,word ptr [errcode]
                mov             word ptr [bx-2],ax
                jmp             short no_ch_addr
                no_exit_pass:
                cmp             ax,di
                jc              no_change_addr
                cmp             dx,ax
                jc              no_change_addr
                sub             ax,di
                add             ax,word ptr [upvoc]
                mov             word ptr [bx-2],ax
                no_change_addr:
                call            use_skip_tail
                no_ch_addr:
                cmp             bx,cx

                jc              use_call_loop

                ret

                use_skip_tail:
                push            bx
                mov             bx,ax
                mov             al,byte ptr [bx-3]
                pop             bx
                shr             al,1
                and             al,7
                jnz             tail_present
                ret
                tail_present:
                cmp             al,1
                jnz             use_no_2
                inc             bx
                inc             bx
                ret
                use_no_2:
                cmp             al,2
                jnz             use_no_4
                add             bx,4
                ret
                use_no_4:
                cmp             al,3
                jnz             use_no_lenstr
                mov             al,byte ptr [bx]
                mov             ah,0
                inc             ax
                add             bx,ax
                ret
                use_no_lenstr:
                cmp             al,4
                jnz             use_no_asc
                use_1:
                inc             bx
                cmp             byte ptr [bx-1],0
                jnz             use_1
                ret
                use_no_asc:
                cmp             al,5
                jnz             use_no_long
                mov             ax,word ptr [bx]
                inc             ax
                inc             ax
                add             bx,ax
                ret
                use_no_long:
                cmp             al,6
                jnz             use_no_byte
                inc             bx
                ret
                use_no_byte:
                inc             bx
                inc             bx
                ret


use_:           db              3,'USE',1
                dk              do_use_
                _use:
                do
                dw              _putword
                dw              _exit
                dw              _bl
                dw              _word
                dw              _dup
                dw              _toupper
                dw              _dup
                dw              _toasciiz
                dw              _do_use
                dw              _latest
                dw              _frname
                dw              _execute
                dw              _st_com
                dw              _exit

do_make_        db              10,'(MAKEUNIT)',0
                dk              use_
                _do_make:
                savebpspsi
                pop             dx
                mov             bx,dx
                cmp             byte ptr [bx],0
                jnz             name_mk_plus
                mov             word ptr [errcode],10
                mov             bx,offset error
                jmp             bx
                name_mk_plus:
                mov             bx,word ptr [upvoc]
                cmp             bx,word ptr [up2]
                jnz             no_empty_make
                mov             word ptr [errcode],17
                mov             bx,offset error
                jmp             bx
                no_empty_make:
                mov             ax,word ptr [up2]
                mov             word ptr [bx],ax
                inc             bx
                inc             bx
                mov             cx,word ptr [lastword]
                sub             cx,ax
                mov             word ptr [bx],cx
                inc             bx
                inc             bx
                mov             ax,word ptr [vers]
                mov             word ptr [bx],ax
                inc             bx
                inc             bx
                mov             word ptr [bx],1231h
                mov             bx,word ptr [up2]
                mov             al,byte ptr [bx]
                mov             ah,0
                add             bx,ax
                inc             bx
                inc             bx
                push            word ptr [bx]
                push            bx
                mov             word ptr [bx],0
                mov             ah,3ch
                xor             cx,cx
                int             21h
                jnc             ok_cr_make
                make_error:
                pop             bx
                pop             word ptr [bx]
                mov             word ptr [errcode],12
                mov             bx,offset error
                jmp             bx
                ok_cr_make:
                push            ax
                mov             bx,ax
                mov             ah,40h
                mov             dx,word ptr [up2]
                mov             cx,word ptr [upvoc]
                add             cx,8
                sub             cx,dx
                int             21h
                pop             bx
                jc              make_error
                mov             ah,3eh
                int             21h
                pop             bx
                pop             word ptr [bx]
                jmp             word ptr [ent]

make_unit_:     db              8,'MAKEUNIT',1
                dk              do_make_
                _make_unit:
                do
                dw              _bl
                dw              _word
                dw              _dup
                dw              _toupper
                dw              _dup
                dw              _toasciiz
                dw              _do_make
                dw              _st_com
                dw              _exit

ifdup_:         db              4,'?DUP',0
                dk              make_unit_
                _ifdup:
                pop             ax
                cmp             ax,0
                jz              no_ifdup
                push            ax
                no_ifdup:
                push            ax
                jmp             word ptr [ent]

div_mod_:       db              4,'/MOD',0
                dk              ifdup_
                _div_mod:
                pop             bx
                pop             ax
                cmp             bx,0
                jz              no_divmod
                cwd
                div             bx
                push            dx
                push            ax
                jmp             word ptr [ent]
                no_divmod:
                mov             word ptr [errcode],0
                mov             ax,offset error__
                jmp             ax

prn_str_:       db              2,'."',128+1
                dk              div_mod_
                _prn_str:
                do
                dw              _ifcomp
                dw              _st
                dw              _putword
                dw              _print
                dw              _comp
                dw              _exit

do_x_:          db              4,'(DO)',14
                dk              prn_str_
                _do_x:


;                lodsw
;                add             ax,si
;                pop             bx
;                pop             dx
;                xchg            bp,sp
;                push            ax
;                mov             ax,8000h
;                sub             ax,dx
;                push            ax
;                add             ax,bx
;                push            ax
;                xchg            bp,sp


                lodsw
                add             ax,si
                pop             cx
                pop             dx
                xchg            bp,sp
                push            ax
                push            dx
                push            cx
                xchg            bp,sp
                jmp             word ptr [ent]

do_:            db              2,'DO',128+1
                dk              do_x_
                _do:
                do
                dw              _ifcomp
                dw              _putword
                dw              _do_x
                dw              _comp
                dw              _here
                dw              _false
                dw              _comp
                dw              _number
                dw              123dh
                dw              _exit

leave_:         db              5,'LEAVE',0
                dk              do_
                _leave:


                mov             si,word ptr [bp+4]
                add             bp,6

;                xchg            bp,sp
;                pop             ax
;                pop             ax
;                pop             si
;                xchg            bp,sp
                jmp             word ptr [ent]

loop_x_:        db              6,'(LOOP)',14
                dk              leave_
                _loop_x:


;                add             word ptr [bp],1
;                jo              end_loop_ks
;                lodsw
;                add             si,ax
;                jmp             word ptr [ent]
;                end_loop_ks:
;                add             si,2


                lodsw
                add             ax,si
                inc             word ptr [bp]
                mov             bx,word ptr [bp]
                cmp             bx,word ptr [bp+2]
                jz              exit_loop_x
                mov             si,ax
                jmp             word ptr [ent]
                exit_loop_x:
                add             bp,6
                jmp             word ptr [ent]

ploop_x_:       db              7,'(+LOOP)',14
                dk              loop_x_
                _ploop_x:


;                pop             ax
;                add             word ptr [bp],ax
;                jo              end_loop_ks2
;                lodsw
;                add             si,ax
;                jmp             word ptr [ent]
;                end_loop_ks2:
;                add             si,2


                lodsw
                add             ax,si
                pop             bx
                add             word ptr [bp],bx
                mov             bx,word ptr [bp]
                cmp             bx,word ptr [bp+2]
                jz              exit_ploop_x
                mov             si,ax
                jmp             word ptr [ent]
                exit_ploop_x:
                add             bp,6
                jmp             word ptr [ent]

loop_:          db              4,'LOOP',128+1
                dk              ploop_x_
                _loop:
                do
                dw              _ifcomp
                dw              _number
                dw              123dh
                dw              _ifpairs
                dw              _putword
                dw              _loop_x
                dw              _comp
                dw              _dup
                dw              _here
                dw              _mines
                dw              _comp
                dw              _here
                dw              _over
                dw              _plus_2
                dw              _mines
                dw              _swap
                dw              _prisv
                dw              _exit

ploop_:         db              5,'+LOOP',128+1
                dk              loop_
                _ploop:
                do
                dw              _ifcomp
                dw              _number
                dw              123dh
                dw              _ifpairs
                dw              _putword
                dw              _ploop_x
                dw              _comp
                dw              _dup
                dw              _here
                dw              _mines
                dw              _comp
                dw              _here
                dw              _over
                dw              _plus_2
                dw              _mines
                dw              _swap
                dw              _prisv
                dw              _exit

i_:             db              1,'I',0
                dk              ploop_
                _i:


;                mov             ax,word ptr [bp]
;                sub             ax,word ptr [bp+2]
;                push            ax


                push            word ptr [bp]
                jmp             word ptr [ent]

j_:             db              1,'J',0
                dk              i_
                _j:


;                mov             ax,word ptr [bp+6]
;                sub             ax,word ptr [bp+8]
;                push            ax


                push            word ptr [bp+6]
                jmp             word ptr [ent]

k_:             db              1,'K',0
                dk              j_
                _k:


;                mov             ax,word ptr [bp+12]
;                sub             ax,word ptr [bp+14]
;                push            ax


                push            word ptr [bp+12]
                jmp             word ptr [ent]

l_:             db              1,'L',0
                dk              k_
                _l:
                push            word ptr [bp+18]
                jmp             word ptr [ent]

m_:             db              1,'M',0
                dk              l_
                _m:
                push            word ptr [bp+24]
                jmp             word ptr [ent]

s0_:            db              2,'S0',0
                dk              m_
                _s0:
                mov             ax,offset s0
                push            ax
                jmp             word ptr [ent]

r0_:            db              2,'R0',0
                dk              s0_
                _r0:
                mov             ax,offset r0
                push            ax
                jmp             word ptr [ent]

case_:          db              4,'CASE',1+128
                dk              r0_
                _case:
                do
                dw              _ifcomp
                dw              _number
                dw              1238h
                dw              _number
                dw              123eh
                dw              _exit

of_:            db              2,'OF',128+1
                dk              case_
                _of:
                do
                dw              _ifcomp
                dw              _number
                dw              123eh
                dw              _ifpairs
                dw              _putword
                dw              _over
                dw              _comp
                dw              _putword
                dw              _equal
                dw              _comp
                dw              _if
                dw              _putword
                dw              _drop
                dw              _comp
                dw              _number
                dw              123fh
                dw              _exit

endof_:         db              5,'ENDOF',128+1
                dk              of_
                _endof:
                do
                dw              _ifcomp
                dw              _number
                dw              123fh
                dw              _ifpairs
                dw              _else
                dw              _number
                dw              123eh
                dw              _exit

endcase_:       db              7,'ENDCASE',128+1
                dk              endof_
                _endcase:
                do
                dw              _ifcomp
                dw              _number
                dw              123eh
                dw              _ifpairs
                end_cs_1:

                dw              _dup
                dw              _number
                dw              123ch
                dw              _equal

                dw              _fbranch
                dj              end_cs_2
                dw              _then
                dw              _branch
                dj              end_cs_1
                end_cs_2:
                dw              _drop
                dw              _exit

put_c_code_:    db              2,'C"',1+128
                dk              endcase_
                _put_c_code:
                do
                dw              _bl
                dw              _word
                dw              _plus_1
                dw              _craz
                dw              _state
                dw              _raz
                dw              _fbranch
                dj              put_c_1
                dw              _putword
                dw              _number
                dw              _comp
                dw              _comp
                put_c_1:
                dw              _exit

plus_prisv_:    db              2,'+!',0
                dk              put_c_code_
                _plus_prisv:
                pop             bx
                pop             ax
                add             word ptr [bx],ax
                jmp             word ptr [ent]

mines_prisv_:   db              2,'-!',0
                dk              plus_prisv_
                _mines_prisv:
                pop             bx
                pop             ax
                sub             word ptr [bx],ax
                jmp             word ptr [ent]

mult2_:         db              2,'2*',0
                dk              mines_prisv_
                _mult2:
                pop             ax
                shl             ax,1
                push            ax
                jmp             word ptr [ent]

div2_:          db              2,'2/',0
                dk              mult2_
                _div2:
                pop             ax
                sar             ax,1
                push            ax
                jmp             word ptr [ent]

udiv2_:         db              3,'U2/',0
                dk              div2_
                _udiv2:
                pop             ax
                shr             ax,1
                push            ax
                jmp             word ptr [ent]

var2_:          db              9,'2VARIABLE',1
                dk              udiv2_
                _var2:
                do
                dw              _create
                dw              _false
                dw              _comp
                dw              _false
                dw              _comp
                dw              _exit

comp2_:         db              2,'2,',0
                dk              var2_
                _comp2:
                mov             bx,word ptr [upvoc]
                pop             word ptr [bx]
                pop             word ptr [bx+2]
                add             word ptr [upvoc],4
                jmp             word ptr [ent]

literal_:       db              7,'LITERAL',1+128
                dk              comp2_
                _literal:
                do
                dw              _state
                dw              _raz
                dw              _fbranch
                dj              nolit_1
                dw              _putword
                dw              _number
                dw              _comp
                dw              _comp
                nolit_1:
                dw              _exit

dliteral_:      db              8,'DLITERAL',1+128
                dk              literal_
                _dliteral:
                do
                dw              _state
                dw              _raz
                dw              _fbranch
                dj              no_dlit
                dw              _putword
                dw              _number2
                dw              _comp
                dw              _comp2
                no_dlit:
                dw              _exit

ifnot_:         db              5,'IFNOT',1+128
                dk              dliteral_
                _ifnot:
                do
                dw              _ifcomp
                dw              _putword
                dw              _eq0
                dw              _comp
                dw              _putword
                dw              _fbranch
                dw              _comp
                dw              _here
                dw              _false
                dw              _comp
                dw              _number
                dw              123ch
                dw              _exit

recurse_:       db              7,'RECURSE',1+128
                dk              ifnot_
                _recurse:
                do
                dw              _ifcomp
                dw              _latest
                dw              _frname
                dw              _comp
                dw              _exit

lemit_:         db              5,'LEMIT',0
                dk              recurse_
                _lemit:
                pop             ax
                xor             dx,dx
                mov             ah,0
                int             17h
                jmp             word ptr [ent]

ltype_:         db              5,'LTYPE',0
                dk              lemit_
                _ltype:
                pop             cx
                pop             bx
                lt_1:
                mov             al,byte ptr [bx]
                mov             ah,0
                xor             dx,dx
                int             17h
                inc             bx
                loop            lt_1
                jmp             word ptr [ent]

replace_:       db              7,'REPLACE',1
                dk              ltype_
                _replace:
                do
                dw              _apostr
                dw              _apostr

;                dw              _dup2
;                dw              _number
;                dw              3
;                dw              _mines
;                dw              _swap
;                dw              _number
;                dw              3
;                dw              _mines
;                dw              _craz
;                dw              _swap
;                dw              _cprisv

                dw              _swap
                dw              _number
                dw              0e9h
                dw              _over
                dw              _cprisv
                dw              _plus_1
                dw              _dup
                dw              _tor
                dw              _mines
                dw              _mines_2
                dw              _frr
                dw              _prisv
                dw              _exit

ifkey_:         db              4,'?KEY',0
                dk              replace_
                _ifkey:
                mov             bx,offset getstat
                call            bx
                jz              no_char
                mov             bx,offset getchar
                call            bx
                mov             ah,0
                push            ax
                mov             ax,0ffffh
                ifk_1:
                push            ax
                jmp             word ptr [ent]
                no_char:
                xor             ax,ax
                jmp             ifk_1

ummult_:        db              3,'UM*',0
                dk              ifkey_
                _ummult:
                pop             ax
                pop             bx
                mul             bx
                push            ax
                push            dx
                jmp             word ptr [ent]

mult_div_:      db              2,'*/',0
                dk              ummult_
                _mult_div:
                pop             bx
                cmp             bx,0
                jz              no_mult_div
                pop             cx
                pop             ax
                mul             cx
                mov             di,ax
                mov             ax,dx
                xor             dx,dx
                div             bx
                mov             ax,di
                div             bx
                push            ax
                jmp             word ptr [ent]
                no_mult_div:
                mov             word ptr [errcode],0
                mov             bx,offset error__
                jmp             bx

mplus_:         db              2,'M+',0
                dk              mult_div_
                _mplus:
                pop             bx
                pop             dx
                pop             ax
                add             ax,bx
                adc             dx,0
                push            ax
                push            dx
                jmp             word ptr [ent]

dplus_:         db              2,'D+',0
                dk              mplus_
                _dplus:
                pop             dx
                pop             ax
                pop             cx
                pop             bx
                add             ax,bx
                adc             dx,cx
                push            ax
                push            dx
                jmp             word ptr [ent]

dmines_:        db              2,'D-',0
                dk              dplus_
                _dmines:
                pop             dx
                pop             ax
                pop             cx
                pop             bx
                sub             bx,ax
                sbb             cx,dx
                push            bx
                push            cx
                jmp             word ptr [ent]

dabs_:          db              4,'DABS',0
                dk              dmines_
                _dabs:
                pop             dx
                pop             ax
                test            dh,128
                jz              no_dabs
                not             ax
                not             dx
                add             ax,1
                adc             dx,0
                no_dabs:
                push            ax
                push            dx
                jmp             word ptr [ent]

d0m_:           db              3,'D0<',0
                dk              dabs_
                _d0m:
                pop             ax
                pop             dx
                test            ah,128
                jz              put_f_d0m
                mov             ax,0ffffh
                d0m_1:
                push            ax
                jmp             word ptr [ent]
                put_f_d0m:
                xor             ax,ax
                jmp             d0m_1

dnegate_:       db              7,'DNEGATE',0
                dk              d0m_
                _dnegate:
                pop             dx
                pop             ax
                not             ax
                not             dx
                add             ax,1
                adc             dx,0
                push            ax
                push            dx
                jmp             word ptr [ent]

mult_div_mod_:  db              5,'*/MOD',0
                dk              dnegate_
                _mult_div_mod:
                pop             bx
                cmp             bx,0
                jz              no_mult_div_mod
                pop             cx
                pop             ax
                mul             cx
                mov             di,ax
                mov             ax,dx
                xor             dx,dx
                div             bx
                mov             ax,di
                div             bx
                push            dx
                push            ax
                jmp             word ptr [ent]
                no_mult_div_mod:
                mov             word ptr [errcode],0
                mov             bx,offset error__
                jmp             bx

tolow_:
                db              4,'>LOW',0
                dk              mult_div_mod_
                _tolow:
                pop             bx
                mov             cl,byte ptr [bx]
                mov             ch,0
                tolow0:
                inc             bx
                jcxz            tolowend
                mov             al,byte ptr [bx]
                dec             cx
                cmp             al,'A'
                jc              tolow0
                cmp             al,'Z'
                ja              tolow0
                add             byte ptr [bx],32
                jmp             short tolow0
                tolowend:
                jmp             word ptr [ent]

comment_:       db              1,'(',1+128
                dk              tolow_
                _comment:
                do
                dw              _number
                dw              41
                dw              _word
                dw              _drop
                dw              _exit

malloc_:        db              6,'MALLOC',0
                dk              comment_
                _malloc:
                pop             bx
                push            bp
                push            si
                mov             ah,48h
                int             21h
                mov             word ptr [errcode],ax
                pop             si
                pop             bp
                jc              malloc_err
                push            ax
                mov             ax,0ffffh
                malloc_end:
                push            ax
                jmp             word ptr [ent]
                malloc_err:
                push            bx
                xor             ax,ax
                jmp             short malloc_end

mfree_:         db              5,'MFREE',0
                dk              malloc_
                _mfree:
                pop             es
                push            bp
                push            si
                mov             ah,49h
                int             21h
                mov             word ptr [errcode],ax
                pop             si
                pop             bp
                jc              err_mfree
                mov             ax,0ffffh
                end_mfree:
                push            ax
                jmp             word ptr [ent]
                err_mfree:
                xor             ax,ax
                jmp             end_mfree

mmodify_:       db              4,'MSET',0
                dk              mfree_
                _mmodify:
                pop             bx
                pop             es
                push            bp
                push            si
                mov             ah,4ah
                int             21h
                mov             word ptr [errcode],ax
                pop             si
                pop             bp
                jc              mset_err
                mov             ax,0ffffh
                mset_end:
                push            ax
                jmp             word ptr [ent]
                mset_err:
                push            bx
                xor             ax,ax
                jmp             short mset_end

tsr_:           db              3,'TSR',0
                dk              mmodify_
                _tsr:
                savebpspsi
                mov             ax,word ptr [m_size]
                cli
                cmp             ax,65535
                jz              set_regpnt_
                add             ax,word ptr [upvoc]
                set_regpnt_:
                mov             word ptr [regpnt],ax
                mov             bx,cs
                mov             ss,bx
                mov             sp,ax
                sub             sp,100
                mov             cl,4
                shr             ax,cl
                add             ax,bx
                inc             ax
                mov             word ptr [stack_seg],ax
                xor             bx,bx
                mov             es,bx
                tsr_loop_:
                cmp             word ptr es:[bx],0
                jnz             tsr_next
                mov             es,word ptr es:[bx+2]
                cmp             byte ptr es:[2],0f4h
                jnz             tsr_next
                push            es
                xor             ax,ax
                mov             es,ax
                mov             ax,word ptr [stack_seg]
                mov             word ptr es:[bx+2],ax
                pop             es
                call            move_int
                tsr_next:
                xor             ax,ax
                mov             es,ax
                add             bx,4
                cmp             bx,1024
                jc              tsr_loop_
                mov             dx,word ptr [stack_seg]
                mov             ax,cs
                sub             dx,ax
                mov             es,ax
                mov             ax,3100h
                sti
                int             21h
                mov             ax,offset no_forth_mem
                jmp             ax
                move_int:
                push            ds
                push            es
                pop             ds
                mov             cx,word ptr ds:[14h]
                mov             es,word ptr cs:[stack_seg]
                mov             ax,cx
                inc             cx
                inc             cx
                shr             ax,1
                shr             ax,1
                shr             ax,1
                shr             ax,1
                inc             ax
                add             word ptr cs:[stack_seg],ax
                xor             si,si
                xor             di,di
                cld
                rep             movsb
                pop             ds
                ret

errno_:         db              5,'ERRNO',0
                dk              tsr_
                _errno:
                mov             ax,offset errcode
                push            ax
                jmp             word ptr [ent]

ss0_:           db              3,'SS0',0
                dk              errno_
                _ss0:
                mov             ax,offset ss0
                push            ax
                jmp             word ptr [ent]

ssp_:           db              3,'SSP',0
                dk              ss0_
                _ssp:
                mov             ax,offset ssp
                push            ax
                jmp             word ptr [ent]

depth_:         db              5,'DEPTH',0
                dk              ssp_
                _depth:
                mov             ax,word ptr [s0]
                sub             ax,sp
                sar             ax,1
                push            ax
                jmp             word ptr [ent]

pick_:          db              4,'PICK',0
                dk              depth_
                _pick:
                pop             ax
                shl             ax,1
                mov             bx,sp
                add             bx,ax
                push            word ptr ss:[bx]
                jmp             word ptr [ent]

rpick_:         db              5,'RPICK',0
                dk              pick_
                _rpick:
                pop             ax
                shl             ax,1
                mov             bx,bp
                add             bx,ax
                push            word ptr ss:[bx]
                jmp             word ptr [ent]

setstr_:        db              9,'SETSTREAM',0
                dk              rpick_
                _setstr:
                pop             bx
                mov             al,byte ptr [bx]
                mov             ah,0
                mov             word ptr [maxpos],ax
                mov             word ptr [inpos],0
                inc             bx
                mov             word ptr [tibadr],bx
                jmp             word ptr [ent]

backspace_:     db              9,'BACKSPACE',1
                dk              setstr_
                _backspace:
                do
                dw              _typeasc
                db              8,' ',8,0
                dw              _exit

backspaces_:    db              10,'BACKSPACES',1
                dk              backspace_
                _backspaces:
                do
                _backsp:
                dw              _dup
                dw              _fbranch
                dj              end_bs
                dw              _mines_1
                dw              _backspace
                dw              _branch
                dj              _backsp
                end_bs:
                dw              _drop
                dw              _exit

string_:        db              6,'STRING',1
                dk              backspaces_
                _string:
                do
                dw              _create
                dw              _strcomp
                dw              _exit

asciiz_:        db              6,'ASCIIZ',1
                dk              string_
                _asciiz:
                do
                dw              _create
                dw              _here
                dw              _swap
                dw              _strcomp
                dw              _toasciiz
                dw              _exit

razraz_:        db              2,'@@',0
                dk              asciiz_
                _razraz:
                pop             bx
                mov             bx,word ptr [bx]
                push            word ptr [bx]
                jmp             word ptr [ent]

razcraz_:       db              3,'@C@',0
                dk              razraz_
                _razcraz:
                mov             bx,word ptr [bx]
                mov             al,byte ptr [bx]
                mov             ah,0
                push            ax
                jmp             word ptr [ent]

hexnum_:        db              1,'$',1+128
                dk              razcraz_
                _hexnum:
                do
                dw              _base
                dw              _raz
                dw              _bl
                dw              _word
                dw              _dup
                dw              _toupper
                dw              _hex
                dw              _val
                dw              _fbranch
                dj              hexerr
                dw              _dpl
                dw              _raz
                dw              _plus_1
                dw              _fbranch
                dj              hex_ok
                dw              _number
                dw              18
                dw              _error
                dw              _exit
                hex_ok:
                dw              _drop
                dw              _state
                dw              _raz
                dw              _fbranch
                dj              no_comp_hex
                dw              _putword
                dw              _number
                dw              _comp
                dw              _comp
                dw              _base
                dw              _prisv
                dw              _exit
                no_comp_hex:
                dw              _swap
                dw              _base
                dw              _prisv
                dw              _exit
                hexerr:
                dw              _number
                dw              1
                dw              _error
                dw              _exit

ts_:            db              2,'.(',1+128
                dk              hexnum_
                _ts:
                do
                dw              _ifexec
                dw              _number
                dw              29h
                dw              _word
                dw              _here
                dw              _swap
                dw              _strcomp
                dw              _dup
                dw              _number
                dw              upvoc
                dw              _prisv
                dw              _print
                dw              _exit

rename_:        db              6,'RENAME',1+128
                dk              ts_
                _rename:
                do
                dw              _apostr
                dw              _toname
                dw              _bl
                dw              _word
                dw              _over
                dw              _over
                dw              _craz
                dw              _swap
                dw              _craz
                dw              _equal
                dw              _fbranch
                dj              cantren
                dw              _dup
                dw              _craz
                dw              _plus_1
                dw              _tor
                dw              _swap
                dw              _cs
                dw              _swap
                dw              _cs
                dw              _frr
                dw              _cmove
                dw              _exit
                cantren:
                dw              _number
                dw              19
                dw              _error
                dw              _exit

reg_:           db              9,'REGISTERS',1
                dk              rename_
                _reg:
                do
                dw              _create
                dw              _number
                dw              16
                dw              _allot
                dw              _number
                dw              200h
                dw              _comp
                dw              _false
                dw              _comp
                dw              _cs
                dw              _comp
                dw              _cs
                dw              _comp
                dw              _cs
                dw              _comp
                dw              _cs
                dw              _comp
                dw              _exit

rax_:           db              2,'AX',0
                dk              reg_
                _rax:
                jmp             word ptr [ent]

rbx_:           db              2,'BX',0
                dk              rax_
                _rbx:
                pop             ax
                inc             ax
                inc             ax
                push            ax
                jmp             word ptr [ent]

rcx_:           db              2,'CX',0
                dk              rbx_
                _rcx:
                pop             ax
                add             ax,4
                push            ax
                jmp             word ptr [ent]

rdx_:           db              2,'DX',0
                dk              rcx_
                _rdx:
                pop             ax
                add             ax,6
                push            ax
                jmp             word ptr [ent]

rsi_:           db              2,'SI',0
                dk              rdx_
                _rsi:
                pop             ax
                add             ax,8
                push            ax
                jmp             word ptr [ent]

rdi_:           db              2,'DI',0
                dk              rsi_
                _rdi:
                pop             ax
                add             ax,10
                push            ax
                jmp             word ptr [ent]

rbp_:           db              2,'BP',0
                dk              rdi_
                _rbp:
                pop             ax
                add             ax,12
                push            ax
                jmp             word ptr [ent]

rsp_:           db              2,'SP',0
                dk              rbp_
                _rsp:
                pop             ax
                add             ax,14
                push            ax
                jmp             word ptr [ent]

rfl_:           db              5,'FLAGS',0
                dk              rsp_
                _rfl:
                pop             ax
                add             ax,16
                push            ax
                jmp             word ptr [ent]

rip_:           db              2,'IP',0
                dk              rfl_
                _rip:
                pop             ax
                add             ax,18
                push            ax
                jmp             word ptr [ent]

rcs_:           db              2,'CS',0
                dk              rip_
                _rcs:
                pop             ax
                add             ax,20
                push            ax
                jmp             word ptr [ent]

rds_:           db              2,'DS',0
                dk              rcs_
                _rds:
                pop             ax
                add             ax,22
                push            ax
                jmp             word ptr [ent]

rss_:           db              2,'SS',0
                dk              rds_
                _rss:
                pop             ax
                add             ax,24
                push            ax
                jmp             word ptr [ent]

res_:           db              2,'ES',0
                dk              rss_
                _res:
                pop             ax
                add             ax,26
                push            ax
                jmp             word ptr [ent]

high_:          db              5,'>HIGH',0
                dk              res_
                _high:
                pop             ax
                inc             ax
                push            ax
                jmp             word ptr [ent]

rdepth_:        db              6,'RDEPTH',0
                dk              high_
                _rdepth:
                mov             ax,word ptr [r0]
                sub             ax,bp
                shr             ax,1
                push            ax
                jmp             word ptr [ent]

smuge_:         db              5,'SMUGE',1
                dk              rdepth_
                _smuge:
                do
                dw              _bl
                dw              _apostr
                dw              _toname
                dw              _plus_1
                dw              _cprisv
                dw              _exit

smudge_:        db              6,'SMUDGE',1
                dk              smuge_
                _smudge:
                do
                dw              _bl
                dw              _apostr
                dw              _toname
                dw              _plus_1
                dw              _cprisv
                dw              _exit

exchange_:      db              8,'EXCHANGE',0
                dk              smudge_
                _exchange:
                pop             bx
                pop             di
                mov             ax,word ptr [bx]
                xchg            ax,word ptr cs:[di]
                mov             word ptr [bx],ax
                jmp             word ptr [ent]


dsqrt_:         db              5,'DSQRT',0
                dk              exchange_
                _dsqrt:
                pop             dx
                pop             ax
                test            dh,1
                jz              do_sqrt_
                mov             word ptr [errcode],0
                mov             ax,offset error__
                jmp             ax
                do_sqrt_:
                push            bp
                push            dx
                push            ax
                mov             bp,sp
                mov             bx,200
                div             bx
                add             ax,2
                next_app:
                mov             bx,ax
                mov             ax,word ptr [bp]
                mov             dx,word ptr [bp+2]
                div             bx
                add             ax,bx
                shr             ax,1
                cmp             ax,bx
                jz              sqrt_done
                sub             bx,ax
                cmp             bx,1
                jz              sqrt_done
                cmp             bx,-1
                jnz             next_app
                sqrt_done:
                pop             bx
                pop             dx
                pop             bp
                push            ax
                jmp             word ptr [ent]

; ( D1 N --> D2=D1*N )
dsmult_:        db              3,'DS*',0
                dk              dsqrt_
                _dsmult:
                pop             di
                pop             bx
                pop             cx
                mov             ax,cx
                mul             di
                push            dx
                mov             cx,ax
                mov             ax,bx
                mul             di
                pop             dx
                add             ax,dx
                push            cx
                push            ax
                jmp             word ptr [ent]

; ( Offset Segment Length Byte --> )
mfill_:         db              5,'MFILL',0
                dk              dsmult_
                _mfill:
                pop             ax
                pop             cx
                pop             es
                pop             di
                rep             stosb
                jmp             word ptr [ent]

zeroprisv_:     db              2,'0!',0
                dk              mfill_
                _zp:
                pop             bx
                mov             word ptr [bx],0
                jmp             word ptr [ent]

; ( Byte Port --> )
out_:           db              3,'OUT',0
                dk              zeroprisv_
                _out:
                pop             dx
                pop             ax
                out             dx,al
                jmp             word ptr [ent]

; ( Port --> Byte )
in_:            db              2,'IN',0
                dk              out_
                _in:
                pop             dx
                in              al,dx
                mov             ah,0
                push            ax
                jmp             word ptr [ent]

dzb_:           db              3,'D0>',0
                dk              in_
                _dzb:
                pop             dx
                pop             ax
                sub             ax,1
                sbb             dx,0
                test            dh,128
                jz              tr_dzb
                xor             ax,ax
                end_dzb:
                push            ax
                jmp             word ptr [ent]
                tr_dzb:
                mov             ax,0ffffh
                jmp             end_dzb

dz_:            db              3,'D0=',0
                dk              dzb_
                _dz:
                pop             ax
                pop             dx
                or              ax,dx
                jz              dz_tr
                xor             ax,ax
                dz_end:
                push            ax
                jmp             word ptr [ent]
                dz_tr:
                mov             ax,0ffffh
                jmp             dz_end

dm_:            db              2,'D<',1
                dk              dz_
                _dm:
                do
                dw              _dmines
                dw              _d0m
                dw              _exit

db_:            db              2,'D>',1
                dk              dm_
                _db:
                do
                dw              _dmines
                dw              _dzb
                dw              _exit

de_:            db              2,'D=',1
                dk              db_
                _de:
                do
                dw              _dmines
                dw              _dz
                dw              _exit

dmult_:         db              2,'D*',0
                dk              de_
                _dmult:
                pop             cx
                pop             ax
                pop             bx
                pop             dx
                push            si
                push            ax
                push            dx
                mul             dx
                mov             di,dx
                mov             si,ax
                pop             ax
                mul             cx
                add             di,ax
                mov             cx,si
                pop             ax
                mul             bx
                add             di,ax
                pop             si
                push            cx
                push            di
                jmp             word ptr [ent]

; ( D1 N1 --> D2=D1/N1 N2=Mod )
dsdivmod_:      db              6,'DS/MOD',0
                dk              dmult_
                _dsdivmod:
                pop             di
                pop             ax
                pop             bx
                xor             dx,dx
                div             di
                xchg            ax,bx
                div             di
                push            ax
                push            bx
                push            dx
                jmp             word ptr [ent]

mrot_:          db              4,'-ROT',0
                dk              dsdivmod_
                _mrot:
                pop             ax
                pop             bx
                pop             cx
                push            ax
                push            cx
                push            bx
                jmp             word ptr [ent]

aattp_:
                db              4,'(A")',8
                dk              mrot_
                _aattp:
                push            si
                aattpp:
                lodsb
                cmp             al,0
                jnz             aattpp
                jmp             word ptr [ent]

ast_:
                db              2,'A"',1+128
                dk              aattp_
                _ast:
                do
                dw              _ifcomp

                dw              _here

                dw              _number
                dw              34
                dw              _word

                dw              _putword
                dw              _aattp
                dw              _comp

                dw              _strcomp
                dw              _plus_2
                dw              _toasciiz
                dw              _exit

; ( Code Left Right --> Flag )
within_:        db              6,'WITHIN',0
                dk              ast_
                _within:
                pop             cx
                pop             dx
                pop             ax
                cmp             ax,dx
                jc              false_win
                cmp            cx,ax
                jc              false_win
                mov             ax,0ffffh
                end_win:
                push            ax
                jmp             word ptr [ent]
                false_win:
                xor             ax,ax
                jmp             short end_win


zero_:          db              1,'0',128+1
                dk              within_
                _zero:
                do
                dw              _state
                dw              _raz
                dw              _fbranch
                dj              pushzero
                dw              _putword
                dw              _false
                dw              _comp
                dw              _exit
                pushzero:
                dw              _false
                dw              _exit


nullstring_:    db              10,'NULLSTRING',1
                dk              zero_
                _nullstring:
                call            next
                db              0


; ( StartOffset Segment AreaLen BlockAddr BlockLen --> {Offset Segment} Flag )
search_:        db              6,'SEARCH',0
                dk              nullstring_
                _search:
                mov             word ptr [time_x],si
                pop             dx
                pop             si
                pop             cx
                pop             es
                pop             di
                or              dx,dx
                jz              search_found_
                cmp             cx,dx
                jc              search_not_found_
                dec             dx
                sub             cx,dx
                lodsb
                start_search_:
                repne           scasb
                jnz             search_not_found_
                push            cx
                push            si
                push            di
                mov             cx,dx
                repe            cmpsb
                pop             di
                pop             si
                pop             cx
                jnz             start_search_
                dec             di
                search_found_:
                push            di
                push            es
                mov             ax,0ffffh
                end_search_:
                push            ax
                mov             si,word ptr [time_x]
                jmp             word ptr [ent]
                search_not_found_:
                xor             ax,ax
                jmp             short end_search_

; ( TableOffset TableSegment Char1 --> Char2 )
xlat_:          db              4,'XLAT',0
                dk              search_
                _xlat:
                pop             ax
                pop             bx
                pop             ds
                xlat
                push            cs
                pop             ds
                mov             ah,0
                push            ax
                jmp             word ptr [ent]

; ( TableOffset TableSegment BlockOffset BlockSegment BlockLength --> )
decode_:        db              6,'DECODE',0
                dk              xlat_
                _decode:
                pop             cx
                pop             es
                pop             di
                pop             ds
                pop             bx
                dec_1:
                mov             al,byte ptr es:[di]
                xlat
                stosb
                loop            dec_1
                push            cs
                pop             ds
                jmp             word ptr [ent]

debug_:         db              5,'DEBUG',0
                dk              decode_
                _debug:
                mov             ax,offset debug
                push            ax
                jmp             word ptr [ent]


st_com_:        db              2,'--',1+128
                dk              debug_
                _st_com:
                do
                dw              _number
                dw              10
                dw              _word
                dw              _drop
                dw              _exit


option_:        db              6,'OPTION',0
                dk              st_com_
                _option:
                mov             cx,word ptr [inpos]
                mov             bx,word ptr [tibadr]
                add             bx,cx
                is_empty_inp:
                cmp             cx,word ptr [maxpos]
                jnz             cont_search_opt
                no_opt:
                xor             ax,ax
                push            ax
                jmp             word ptr [ent]
                cont_search_opt:
                cmp             byte ptr [bx],'/'
                jz              found_opt
                inc             bx
                inc             cx
                mov             word ptr [inpos],cx
                jmp             short is_empty_inp
                found_opt:
                inc             bx
                inc             cx
                mov             word ptr [inpos],cx
                cmp             cx,word ptr [maxpos]
                jz              no_opt
                inc             word ptr [inpos]
                mov             al,byte ptr [bx]
                cmp             al,'a'
                jc              no_and_opt
                cmp             al,'z'
                ja              no_and_opt
                and             al,5fh
                no_and_opt:
                mov             ah,0
                push            ax
                jmp             word ptr [ent]

clear_init_:    db              9,'CLEARINIT',1
                dk              option_
                _clear_init:
                do
                dw              _bl
                dw              _word
                dw              _find
                dw              _fbranch
                dj              wnf_clin
                dw              _mines_1
                dw              _mines_2
                dw              _dup
                dw              _craz
                dw              _number
                dw              255-32
                dw              _and
                dw              _swap
                dw              _cprisv
                dw              _exit
                wnf_clin:
                dw              _number
                dw              1
                dw              _number
                dw              errcode
                dw              _prisv
                dw              _abort


clear_para_:    db              9,'CLEARPARA',1
                dk              clear_init_
                _clear_para:
                do
                dw              _bl
                dw              _word
                dw              _find
                dw              _fbranch
                dj              wnf_clpara
                dw              _mines_1
                dw              _mines_2
                dw              _dup
                dw              _craz
                dw              _number
                dw              255-32
                dw              _and
                dw              _swap
                dw              _cprisv
                dw              _exit
                wnf_clpara:
                dw              _number
                dw              1
                dw              _number
                dw              errcode
                dw              _prisv
                dw              _abort

set_attr_:      db              7,'SETATTR',1
                dk              clear_para_
                _set_para:
                do
                dw              _apostr
                dw              _number
                dw              3
                dw              _mines
                dw              _cprisv
                dw              _exit

get_attr_:      db              7,'GETATTR',1
                dk              set_attr_
                _get_attr:
                do
                dw              _apostr
                dw              _number
                dw              3
                dw              _mines
                dw              _craz
                dw              _exit

; ( N Addr --> )
p_prisv_:       db              3,' P!',1
                dk              get_attr_
                _p_prisv:
                savebpspsi
                pop             bx
                pop             word ptr [bx]
                push            si
                mov             ax,word ptr [comp_seg]
                cmp             ax,0
                jnz             comp_seg_present_
                mov             ah,48h
                mov             bx,301h
                int             21h
                jnc             comp_seg_p_
                mov             word ptr [errcode],9
                mov             ax,offset error
                jmp             ax
                comp_seg_p_:
                mov             word ptr [comp_seg],ax
                mov             ds,ax
                mov             si,1
                jmp             short put_p_prisv_
                comp_seg_present_:
                mov             ds,ax
                xor             si,si
                l_p_1_:
                lodsb
                cmp             al,255
                jz              put_p_prisv_
                inc             si
                inc             si
                jmp             l_p_1_
                put_p_prisv_:
                mov             byte ptr [si-1],0
                mov             ax,bx
                stosw
                mov             al,255
                stosb
                pop             si
                push            cs
                pop             ds
                jmp             word ptr [ent]


p_comp_:        db              3,' P,',1
                dk              p_prisv_
                _p_comp:
                do
                dw              _here
                dw              _p_prisv
                dw              _number
                dw              2
                dw              _allot
                dw              _exit


inc_1_:         db              1,' ',0
                dk              p_comp_
                _inc_1:
                savebpspsi
                xchg            bp,sp
                push            word ptr [handle]
                push            word ptr [bufseg]
                push            word ptr [maxbuf]
                push            word ptr [bufpnt]
                xchg            bp,sp
                pop             dx
                mov             bx,dx
                cmp             byte ptr [bx],0
                jnz             fname_inc_present_
                mov             word ptr [errcode],10
                mov             ax,offset error
                jmp             ax
                fname_inc_present_:
                mov             ax,3d00h
                int             21h
                jnc             file_inc_opened_
                mov             word ptr [errcode],21
                mov             ax,offset error
                jmp             ax
                file_inc_opened_:
                mov             word ptr [handle],ax
                mov             ah,48h
                mov             bx,256
                int             21h
                jnc             inc_mem_ok_
                mov             word ptr [errcode],9
                mov             ax,offset error
                jmp             ax
                inc_mem_ok_:
                mov             word ptr [bufseg],ax
                mov             word ptr [bufpnt],4096
                mov             word ptr [maxbuf],4096
                jmp             word ptr [ent]


inc_2_:         db              1,' ',0
                dk              inc_1_
                _inc_2:
                mov             bx,word ptr [handle]
                mov             ah,3eh
                int             21h
                mov             es,word ptr [bufseg]
                mov             ah,49h
                int             21h
                xchg            bp,sp
                pop             word ptr [bufpnt]
                pop             word ptr [maxbuf]
                pop             word ptr [bufseg]
                pop             word ptr [handle]
                xchg            bp,sp
                jmp             word ptr [ent]


include_:       db              7,'INCLUDE',1
                dk              inc_2_
                _include:
                do
                dw              _bl
                dw              _word
                dw              _dup
                dw              _toasciiz
                dw              _inc_1
                f0001b:
                dw              _number
                dw              maxbuf
                dw              _raz
                dw              _number
                dw              5000
                dw              _equal
                dw              _fbranch
                dj              fx_01b
                ;  䠩
                dw              _inc_2
                dw              _number
                dw              13
                dw              _word
                dw              _drop
                dw              _exit
                fx_01b:
                dw              _getstring
                dw              _interpret
                dw              _branch
                dj              f0001b


byte_2_word_:   db              3,'B>W',0
                dk              include_
                _byte_2_word:
                pop             ax
                cbw
                push            ax
                jmp             word ptr [ent]


stack_segment_: db              12,'STACKSEGMENT',0
                dk              byte_2_word_
                _stack_segment:
                push            ss
                jmp             word ptr [ent]

call_dos_:      db              4,'FDOS',0
                dk              stack_segment_
                _call_dos:
                pop             bx
                push            bp
                push            si
                mov             ax,word ptr [bx]
                mov             cx,word ptr [bx+4]
                mov             dx,word ptr [bx+6]
                mov             si,word ptr [bx+8]
                mov             di,word ptr [bx+10]
                mov             es,word ptr [bx+26]
                mov             ds,word ptr [bx+22]
                push            bx
                mov             bx,word ptr cs:[bx+2]
                int             21h
                db              2eh
                storeerr:
                pop             bp
                pushf
                mov             word ptr cs:[bp+22],ds
                mov             word ptr cs:[bp+2],bx
                pop             word ptr cs:[bp+16]
                push            cs
                pop             ds
                mov             bx,bp
                mov             word ptr [bx],ax
                mov             word ptr [bx+4],cx
                mov             word ptr [bx+6],dx
                mov             word ptr [bx+8],si
                mov             word ptr [bx+10],di
                mov             word ptr [bx+26],es
                pop             si
                pop             bp
                jmp             word ptr [ent]

intr_:          db              4,'INTR',0
                dk              call_dos_
                _intr:
                pop             bx
                pop             di
                xor             ax,ax
                mov             es,ax
                shl             di,1
                shl             di,1
                and             di,1023
                push            bp
                push            si
                pushf
                push            cs
                call            ret_from_int
                push            ax
                push            bx
                mov             ax,word ptr cs:[errcode]
                mov             bx,ax
                pushf
                mov             word ptr cs:[bx+22],ds
                pop             word ptr cs:[bx+16]
                pop             word ptr cs:[bx+2]
                pop             word ptr cs:[bx]
                push            cs
                pop             ds
                mov             word ptr [bx+12],bp
                mov             word ptr [bx+4],cx
                mov             word ptr [bx+6],dx
                mov             word ptr [bx+8],si
                mov             word ptr [bx+10],di
                mov             word ptr [bx+26],es
                pop             si
                pop             bp
                jmp             word ptr [ent]
                ret_from_int:
                cli
                pushf
                sti
                push            word ptr es:[di+2]
                push            word ptr es:[di]
                mov             ax,word ptr [bx]
                mov             cx,word ptr [bx+4]
                mov             dx,word ptr [bx+6]
                mov             si,word ptr [bx+8]
                mov             di,word ptr [bx+10]
                mov             es,word ptr [bx+26]
                mov             bp,word ptr [bx+12]
                mov             ds,word ptr [bx+22]
                push            ax
                mov             ax,bx
                mov             word ptr cs:[errcode],ax
                pop             ax
                mov             bx,word ptr cs:[bx+2]
                iret

to_in_:         db              3,'>IN',0
                dk              intr_
                _to_in:
                mov             ax,offset inpos
                push            ax
                jmp             word ptr [ent]

stack_size_:    db              9,'STACKSIZE',0
                dk              to_in_
                _stack_size:
                mov             ax,offset st_size
                push            ax
                jmp             word ptr [ent]

ret_size_:      db              15,'RETURNSTACKSIZE',0
                dk              stack_size_
                _ret_size:
                mov             ax,offset rs_size
                push            ax
                jmp             word ptr [ent]

scr_size_:      db              15,'SCREENSTACKSIZE',0
                dk              ret_size_
                _scr_size:
                mov             ax,offset ss_size
                push            ax
                jmp             word ptr [ent]

mem_size_:      db              10,'MEMORYSIZE',0
                dk              scr_size_
                _mem_size:
                mov             ax,offset m_size
                push            ax
                jmp             word ptr [ent]

drop_all_:      db              7,'DROPALL',0
                dk              mem_size_
                _drop_all:
                mov             ax,word ptr [s0]
                mov             sp,ax
                jmp             word ptr [ent]

messages_:      db              8,'MESSAGES',0
                dk              drop_all_
                _messages:
                mov             ax,offset messages
                push            ax
                jmp             word ptr [ent]


; ( Int# HookProc ReturnStackSize StackSize ScreenStackSize --> )
hook_int_:      db              7,'HOOKINT',0
                dk              messages_
                _hook_int:
                nop
                call            final_int_

; *****************************************************************************
hook_code_:

ibase           equ             offset hook_code_

                jmp             short int_data_
                hlt

active_flag_:   db              0               ; 3
int_proc_:      dw              0               ; 4
forth_seg_:     dw              0               ; 6
std_ip_:        dw              0               ; 8
std_cs_:        dw              0               ; A
int_bp_:        dw              0               ; C
int_sp_:        dw              0               ; E
int_ssp_:       dw              0               ; 10
int_s0_:        dw              0               ; 12
int_r0_:        dw              0               ; 14
int_ss0_:       dw              0               ; 16

int_data_:      cli
                push            ds
                push            bx

                mov             ds,word ptr cs:[forth_seg_-ibase]
                mov             bx,word ptr [regpnt]

                sub             bx,50
                mov             word ptr [regpnt],bx
                pop             word ptr [bx+2]
                pop             word ptr [bx+22]
                pop             word ptr [bx+18]
                pop             word ptr [bx+20]
                pop             word ptr [bx+16]
                mov             word ptr [bx+14],sp
                mov             word ptr [bx],ax
                mov             word ptr [bx+4],cx
                mov             word ptr [bx+6],dx
                mov             word ptr [bx+8],si
                mov             word ptr [bx+10],di
                mov             word ptr [bx+12],bp
                mov             word ptr [bx+24],ss
                mov             word ptr [bx+26],es

                mov             word ptr [bx+40],cs
                mov             word ptr [bx+38],(offset finish_int_)-ibase

                mov             ax,word ptr [s0]
                mov             word ptr [bx+30],ax
                mov             ax,word ptr [r0]
                mov             word ptr [bx+32],ax
                mov             ax,word ptr [ss0]
                mov             word ptr [bx+34],ax
                mov             ax,word ptr [ssp]
                mov             word ptr [bx+36],ax

                mov             word ptr [bx+28],cs

                mov             ax,word ptr cs:[int_s0_-ibase]
                mov             word ptr [s0],ax
                mov             cx,word ptr cs:[int_r0_-ibase]
                mov             word ptr [r0],cx
                mov             dx,word ptr cs:[int_ss0_-ibase]
                mov             word ptr [ss0],dx

                cmp             byte ptr cs:[active_flag_-ibase],0
                jz              skip_set_regs_

                mov             ax,word ptr cs:[int_sp_-ibase]
                mov             cx,word ptr cs:[int_bp_-ibase]
                mov             dx,word ptr cs:[int_ssp_-ibase]

skip_set_regs_:
                mov             word ptr [ssp],dx
                mov             bp,cx
                mov             sp,ax
                mov             word ptr [bx+44],ax
                mov             word ptr [bx+46],cx
                mov             word ptr [bx+48],dx
                mov             ax,cs
                mov             ss,ax

                mov             ax,word ptr cs:[int_proc_-ibase]
                mov             word ptr [first_],ax
                mov             word ptr [second_],offset jmp_far_

                inc             byte ptr cs:[active_flag_-ibase]
                push            ds
                mov             ax,offset forth_call_
                push            ax
                sti
                retf

finish_int_:    mov             ds,word ptr cs:[forth_seg_-ibase]
                mov             bx,word ptr [regpnt]
                add             word ptr [regpnt],50

                dec             byte ptr cs:[active_flag_-ibase]

                mov             ax,word ptr [bx+30]
                mov             word ptr [s0],ax
                mov             ax,word ptr [bx+32]
                mov             word ptr [r0],ax
                mov             ax,word ptr [bx+34]
                mov             word ptr [ss0],ax
                mov             ax,word ptr [bx+36]
                mov             word ptr [ssp],ax

                mov             ax,word ptr [bx+44]
                mov             word ptr cs:[14],ax
                mov             ax,word ptr [bx+46]
                mov             word ptr cs:[12],ax
                mov             ax,word ptr [bx+48]
                mov             word ptr cs:[16],ax

                cli
                mov             sp,word ptr [bx+14]
                mov             ss,word ptr [bx+24]
                push            word ptr [bx+16]
                push            word ptr [bx+20]
                push            word ptr [bx+18]
                push            word ptr [bx+2]
                push            word ptr [bx+22]
                mov             ax,word ptr [bx]
                mov             cx,word ptr [bx+4]
                mov             dx,word ptr [bx+6]
                mov             si,word ptr [bx+8]
                mov             di,word ptr [bx+10]
                mov             bp,word ptr [bx+12]
                mov             es,word ptr [bx+26]

                pop             ds
                pop             bx
                iret
final_int_:
; *****************************************************************************

                pop             bx
                pop             ax              ; Scr Stack Size
                add             ax,(offset final_int_)-(offset hook_code_)
                mov             word ptr [bx+16h],ax
                pop             cx              ; Stack Size
                add             ax,cx
                mov             word ptr [bx+12h],ax
                pop             cx              ; Ret Stack Size
                add             ax,cx
                mov             word ptr [bx+14h],ax
                mov             word ptr [time_t],ax
                pop             word ptr [bx+4]
                mov             word ptr [bx+6],cs

                pop             ax
                push            si
                push            ax
                mov             ah,35h
                push            bp
                push            bx
                int             21h
                mov             ax,bx
                pop             bx
                pop             bp
                mov             word ptr [bx+8],ax
                mov             word ptr [bx+0ah],es
                mov             byte ptr [bx+3],0
                mov             word ptr [time_z],bx
                mov             bx,word ptr [time_t]
                mov             cl,4
                shr             bx,cl
                inc             bx

                mov             ah,48h
                push            bp
                int             21h
                pop             bp
                jnc             no_halt_
                mov             ax,offset no_forth_mem
                jmp             ax
                no_halt_:

; **********************************************************************



                mov             es,ax
                xor             di,di
                mov             cx,(offset final_int_)-(offset hook_code_)
                mov             si,word ptr [time_z]
                cld
                rep             movsb
                mov             ds,ax
                xor             dx,dx
                pop             ax
                mov             ah,25h
                int             21h
                push            cs
                pop             ds
                pop             si
                jmp             word ptr [ent]


c_regs_:        db              7,'INTREGS',0
                dk              hook_int_
                _c_regs:
                push            word ptr [regpnt]
                jmp             word ptr [ent]

exec_int_:      db              10,'EXECUTEINT',0
                dk              c_regs_
                _exec_int:
                mov             ax,ss
                mov             es,ax
                mov             bx,word ptr [regpnt]
                mov             word ptr es:[12],bp
                mov             word ptr es:[14],sp
                mov             ax,word ptr [ssp]
                mov             word ptr es:[16],ax
                cli
                mov             ss,word ptr [bx+24]
                xchg            sp,word ptr [bx+14]
                pushf
                push            cs
                call            start_exec_int_

                cli
                push            ds
                push            bx

                mov             bx,cs
                mov             ds,bx
                mov             bx,word ptr [regpnt]

                pop             word ptr [bx+2]
                pop             word ptr [bx+22]
                mov             word ptr [bx],ax
                mov             word ptr [bx+4],cx
                mov             word ptr [bx+6],dx
                xchg            word ptr [bx+8],si
                mov             word ptr [bx+10],di
                xchg            word ptr [bx+12],bp
                mov             word ptr [bx+24],ss
                mov             word ptr [bx+26],es

                mov             ss,word ptr [bx+28]
                xchg            word ptr [bx+14],sp
                pushf
                pop             ax
                mov             word ptr [bx+16],ax
                sti
                jmp             word ptr [ent]

                start_exec_int_:
                push            word ptr [bx+16]
                push            word ptr es:[0ah]
                push            word ptr es:[8]
                push            word ptr [bx+2]
                push            word ptr [bx+22]
                mov             ax,word ptr [bx]
                mov             cx,word ptr [bx+4]
                mov             dx,word ptr [bx+6]
                xchg            si,word ptr [bx+8]
                mov             di,word ptr [bx+10]
                xchg            bp,word ptr [bx+12]
                mov             es,word ptr [bx+26]

                pop             ds
                pop             bx
                iret

exec_int_end_:  db              9,'FINISHINT',0
                dk              exec_int_
                _exec_int2:
                mov             ax,offset jmp_far_
                jmp             ax

st_com_2_:      db              1,'\',1+128
                dk              exec_int_end_
                _st_com_2:
                jmp             _st_com

di_:            db              3,'CLI',0
                dk              st_com_2_
                _di:
                cli
                jmp             word ptr [ent]

ei_:            db              3,'STI',0
                dk              di_
                _ei:
                sti
                jmp             word ptr [ent]

t_off_:         db              10,'(TRACEOFF)',0
                dk              ei_
                _t_off:
                pushf
                pop             ax
                and             ah,254
                push            ax
                popf
                jmp             word ptr [ent]

; ( IntNo --> Flag )
rel_int_:       db              10,'RELEASEINT',0
                dk              t_off_
                _rel_int:
                pop             bx
                mov             bh,0
                shl             bx,1
                shl             bx,1
                xor             ax,ax
                mov             es,ax
                mov             es,word ptr es:[bx+2]
                cmp             byte ptr es:[2],0f4h
                jnz             cant_rel_
                mov             cx,word ptr es:[8]
                mov             dx,word ptr es:[10]
                push            es
                xor             ax,ax
                mov             es,ax
                mov             word ptr es:[bx],cx
                mov             word ptr es:[bx+2],dx
                pop             es
                mov             ah,49h
                push            bp
                push            si
                int             21h
                pop             si
                pop             bp
                mov             ax,0
                jc              cant_rel_
                mov             ax,0ffffh
                cant_rel_:
                push            ax
                jmp             word ptr [ent]

error_:         db              5,'ERROR',1
                dk              rel_int_
                _error:
                do
                dw              _errno
                dw              _prisv
                dw              _system
                dw              _raz
                dw              _fbranch
                dj              no_error_process_
                dw              _system
                dw              _raz
                dw              _execute
                no_error_process_:
                dw              _exit

is_compiler_:   db              9,'?MESSAGES',1
                dk              error_
                _is_compiler:
                do
                dw              _number
                dw              _messages
                dw              _raz
                dw              _eq0
                dw              _eq0
                dw              _exit

err_msg_:       db              12,'ERRORMESSAGE',0
                dk              is_compiler_
                _err_msg:
                pop             ax
                cmp             word ptr [messages],0
                jnz             _messages_present
                push            word ptr [messages]
                jmp             word ptr [ent]
                _messages_present:
                shl             ax,1
                mov             bx,offset mess_table_
                add             bx,ax
                push            word ptr [bx]
                jmp             word ptr [ent]

lines_:         db              5,'LINES',0
                dk              err_msg_
                _lines:
                mov             ax,offset lines
                push            ax
                jmp             word ptr [ent]

rdropall_:      db              8,'RDROPALL',0
                dk              lines_
                _rdropall:
                mov             bp,word ptr [r0]
                jmp             word ptr [ent]

tib_:           db              3,'TIB',0
                dk              rdropall_
                _tib:
                push            word ptr [tibadr]
                jmp             word ptr [ent]

tib_d_:         db              4,'TIB#',0
                dk              tib_
                _tib_d:
                mov             ax,offset maxpos
                push            ax
                jmp             word ptr [ent]

; ( ASCIIzFullName --> Drive[0=None;1=A:;2=B:] )
todrive_:       db              6,'>DRIVE',0
                dk              tib_d_
                _todrive:
                pop             bx
                dec             bx
                xor             ax,ax
                skip_bl_dr_:
                inc             bx
                cmp             byte ptr [bx],' '
                jz              skip_bl_dr_
                cmp             byte ptr [bx],0
                jz              no_drive_
                inc             bx
                cmp             byte ptr [bx],':'
                jnz             no_drive_
                mov             al,byte ptr [bx-1]
                and             al,5fh
                sub             al,'@'
                no_drive_:
                push            ax
                jmp             word ptr [ent]

; ( ASCIIzFullName DestBufferForASCIIzPath -->  )
to_path_:       db              5,'>PATH',0
                dk              todrive_
                _to_path:
                pop             di
                push            cs
                pop             es
                pop             bx
                mov             byte ptr [di],0
                mov             ax,bx
                dec             bx
                found_0_path_:
                inc             bx
                cmp             byte ptr [bx],0
                jnz             found_0_path_
                find_sl_path_:
                dec             bx
                cmp             bx,ax
                jc              no_path_
                cmp             byte ptr [bx],'/'
                jz              found_sl_path_
                cmp             byte ptr [bx],'\'
                jnz             find_sl_path_
                found_sl_path_:
                mov             cx,bx
                mov             bx,ax
                dec             bx
                skip_bl_path_:
                inc             bx
                cmp             byte ptr [bx],' '
                jz              skip_bl_path_
                cmp             byte ptr [bx+1],':'
                jnz             path_found_
                inc             bx
                inc             bx
                path_found_:
                sub             cx,bx
                push            si
                mov             si,bx
                rep             movsb
                pop             si
                xor             al,al
                stosb
                no_path_:
                jmp             word ptr [ent]

; ( ButeCount ASCIIzName --> )
load_code_:     db              10,'(LOADCODE)',0
                dk              to_path_
                _load_code:
                savebpspsi
                pop             dx
                pop             cx
                push            bp
                push            si
                push            cx
                mov             ax,3d00h
                int             21h
                jc              lc_err_1
                pop             cx
                push            ax
                mov             bx,ax
                mov             dx,word ptr [upvoc]
                mov             ah,3fh
                int             21h
                jc              lc_err_2
                add             word ptr [upvoc],ax
                pop             bx
                mov             ah,3eh
                int             21h
                pop             si
                pop             bp
                jmp             word ptr [ent]
                lc_err_2:
                mov             ax,23
                jmp             short lc_err_
                lc_err_1:
                mov             ax,21
                lc_err_:
                mov             word ptr [errcode],ax
                mov             si,word ptr [link_si]
                mov             bp,word ptr [link_bp]
                mov             bx,offset error
                jmp             bx


; ( ByteCount --> )
ld_code_:       db      8,'LOADCODE',1
                dj      load_code_
                _ld_code:
                do
                dw              _bl
                dw              _word
                dw              _dup
                dw              _toasciiz
                dw              _load_code
                dw              _exit


if_err_:        db              10,'?UNDERFLOW',1
                dj              ld_code_
                _iferror2:
                do
                dw              _depth
                dw              _men0
                dw              _fbranch
                dj              end_err2
                dw              _number
                dw              2
                dw              _error
                end_err2:
                dw              _exit

; 뤥    ६
; ( Size --> )
locate_:        db      6,'LOCATE',0
                dj      if_err_
                pop     ax
                mov     cx,ax
                add     ax,2
                sub     word ptr [ssp],ax
                mov     di,word ptr [ssp]
                push    ss
                pop     es
                stosw
                xor     al,al
                rep     stosb
                jmp     word ptr [ent]

unlocate_:      db      8,'UNLOCATE',0
                dj      locate_
                mov     di,word ptr [ssp]
                mov     ax,word ptr ss:[di]
                add     word ptr [ssp],ax
                jmp     word ptr [ent]

; ( Offset --> Value )
l_raz_:         db      2,'L@',0
                dj      unlocate_
                pop     bx
                add     bx,2
                add     bx,word ptr [ssp]
                push    word ptr ss:[bx]
                jmp     word ptr [ent]

; ( Offset --> [d]Value )
l_2raz_:        db      3,'L2@',0
                dj      l_raz_
                pop     bx
                add     bx,2
                add     bx,word ptr [ssp]
                push    word ptr ss:[bx+2]
                push    word ptr ss:[bx]
                jmp     word ptr [ent]

; ( [d]Value Offset --> )
l_2prisv_:      db      3,'L2!',0
                dj      l_2raz_
                pop     bx
                add     bx,2
                add     bx,word ptr [ssp]
                pop     word ptr ss:[bx]
                pop     word ptr ss:[bx+2]
                jmp     word ptr [ent]

; ( Data Offset --> )
l_prisv_:       db      2,'L!',0
                dj      l_2prisv_
                pop     bx
                add     bx,2
                add     bx,word ptr [ssp]
                pop     word ptr ss:[bx]
                jmp     word ptr [ent]

; ( Offset --> )
lc_raz_:        db      3,'LC@',0
                dj      l_prisv_
                pop     bx
                add     bx,2
                add     bx,word ptr [ssp]
                mov     al,byte ptr ss:[bx]
                mov     ah,0
                push    ax
                jmp     word ptr [ent]

lc_prisv_:      db      3,'LC!',0
                dj      lc_raz_
                pop     bx
                add     bx,2
                add     bx,word ptr [ssp]
                pop     ax
                mov     byte ptr ss:[bx],al
                jmp     word ptr [ent]

; ( ParasCount --> )
move_paras_:    db      3,'S>L',0
                dj      lc_prisv_
                pop     cx
                mov     bx,word ptr [ssp]
                add     bx,word ptr ss:[bx]
                movp_loop_:
                sub     bx,2
                pop     ax
                mov     word ptr ss:[bx],ax
                loop    movp_loop_
                jmp     word ptr [ent]

push_s_:        db              2,'>S',0
                dk              move_paras_
                _push_s:
                mov             bx,word ptr [ssp]
                dec             bx
                dec             bx
                pop             word ptr ss:[bx]
                mov             word ptr [ssp],bx
                jmp             word ptr [ent]

pop_s_:         db              2,'S>',0
                dk              push_s_
                _pop_s:
                mov             bx,word ptr [ssp]
                push            word ptr ss:[bx]
                inc             bx
                inc             bx
                mov             word ptr [ssp],bx
                jmp             word ptr [ent]

; ( SrcOff SrcSeg DestOff DestSeg SrcLength --> DestLength )
compress_:      db      11,'RLECOMPRESS',0
                dj      pop_s_
                mov     word ptr [err_si_],si
                pop     cx
                pop     es
                pop     di
                pop     ds
                pop     si
                mov     dx,di           ; for dest block length
                jcxz    rle3b_
                add     cx,si           ; for stop address

                rle1_:
                mov     bx,di
                mov     al,1
                stosb
                movsb
                cmp     si,cx
                jnz     rle2_

                rle1a_:
                xor     ax,ax
                stosw

                end_compress_:
                push    cs
                pop     ds
                mov     si,word ptr [err_si_]
                sub     di,dx
                push    di
                jmp     word ptr [ent]

                rle2_:
                lodsb
                cmp     al,byte ptr [si-2]
                jz      rle3_
                rle2a_:
                stosb
                inc     byte ptr es:[bx]
                cmp     si,cx
                jz      rle1a_
                cmp     byte ptr es:[bx],255
                jnz     rle2_

                mov     al,0
                stosb
                jmp     rle1_

                rle3_:
                mov     ah,1

                rle3a_:
                cmp     si,cx
                jz      rle4_
                cmp     al,byte ptr [si]
                jnz     rle5_
                inc     si
                inc     ah
                cmp     ah,255
                jnz     rle3a_

                mov     al,ah
                stosb
                cmp     cx,si
                jnz     rle1_

                rle3b_:
                mov     al,0
                stosb
                jmp     end_compress_

                rle4_:
                mov     al,ah
                stosb
                jmp     rle3b_

                rle5_:
                cmp     ah,1
                jz      rle2a_
                mov     al,ah
                stosb
                jmp     rle1_


; ( SrcOff SrcSeg DestOff DestSeg --> DestLen )
decode__:       db      13,'RLEDECOMPRESS',0
                dj      compress_
                mov     word ptr [err_si_],si
                pop     es
                pop     di
                pop     ds
                pop     si
                xor     ah,ah
                mov     dx,di

                dec_loop_:
                lodsb
                mov     cx,ax
                jcxz    end_decode_

                rep     movsb

                lodsb
                mov     cx,ax
                jcxz    dec_loop_
                mov     al,byte ptr es:[di-1]
                rep     stosb
                jmp     dec_loop_

                end_decode_:
                push    cs
                pop     ds
                mov     si,word ptr [err_si_]
                sub     di,dx
                push    di
                jmp     word ptr [ent]

; ( D1 D2 --> Flag )
udm__:          db      3,'UD<',0
                dj      decode__
                pop     ax
                pop     bx
                pop     cx
                pop     dx
                cmp     cx,ax
                jc      udm_yes_
                ja      udm_no_
                cmp     dx,bx
                jc      udm_yes_
                udm_no_:
                xor     ax,ax
                udm_exit_:
                push    ax
                jmp     word ptr [ent]
                udm_yes_:
                mov     ax,0ffffh
                jmp     short udm_exit_

end_label:

                end             label100
