                include fasm.inc

                model           tiny

                .code

                org             100h

module:

; ( Mode# --> )
set_v_mode_:    db              12,'SETVIDEOMODE',0
                dw              0
                _set_v_mode:
                pop             ax
                stal            drivetype
                mov             ah,0
                cmp             ax,8
                jz              hmode_8_
                push            si
                push            bp
                int             10h
                pop             bp
                pop             si
                xor             ax,ax
                stal            undercursor
                stax            crx
                next

                hmode_8_:
                xor             ax,ax
                mov             ds,ax
                cli
                mov             bx,449h
                mov             byte ptr [bx],8
                inc             bx
                mov             word ptr [bx],50h
                mov             bx,462h
                mov             byte ptr [bx],0
                mov             bx,450h
                mov             word ptr [bx],0
                inc             bx
                inc             bx
                mov             word ptr [bx],0
                mov             bx,44eh
                mov             word ptr [bx],0
                dec             bx
                dec             bx
                mov             word ptr [bx],8000h
                push            cs
                pop             ds
                mov             dx,3b8h
                mov             al,2
                out             dx,al
                mov             ax,0b000h
                mov             es,ax
                xor             ax,ax
                mov             cx,8000h
                xor             di,di
                cld
                rep             stosw
                mov             dx,3b4h
                mov             ah,0
                call            hmode_1
                db              35h,2dh,2eh,7,5bh,2,57h,57h,2,3,0,0,0,0
                hmode_1:
                pop             bx
                hmode_2:
                mov             al,ah
                out             dx,al
                inc             dx
                mov             al,byte ptr [bx]
                out             dx,al
                inc             bx
                inc             ah
                dec             dx
                cmp             ah,14
                jnz             hmode_2
                mov             dx,3bfh
                mov             al,3
                out             dx,al
                mov             dx,3bah
                mov             cx,14h
                hmode_3:
                in              al,dx
                or              al,al
                jns             hmode_3
                hmode_4:
                in              al,dx
                or              al,al
                js              hmode_4
                loop            hmode_3
                mov             dx,3b8h
                mov             al,0ah
                out             dx,al
                sti
                next


; ( X Y Color --> )
set_pixel_:     db              8,'PUTPIXEL',0
                dk              set_v_mode_
                _set_pixel:
                pop             dx
                pop             bx
                pop             cx
                ldal            drivetype
                cmp             al,8
                jnz             no_hpset
                call            pset_mode8
                next

                pset_mode8:
                ror             dl,1
                and             dl,128
                mov             dh,cl
                mov             al,bl
                and             ax,3
                mov             cl,0dh
                shl             ax,cl
                mov             cl,dh
                shr             cx,1
                shr             cx,1
                shr             cx,1
                add             cx,ax
                shr             bx,1
                and             bl,0feh
                mov             ax,bx
                shl             bx,1
                shl             bx,1
                add             bx,ax
                mov             ax,bx
                shl             bx,1
                shl             bx,1
                shl             bx,1
                add             bx,ax
                add             bx,cx
                mov             cl,dh
                and             cl,7
                mov             ax,0b000h
                push            ds
                mov             ds,ax
                mov             ah,128
                mov             al,dl
                shr             ax,cl
                not             ah
                and             byte ptr [bx],ah
                or              byte ptr [bx],al
                pop             ds
                ret

                no_hpset:
                cmp             al,5
                jnz             no_5_pset
                mov             dh,bl
                call            pset_mode5
                next

                pset_mode5:
                ror             dl,1
                ror             dl,1
                and             dl,192
                and             bl,0feh
                shl             bx,1
                shl             bx,1
                shl             bx,1
                mov             ax,bx
                shl             bx,1
                shl             bx,1
                add             bx,ax
                test            dh,1
                jz              no_add_5
                or              bh,20h
                no_add_5:
                push            ds
                mov             ax,0b800h
                mov             ds,ax
                mov             ax,cx
                shr             ax,1
                shr             ax,1
                add             bx,ax
                and             cl,3
                shl             cl,1
                mov             ah,192
                mov             al,dl
                shr             ax,cl
                not             ah
                and             byte ptr [bx],ah
                or              byte ptr [bx],al
                pop             ds
                ret

                no_5_pset:
                cmp             al,6
                jnz             no_6_pset
                mov             dh,bl
                call            pset_mode6
                next

                pset_mode6:
                ror             dl,1
                and             dl,128
                and             bx,0feh
                shl             bx,1
                shl             bx,1
                shl             bx,1
                mov             ax,bx
                shl             bx,1
                shl             bx,1
                add             bx,ax
                test            dh,1
                jz              no_add_6
                or              bh,20h
                no_add_6:
                push            ds
                mov             ax,0b800h
                mov             ds,ax
                mov             ax,cx
                shr             ax,1
                shr             ax,1
                shr             ax,1
                add             bx,ax
                and             cl,7
                mov             ah,128
                mov             al,dl
                shr             ax,cl
                not             ah
                and             byte ptr [bx],ah
                or              byte ptr [bx],al
                pop             ds
                ret

                no_6_pset:
                cmp             al,0dh
                jnz             no_d_pset
                call            pset_moded
                next

                pset_moded:
                mov             ax,40
                jmp             d_pset
                no_d_pset:
                cmp             al,0eh
                jnz             no_e_pset
                e_pset:
                call            pset_modee
                next
                d_pset:
                call            pset_modee
                next

                pset_modee:
                mov             ax,80
                push            ds
                push            dx
                mul             bx
                mov             bx,cx
                shr             bx,1
                shr             bx,1
                shr             bx,1
                add             bx,ax
                mov             ax,0a000h
                mov             ds,ax
                mov             al,byte ptr [bx]
                and             cl,7
                mov             dx,3ceh
                mov             al,8
                out             dx,al
                inc             dx
                mov             al,128
                shr             al,cl
                out             dx,al
                mov             dl,0c4h
                mov             al,2
                out             dx,al
                inc             dx
                mov             al,15
                out             dx,al
                mov             byte ptr [bx],0
                pop             ax
                and             al,15
                out             dx,al
                mov             byte ptr [bx],255
                pop             ds
                mov             dx,3ceh
                mov             al,8
                out             dx,al
                inc             dx
                mov             al,255
                out             dx,al
                ret

                no_e_pset:
                cmp             al,10h
                jz              e_pset
                cmp             al,11h
                jz              e_pset
                cmp             al,12h
                jz              e_pset
                cmp             al,13h
                jnz             no_13_pset

                push            dx
                mov             ax,0a000h
                mov             es,ax
                mov             ax,320
                mul             bx
                add             ax,cx
                mov             bx,ax
                pop             ax
                mov             byte ptr es:[bx],al
                next
                no_13_pset:
                mov             ax,dx
                mov             dx,bx
                push            ax
                ldal            undercursor
                mov             bh,al
                pop             ax
                mov             ah,13

                push            bp
                push            si
                int             10h
                pop             si
                pop             bp
                next

; ( X Y --> Color )
read_pixel_:    db              9,'READPIXEL',0
                dk              set_pixel_
                _read_pixel:
                ldal            undercursor
                mov             bh,al
                mov             ah,13
                pop             dx
                pop             cx
                push            bp
                push            si
                int             10h
                pop             si
                pop             bp
                mov             ah,0
                push            ax
                next


set_page_:      db              13,'SETACTIVEPAGE',0
                dk              read_pixel_
                _set_page:
                pop             ax
                mov             ah,0
                push            bp
                push            si
                int             10h
                pop             si
                pop             bp
                next

set_v_page_:    db              11,'SETWORKPAGE',0
                dk              set_page_
                _set_v_page:
                pop             ax
                stal            undercursor
                next


; ( --> Mode# )
get_v_mode_:    db              12,'GETVIDEOMODE',0
                dk              set_v_page_
                _get_v_mode:
                mov             ah,15
                push            bp
                push            si
                int             10h
                pop             si
                pop             bp
                mov             ah,0
                push            ax
                next

; ( Pal# --> )
set_cga_pal_:   db              13,'SETCGAPALETTE',0
                dk              get_v_mode_
                _set_cga_pal:
                pop             bx
                and             bx,1
                mov             ah,11
                push            bp
                push            si
                int             10h
                pop             si
                pop             bp
                next

; ( Color Value --> )
set_ega_pal_:   db              13,'SETEGAPALETTE',0
                dk              set_cga_pal_
                _set_ega_pal:
                pop             ax
                pop             bx
                mov             bh,al
                mov             ax,1000h
                push            bp
                push            si
                int             10h
                pop             si
                pop             bp
                next

; ( Color Red Green Blue --> )
set_vga_pal_:   db              13,'SETVGAPALETTE',0
                dk              set_ega_pal_
                _set_vga_pal:
                pop             cx
                pop             ax
                mov             ch,al
                pop             ax
                mov             dh,al
                pop             bx
                mov             ax,1010h
                push            bp
                push            si
                int             10h
                pop             si
                pop             bp
                next


; ( BX BY Offset Segment --> )
putblock_:      db              8,'PUTBLOCK',0
                dk              set_vga_pal_
                _putblock:
                pop             ax
                pop             bx
                pop             dx
                pop             cx
                push            si
                push            ax
                ldal            drivetype
                pop             ds
                mov             si,bx
                ; al - Video mode
                ; cx - BX
                ; dx - BY
                ; DS:SI - Address
                cmp             al,19
                jnz             no_vga_256
                mov             ax,2560
                mul             dx
                shl             cx,1
                shl             cx,1
                shl             cx,1
                add             ax,cx
                mov             di,ax
                mov             ax,0a000h
                mov             es,ax
                mov             dl,8
                xor             ch,ch
                vga_256_loop_:
                mov             cl,4
                rep             movsw
                add             di,312
                dec             dl
                jnz             vga_256_loop_
                jmp             end_pbl_

                no_vga_256:

                end_pbl_:
                pop             si
                push            cs
                pop             ds
                next

init_:          db              1,' ',0
                dk              putblock_
                next

                dw              100h
                dw              init_-100h
                include         vers.inc
                dw              1231h

                end             module
