
include fasm.inc

code            segment
                assume          cs:code,ds:code,es:code,ss:code
                org             100h

module:

sound_:         db              5,'SOUND',0
                dw              0
                _sound:
                pop             bx
                cmp             bx,21
                jnc             sound_ok
                mov             bx,21
                sound_ok:
                mov             al,0b6h
                out             43h,al
                mov             dx,14h
                mov             ax,4f38h
                div             bx
                out             42h,al
                mov             al,ah
                out             42h,al
                in              al,61h
                or              al,3
                out             61h,al
                next

nosound_:       db              7,'NOSOUND',0
                dk              sound_
                _nosound:
                in              al,61h
                and             al,0fch
                out             61h,al
                next

; ( ASCIIz --> )
play_:          db              4,'PLAY',0
                dk              nosound_
                _play:
                pop             di
                call            block_play
                play_2:
                cmp             byte ptr [bx],0
                jz              may_play
                cmp             byte ptr cs:[di],'*'
                jnz             play_2
                call            restore_ints
                may_play:
                mov             byte ptr [bx+11],1
                push            bp
                push            si
                mov             word ptr [bx+12],di
                mov             byte ptr [bx],255
                push            bx
                mov             ax,351ch
                int             21h
                pop             di
                mov             word ptr cs:[di+1],bx
                mov             word ptr cs:[di+3],es
                push            di
                mov             ax,3520h
                int             21h
                pop             di
                mov             word ptr cs:[di+5],bx
                mov             word ptr cs:[di+7],es
                call            int1c

; *****************************************************************************

                push            ax
                push            ax

                push            ax
                push            cx
                push            dx
                push            bx
                push            bp
                push            si
                push            di
                push            ds
                push            es

                call            block_play
                push            cs
                pop             ds
                mov             si,word ptr [bx+12]
                cld
                dec             byte ptr [bx+11]
                jz              new_note
                jmp             exit_1c

                new_note:
                lodsb
                cmp             al,'*'
                jz              new_note
                cmp             al,'#'
                jz              new_note
                cmp             al,'@'
                jnz             no_ch_mode
                ch_mode:
                lodsb
                cmp             al,0
                jz              close_play
                mov             byte ptr [bx+14],al
                jmp             new_note
                no_ch_mode:
                cmp             al,'A'
                jc              close_play
                and             al,5fh
                cmp             al,'M'
                jz              ch_mode
                cmp             al,'O'
                jnz             no_oct
                lodsb
                cmp             al,0
                jz              close_play
                mov             byte ptr [bx+10],al
                jmp             new_note
                no_oct:
                cmp             al,'T'
                jnz             no_temp
                lodsb
                cmp             al,0
                jz              close_play
                mov             byte ptr [bx+9],al
                jmp             new_note
                no_temp:
                cmp             al,'P'
                jnz             no_pause
                in              al,61h
                and             al,0fch
                out             61h,al
                jmp             short set_time

                no_pause:
                cmp             al,'H'
                jnc             close_play
                jmp             set_hz

                set_time:
                test            byte ptr [bx+14],1
                jz              temp_time
                lodsb
                cmp             al,0
                jz              close_play
                mov             byte ptr [bx+11],al
                jmp             exit_1c
                temp_time:
                mov             al,byte ptr [bx+9]
                mov             byte ptr [bx+11],al
                jmp             exit_1c

                close_play:
                in              al,61h
                and             al,0fch
                out             61h,al
                call            restore_ints

                exit_1c:
                mov             word ptr [bx+12],si
                mov             bp,sp
                mov             ax,word ptr [bx+1]
                mov             word ptr [bp+18],ax
                mov             ax,word ptr [bx+3]
                mov             word ptr [bp+20],ax

                pop             es
                pop             ds
                pop             di
                pop             si
                pop             bp
                pop             bx
                pop             dx
                pop             cx
                pop             ax

                retf


                set_hz:
                sub             al,'A'
                call            oct_tbl
                db              9,11,0,2,4,5,7
;               db              0,2,4,5,7,9,11
                oct_tbl:
                pop             di
                mov             ah,0
                add             di,ax
                mov             al,byte ptr cs:[di]
                cmp             byte ptr [si],'#'
                jnz             no_inc_oct
                inc             ax
                no_inc_oct:

                call            hz_tbl
                dw              327,346,367,389,412,437,462,490,519,550,583,617,654
                hz_tbl:
                pop             di
                add             di,ax
                add             di,ax
                mov             ax,word ptr cs:[di]
                mov             cl,byte ptr [bx+10]
                shl             ax,cl
                mov             cx,10
                xor             dx,dx
                div             cx
                mov             cx,ax

                cmp             cx,21
                jnc             sound_ok1
                mov             cx,21
                sound_ok1:
                mov             al,0b6h
                out             43h,al
                mov             dx,14h
                mov             ax,4f38h
                div             cx
                out             42h,al
                mov             al,ah
                out             42h,al
                in              al,61h
                or              al,3
                out             61h,al

                jmp             set_time

; *****************************************************************************

                int1c:
                pop             dx
                mov             ax,251ch
                int             21h
                call            int20

                call            restore_ints
                int             20h

                int20:
                pop             dx
                mov             ax,2520h
                int             21h
                pop             si
                pop             bp
                next

                restore_ints:
                mov             byte ptr [bx],0
                push            ds
                push            es
                push            si
                call            block_play
                push            cs
                pop             ds
                xor             ax,ax
                mov             es,ax
                mov             si,bx
                inc             si
                mov             di,70h
                cld
                cli
                movsw
                movsw
                mov             di,80h
                movsw
                movsw
                sti
                pop             si
                pop             es
                pop             ds
                ret

                block_play:
                call            play_1
                db              0               ; Active Flag     0
                dw              0,0             ; Int1c vector    1
                dw              0,0             ; Int20 vector    5
                db              0               ; Temp            9
                db              0               ; Oct            10
                db              1               ; Time           11
                dw              0               ; Music          12
                db              0               ; Mode           14
                play_1:
                pop             bx
                ret

init_:          db              1,' ',0
                dk              play_
                _init:
                next

                dw              100h
                dw              init_-100h
                include         vers.inc
                dw              1231h

code            ends
                end             module
