
8000 StackSize !
4000 ScreenStackSize !
4000 ReturnStackSize !
4000 MemorySize !

Use DOS.frl
Use CRT.frl /a

Variable CURRLINE
Variable MTASKFLAG
Variable EXITCODE

\  ERRORS PROCESSOR
Registers REGS

: BYE
   ExitCode @ 255 And $ 4c00 Or Regs !
   Regs FDOS
;

: PRINTMESSAGE ( String --> )
   2 Swap Count CodeSegment Swap FWrite 2Drop
;

: ERROR ( ErrorNo --> )
   " \r\n\7;Error #" PrintMessage
   Dup Decimal 0 Str PrintMessage
   "  in line #" PrintMessage
   CurrLine @ 0 Str PrintMessage
   "     " PrintMessage
   Case
      0 Of
         " Unexepected end of file"
      EndOf
      1 Of
         " Cannot read source file"
      EndOf
      2 Of
         " Internal error"
      EndOf
      3 Of
         " Name or string too long"
      EndOf
      4 Of
         " Source file not found"
      EndOf
      5 Of
         " Not enough memory"
      EndOf
      6 Of
         " Invalid memory call"
      EndOf
      7 Of
         " Identifier expected"
      EndOf
      8 Of
         " Semicolon expected"
      EndOf
      9 Of
         " Unsigned number expected"
      EndOf
      10 Of
         " ']' expected"
      EndOf
      11 Of
         " Unresolved forward definition"
      EndOf
      12 Of
         " Syntax error"
      EndOf
      13 Of
         " No memory for symbol table"
      EndOf
      14 Of
         " Identifier too long"
      EndOf
      15 Of
         " Symbol already defined"
      EndOf
      16 Of
         " Invalid VAR or CHANNEL definition"
      EndOf
      17 Of
         " Invalid parameters list"
      EndOf
      18 Of
         " 'THEN' expected"
      EndOf
      19 Of
         " Invalid expression"
      EndOf
      20 Of
         " 'DO' expected"
      EndOf
      21 Of
         " Objects types mistmatch"
      EndOf
      22 Of
         " Unit name expected (string)"
      EndOf
      23 Of
         " Invalid number of parameters"
      EndOf
      24 Of
         " Invalid function call"
      EndOf
      25 Of
         " ':=' expected"
      EndOf
      26 Of
         " Invalud number or syntax error"
      EndOf
      27 Of
         " Forth-source module name expected (string)"
      EndOf
      28 Of
         " Expression too complex"
      EndOf
      29 Of
         " Interenal stack underflow"
      EndOf
      30 Of
         " Procedure or function too complex"
      EndOf
      31 Of
         " 'TO' or 'DOWNTO' expected"
      EndOf
      32 Of
         " 'PROGRAM' or 'UNIT' expected"
      EndOf
      33 Of
         " Point expected"
      EndOf
      34 Of
         " Global object expected"
      EndOf
         Drop " Unprintable error: invalid error code"
   EndCase
   PrintMessage " \r\n" PrintMessage
   2 ExitCode ! Bye
;

\  BUFFER IO
4096 Constant BUFFERSIZE
Variable BUFFERSEG
Variable BUFFERPOINTER
Variable CHARSINBUFFER

Variable SOURCEHANDLE

: READ
   SourceHandle @ 0 BufferSeg @ BufferSize FRead
   If
      Dup CharsInBuffer !
      If
         BufferPointer 0!
      Else
         0 Error
      Then
   Else
      1 Error
   Then
;

: GETCHAR ( --> Char )
   BufferPointer @ CharsInBuffer @ =
   If
      Read
   Then
   BufferPointer @ BufferSeg @ ac@
   BufferPointer 1+!
   Dup 13 = If CurrLine 1+! Drop Bl Bl BufferPointer @ 1- BufferSeg @ ac! Then
;

: UNGETCHAR ( --> )
   BufferPointer @
   If
      BufferPointer 1-!
   Else
      2 Error
   Then
;

\  SCANER
Variable @LEXEM
: LEXEM @LEXEM @ ;
Variable LEXLEN
Variable LEXFLAG                \ FALSE - No Lexem in LEXEM
                                \ TRUE  - There is a next lexem in LEXEM
: GET&STORE ( --> Char )
   LexLen @ 255 =
   If
      3 Error
   Then
   GetChar Dup Lexem LexLen @ + c!
   LexLen 1+!
;

: ?SIGN ( Char --> Flag )
   255 And Here !
   a" :=<>;.,()[]+-*/\\%&|!$@\r\n\t " Here 0 Pos* 0< Not
;

: ?COMPARE ( Char --> Flag )
   255 And Here !
   a" <>=" Here 0 Pos* 0< Not
;

: ?DIGIT ( Char --> Flag )
   c" 0 c" 9 WithIn
;

: ?HDIGIT ( Char --> Flag )
   Dup c" a c" f WithIn If True Exit Then
   Dup c" A c" F WithIn If True Exit Then
   ?Digit
;

: ?LETTER ( Char --> Flag )
   Dup c" A c" Z WithIn Swap c" _ = Or
;

: ?IDENT ( Char --> Flag )
   Dup ?Digit Swap ?Letter Or
;

: ENDLEXEM
   0 Lexem LexLen @ + c!
;

: >UPCASE ( c --> C )
   Dup c" a c" z WithIn If $ 5f And Then
;

: DROPLEXEM ( --> )
   LexFlag 0!
;

: RESTORELEXEM ( --> )
   True LexFlag !
;

: SCAN
   Begin
      LexFlag @
      IfNot
         LexLen 0!
         Get&Store
         Case
            c" > Of
               Get&Store ?Compare
               IfNot LexLen 1-! UnGetChar Then
            EndOf
            c" < Of
               Get&Store ?Compare
               IfNot LexLen 1-! UnGetChar Then
            EndOf
            c" = Of
               Get&Store ?Compare
               IfNot LexLen 1-! UnGetChar Then
            EndOf
            c" ! Of
               Get&Store ?Compare
               IfNot LexLen 1-! UnGetChar Then
            EndOf
            c" " Of
               Begin
                  Get&Store c" " =
               Until
            EndOf
            c" ' Of
               Begin
                  Get&Store c" ' =
               Until
            EndOf
            c" { Of
               Begin
                  Get&Store c" } = LexLen 1-!
               Until
               c" { Lexem !
            EndOf
            c" $ Of
                Begin
                   Get&Store ?HDigit Not
                Until
                LexLen 1-!
                UnGetChar
            EndOf
               Dup ?Sign
               If                                  \ Sign
                  Drop
               Else
                  ?Digit
                  If                               \ Digit
                     Begin
                        Get&Store ?Digit Not
                     Until
                     LexLen 1-!
                     UnGetChar
                  Else                             \ Identifier
                     Begin
                        Get&Store >UpCase ?Ident Not
                     Until
                     LexLen 1-!
                     UnGetChar
                     LexLen @ 0
                     Do
                        Lexem i + c@ >UpCase
                        Lexem i + c!
                     Loop
                  Then
               Then
         EndCase
         EndLexem
         True LexFlag !
      Then
      Lexem @
      Case
         13 Of True EndOf
         10 Of True EndOf
          9 Of True EndOf
         Bl Of True EndOf
            Drop False
      EndCase
      Lexem c@ c" { = If Drop True Then
   While
      DropLexem
   Repeat
;

\ : SCAN Scan ."  {" Lexem .ASCIIz ." } " ;

\  SYMBOL TABLES
Variable SYMSEG
Variable LASTPROCINDEX
Variable LASTSEARCHINDEX

: HASH ( ASCIIzName --> SymSegAddr )
   0 Swap
   Begin
      Dup c@
   While
      Dup c@ Rot + Swap 1+
   Repeat
   Drop 255 And 256 *
;

: INITSYM
   4096 Malloc
   If
      SymSeg !
      0 SymSeg @ 65535 0 MFill
   Else
      13 Error
   Then
;

: ASCIIZCOMP ( LineSM LineCS --> EqFlag )
   Begin
      Over SymSeg @ ac@ Over c@ =
   While
      Dup c@
      IfNot
         2Drop True Exit
      Then
      1+ Swap 1+ Swap
   Repeat
   2Drop False
;

: SYMSEARCH ( ASCIIzName --> Index True )
                   ( ... --> FirstFreeIndex False )
   Dup >R Hash
   Begin
      Dup SymSeg @ ac@
   While
      Dup R@ ASCIIzComp
      If
         R> Drop Dup LastSearchIndex ! True Exit
      Then
      32 +
   Repeat
   R> Drop Dup LastSearchIndex ! False
;

: SYMSTORE ( Value Type --> )
   Lexem SymSearch
   If
      Dup >R 31 +
      Dup SymSeg @ ac@ 1 = IfNot 15 Error Then
      2 Swap SymSeg @ ac!
      R@ LastProcIndex !
      R> 28 + Dup >R SymSeg @ ac@ = IfNot 21 Error Then
      R> 2- SymSeg @ a@ = IfNot 21 Error Then
   Then
   >R
   Lexem CodeSegment R@ SymSeg @ Lexem ASCIIzLen 1+ ACMove
   Dup IfNot R@ LastProcIndex ! Then
   R> 28 + Dup >R SymSeg @ ac!
   R> 2- SymSeg @ a!
;

\  INITIALIZATION, GLOBAL IO DEFINITIONS
: ADDSYM ( ASCIIzName Type Value ParasC --> )
   >R >R >R Lexem 0 200 Copy* R> R> Swap SymStore
   R> LastSearchIndex @ 29 + SymSeg @ a!
;

: STOREGLOBALS ( --> )
   a" PUTC" 0 0 1 AddSym
   a" PUTS" 0 0 1 AddSym
   a" PUTN" 0 0 2 AddSym
   a" PUTW" 0 0 2 AddSym
   a" INTR" 0 0 1 AddSym
   a" _AX" 1 True 0 AddSym
   a" _BX" 1 True 0 AddSym
   a" _CX" 1 True 0 AddSym
   a" _DX" 1 True 0 AddSym
   a" _BP" 1 True 0 AddSym
   a" _SI" 1 True 0 AddSym
   a" _DI" 1 True 0 AddSym
   a" _ES" 1 True 0 AddSym
   a" _DS" 1 True 0 AddSym
;

: STOREMTGLOBALS ( --> )
   a" KEYBOARD" 2 0 0 AddSym
   a" START" 0 1 4 AddSym
   a" STOP" 0 0 1 AddSym
   a" CONT" 0 0 1 AddSym
   a" CANCEL" 0 0 1 AddSym
   a" TERMINATE" 0 0 0 AddSym
   a" HALT" 0 0 0 AddSym
   a" LOCK" 0 0 0 AddSym
   a" UNLOCK" 0 0 0 AddSym
   a" DELAY" 0 0 1 AddSym
   a" CHECK" 0 1 1 AddSym
   a" WAIT" 0 0 2 AddSym
   a" READKEY" 0 1 0 AddSym
   a" KEYPRESSED" 0 1 0 AddSym
   1 ExitCode !
;

\  WORDS FOR SYNTAX ANALISYS
25 Constant MAXIDENTLEN

: ?IS ( TestNotTerm --> EqualFlag )
   Lexem Compare* 0= Dup
   If
      DropLexem
   Then
;

: ?IDENTIFIER ( --> Flag )
   Lexem c@ ?Letter Dup If DropLexem
   LexLen @ MaxIdentLen > If 14 Error Then Then
;

: ?NUMBER ( --> Number True )
          ( --> False )
   Lexem c@ c" $ =
   If
      Hex Lexem 1+ Dup ASCIIz> Val Decimal
      If Press Lexem 1+ >ASCIIz True Exit Else 26 Error Then
   Else
      Lexem ASCIIz> Lexem Val Lexem >ASCIIz
      Press Dup IfNot Press Then
   Then
; : ?NUMBER ?Number Dup If DropLexem Then ;

" +  -  *  /  %  &  |  ^  <  >  =  <= >= <> >< => =< != !> !< "
ASCIIz OPERATIONS
Create PRIORITY
6 c, 6 c, 8 c, 8 c, 8 c, 2 c, 2 c, 2 c, 4 c, 4 c,
4 c, 4 c, 4 c, 4 c, 4 c, 4 c, 4 c, 4 c, 4 c, 4 c,

: ?LEGALOP ( --> Flag )
   Lexem Dup ASCIIzLen + Bl !
   Operations Lexem 0 Pos*
   0< Not Dup If DropLexem Then
;

: ?PROCEDURE ( --> Flag )
   Lexem SymSearch
   If
      28 + Dup SymSeg @ ac@ 0=
      If
         2- SymSeg @ a@ 0=
         If
            DropLexem
            True
            Exit
         Then
      Then
   Then
   Drop
   False
;

: ?FUNCTION ( --> Flag )
   Lexem SymSearch
   If
      28 + Dup SymSeg @ ac@ 0=
      If
         2- SymSeg @ a@ 1 =
         If
            DropLexem
            True
            Exit
         Then
      Then
   Then
   Drop
   False
;

: ?LOCAL ( --> Flag )
   Lexem SymSearch
   If
      28 + Dup SymSeg @ ac@ 1 =
      If
         2- SymSeg @ a@ 0< 0=
         If
            DropLexem
            True
            Exit
         Then
      Then
   Then
   Drop
   False
;

: ?GLOBAL ( --> Flag )
   Lexem SymSearch
   If
      28 + Dup SymSeg @ ac@ 1 =
      If
         2- SymSeg @ a@ True =
         If
            DropLexem
            True
            Exit
         Then
      Then
   Then
   Drop
   False
;

: ?CHANNEL ( --> Flag )
   Lexem SymSearch
   If
      28 + SymSeg @ ac@ 2 =
      If
         DropLexem
         True
         Exit
      Then
   Then
   Drop
   False
;

: ?;
   a" ;" ?Is
;

: .LEXEM ( --> )
   Lexem .ASCIIz
;

Variable LEXSTACKSEG
Variable LSP

: PUSHLEXEM ( --> )
   Lexem CodeSegment LSP @ LexStackSeg @ 256 ACMove
   256 LSP +!
   LSP @ 4096 = If 30 Error Then
;

Variable @THERE
: THERE @THERE @ ;

: HPOPLEXEM ( --> )
   LSP @ IfNot 29 Error Then
   256 LSP -!
   LSP @ LexStackSeg @ There CodeSegment 256 ACMove
;

: //
   ." _"
;

\  SYNTAX & SEMANTIC ANALISYS, CODE GENERATION
Variable PARASLEN
Variable VARLEN
Variable PROCFLAG

: PARASLIST
   ParasLen 0!
   Scan ?;
   IfNot
      a" (" ?Is
      If
         Begin
            DropAll
            Scan ?Identifier
            If
               ParasLen @ 1 SymStore
               ParasLen 2+!
               Scan a" )" ?Is
               If
                  Scan ?;
                  If
                     Exit
                  Else
                     8 Error
                  Then
               Else
                  a" ," ?Is
                  IfNot 17 Error Then
               Then
            Else
               17 Error
            Then
         Again
      Else
         17 Error
      Then
   Then
;

: GETSIZE ( --> SizeInWords )
   Scan a" [" ?Is
   If
      Scan ?Number
      If
         Lexem c@ c" $ =
         If
            Hex Lexem 1+
         Else
            Lexem
         Then
         Dup ASCIIz> Val Decimal
         IfNot 9 Error Then
         If 9 Error Then
         Scan a" ]" ?Is IfNot 10 Error Then
      Else
         9 Error
      Then
   Then
;

: BSIZE ( --> Size )
   Scan a" [" ?Is
   If
      Scan ?Number
      If
         Lexem c@ c" $ =
         If
            Lexem 1+ Hex
         Else
            Lexem
         Then
         Dup ASCIIz> Val Decimal
         IfNot 9 Error Then
         Drop 2*
         Scan a" ]" ?Is IfNot 10 Error Then
      Else
         9 Error
      Then
   Else
      2
   Then
;

: LOCALVARS
   VarLen 0!
   Scan
   a" VAR" ?Is
   If
      Begin
         DropAll
         Scan ?Identifier
         If
            VarLen @ ParasLen @ + 1 SymStore
            BSize VarLen +!
            Scan ?;
            If
               Exit
            Else
               a" ," ?Is
               IfNot
                  a" :" ?Is
                  If
                     Scan a" INTEGER" ?Is
                     If
                        Scan ?; IfNot 16 Error Then
                     Else
                        16 Error
                     Then
                  Else
                     16 Error
                  Then
               Then
            Then
         Else
            16 Error
         Then
      Again
   Then
;

Variable EXPRSTATE                      \  0     f+(      -->       (a1f
                                        \ -1     a1)      -->         +)

Create STACK 45 Allot
Stack CodeSegment 45 0 MFill
Variable STP

: PRI ( OpNo --> Priority )
   Priority + c@
;

: POPONE
   STP @ Stack = If 29 Error Then
   STP 1-!
   STP @ c@
   Case
      0 Of ." + " EndOf
      1 Of ." - " EndOf
      2 Of ." * " EndOf
      3 Of ." / " EndOf
      4 Of ." MOD " EndOf
      5 Of ." AND " EndOf
      6 Of ." OR " EndOf
      7 Of ." XOR " EndOf
      8 Of ." < " EndOf
      9 Of ." > " EndOf
      10 Of ." = " EndOf
      11 Of ." > NOT " EndOf
      12 Of ." < NOT " EndOf
      13 Of ." = NOT " EndOf
      14 Of ." = NOT " EndOf
      15 Of ." < NOT " EndOf
      16 Of ." > NOT " EndOf
      17 Of ." = NOT " EndOf
      18 Of ." > NOT " EndOf
      19 Of ." < NOT " EndOf
         Drop 19 Error
   EndCase
   0 L@ 1- 0 L!
;

Variable @EXPRESSION
: EXPRESSION @EXPRESSION @ Execute ;

: MCALL
   Scan a" [" ?Is IfNot 6 Error Then
   Expression If 19 Error Then
   Scan a" :" ?Is IfNot 6 Error Then
   Expression If 19 Error Then
   Scan a" ]" ?Is IfNot 6 Error Then
   ." SWAP "
;

: POPOPERATIONS ( --> )
   Begin
      0 L@ 0>
   While
      PopOne
   Repeat
;

: INDEX ( --> Flag )
   Scan a" [" ?Is
   If
      Space Expression If 19 Error Then
      Scan a" ]" ?Is IfNot 10 Error Then
      True
   Else
      False
   Then
;

: GETADDR ( --> )
   // .Lexem
   True ExprState !
;

: EXPEND
   RestoreLexem
   PopOperations
   UnLocate
   False
;

: .(EXPRESSION)
   ExprState 0!
   2 Locate 0 0 L!
   Begin
      DropAll
      Scan
      ExprState @
      If \ Expected operation, ')' or end of expression
         a" )" ?Is
         If
            PopOperations
            UnLocate
            True
            Exit
         Else
            a" END" ?Is
            If
               ExpEnd
               Exit
            Else
               ?;
               If
                  ExpEnd
                  Exit
               Else
                  ?LegalOp
                  If
                     Operations Lexem 0 Pos* 3 /
                     >R
                     Begin
                        0 L@ 0> STP @ 1- c@ PRI R@ PRI < Not And
                     While
                        PopOne
                     Repeat
                     R> STP @ c! STP 1+!
                     STP @ Stack 40 + = If 28 Error Then
                     0 L@ 1+ 0 L!
                     ExprState 0!
                  Else
                     a" ," ?Is
                     If
                        ExpEnd
                        Exit
                     Else
                        a" THEN" ?Is
                        If
                           ExpEnd
                           Exit
                        Else
                           a" DO" ?Is
                           If
                              ExpEnd
                              Exit
                           Else
                              a" ELSE" ?Is
                              If
                                 ExpEnd
                                 Exit
                              Else
                                 a" TO" ?Is
                                 If
                                    ExpEnd
                                    Exit
                                 Else
                                    a" DOWNTO" ?Is
                                    If
                                       ExpEnd
                                       Exit
                                    Else
                                       a" ]" ?Is
                                       If
                                          ExpEnd
                                          Exit
                                       Else
                                          a" :" ?Is
                                          If
                                             ExpEnd
                                             Exit
                                          Else
                                             19 Error
                                          Then
                                       Then
                                    Then
                                 Then
                              Then
                           Then
                        Then
                     Then
                  Then
               Then
            Then
         Then
      Else \ Expected constant, variable, function or '(', '!', '-', '@'
         a" -" ?Is
         If
            Scan Lexem c@ c" 0 c" 9 WithIn
            If
               ." -" .Lexem DropLexem Space
               True ExprState !
            Else
               ?Local
               If
                  LastSearchIndex @ 26 + SymSeg @ a@
                  . Index If ." 2* +" Then ."  L@ NEGATE "
                  True ExprState !
               Else
                  ?Global
                  If
                     // .Lexem Index If ." 2* +" Then ."  @ NEGATE "
                     True ExprState !
                  Else
                     a" (" ?Is
                     If
                        1000 Error
                     Else
                        ?Function
                        If
                           1000 Error
                        Else
                           19 Error
                        Then
                     Then
                  Then
               Then
            Then
         Else
            a" !" ?Is
            If
               1000 Error
            Else
               ?Number
               If
                  Lexem c@ c" $ =
                  If
                     ." $ " Lexem 1+ .ASCIIz
                  Else
                     .Lexem
                  Then
                  Space
                  True ExprState !
               Else
                  ?Local
                  If
                     LastSearchIndex @ 26 + SymSeg @ a@
                     . Index If ."  2* +" Then ."  L@" Cr
                     True ExprState !
                  Else
                     ?Global
                     If
                        // .Lexem Index If ."  2* +" Then ."  @" Cr
                        True ExprState !
                     Else
                        ?Function
                        If
                           LastSearchIndex @ >R
                           PushLexem
                           LastSearchIndex @ 29 + SymSeg @ a@ Dup
                           If
                              >R
                              Scan a" (" ?Is IfNot 19 Error Then
                              R> 0
                              Do
                                 R> R> 2Dup >R >R 1- =
                                 If
                                    Recurse IfNot 19 Error Then
                                 Else
                                    Recurse If 23 Error Then
                                    a" ," ?Is IfNot 23 Error Then
                                 Then
                              Loop
                           Else
                              Drop
                           Then
                           HPopLexem
                           R> LastProcIndex @ =
                           If
                              ." RECURSE" Cr
                           Else
                              // There .ASCIIz Cr
                           Then
                           True ExprState !
                        Else
                           a" (" ?Is
                           If
                              Recurse IfNot 19 Error Then
                           Else
                              Lexem c@ 34 = Lexem c@ 39 = Or
                              If
                                 Lexem ASCIIzLen 2 >
                                 If
                                    ." A\34; "
                                    Lexem 1+ Lexem ASCIIzLen 2- Type
                                    c" " Emit Cr
                                 Else
                                    ." NULLSTRING" Cr
                                 Then
                                 DropLexem
                                 True ExprState !
                              Else
                                 a" @" ?Is
                                 If
                                    Scan ?Global
                                    If
                                       GetAddr Index If ."  2* +" Then Cr
                                    Else
                                       ?Procedure
                                       If
                                          ." ['] "
                                          GetAddr Cr
                                       Else
                                          ?Function
                                          If
                                             ." ['] "
                                             GetAddr Cr
                                          Else
                                             ?Channel
                                             If
                                                GetAddr
                                             Else
                                                34 Error
                                             Then
                                          Then
                                       Then
                                    Then
                                 Else
                                    ?Channel
                                    If
                                       // .Lexem ."  GET" Cr
                                       True ExprState !
                                    Else
                                       a" TRUE" ?Is
                                       If
                                          ." TRUE "
                                          True ExprState !
                                       Else
                                          a" FALSE" ?Is
                                          If
                                             ." FALSE "
                                             True ExprState !
                                          Else
                                             a" CODESEGMENT" ?Is
                                             If
                                                ." CODESEGMENT "
                                                True ExprState !
                                             Else
                                                a" STACKSEGMENT" ?Is
                                                If
                                                   ." STACKSEGMENT "
                                                   True ExprState !
                                                Else
                                                   a" MEM" ?Is
                                                   If
                                                      MCall
                                                      ." AC@ "
                                                      True ExprState !
                                                   Else
                                                      a" MEMW" ?Is
                                                      If
                                                         MCall
                                                         ." A@ "
                                                         True ExprState !
                                                      Else
                                                         19 Error
                                                      Then
                                                   Then
                                                Then
                                             Then
                                          Then
                                       Then
                                    Then
                                 Then
                              Then
                           Then
                        Then
                     Then
                  Then
               Then
            Then
         Then
      Then
   Again
;

: .EXPRESSION
   Stack STP !
   .(Expression)
;

: EXPRESSION
   .Expression If 19 Error Then
;

: PUSHFACTPARAS ( --> ParasCount )
   LastSearchIndex @ 29 + SymSeg @ a@ IfNot 0 Exit Then
   2 Locate 0 0 L!
   Scan a" (" ?Is
   If
      Begin
         DropAll
         .Expression If RestoreLexem Then 0 L@ 1+ 0 L!
         Scan a" )" ?Is
         If
            0 L@ UnLocate Exit
         Else
            a" ," ?Is
            IfNot 17 Error Then
         Then
      Again
   Then
   17 Error
   UnLocate
;

: :=
   Scan a" :" ?Is
   IfNot 25 Error Then
   Scan a" =" ?Is
   IfNot 25 Error Then
;

: OPERATOR
   Scan ?;
   If
      RestoreLexem
   Else
      a" BEGIN" ?Is
      If
         Begin
            DropAll
            Recurse
            Scan
            a" END" ?Is
            If
               Exit
            Else
               ?; IfNot 8 Error Then
            Then
         Again
      Else
         a" IF" ?Is
         If
            Expression
            ." IF" Cr
            Scan a" THEN" ?Is IfNot 18 Error Then
            Recurse
            Scan a" ELSE" ?Is
            If
               ." ELSE" Cr
               Recurse
            Then
            ." THEN" Cr
         Else
            a" WHILE" ?Is
            If
               ." BEGIN" Cr
               Expression
               Scan a" DO" ?Is IfNot 20 Error Then
               ." WHILE" Cr
               Recurse
               ." REPEAT" Cr
            Else
               a" REPEAT" ?Is
               If
                  ." BEGIN" Cr
                  Begin
                     DropAll
                     Recurse
                     Scan
                     a" UNTIL" ?Is
                     If
                        Expression
                        ." UNTIL" Cr
                        Exit
                     Else
                        ?; IfNot 8 Error Then
                     Then
                  Again
               Else
                  a" FOR" ?Is
                  If
                     Scan ?Local
                     If
                        LastSearchIndex @ 26 + SymSeg @ a@ >R
                        :=
                        Expression
                        R@ . ."  L!" Cr
                        ." BEGIN" Cr
                        Scan a" TO" ?Is
                        If
                           1
                        Else
                           a" DOWNTO" ?Is
                           If
                              -1
                           Else
                              31 Error
                           Then
                        Then
                        >R
                        Expression
                        R@ 0> If ." 1+ " Else ." 1- " Then
                        Scan a" DO" ?Is IfNot 20 Error Then
                        1 RPick . ."  L@ = NOT" Cr
                        ." WHILE" Cr
                        Recurse
                        1 RPick . ."  L@"
                        R> 0>
                        If ."  1+ " Else ."  1- " Then R> . ."  L!" Cr
                        ." REPEAT" Cr
                     Else
                        ?Global
                        If
                           PushLexem
                           :=
                           Expression
                           HPopLexem 256 Allot
                           There CodeSegment Here 256 - CodeSegment 256 ACMove
                           // Here 256 - .ASCIIz ."  !" Cr
                           ." BEGIN" Cr
                           Scan a" TO" ?Is
                           If
                              1
                           Else
                              a" DOWNTO" ?Is
                              If
                                 -1
                              Else
                                 31 Error
                              Then
                           Then
                           >R
                           Expression
                           R@ 0> If ." 1+ " Else ." 1- " Then
                           Scan a" DO" ?Is IfNot 20 Error Then
                           // Here 256 - .ASCIIz ."  @ = NOT" Cr
                           ." WHILE" Cr
                           Recurse
                           -256 Allot
                           // Here .ASCIIz R> 0>
                           If ."  1+!" Else ."  1-!" Then Cr
                           ." REPEAT" Cr
                        Else
                           7 Error
                        Then
                     Then
                  Else
                     ?Procedure
                     If
                        PushLexem
                        LastSearchIndex @ >R
                        PushFactParas
                        R@ 29 + SymSeg @ a@ =
                        IfNot 23 Error Then
                        HPopLexem
                        R> LastProcIndex @ =
                        If
                           ." RECURSE" Cr
                        Else
                           // There .ASCIIz Cr
                        Then
                     Else
                        ?Global
                        If
                           PushLexem Index >R
                           :=
                           Expression
                           HPopLexem
                           // There .ASCIIz
                           R> If ."  ROT 2* +" Then
                           ."  !" Cr
                        Else
                           ?Local
                           If
                              LastSearchIndex @ >R Index R> Swap >R >R
                              :=
                              Expression
                              R> 26 + SymSeg @ a@
                              . R> If ."  ROT 2* +" Then
                              ."  L!" Cr
                           Else
                              ?Function
                              If
                                 ProcFlag @ If 24 Error Then
                                 LastProcIndex @ LastSearchIndex @ =
                                 IfNot 24 Error Then
                                 :=
                                 Expression
                                 ." R> DROP >R" Cr
                              Else
                                 a" EXIT" ?Is
                                 If
                                    ProcFlag @
                                    If
                                       ." EXIT"
                                    Else
                                       ." R> EXIT"
                                    Then
                                    Cr
                                 Else
                                    ?Channel
                                    If
                                       PushLexem
                                       :=
                                       Expression
                                       HPopLexem
                                       // There .ASCIIz ."  PUT" Cr
                                    Else
                                       a" MEM" ?Is
                                       If
                                          MCall
                                          :=
                                          Expression
                                          ." -ROT AC!" Cr
                                       Else
                                          a" MEMW" ?Is
                                          If
                                             MCall
                                             :=
                                             Expression
                                             ." -ROT A!" Cr
                                          Else

                                          Then
                                       Then
                                    Then
                                 Then
                              Then
                           Then
                        Then
                     Then
                  Then
               Then
            Then
         Then
      Then
   Then
;

: DROPLOCALS
   0 >R
   Begin
      R@ 28 + SymSeg @ ac@ 1 =
      If
         R@ 26 + SymSeg @ a@ True =
         IfNot
            R@ SymSeg @ 32 0 MFill
         Then
      Then
      R> 32 + Dup >R 0=
   Until
   R> Drop
;

: GLOBAL
   Scan
   a" PROCEDURE" ?Is
   If
      Scan ?Identifier
      If
         0 0 SymStore
         PushLexem
         ParasList
         ParasLen @ U2/ LastProcIndex @ 29 + SymSeg @ a!

         Scan a" EXTERNAL" ?Is
         If
            DropLocals HPopLexem Scan ?; IfNot 8 Error Then Exit
         Then

         Scan a" FORWARD" ?Is
         If
            1 LastProcIndex @ 31 + SymSeg @ ac!
            DropLocals HPopLexem
            ." VARIABLE @" There .ASCIIz ."  \\ Forward definition" Cr
            ." : _" There .ASCIIz
            ."  @" There .ASCIIz ."  @ EXECUTE ;" Cr Cr
            Scan ?; IfNot 8 Error Then Exit
         Then

         ." : " HPopLexem // There .ASCIIz ."  \\ Procedure" Cr
         LocalVars
         VarLen @ ParasLen @ + ?Dup If . ."  LOCATE" Cr Then
         ParasLen @ If ParasLen @ U2/ . ."  STOREPARAS" Cr Then
         True ProcFlag !
         Operator
         DropLocals
         VarLen @ ParasLen @ + ?Dup If ." UNLOCATE" Cr Then
         ." ;" Cr Cr
      Else
         7 Error
      Then
   Else
      a" FUNCTION" ?Is
      If
         Scan ?Identifier
         If
            1 0 SymStore
            PushLexem
            ParasList
            ParasLen @ U2/ LastProcIndex @ 29 + SymSeg @ a!

            Scan a" EXTERNAL" ?Is
            If
               DropLocals HPopLexem
               Scan ?; IfNot 8 Error Then Exit
            Then

            Scan a" FORWARD" ?Is
            If
               1 LastProcIndex @ 31 + SymSeg @ ac!
               DropLocals HPopLexem
               ." VARIABLE @" There .ASCIIz ."  \\ Forward definition" Cr
               ."  : _" There .ASCIIz
               ."  @" There .ASCIIz ."  @ EXECUTE ;"
               Cr Cr Scan ?; IfNot 8 Error Then Exit
            Then

            ." : " HPopLexem // There .ASCIIz ."  \\ Function" Cr
            ." 0 >R" Cr

            LocalVars
            VarLen @ ParasLen @ + ?Dup If . ."  LOCATE" Cr Then
            ParasLen @ If ParasLen @ U2/ . ."  STOREPARAS" Cr Then
            False ProcFlag !
            Operator
            DropLocals
            VarLen @ ParasLen @ + ?Dup If ." UNLOCATE" Cr Then
            ." R> ;" Cr Cr
         Else
            7 Error
         Then
      Else
         a" USES" ?Is
         If

            Begin
               DropAll
               Scan Lexem c@ 34 = Lexem c@ 39 = Or Lexem 2+ c@ 0> And
               If
                  ." USE " Lexem 1+ Lexem ASCIIzLen 2- Type Cr
                  DropLexem
                  Scan ?;
                  If
                     Cr Exit
                  Else
                     a" ," ?Is
                     IfNot
                        22 Error
                     Then
                  Then
               Else
                  22 Error
               Then
            Again

         Else
            a" VAR" ?Is
            If
               Begin
                  DropAll
                  Scan ?Identifier
                  If
                     True 1 SymStore PushLexem BSize HPopLexem
                     Dup 2 =
                     If
                        Drop ." VARIABLE " // There .ASCIIz Cr
                        0 LastSearchIndex @ 29 + SymSeg @ a!
                     Else
                        LastSearchIndex @ 29 + SymSeg @ a!
                        ." VARIABLE @" There .ASCIIz
                        ."  \\ Global array definition" Cr
                        ." : " // There .ASCIIz ."  @"
                        There .ASCIIz ."  @ ;" Cr
                     Then
                     Scan ?;
                     If
                        Cr Exit
                     Else
                        a" ," ?Is
                        IfNot
                           a" :" ?Is
                           If
                              Scan a" INTEGER" ?Is
                              If
                                 Scan ?; If Cr Exit Else 16 Error Then
                              Else
                                 16 Error
                              Then
                           Else
                              16 Error
                           Then
                        Then
                     Then
                  Else
                     16 Error
                  Then
               Again
            Else
               a" CHANNEL" ?Is
               If
                  MtaskFlag @
                  IfNot
                     True MTaskFlag !
                     ." USE MTASK.FRL" Cr Cr

                     ." : _START >R >R >R 1024 DUP DUP R> R> R> START ;\r\n"
                     ." : _STOP COMPILE STOP ; IMMEDIATE\r\n"
                     ." : _CONT COMPILE CONT ; IMMEDIATE\r\n"
                     ." : _CANCEL COMPILE CANCEL ; IMMEDIATE\r\n"
                     ." : _TERMANATE COMPILE TERMINATE ; IMMEDIATE\r\n"
                     ." : _HALT COMPILE HALT ; IMMEDIATE\r\n"
                     ." : _LOCK COMPILE LOCK ; IMMEDIATE\r\n"
                     ." : _UNLOCK COMPILE UNLOCK ; IMMEDIATE\r\n"
                     ." : _DELAY COMPILE DELAY ; IMMEDIATE\r\n"
                     ." : _CHECK COMPILE CHECK ; IMMEDIATE\r\n"
                     ." : _WAIT COMPILE WAIT ; IMMEDIATE\r\n"
                     ." : _KEYBOARD KEYBOARD ;\r\n"
                     ." : _READKEY KEYBOARD GET ;\r\n"
                     ." : _KEYPRESSED KEYBOARD CHECK ;\r\n\r\n"

                     StoreMTGlobals
                  Then
                  Begin
                     DropAll
                     Scan ?Identifier
                     If
                        True 2 SymStore
                        ." CHANNEL " // .Lexem Cr
                        Scan ?;
                        If
                           Cr Exit
                        Else
                           a" ," ?Is
                           IfNot
                              16 Error
                           Then
                        Then
                     Else
                        16 Error
                     Then
                  Again

               Else
                  a" FORTH" ?Is
                  If

                     Begin
                        DropAll
                        Scan Lexem c@ 34 = Lexem c@ 39 = Or Lexem 2+ c@ 0> And
                        If
                           ." INCLUDE " Lexem 1+ Lexem ASCIIzLen 2- Type Cr
                           DropLexem
                           Scan ?;
                           If
                              Cr Exit
                           Else
                              a" ," ?Is
                              IfNot
                                 27 Error
                              Then
                           Then
                        Else
                           27 Error
                        Then
                     Again

                  Else
                     ?;
                     IfNot 12 Error Then
                  Then
               Then
            Then
         Then
      Then
   Then
;

Variable PROGFLAG
Create PRGNAME 30 Allot
PrgName CodeSegment 30 0 MFill

: .NAME ( Index --> )
   Begin
      Dup SymSeg @ ac@
   While
      Dup SymSeg @ ac@ Emit 1+
   Repeat
   Drop
;

: RESOLVEFORWARDS ( --> )
   0 >R
   Begin
      R@ SymSeg @ ac@
      If
         R@ 28 + SymSeg @ ac@ 0=
         If
            R@ 31 + SymSeg @ ac@
            Case
               0 Of EndOf
               1 Of 11 Error EndOf
               2 Of ." ['] _" R@ .Name ."  @" R@ .Name ."  !" Cr EndOf
                  2 Error
            EndCase
         Else
            R@ 28 + SymSeg @ ac@ 1 =
            If
               R@ 26 + SymSeg @ a@ True =
               If
                  R@ 29 + SymSeg @ a@ ?Dup
                  If
                     . ."  @" R@ .Name ."  MAKEARRAY" Cr
                  Then
               Then
            Then
         Then
      Then
      R> 32 + Dup >R 0=
   Until
   R> Drop
;

: BODY ( --> )
   PrgName 0!
   Scan ?Identifier If Lexem PrgName 0 28 Copy* Then
   Scan ?; IfNot 8 Error Then

   Begin
      Scan a" BEGIN" ?Is
      If
         True ProcFlag !

         LastProcIndex 0!
         Begin
            LastProcIndex @ SymSeg @ ac@
         While
            32 LastProcIndex +!
         Repeat

         RestoreLexem
         ." : _MAIN" Cr
         Operator
         ." ;" Cr Cr

         ProgFlag @
         If
            ." : _START_"
         Else
            ." : _INIT_"
         Then
         PrgName .ASCIIz ."  \\ Main word" Cr
         ResolveForwards
         MTaskFlag @ ProgFlag @ And
         If
            ." 16 OPENMT DROP" Cr
         Then
         ." _MAIN" Cr
         MtaskFlag @ ProgFlag @ And
         If
            ." CLOSEMT" Cr
         Then
         ." ;" Cr Cr

         Scan a" ." ?Is
         IfNot 33 Error Then
         Exit
      Else
         Global
      Then
   Again
;

\  MAIN WORD
Create INPNAME 85 Allot
InpName CodeSegment 80 0 MFill

: INITVARS
   BufferSize 15 + 16/ Malloc
   If
      BufferSeg !
   Else
      5 Error
   Then

   256 Malloc
   If
      LexStackSeg !
   Else
      5 Error
   Then

   BufferSize BufferPointer !
   BufferSize CharsInBuffer !
   LSP 0!
   Here @Lexem ! 256 Allot
   Here @There ! 256 Allot
   1 CurrLine !
   MtaskFlag 0!
   ExitCode 0!
   DropLexem

   ['] .(EXPRESSION) @EXPRESSION !

   Bl Word Dup >ASCIIz InpName 0 80 Copy*

   Cr
   ." \\ Ŀ\r\n"
   ." \\         Created by PASCAL --> GP-Forth Convertor        \r\n"
   ." \\        (C), 1993 by The Golden Porcupine Software       \r\n"
   ." \\ \r\n"
   Cr ." \\ Program name --> " InpName .ASCIIz Cr Cr
   ." : STOREPARAS ( a1 a2 ... aN N --> )\r\n"
   ."    2*\r\n"
   ."    BEGIN 2-\r\n"
   ."    SWAP OVER L! DUP 0=\r\n"
   ."    UNTIL DROP ;\r\n\r\n"
   ." : MAKEARRAY ( ArraySize PoitnerVariable --> )\r\n"
   ."    HERE SWAP ! ALLOT ;\r\n\r\n"

   ." \\ Standard I/O functions\r\n"
   ." : _PUTC COMPILE EMIT ; IMMEDIATE\r\n"
   ." : _PUTS COMPILE .ASCIIZ ; IMMEDIATE\r\n"
   ." : _PUTN COMPILE .R ; IMMEDIATE\r\n"
   ." : _PUTW COMPILE FALSE COMPILE SWAP COMPILE D.R ; IMMEDIATE\r\n\r\n"
   ." \\ INTR procedure\r\n"
   ." VARIABLE __AX VARIABLE __BX VARIABLE __CX VARIABLE __DX\r\n"
   ." VARIABLE __BP VARIABLE __SI VARIABLE __DI VARIABLE __ES\r\n"
   ." VARIABLE __DS REGISTERS REGS\r\n"
   ." : _INTR\r\n"
   ."    __AX @ REGS AX !     __BX @ REGS BX !\r\n"
   ."    __CX @ REGS CX !     __DX @ REGS DX !\r\n"
   ."    __BP @ REGS BP !\r\n"
   ."    __SI @ REGS SI !     __DI @ REGS DI !\r\n"
   ."    __DS @ REGS DS !     __ES @ REGS ES !\r\n"
   ."    REGS INTR\r\n"
   ."    REGS AX @ __AX !     REGS BX @ __BX !\r\n"
   ."    REGS CX @ __CX !     REGS DX @ __DX !\r\n"
   ."    REGS BP @ __BP !\r\n"
   ."    REGS SI @ __SI !     REGS DI @ __DI !\r\n"
   ."    REGS DS @ __DS !     REGS ES @ __ES ! ;\r\n"
   Cr

   InpName 0 FOpen
   If
      SourceHandle !
   Else
      4 Error
   Then

   InpName a" ." 0 Pos* Dup -1 =
   If
      Drop
   Else
      InpName + 0 Swap c!
   Then

   InitSym
   StoreGlobals
;

: PROGRAM
   InitVars
   Scan a" PROGRAM" ?Is
   If
      True ProgFlag !
      Body
      ." FALSE MESSAGES !" Cr
      ." ' BYE ERRORPROC !" Cr
      MtaskFlag @ IfNot ." TRUE DEBUG !" Cr Then
      Cr
      ." BUILD " a" .COM"
   Else
      a" UNIT" ?Is
      If
         1 ExitCode !
         ProgFlag 0!
         Body
         ." SETSTART _INIT_" PrgName .ASCIIz Cr Cr
         ." MAKEUNIT " a" .FRL"
      Else
         32 Error
      Then
   Then
   InpName Swap InpName ConCat*
   InpName .ASCIIz Cr
   Bye
;

False Messages !
' BYE ErrorProc !

Build pas.com pas.map
