
                .model  tiny
                .code
                org     100h

; ***************************************************************************
;                              Library header
; ***************************************************************************
EntryTable:
                db      'GPRTL'
ProcCount:      dw      10
ExecProc:       dw      ExecRTL
ListOff:        dw      ProcList
NameOff:        dw      RTLName
LibType:        db      'G'

                db      13,10
RTLName:        db      'VGA',27h,'s Mode 320*200, 256 colors '
                db      'Run Time Library',0,13,10
;               db      '(C), 1993 by The Golden Porcupine Software',13,10,0

ProcList:
                ; ( Func# --> SupportFlag )                     --> 0
                dw      InitRTL

                ; ( --> )                                       --> 1
                dw      Set320x240Mode

                ; ( xLoc yLoc --> )                             --> 2
                dw      Reloc

                ; ( --> xSize ySize Colors )                    --> 3
                dw      GetParas

                ; ( Offset --> )                                --> 4
                dw      SetOriginOffset

                ; ( X Y Color --> )                             --> 5
                dw      WritePixelX

                ; ( X Y --> Color )                             --> 6
                dw      ReadPixelX

                ; ( X0 Y0 X1 Y1 Color --> )                     --> 7
                dw      FillRectangleX

                ; ( --> )                                       --> 8
                dw      xSet320x240Mode

                ; ( X0 Y0 X1 Y1 Color --> )                     --> 9
                dw      Line

; ***************************************************************************

CallerIP:       dw      ?
CallerCS:       dw      ?
CallerDS:       dw      ?

ExecRTL:        pop     word ptr cs:[CallerIP]
                pop     word ptr cs:[CallerCS]
                mov     word ptr cs:[CallerDS],ds
                push    cs
                pop     ds
                pop     bx
                cmp     bx,word ptr [ProcCount]
                jnc     Restore
                add     bx,bx
                add     bx,offset ProcList
                cmp     word ptr [bx],0
                jz      Restore
                call    word ptr [bx]
Restore:        mov     ds,word ptr cs:[CallerDS]
                jmp     dword ptr cs:[CallerIP]

; ***************************************************************************
SCREEN_WIDTH    dw      320
SCREEN_SEG      dw      0a000h
ORIGIN_OFFSET   dw      0
X_SIZE          dw      320
Y_SIZE          dw      200
COLORS          dw      256
X_LOC           dw      0
Y_LOC           dw      0

; ***************************************************************************


InitRTL         proc    near
                push    bp
                mov     bp,sp
                push    si
                mov     ax,word ptr [bp+4]
                or      ax,ax
                jnz     Test4F
                mov     ax,01a00h
                int     10h
                cmp     al,1ah
                jnz     InitFalse
                cmp     bl,7
                jz      InitTrue
                cmp     bl,8
                jz      InitTrue
InitFalse:      xor     ax,ax
                jmp     short EndInit
InitTrue:       mov     ax,0ffffh
EndInit:        pop     si
                pop     bp
                pop     dx
                pop     cx
                push    ax
                jmp     dx
Test4F:         cmp     ax,word ptr [ProcCount]
                jnc     InitFalse
                add     ax,ax
                add     ax,offset ProcList
                mov     bx,ax
                cmp     word ptr [bx],0
                jz      InitFalse
                jmp     short InitTrue
InitRTL         endp

Set320x240Mode  proc    near
                push    bp              ; preserve caller's stack frame
                push    si              ; preserve C register vars
                push    di              ; (don't count on BIOS preserving anything)

                mov     ax,13h          ; let the BIOS set standard 256-color
                int     10h             ; mode (320x200 linear)

                pop     di              ; restore C register vars
                pop     si
                pop     bp              ; restore caller's stack frame
                ret
Set320x240Mode  endp

Reloc           proc    near
                push    bp
                mov     bp,sp
                mov     ax,word ptr [bp+4]
                mov     Y_LOC,ax
                mov     ax,word ptr [bp+6]
                mov     X_LOC,ax
                pop     bp
                ret     4
Reloc           endp

GetParas        proc    near
                pop     dx
                push    word ptr [X_SIZE]
                push    word ptr [Y_SIZE]
                push    word ptr [COLORS]
                jmp     dx
GetParas        endp

SetOriginOffset proc    near
                push    bp
                mov     bp,sp
                mov     ax,word ptr [bp+4]
                mov     ORIGIN_OFFSET,ax
                pop     bp
                ret     2
SetOriginOffset endp

WritePixelX     proc    near
                push    bp
                mov     bp,sp
                mov     ax,X_LOC
                add     word ptr [bp+8],ax
                mov     ax,Y_LOC
                add     word ptr [bp+6],ax
                mov     ax,SCREEN_WIDTH
                mul     word ptr [bp+6]
                mov     bx,word ptr [bp+8]
                add     bx,ax
                add     bx,ORIGIN_OFFSET
                mov     es,SCREEN_SEG
                mov     al,byte ptr [bp+4]
                mov     es:[bx],al
                pop     bp
                ret     6
WritePixelX     endp

ReadPixelX      proc    near
                push    bp
                mov     bp,sp
                mov     ax,X_LOC
                add     word ptr [bp+6],ax
                mov     ax,Y_LOC
                add     word ptr [bp+4],ax
                mov     ax,SCREEN_WIDTH
                mul     word ptr [bp+4]
                mov     bx,word ptr [bp+6]
                add     bx,ax
                add     bx,ORIGIN_OFFSET
                mov     es,SCREEN_SEG
                mov     al,es:[bx]
                sub     ah,ah
                mov     word ptr [bp+6],ax
                pop     bp
                ret     2
ReadPixelX      endp

time_f:         dw      0
time_x:         dw      0
time_y:         dw      0
time_z:         dw      0
time_t:         dw      0

FillRectangleX  proc    near
                pop     word ptr [time_f]

                pop     word ptr [time_t]
                pop     dx                              ; y2
                pop     bx                              ; x2
                pop     cx                              ; y1
                pop     ax                              ; x1

                add     ax,X_LOC
                add     cx,Y_LOC
                add     bx,X_LOC
                add     dx,Y_LOC

                push    word ptr [ORIGIN_OFFSET]
                push    word ptr [SCREEN_SEG]
                push    ax
                push    cx
                push    word ptr [SCREEN_WIDTH]
                sub     bx,ax
                inc     bx
                push    bx
                sub     dx,cx
                inc     dx
                push    dx

                pop     word ptr [time_y]
                pop     ax
                mov     word ptr [time_x],ax
                pop     bx
                mov     cx,bx
                sub     bx,ax
                pop     ax
                mul     cx
                pop     di
                add     di,ax
                pop     es
                pop     ax
                add     di,ax
                mov     dx,word ptr [time_x]
                mov     al,byte ptr [time_t]
                fill1:
                mov     cx,dx
                rep     stosb
                add     di,bx
                dec     word ptr [time_y]
                jnz     fill1
                jmp     word ptr [time_f]
FillRectangleX  endp

xSet320x240Mode proc    near
                push    bp              ; preserve caller's stack frame
                push    si              ; preserve C register vars
                push    di              ; (don't count on BIOS preserving anything)

                mov     ax,13h+80h      ; let the BIOS set standard 256-color
                int     10h             ; mode (320x200 linear)

                pop     di              ; restore C register vars
                pop     si
                pop     bp              ; restore caller's stack frame
                ret
xSet320x240Mode endp

;
; Name:		PixelAddr13
;
; Function: Determine buffer address of pixel in 320x200 256-color mode
;
; Caller:	AX = y-coordinate (0-199)
;       BX = x-coordinate (0-319)
;
; Returns:	BX = byte offset in buffer
;		ES = video buffer segment

PixelAddr13     PROC    near

                xchg       ah,al    ; AX := 256*y
                add     bx,ax       ; BX := 256*y + x
                shr     ax,1
                shr     ax,1        ; AX := 64*y
                add     bx,ax       ; BX := 320*y + x

                add     bx,ORIGIN_OFFSET
                                    ; BX := byte offset in video buffer

                mov     es,SCREEN_SEG
                                    ; ES:BX := byte address of pixel
                ret

PixelAddr13     ENDP

ARGx1           EQU     word ptr [bp+12] ; stack frame addressing
ARGy1           EQU     word ptr [bp+10]
ARGx2           EQU     word ptr [bp+8]
ARGy2           EQU     word ptr [bp+6]
ARGn            EQU     byte ptr [bp+4]
VARincr1        EQU     word ptr [bp-2]
VARincr2        EQU     word ptr [bp-4]
VARroutine      EQU     word ptr [bp-6]

Line            PROC    near

                push    bp              ; preserve caller registers
                mov     bp,sp
                sub     sp,6            ; stack space for local variables
                push    si
                push    di

                mov     ax,X_LOC
                add     word ptr [bp+8],ax
                add     word ptr [bp+12],ax

                mov     ax,Y_LOC
                add     word ptr [bp+6],ax
                add     word ptr [bp+10],ax

; check for vertical line

                mov     si,SCREEN_WIDTH ; initial y-increment

                mov     cx,ARGx2
                sub     cx,ARGx1        ; CX := x2 - x1
                jz      VertLine13      ; jump if vertical line

; force x1 < x2

                jns     L01             ; jump if x2 > x1

                neg     cx              ; CX := x1 - x2
                
                mov     bx,ARGx2        ; exchange x1 and x2
                xchg    bx,ARGx1
                mov     ARGx2,bx

                mov     bx,ARGy2        ; exchange y1 and y2
                xchg    bx,ARGy1
                mov     ARGy2,bx

; calculate dy = ABS(y2-y1)

L01:            mov     bx,ARGy2
                sub     bx,ARGy1        ; BX := y2 - y1
                jz      HorizLine13     ; jump if horizontal line

                jns     L03             ; jump if slope is positive

                neg     bx              ; BX := y1 - y2
                neg     si              ; negate y-increment

; select appropriate routine for slope of line

L03:            push    si              ; preserve y-increment

                mov     VARroutine,offset LoSlopeLine13
                cmp     bx,cx
                jle     L04             ; jump if dy <= dx (slope <= 1)
                mov     VARroutine,offset HiSlopeLine13
                xchg    bx,cx           ; exchange dy and dx

; calculate initial decision variable and increments

L04:            shl     bx,1            ; BX := 2 * dy
                mov     VARincr1,bx     ; incr1 := 2 * dy
                sub     bx,cx
                mov     si,bx           ; SI := d = 2 * dy - dx
                sub     bx,cx
                mov     VARincr2,bx     ; incr2 := 2 * (dy - dx)

; calculate first pixel address

                push    cx              ; preserve this register
                mov     ax,ARGy1        ; AX := y
                mov     bx,ARGx1        ; BX := x
                call    PixelAddr13     ; ES:BX -> buffer

                mov     di,bx           ; ES:DI -> buffer

                pop     cx              ; restore this register
                inc     cx              ; CX := # of pixels to draw

                pop     bx              ; BX := y-increment
                jmp     VARroutine      ; jump to appropriate routine for slope


; routine for vertical lines

VertLine13:     mov     ax,ARGy1        ; AX := y1
                mov     bx,ARGy2        ; BX := y2
                mov     cx,bx
                sub     cx,ax           ; CX := dy
                jge     L31             ; jump if dy >= 0

                neg     cx              ; force dy >= 0
                mov     ax,bx           ; AX := y2

L31:            inc     cx              ; CX := # of pixels to draw
                mov     bx,ARGx1        ; BX := x
                push    cx              ; preserve this register
                call    PixelAddr13     ; ES:BX -> video buffer
                pop     cx

                mov     di,bx           ; ES:DI -> video buffer
                dec     si              ; SI := bytes/line - 1

                mov     al,ARGn         ; AL := pixel value

L32:            stosb                   ; set pixel value in buffer
                add     di,si           ; increment to next line
                loop    L32

                jmp     Lexit



; routine for horizontal lines (slope = 0)

HorizLine13:
                push    cx              ; preserve CX
                mov     ax,ARGy1
                mov     bx,ARGx1
                call    PixelAddr13     ; ES:BX -> video buffer
                mov     di,bx           ; ES:DI -> buffer

                pop     cx
                inc     cx              ; CX := number of pixels to draw

                mov     al,ARGn         ; AL := pixel value

                rep     stosb           ; update the video buffer

                jmp     short Lexit


; routine for dy <= dx (slope <= 1)     ; ES:DI -> video buffer
                                        ; BX = y-increment
                                        ; CX = #pixels to draw
                                        ; SI = decision variable
LoSlopeLine13:

                mov     al,ARGn         ; AL := pixel value

L11:            stosb                   ; store pixel, increment x

                or      si,si           ; test sign of d
                jns     L12             ; jump if d >= 0

                add     si,VARincr1     ; d := d + incr1
                loop    L11
                jmp     short Lexit

L12:            add     si,VARincr2     ; d := d + incr2
                add     di,bx           ; increment y
                loop    L11
                jmp     short Lexit


; routine for dy > dx (slope > 1)       ; ES:DI -> video buffer
                                        ; BX = y-increment
                                        ; CX = #pixels to draw
                                        ; SI = decision variable
HiSlopeLine13:
                mov     al,ARGn         ; AL := pixel value

L21:            stosb                   ; update next pixel, increment x

                add     di,bx           ; increment y

L22:            or      si,si           ; test sign of d
                jns     L23             ; jump if d >= 0

                add     si,VARincr1     ; d := d + incr1
                dec     di              ; decrement x (already incremented
                                        ;  by stosb)
                loop    L21
                jmp     short Lexit


L23:            add     si,VARincr2     ; d := d + incr2
                loop    L21


Lexit:          pop     di              ; restore registers and return
                pop     si
                mov     sp,bp
                pop     bp
                ret     10

Line            ENDP

                end     EntryTable
