
                .model  tiny
                .code
                org     100h

; ***************************************************************************
;                              Library header
; ***************************************************************************
EntryTable:
                db      'GPRTL'
ProcCount:      dw      10
ExecProc:       dw      ExecRTL
ListOff:        dw      ProcList
NameOff:        dw      RTLName
LibType:        db      'G'

                db      13,10
RTLName:        db      'VGA',27h,'s Mode 400*480, 256 colors '
                db      'Run Time Library',0,13,10
;               db      '(C), 1993 by The Golden Porcupine Software',13,10,0

ProcList:
                ; ( Func# --> SupportFlag )                     --> 0
                dw      InitRTL

                ; ( --> )                                       --> 1
                dw      Mode400x480

                ; ( xLoc yLoc --> )                             --> 2
                dw      Reloc

                ; ( --> xSize ySize Colors )                    --> 3
                dw      GetParas

                ; ( Offset --> )                                --> 4
                dw      SetOriginOffset

                ; ( X Y Color --> )                             --> 5
                dw      WritePixelX

                ; ( X Y --> Color )                             --> 6
                dw      ReadPixelX

                ; ( X0 Y0 X1 Y1 Color --> )                     --> 7
                dw      FillRectangleX

                ; ( --> )                                       --> 8
                dw      xMode400x480

                ; ( X0 Y0 X1 Y1 Color --> )                     --> 9
                dw      Line

; ***************************************************************************

CallerIP:       dw      ?
CallerCS:       dw      ?
CallerDS:       dw      ?

ExecRTL:        pop     word ptr cs:[CallerIP]
                pop     word ptr cs:[CallerCS]
                mov     word ptr cs:[CallerDS],ds
                push    cs
                pop     ds
                pop     bx
                cmp     bx,word ptr [ProcCount]
                jnc     Restore
                add     bx,bx
                add     bx,offset ProcList
                cmp     word ptr [bx],0
                jz      Restore
                call    word ptr [bx]
Restore:        mov     ds,word ptr cs:[CallerDS]
                jmp     dword ptr cs:[CallerIP]

; ***************************************************************************
SCREEN_WIDTH    dw      100
SCREEN_SEG      dw      0a000h
ORIGIN_OFFSET   dw      0
X_SIZE          dw      400
Y_SIZE          dw      480
COLORS          dw      256
X_LOC           dw      0
Y_LOC           dw      0

; ***************************************************************************

SC_INDEX        equ     03c4h           ; Sequence Controller Index
CRTC_INDEX      equ     03d4h           ; CRT Controller Index
MISC_OUTPUT     equ     03c2h           ; Miscellaneous Output register
MAP_MASK        equ     02h             ; index in SC of Map Mask register
GC_INDEX        equ     03ceh           ; Graphics Controller Index
READ_MAP        equ     04h             ; Index in GC of Read Map register

; ***************************************************************************

InitRTL         proc    near
                push    bp
                mov     bp,sp
                push    si
                mov     ax,word ptr [bp+4]
                or      ax,ax
                jnz     Test4F
                mov     ax,01a00h
                int     10h
                cmp     al,1ah
                jnz     InitFalse
                cmp     bl,7
                jz      InitTrue
                cmp     bl,8
                jz      InitTrue
InitFalse:      xor     ax,ax
                jmp     short EndInit
InitTrue:       mov     ax,0ffffh
EndInit:        pop     si
                pop     bp
                pop     dx
                pop     cx
                push    ax
                jmp     dx
Test4F:         cmp     ax,word ptr [ProcCount]
                jnc     InitFalse
                add     ax,ax
                add     ax,offset ProcList
                mov     bx,ax
                cmp     word ptr [bx],0
                jz      InitFalse
                jmp     short InitTrue
InitRTL         endp

CRTParms        label   word
                dw      00d06h          ; vertical total
                dw      03e07h          ; overflow (bit 8 of vertical counts)
                dw      04009h          ; cell height (2 to double-scan)
                dw      0ea10h          ; v sync start
                dw      0ac11h          ; v sync end and protect cr0-cr7
                dw      0df12h          ; vertical displayed
                dw      00014h          ; turn off dword mode
                dw      0e715h          ; v blank start
                dw      00616h          ; v blank end
                dw      0e317h          ; turn on byte mode
CRT_PARM_LENGTH equ     (($-CRTParms)/2)

tab             db      000h,06bh,001h,059h,002h,05Ah,003h,08Eh
                db      004h,05Eh,005h,08Ah,006h,00Eh,007h,03Eh
                db      009h,040h,010h,0EAh,011h,0ACh,012h,0DFh
                db      013h,02Dh,014h,000h,015h,0E7h,016h,006h
                db      017h,0E3h

tab1            db      000h,071h
                db      001h,063h
                db      002h,06fh
                db      003h,090h               ; or 80h
                db      004h,066h
                db      005h,080h
                db      006h,0ffh
                db      007h,00fh
                db      009h,040h               ; or 040h
                db      010h,0EAh               ; or 0EAh
                db      011h,0ACh               ; or 0ACh
                db      012h,0DFh               ; or 0DFh
                db      013h,032h               ; or 02Dh
                db      014h,000h               ; or 000h
                db      015h,0E7h               ; or 0E7h
                db      016h,006h               ; or 006h
                db      017h,0e3h               ; or 0E3h

Mode400x480     proc    near
                push    es
                push    ds
                push    bp
                push    si

                mov     ax,13h
                int     10h                     ; Video display   ah=functn 00h
                                                ;  set display mode in al
                mov     dx,3C4h
                mov     ax,604h
                out     dx,ax                   ; port 3C4h, EGA sequencr index
                                                ;  al = 4, memory mode select
                mov     ax,0f02h
                out     dx,ax                   ; port 3C4h, EGA sequencr index
                                                ;  al = 2, map mask register
                push    di
                xor     di,di                   ; Zero register
                mov     ax,0a000h
                mov     es,ax
                mov     cx,5460h
                xor     ax,ax                   ; Zero register
                cld                             ; Clear direction
                repne   stosw                   ; Rep zf=0+cx >0 Store ax to e
                pop     di
                mov     ax,100h
                out     dx,ax                   ; port 3C4h, EGA sequencr index
                                                ;  al = 0, reset sequencer
                mov     dx,3C2h
                mov     al,0e7h
                out     dx,al                   ; port 3C2h, EGA misl out reg
                mov     dx,3C4h
                mov     ax,300h
                out     dx,ax                   ; port 3C4h, EGA sequencr index
                                                ;  al = 0, reset sequencer
                mov     dx,3D4h
                mov     al,11h
                out     dx,al                   ; port 3D4h, CGA/EGA reg index
                                                ;  al = 11h, light pen low
                inc     dx
                in      al,dx                   ; port 3D5h, CGA/EGA indxd data
                and     al,07Fh
                out     dx,al                   ; port 3D5h, CGA/EGA indxd data
                dec     dx
                cld                             ; Clear direction
                push    cs
                pop     ds
                mov     si,offset tab1
                mov     cx,11h

locloop_1298:   lodsw                           ; String [si] to ax
                out     dx,ax                   ; port 3D4h, CGA/EGA reg index
                                                ;  al = 11h, light pen low
                loop    locloop_1298            ; Loop if cx > 0

                pop     si
                pop     bp
                pop     ds
                pop     es
                ret
Mode400x480     endp

Reloc           proc    near
                push    bp
                mov     bp,sp
                mov     ax,word ptr [bp+4]
                mov     Y_LOC,ax
                mov     ax,word ptr [bp+6]
                mov     X_LOC,ax
                pop     bp
                ret     4
Reloc           endp

GetParas        proc    near
                pop     dx
                push    word ptr [X_SIZE]
                push    word ptr [Y_SIZE]
                push    word ptr [COLORS]
                jmp     dx
GetParas        endp

SetOriginOffset proc    near
                push    bp
                mov     bp,sp
                mov     ax,word ptr [bp+4]
                mov     ORIGIN_OFFSET,ax
                pop     bp
                ret     2
SetOriginOffset endp

WritePixelX     proc    near
                push    bp
                mov     bp,sp
                mov     ax,X_LOC
                add     word ptr [bp+8],ax
                mov     ax,Y_LOC
                add     word ptr [bp+6],ax
                mov     ax,SCREEN_WIDTH
                mul     word ptr [bp+6]
                mov     bx,word ptr [bp+8]
                shr     bx,1
                shr     bx,1
                add     bx,ax
                add     bx,ORIGIN_OFFSET
                mov     es,SCREEN_SEG
                mov     cl,byte ptr [bp+8]
                and     cl,011b
                mov     ax,0100h+MAP_MASK
                shl     ah,cl
                mov     dx,SC_INDEX
                out     dx,ax
                mov     al,byte ptr [bp+4]
                mov     es:[bx],al
                pop     bp
                ret     6
WritePixelX     endp

ReadPixelX      proc    near
                push    bp
                mov     bp,sp
                mov     ax,X_LOC
                add     word ptr [bp+6],ax
                mov     ax,Y_LOC
                add     word ptr [bp+4],ax
                mov     ax,SCREEN_WIDTH
                mul     word ptr [bp+4]
                mov     bx,word ptr [bp+6]
                shr     bx,1
                shr     bx,1
                add     bx,ax
                add     bx,ORIGIN_OFFSET
                mov     es,SCREEN_SEG
                mov     ah,byte ptr [bp+6]
                and     ah,011b
                mov     al,READ_MAP
                mov     dx,GC_INDEX
                out     dx,ax
                mov     al,es:[bx]
                sub     ah,ah
                mov     word ptr [bp+6],ax
                pop     bp
                ret     2
ReadPixelX      endp

LeftClipPlnMsk  db      0fh,0eh,0ch,08h
RightClipPlnMsk db      0fh,01h,03h,07h

FillRectangleX  proc    near
                push    bp
                mov     bp,sp
                push    si
                push    di
                mov     ax,X_LOC
                add     word ptr [bp+8],ax
                add     word ptr [bp+12],ax

                mov     ax,Y_LOC
                add     word ptr [bp+6],ax
                add     word ptr [bp+10],ax

                inc     word ptr [bp+8]
                inc     word ptr [bp+6]

                cld
                mov     ax,SCREEN_WIDTH
                mul     word ptr [bp+10]
                mov     di,word ptr [bp+12]
                shr     di,1
                shr     di,1
                add     di,ax
                add     di,ORIGIN_OFFSET
                mov     es,SCREEN_SEG
                mov     dx,SC_INDEX
                mov     al,MAP_MASK
                out     dx,al
                inc     dx
                mov     si,word ptr [bp+12]
                and     si,03h
                mov     bh,byte ptr [si+LeftClipPlnMsk]
                mov     si,word ptr [bp+8]
                and     si,03h
                mov     bl,byte ptr [si+RightClipPlnMsk]
                mov     cx,word ptr [bp+8]
                mov     si,word ptr [bp+12]
                cmp     cx,si
                jle     FillDone
                dec     cx
                and     si,not 011b
                sub     cx,si
                shr     cx,1
                shr     cx,1
                jnz     MasksSet
                and     bh,bl
MasksSet:       mov     si,word ptr [bp+6]
                sub     si,word ptr [bp+10]
                jle     FillDone
                mov     ah,byte ptr [bp+4]
                mov     bp,SCREEN_WIDTH
                sub     bp,cx
                dec     bp
FillRowsLoop:   push    cx
                mov     al,bh
                out     dx,al
                mov     al,ah
                stosb
                dec     cx
                js      FillLoopBottom
                jz      DoRightEdge
                mov     al,0fh
                out     dx,al
                mov     al,ah
                rep     stosb
DoRightEdge:    mov     al,bl
                out     dx,al
                mov     al,ah
                stosb
FillLoopBottom: add     di,bp
                pop     cx
                dec     si
                jnz     FillRowsLoop
FillDone:       pop     di
                pop     si
                pop     bp
                ret     10
FillRectangleX  endp

xMode400x480    proc    near
                push    es
                push    ds
                push    bp
                push    si

                mov     ax,13h+128
                int     10h                     ; Video display   ah=functn 00h
                                                ;  set display mode in al
                mov     dx,3C4h
                mov     ax,604h
                out     dx,ax                   ; port 3C4h, EGA sequencr index
                                                ;  al = 4, memory mode select
                mov     ax,0f02h
                out     dx,ax                   ; port 3C4h, EGA sequencr index
                                                ;  al = 2, map mask register
                push    di
                xor     di,di                   ; Zero register
                mov     ax,0a000h
                mov     es,ax
                mov     cx,5460h
                xor     ax,ax                   ; Zero register
                cld                             ; Clear direction
                repne   stosw                   ; Rep zf=0+cx >0 Store ax to e
                pop     di
                mov     ax,100h
                out     dx,ax                   ; port 3C4h, EGA sequencr index
                                                ;  al = 0, reset sequencer
                mov     dx,3C2h
                mov     al,0e7h
                out     dx,al                   ; port 3C2h, EGA misl out reg
                mov     dx,3C4h
                mov     ax,300h
                out     dx,ax                   ; port 3C4h, EGA sequencr index
                                                ;  al = 0, reset sequencer
                mov     dx,3D4h
                mov     al,11h
                out     dx,al                   ; port 3D4h, CGA/EGA reg index
                                                ;  al = 11h, light pen low
                inc     dx
                in      al,dx                   ; port 3D5h, CGA/EGA indxd data
                and     al,07Fh
                out     dx,al                   ; port 3D5h, CGA/EGA indxd data
                dec     dx
                cld                             ; Clear direction
                push    cs
                pop     ds
                mov     si,offset tab1
                mov     cx,11h

xlocloop_1298:  lodsw                           ; String [si] to ax
                out     dx,ax                   ; port 3D4h, CGA/EGA reg index
                                                ;  al = 11h, light pen low
                loop    xlocloop_1298           ; Loop if cx > 0

                pop     si
                pop     bp
                pop     ds
                pop     es
                ret
xMode400x480    endp


; Caller:   AX = y-coordinate (0-239)
;       BX = x-coordinate (0-319)
;
; Returns:  AH = bit mask
;       BX = byte offset in buffer
;       ES = video buffer segment
;

Masks_04:       db      1,2,4,8

PixelAddr04     PROC       near
                push    dx
                mul     word ptr [SCREEN_WIDTH]
                push    bx
                shr     bx,1
                shr     bx,1
                add     ax,bx
                pop     bx
                pop     dx
                and     bx,3
                mov     bh,byte ptr [bx+Masks_04]
                xchg    ax,bx
                add     bx,word ptr [ORIGIN_OFFSET]
                mov     es,SCREEN_SEG
                ret

PixelAddr04     ENDP

;
; Name:         Line04
;
; Function:     Draw a line in 320x200 4-color mode
;
; Caller:       Microsoft C:
;
;                       void Line04(x1,y1,x2,y2,n);
;
;                       int x1,y1,x2,y2;        /* pixel coordinates */
;
;                       int n;                  /* pixel value */
;

ARGx1           EQU     word ptr [bp+12] ; stack frame addressing
ARGy1           EQU     word ptr [bp+10]
ARGx2           EQU     word ptr [bp+8]
ARGy2           EQU     word ptr [bp+6]
ARGn            EQU     byte ptr [bp+4]
VARvertincr     EQU     word ptr [bp-2]
VARincr1        EQU     word ptr [bp-4]
VARincr2        EQU     word ptr [bp-6]
VARroutine      EQU     word ptr [bp-8]

; ByteOffsetShift EQU     2

Line            PROC    near

                push    bp              ; preserve caller registers
                mov     bp,sp
                sub     sp,8            ; stack space for local variables
                push    si
                push    di

                mov     ax,X_LOC
                add     word ptr [bp+8],ax
                add     word ptr [bp+12],ax

                mov     ax,Y_LOC
                add     word ptr [bp+6],ax
                add     word ptr [bp+10],ax

; configure the Graphics Controller

;                mov     dx,3CEh         ; DX := Graphics Controller port addr

;                mov     ah,15           ; AH := pixel value
;                xor     al,al           ; AL := Set/Reset Register number
;                out     dx,ax

;                mov     ax,0F01h        ; AH := 1111b (bit plane mask for
                                        ;  Enable Set/Reset
;                out     dx,ax           ; AL := Enable Set/Reset Register #

;                mov     ah,0            ; bits 3 and 4 of AH := function
;                mov     al,3            ; AL := Data Rotate/Func Select reg #
;                out     dx,ax
                
; check for vertical line

                mov     si,SCREEN_WIDTH ; increment for video buffer

                mov     cx,ARGx2
                sub     cx,ARGx1        ; CX := x2 - x1
                jz      VertLine04      ; jump if vertical line

; force x1 < x2

                jns     L01             ; jump if x2 > x1

                neg     cx              ; CX := x1 - x2

                mov     bx,ARGx2        ; exchange x1 and x2
                xchg    bx,ARGx1
                mov     ARGx2,bx

                mov     bx,ARGy2        ; exchange y1 and y2
                xchg    bx,ARGy1
                mov     ARGy2,bx

; calculate dy = ABS(y2-y1)

L01:            mov     bx,ARGy2
                sub     bx,ARGy1        ; BX := y2 - y1
                jz      HorizLine04     ; jump if horizontal line

                jns     L03             ; jump if slope is positive

                neg     bx              ; BX := y1 - y2
                neg     si              ; negate increment for buffer interleave

; select appropriate routine for slope of line

L03:            mov     VARvertincr,si  ; save vertical increment

                mov     VARroutine,offset LoSlopeLine10
                cmp     bx,cx
                jle     L04             ; jump if dy <= dx (slope <= 1)
                mov     VARroutine,offset HiSlopeLine10
                xchg    bx,cx           ; exchange dy and dx

; calculate initial decision variable and increments

L04:            shl     bx,1            ; BX := 2 * dy
                mov     VARincr1,bx     ; incr1 := 2 * dy
                sub     bx,cx
                mov     si,bx           ; SI := d = 2 * dy - dx
                sub     bx,cx
                mov     VARincr2,bx     ; incr2 := 2 * (dy - dx)

; calculate first pixel address

                push    cx              ; preserve this register
                mov     ax,ARGy1        ; AX := y
                mov     bx,ARGx1        ; BX := x
                call    PixelAddr04     ; AH := bit mask
                                        ; ES:BX -> buffer

                mov     di,bx           ; ES:DI -> buffer
                mov     bl,ah           ; AH,BL := bit mask
                mov     al,MAP_MASK            ; AL := Bit Mask Register number

                pop     cx              ; restore this register
                inc     cx              ; CX := # of pixels to draw

                mov     dx,SC_INDEX

                jmp     VARroutine      ; jump to appropriate routine for slope

VertLine04:
HorizLine04:
                mov     ax,ARGx1
                mov     bx,ARGx2
                cmp     ax,bx
                jc      vl4a
                xchg    ax,bx
vl4a:           mov     cx,ARGy1
                mov     dx,ARGy2
                cmp     cx,dx
                jc      vl4b
                xchg    cx,dx
vl4b:           push    ax

                push    cx
                push    bx
                push    dx
                push    word ptr [bp+4]
                call    FillRectangleX

                jmp     Lexit

LoSlopeLine10:

L10:            mov     ah,bl           ; AH := bit mask for next pixel

L11:            or      ah,bl           ; mask current pixel position
                rol     bl,1            ; rotate pixel value
                test    bl,10h
                jnz     L14             ; jump if bit mask rotated to
                                        ;  leftmost pixel position

; bit mask not shifted out

                or      si,si           ; test sign of d
                jns     L12             ; jump if d >= 0

                add     si,VARincr1     ; d := d + incr1
                loop    L11

                out     dx,ax           ; update Bit Mask Register
                mov     al,ARGn
                mov     es:[di],al      ; set remaining pixel(s)
                jmp     short Lexit

L12:            add     si,VARincr2     ; d := d + incr2
                out     dx,ax           ; update Bit Mask Register

                mov     al,ARGn
                mov     es:[di],al      ; update bit planes
                mov     al,MAP_MASK

                add     di,VARvertincr  ; increment y
                loop    L10
                jmp     short Lexit

; bit mask shifted out

L14:            out     dx,ax           ; update Bit Mask Register ...

                mov     bl,1

                mov     al,ARGn
                mov     es:[di],al      ; update bit planes
                mov     al,MAP_MASK
                inc     di              ; increment x

                or      si,si           ; test sign of d
                jns     L15             ; jump if non-negative

                add     si,VARincr1     ; d := d + incr1
                loop    L10
                jmp     short Lexit

L15:            add     si,VARincr2     ; d := d + incr2
                add     di,VARvertincr  ; vertical increment
                loop    L10
                jmp     short Lexit


; routine for dy > dx (slope > 1)       ; ES:DI -> video buffer
                                        ; AH = bit mask for 1st pixel
                                        ; AL = Bit Mask Register number
                                        ; CX = #pixels to draw
                                        ; DX = Graphics Controller port addr
                                        ; SI = decision variable
HiSlopeLine10:
                mov     bx,VARvertincr  ; BX := y-increment

L21:            out     dx,ax           ; update Bit Mask Register
                mov     al,ARGn
                mov     es:[di],al      ; update bit planes
                mov     al,MAP_MASK

                add     di,bx           ; increment y

L22:            or      si,si           ; test sign of d
                jns     L23             ; jump if d >= 0

                add     si,VARincr1     ; d := d + incr1
                loop    L21
                jmp     short Lexit


L23:            add     si,VARincr2     ; d := d + incr2

                rol     ah,1            ; rotate bit mask
                test    ah,10h

                jz      vvv
                mov     ah,1
                add     di,1            ; increment DI if when mask rotated to
                                        ;  leftmost pixel position
vvv:

                loop    L21

Lexit:          pop     di              ; restore registers and return
                pop     si
                mov     sp,bp
                pop     bp
                ret     10

Line            ENDP

                end     EntryTable
