
bs_char         equ     1


                .model  tiny
                .code
                org     100h

; ***************************************************************************
;                              Library header
; ***************************************************************************
EntryTable:
                db      'GPRTL'
ProcCount:      dw      15
ExecProc:       dw      ExecRTL
ListOff:        dw      ProcList
NameOff:        dw      RTLName
LibType:        db      'G'

                db      13,10
RTLName:        db      'VGA',27h,'s 640*480, 16 colors mode '
                db      'Run Time Library',0,13,10
;               db      '(C), 1993 by The Golden Porcupine Software',13,10,0

ProcList:
; ( Func# --> SupportFlag )                     --> 0
                dw      InitRTL

; ( --> )                                       --> 1
                dw      Set320x240Mode

; ( xLoc yLoc --> )                             --> 2
                dw      Reloc

; ( --> xSize ySize Colors )                    --> 3
                dw      GetParas

; ( Offset --> )                                --> 4
                dw      SetOriginOffset

; ( X Y Color --> )                             --> 5
                dw      WritePixelX

; ( X Y --> Color )                             --> 6
                dw      ReadPixelX

; ( X0 Y0 X1 Y1 Color --> )                     --> 7
                dw      FillRectangleX

; ( --> )                                       --> 8
                dw      xSet320x240Mode

; ( X0 Y0 X1 Y1 Color --> )                     --> 9
                dw      Line

; ( LineOff LineSeg X Y Color --> )             --> 10
                dw      Text8x16

; ( --> )                                       --> 11
                dw      SaveScreen

; ( --> )                                       --> 12
                dw      RestoreScreen

; ( X Y --> )                                   --> 13
                dw      SaveCross

; ( X Y --> )                                   --> 14
                dw      RestoreCross
; ***************************************************************************

CallerIP:       dw      ?
CallerCS:       dw      ?
CallerDS:       dw      ?

ExecRTL:        pop     word ptr cs:[CallerIP]
                pop     word ptr cs:[CallerCS]
                mov     word ptr cs:[CallerDS],ds
                push    cs
                pop     ds
                pop     bx
                cmp     bx,word ptr [ProcCount]
                jnc     Restore
                add     bx,bx
                add     bx,offset ProcList
                cmp     word ptr [bx],0
                jz      Restore
                call    word ptr [bx]
Restore:        mov     ds,word ptr cs:[CallerDS]
                jmp     dword ptr cs:[CallerIP]

; ***************************************************************************
SCREEN_WIDTH    dw      80
SCREEN_SEG      dw      0a000h
ORIGIN_OFFSET   dw      0
X_SIZE          dw      640
Y_SIZE          dw      480
COLORS          dw      16
X_LOC           dw      0
Y_LOC           dw      0

; ***************************************************************************

SC_INDEX        equ     03c4h           ; Sequence Controller Index
CRTC_INDEX      equ     03d4h           ; CRT Controller Index
MISC_OUTPUT     equ     03c2h           ; Miscellaneous Output register
MAP_MASK        equ     02h             ; index in SC of Map Mask register
GC_INDEX        equ     03ceh           ; Graphics Controller Index
READ_MAP        equ     04h             ; Index in GC of Read Map register

; ***************************************************************************
; 8*16 Font
Font_8x16:
 db 000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h; 000
 db 000h,03Ch,042h,081h,0A5h,0A5h,081h,081h,0A5h,099h,042h,03Ch,000h,000h,000h,000h; 001
 db 03Fh,080h,080h,080h,080h,080h,080h,000h,000h,080h,080h,080h,080h,080h,080h,03Fh; 002
 db 000h,040h,040h,040h,040h,040h,040h,000h,000h,040h,040h,040h,040h,040h,040h,000h; 003
 db 000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h; 004
 db 000h,040h,040h,040h,040h,040h,040h,000h,000h,040h,040h,040h,040h,040h,040h,000h; 005
 db 03Fh,000h,000h,000h,000h,000h,000h,03Fh,000h,080h,080h,080h,080h,080h,080h,03Fh; 006
 db 000h,040h,040h,040h,040h,040h,040h,000h,000h,000h,000h,000h,000h,000h,000h,000h; 007
 db 03Fh,000h,000h,000h,000h,000h,000h,03Fh,000h,000h,000h,000h,000h,000h,000h,03Fh; 008
 db 000h,040h,040h,040h,040h,040h,040h,000h,000h,040h,040h,040h,040h,040h,040h,000h; 009
 db 000h,080h,080h,080h,080h,080h,080h,03Fh,000h,000h,000h,000h,000h,000h,000h,000h; 00A
 db 000h,040h,040h,040h,040h,040h,040h,000h,000h,040h,040h,040h,040h,040h,040h,000h; 00B
 db 03Fh,080h,080h,080h,080h,080h,080h,03Fh,000h,000h,000h,000h,000h,000h,000h,03Fh; 00C
 db 000h,000h,000h,000h,000h,000h,000h,000h,000h,040h,040h,040h,040h,040h,040h,000h; 00D
 db 03Fh,080h,080h,080h,080h,080h,080h,03Fh,000h,080h,080h,080h,080h,080h,080h,03Fh; 00E
 db 000h,000h,000h,000h,000h,000h,000h,000h,000h,040h,040h,040h,040h,040h,040h,000h; 00F
 db 000h,000h,000h,000h,080h,0E0h,0F8h,0FEh,0F8h,0E0h,080h,000h,000h,000h,000h,000h; 010
 db 000h,000h,000h,000h,002h,00Eh,03Eh,0FEh,03Eh,00Eh,002h,000h,000h,000h,000h,000h; 011
 db 03Fh,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h; 012
 db 000h,040h,040h,040h,040h,040h,040h,000h,000h,040h,040h,040h,040h,040h,040h,000h; 013
 db 03Fh,080h,080h,080h,080h,080h,080h,03Fh,000h,080h,080h,080h,080h,080h,080h,03Fh; 014
 db 000h,040h,040h,040h,040h,040h,040h,000h,000h,040h,040h,040h,040h,040h,040h,000h; 015
 db 03Fh,080h,080h,080h,080h,080h,080h,03Fh,000h,000h,000h,000h,000h,000h,000h,03Fh; 016
 db 000h,040h,040h,040h,040h,040h,040h,000h,000h,040h,040h,040h,040h,040h,040h,000h; 017
 db 000h,000h,000h,000h,000h,000h,000h,03Fh,000h,000h,000h,000h,000h,000h,000h,000h; 018
 db 000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h; 019
 db 03Fh,080h,080h,080h,080h,080h,080h,03Fh,000h,080h,080h,080h,080h,080h,080h,03Fh; 01A
 db 000h,040h,040h,040h,040h,040h,040h,000h,000h,040h,040h,040h,040h,040h,040h,000h; 01B
 db 03Fh,080h,080h,080h,080h,080h,080h,03Fh,000h,080h,080h,080h,080h,080h,080h,03Fh; 01C
 db 000h,040h,040h,040h,040h,040h,040h,000h,000h,040h,040h,040h,040h,040h,040h,000h; 01D
 db 03Fh,080h,080h,080h,080h,080h,080h,03Fh,000h,080h,080h,080h,080h,080h,080h,03Fh; 01E
 db 000h,040h,040h,040h,040h,040h,040h,000h,000h,040h,040h,040h,040h,040h,040h,000h; 01F
 db 000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h; 020
 db 000h,000h,010h,010h,010h,010h,010h,010h,000h,000h,010h,010h,000h,000h,000h,000h; 021
 db 000h,000h,024h,024h,024h,024h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h; 022
 db 000h,000h,044h,044h,044h,0FEh,044h,044h,0FEh,044h,044h,044h,000h,000h,000h,000h; 023
 db 000h,028h,07Ch,0AAh,0A8h,0A8h,07Ch,02Ah,02Ah,0AAh,07Ch,028h,000h,000h,000h,000h; 024
 db 000h,060h,090h,092h,064h,008h,010h,020h,04Ch,092h,012h,00Ch,000h,000h,000h,000h; 025
 db 000h,000h,038h,044h,044h,028h,030h,052h,08Ah,08Ch,074h,002h,000h,000h,000h,000h; 026
 db 000h,000h,008h,008h,010h,010h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h; 027
 db 000h,004h,008h,010h,010h,020h,020h,020h,010h,010h,008h,004h,000h,000h,000h,000h; 028
 db 000h,040h,020h,010h,010h,008h,008h,008h,010h,010h,020h,040h,000h,000h,000h,000h; 029
 db 000h,000h,000h,000h,010h,092h,054h,038h,054h,092h,010h,000h,000h,000h,000h,000h; 02A
 db 000h,000h,000h,000h,010h,010h,010h,0FEh,010h,010h,010h,000h,000h,000h,000h,000h; 02B
 db 000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,030h,030h,010h,010h,000h,000h; 02C
 db 000h,000h,000h,000h,000h,000h,000h,07Eh,000h,000h,000h,000h,000h,000h,000h,000h; 02D
 db 000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,030h,030h,000h,000h,000h,000h; 02E
 db 000h,002h,002h,004h,004h,008h,008h,008h,010h,010h,020h,020h,000h,000h,000h,000h; 02F
 db 000h,000h,03Ch,042h,046h,046h,04Ah,052h,062h,062h,042h,03Ch,000h,000h,000h,000h; 030
 db 000h,000h,008h,018h,028h,008h,008h,008h,008h,008h,008h,03Eh,000h,000h,000h,000h; 031
 db 000h,000h,03Ch,042h,042h,002h,004h,008h,010h,020h,042h,07Eh,000h,000h,000h,000h; 032
 db 000h,000h,03Ch,042h,042h,004h,018h,004h,002h,042h,042h,03Ch,000h,000h,000h,000h; 033
 db 000h,000h,004h,00Ch,014h,024h,044h,084h,0FEh,004h,004h,01Eh,000h,000h,000h,000h; 034
 db 000h,000h,07Eh,040h,040h,07Ch,042h,002h,002h,002h,042h,03Ch,000h,000h,000h,000h; 035
 db 000h,000h,03Ch,042h,040h,040h,07Ch,042h,042h,042h,042h,03Ch,000h,000h,000h,000h; 036
 db 000h,000h,0FEh,082h,084h,004h,008h,008h,010h,010h,010h,010h,000h,000h,000h,000h; 037
 db 000h,000h,03Ch,042h,042h,024h,018h,024h,042h,042h,042h,03Ch,000h,000h,000h,000h; 038
 db 000h,000h,03Ch,042h,042h,042h,042h,03Eh,002h,002h,042h,03Ch,000h,000h,000h,000h; 039
 db 000h,000h,000h,000h,030h,030h,000h,000h,000h,030h,030h,000h,000h,000h,000h,000h; 03A
 db 000h,000h,000h,000h,030h,030h,000h,000h,000h,000h,030h,030h,010h,010h,000h,000h; 03B
 db 000h,000h,002h,004h,008h,010h,020h,020h,010h,008h,004h,002h,000h,000h,000h,000h; 03C
 db 000h,000h,000h,000h,000h,07Eh,000h,000h,000h,07Eh,000h,000h,000h,000h,000h,000h; 03D
 db 000h,000h,040h,020h,010h,008h,004h,004h,008h,010h,020h,040h,000h,000h,000h,000h; 03E
 db 000h,000h,03Ch,042h,042h,004h,008h,010h,010h,000h,000h,010h,000h,000h,000h,000h; 03F
 db 000h,038h,044h,082h,09Ah,0AAh,0AAh,0AAh,094h,080h,042h,03Ch,000h,000h,000h,000h; 040
 db 000h,000h,070h,010h,028h,028h,044h,044h,07Ch,082h,082h,0C6h,000h,000h,000h,000h; 041
 db 000h,000h,0FCh,042h,042h,042h,07Ch,042h,042h,042h,042h,0FCh,000h,000h,000h,000h; 042
 db 000h,000h,03Eh,042h,082h,080h,080h,080h,082h,082h,044h,038h,000h,000h,000h,000h; 043
 db 000h,000h,0F8h,044h,042h,042h,042h,042h,042h,042h,044h,0F8h,000h,000h,000h,000h; 044
 db 000h,000h,0FEh,042h,040h,044h,07Ch,044h,040h,040h,042h,0FEh,000h,000h,000h,000h; 045
 db 000h,000h,0FEh,042h,040h,044h,07Ch,044h,040h,040h,040h,0F0h,000h,000h,000h,000h; 046
 db 000h,000h,03Ch,042h,082h,080h,080h,09Eh,082h,082h,042h,03Eh,000h,000h,000h,000h; 047
 db 000h,000h,0E6h,042h,042h,042h,042h,07Eh,042h,042h,042h,0E6h,000h,000h,000h,000h; 048
 db 000h,000h,07Ch,010h,010h,010h,010h,010h,010h,010h,010h,07Ch,000h,000h,000h,000h; 049
 db 000h,000h,01Eh,004h,004h,004h,004h,004h,084h,084h,088h,070h,000h,000h,000h,000h; 04A
 db 000h,000h,0CEh,084h,088h,090h,0A0h,0D0h,088h,084h,082h,0C6h,000h,000h,000h,000h; 04B
 db 000h,000h,0E0h,040h,040h,040h,040h,040h,040h,042h,042h,0FEh,000h,000h,000h,000h; 04C
 db 000h,000h,0C6h,0C6h,0AAh,0AAh,092h,092h,082h,082h,082h,0C6h,000h,000h,000h,000h; 04D
 db 000h,000h,0C6h,042h,062h,052h,052h,04Ah,04Ah,046h,042h,0E6h,000h,000h,000h,000h; 04E
 db 000h,000h,038h,044h,082h,082h,082h,082h,082h,082h,044h,038h,000h,000h,000h,000h; 04F
 db 000h,000h,0FCh,042h,042h,042h,042h,07Ch,040h,040h,040h,0E0h,000h,000h,000h,000h; 050
 db 000h,000h,038h,044h,082h,082h,082h,082h,082h,092h,04Ch,038h,004h,000h,000h,000h; 051
 db 000h,000h,0FCh,042h,042h,042h,042h,07Ch,048h,044h,042h,0E6h,000h,000h,000h,000h; 052
 db 000h,000h,03Ch,042h,040h,040h,03Ch,002h,002h,002h,042h,03Ch,000h,000h,000h,000h; 053
 db 000h,000h,0FEh,092h,092h,010h,010h,010h,010h,010h,010h,038h,000h,000h,000h,000h; 054
 db 000h,000h,0E6h,042h,042h,042h,042h,042h,042h,042h,042h,03Ch,000h,000h,000h,000h; 055
 db 000h,000h,0C6h,082h,082h,044h,044h,044h,028h,028h,010h,010h,000h,000h,000h,000h; 056
 db 000h,000h,0C6h,082h,082h,092h,092h,092h,054h,054h,06Ch,044h,000h,000h,000h,000h; 057
 db 000h,000h,0C6h,082h,044h,028h,010h,010h,028h,044h,082h,0C6h,000h,000h,000h,000h; 058
 db 000h,000h,0C6h,082h,044h,044h,028h,028h,010h,010h,010h,038h,000h,000h,000h,000h; 059
 db 000h,000h,07Eh,042h,004h,004h,008h,010h,020h,020h,042h,07Eh,000h,000h,000h,000h; 05A
 db 000h,03Ch,020h,020h,020h,020h,020h,020h,020h,020h,020h,03Ch,000h,000h,000h,000h; 05B
 db 000h,040h,040h,020h,020h,010h,010h,010h,008h,008h,004h,004h,000h,000h,000h,000h; 05C
 db 000h,078h,008h,008h,008h,008h,008h,008h,008h,008h,008h,078h,000h,000h,000h,000h; 05D
 db 000h,010h,028h,044h,082h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h; 05E
 db 000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,0FFh,000h,000h; 05F
 db 000h,020h,020h,010h,010h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h; 060
 db 000h,000h,000h,000h,000h,078h,084h,004h,07Ch,084h,084h,07Ah,000h,000h,000h,000h; 061
 db 000h,000h,0C0h,040h,040h,05Ch,062h,042h,042h,042h,062h,0DCh,000h,000h,000h,000h; 062
 db 000h,000h,000h,000h,000h,03Eh,042h,040h,040h,040h,042h,03Ch,000h,000h,000h,000h; 063
 db 000h,000h,00Ch,004h,004h,074h,08Ch,084h,084h,084h,08Ch,076h,000h,000h,000h,000h; 064
 db 000h,000h,000h,000h,000h,03Ch,042h,042h,07Eh,040h,040h,03Ch,000h,000h,000h,000h; 065
 db 000h,00Ch,010h,010h,010h,07Ch,010h,010h,010h,010h,010h,07Ch,000h,000h,000h,000h; 066
 db 000h,000h,000h,000h,000h,076h,08Ch,084h,084h,08Ch,074h,004h,084h,078h,000h,000h; 067
 db 000h,000h,0C0h,040h,040h,05Ch,062h,042h,042h,042h,042h,0E2h,000h,000h,000h,000h; 068
 db 000h,000h,018h,000h,000h,038h,008h,008h,008h,008h,008h,03Ch,000h,000h,000h,000h; 069
 db 000h,000h,00Ch,000h,000h,01Ch,004h,004h,004h,004h,004h,084h,088h,070h,000h,000h; 06A
 db 000h,000h,0C0h,040h,040h,046h,048h,050h,068h,044h,042h,0C6h,000h,000h,000h,000h; 06B
 db 000h,000h,038h,008h,008h,008h,008h,008h,008h,008h,008h,03Ch,000h,000h,000h,000h; 06C
 db 000h,000h,000h,000h,000h,0ECh,092h,092h,092h,092h,092h,0D6h,000h,000h,000h,000h; 06D
 db 000h,000h,000h,000h,000h,0DCh,062h,042h,042h,042h,042h,0E6h,000h,000h,000h,000h; 06E
 db 000h,000h,000h,000h,000h,038h,044h,082h,082h,082h,044h,038h,000h,000h,000h,000h; 06F
 db 000h,000h,000h,000h,000h,0DCh,062h,042h,042h,042h,062h,05Ch,040h,0E0h,000h,000h; 070
 db 000h,000h,000h,000h,000h,076h,08Ch,084h,084h,084h,08Ch,074h,004h,00Eh,000h,000h; 071
 db 000h,000h,000h,000h,000h,0DEh,062h,040h,040h,040h,040h,0E0h,000h,000h,000h,000h; 072
 db 000h,000h,000h,000h,000h,03Ch,042h,040h,03Ch,002h,042h,03Ch,000h,000h,000h,000h; 073
 db 000h,000h,020h,020h,020h,078h,020h,020h,020h,020h,020h,01Ch,000h,000h,000h,000h; 074
 db 000h,000h,000h,000h,000h,0EEh,044h,044h,044h,044h,044h,038h,000h,000h,000h,000h; 075
 db 000h,000h,000h,000h,000h,0C6h,082h,044h,044h,028h,028h,010h,000h,000h,000h,000h; 076
 db 000h,000h,000h,000h,000h,0C6h,082h,092h,092h,054h,07Ch,044h,000h,000h,000h,000h; 077
 db 000h,000h,000h,000h,000h,0EEh,044h,028h,010h,028h,044h,0EEh,000h,000h,000h,000h; 078
 db 000h,000h,000h,000h,000h,0C6h,044h,044h,028h,028h,010h,010h,020h,0C0h,000h,000h; 079
 db 000h,000h,000h,000h,000h,0FEh,084h,008h,010h,020h,042h,0FEh,000h,000h,000h,000h; 07A
 db 000h,00Ch,010h,010h,010h,010h,060h,010h,010h,010h,010h,00Ch,000h,000h,000h,000h; 07B
 db 000h,000h,010h,010h,010h,010h,000h,000h,010h,010h,010h,010h,000h,000h,000h,000h; 07C
 db 000h,060h,010h,010h,010h,010h,00Ch,010h,010h,010h,010h,060h,000h,000h,000h,000h; 07D
 db 000h,060h,092h,092h,00Ch,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h; 07E
 db 000h,000h,000h,000h,010h,010h,028h,028h,044h,044h,082h,0FEh,000h,000h,000h,000h; 07F
 db 000h,000h,01Ch,024h,044h,044h,044h,044h,07Ch,044h,044h,0EEh,000h,000h,000h,000h; 080
 db 000h,000h,0FEh,042h,040h,07Ch,042h,042h,042h,042h,042h,0FCh,000h,000h,000h,000h; 081
 db 000h,000h,0FCh,042h,042h,044h,078h,044h,042h,042h,042h,0FCh,000h,000h,000h,000h; 082
 db 000h,000h,0FEh,042h,040h,040h,040h,040h,040h,040h,040h,0F0h,000h,000h,000h,000h; 083
 db 000h,000h,03Eh,014h,014h,024h,024h,024h,044h,044h,044h,0FEh,082h,000h,000h,000h; 084
 db 000h,000h,0FEh,042h,040h,044h,07Ch,044h,040h,040h,042h,0FEh,000h,000h,000h,000h; 085
 db 000h,000h,0D6h,054h,054h,038h,010h,038h,054h,054h,054h,0D6h,000h,000h,000h,000h; 086
 db 000h,000h,03Ch,042h,002h,004h,018h,004h,002h,082h,082h,07Ch,000h,000h,000h,000h; 087
 db 000h,000h,0E6h,042h,046h,04Ah,04Ah,052h,052h,062h,042h,0E6h,000h,000h,000h,000h; 088
 db 038h,000h,0E6h,042h,046h,04Ah,04Ah,052h,052h,062h,042h,0E6h,000h,000h,000h,000h; 089
 db 000h,000h,0CEh,084h,088h,090h,0A0h,0D0h,088h,088h,084h,0CEh,000h,000h,000h,000h; 08A
 db 000h,000h,03Eh,014h,014h,014h,024h,024h,024h,044h,044h,0CEh,000h,000h,000h,000h; 08B
 db 000h,000h,0C6h,0C6h,0AAh,0AAh,092h,092h,082h,082h,082h,0C6h,000h,000h,000h,000h; 08C
 db 000h,000h,0E6h,042h,042h,042h,07Eh,042h,042h,042h,042h,0E6h,000h,000h,000h,000h; 08D
 db 000h,000h,03Ch,042h,042h,042h,042h,042h,042h,042h,042h,03Ch,000h,000h,000h,000h; 08E
 db 000h,000h,0FEh,044h,044h,044h,044h,044h,044h,044h,044h,0EEh,000h,000h,000h,000h; 08F
 db 000h,000h,0FCh,042h,042h,042h,042h,07Ch,040h,040h,040h,0E0h,000h,000h,000h,000h; 090
 db 000h,000h,03Ch,042h,042h,040h,040h,040h,040h,042h,042h,03Ch,000h,000h,000h,000h; 091
 db 000h,000h,0FEh,092h,092h,010h,010h,010h,010h,010h,010h,038h,000h,000h,000h,000h; 092
 db 000h,000h,0EEh,044h,044h,044h,044h,044h,03Ch,004h,004h,078h,000h,000h,000h,000h; 093
 db 000h,000h,038h,010h,07Ch,092h,092h,092h,092h,07Ch,010h,038h,000h,000h,000h,000h; 094
 db 000h,000h,0C6h,082h,044h,028h,010h,028h,044h,044h,082h,0C6h,000h,000h,000h,000h; 095
 db 000h,000h,0EEh,044h,044h,044h,044h,044h,044h,044h,044h,0FEh,002h,000h,000h,000h; 096
 db 000h,000h,0EEh,044h,044h,044h,044h,044h,03Ch,004h,004h,00Eh,000h,000h,000h,000h; 097
 db 000h,000h,0EEh,044h,044h,044h,054h,054h,054h,054h,054h,0FEh,000h,000h,000h,000h; 098
 db 000h,000h,0EEh,044h,044h,044h,054h,054h,054h,054h,054h,0FEh,002h,000h,000h,000h; 099
 db 000h,000h,0F0h,0A0h,0A0h,0A0h,03Ch,022h,022h,022h,022h,07Ch,000h,000h,000h,000h; 09A
 db 000h,000h,0E6h,042h,042h,042h,072h,04Ah,04Ah,04Ah,04Ah,0F6h,000h,000h,000h,000h; 09B
 db 000h,000h,0E0h,040h,040h,040h,07Ch,042h,042h,042h,042h,0FCh,000h,000h,000h,000h; 09C
 db 000h,000h,038h,044h,082h,012h,01Eh,012h,002h,082h,044h,038h,000h,000h,000h,000h; 09D
 db 000h,000h,0CCh,052h,052h,052h,072h,052h,052h,052h,052h,0CCh,000h,000h,000h,000h; 09E
 db 000h,000h,07Eh,084h,084h,084h,084h,07Ch,014h,024h,044h,0EEh,000h,000h,000h,000h; 09F
 db 000h,000h,000h,000h,000h,078h,084h,004h,07Ch,084h,084h,07Ah,000h,000h,000h,000h; 0A0
 db 000h,000h,002h,03Ch,040h,05Ch,062h,042h,042h,042h,042h,03Ch,000h,000h,000h,000h; 0A1
 db 000h,030h,048h,048h,050h,040h,07Ch,042h,042h,042h,042h,03Ch,000h,000h,000h,000h; 0A2
 db 000h,000h,000h,000h,000h,0FEh,042h,040h,040h,040h,040h,0E0h,000h,000h,000h,000h; 0A3
 db 000h,000h,03Ch,042h,002h,03Eh,042h,042h,042h,042h,042h,03Ch,000h,000h,000h,000h; 0A4
 db 000h,000h,000h,000h,000h,03Ch,042h,042h,07Eh,040h,040h,03Ch,000h,000h,000h,000h; 0A5
 db 000h,000h,000h,000h,000h,0D6h,054h,038h,010h,038h,054h,0D6h,000h,000h,000h,000h; 0A6
 db 000h,000h,000h,000h,000h,03Ch,042h,002h,01Ch,002h,042h,03Ch,000h,000h,000h,000h; 0A7
 db 000h,000h,000h,000h,000h,0EEh,044h,04Ch,054h,064h,044h,0EEh,000h,000h,000h,000h; 0A8
 db 000h,000h,000h,038h,000h,0EEh,044h,04Ch,054h,064h,044h,0EEh,000h,000h,000h,000h; 0A9
 db 000h,000h,000h,000h,000h,0E6h,044h,048h,050h,068h,044h,0EEh,000h,000h,000h,000h; 0AA
 db 000h,000h,000h,000h,000h,07Eh,024h,024h,024h,024h,044h,0CEh,000h,000h,000h,000h; 0AB
 db 000h,000h,000h,000h,000h,0C6h,0C6h,0AAh,092h,082h,082h,0C6h,000h,000h,000h,000h; 0AC
 db 000h,000h,000h,000h,000h,0EEh,044h,044h,07Ch,044h,044h,0EEh,000h,000h,000h,000h; 0AD
 db 000h,000h,000h,000h,000h,03Ch,042h,042h,042h,042h,042h,03Ch,000h,000h,000h,000h; 0AE
 db 000h,000h,000h,000h,000h,0FEh,044h,044h,044h,044h,044h,0EEh,000h,000h,000h,000h; 0AF
 db 022h,088h,022h,088h,022h,088h,022h,088h,022h,088h,022h,088h,022h,088h,022h,088h; 0B0
 db 0AAh,055h,0AAh,055h,0AAh,055h,0AAh,055h,0AAh,055h,0AAh,055h,0AAh,055h,0AAh,055h; 0B1
 db 0DDh,077h,0DDh,077h,0DDh,077h,0DDh,077h,0DDh,077h,0DDh,077h,0DDh,077h,0DDh,077h; 0B2
 db 010h,010h,010h,010h,010h,010h,010h,010h,010h,010h,010h,010h,010h,010h,010h,010h; 0B3
 db 010h,010h,010h,010h,010h,010h,010h,010h,0F0h,010h,010h,010h,010h,010h,010h,010h; 0B4
 db 010h,010h,010h,010h,010h,010h,0F0h,010h,0F0h,010h,010h,010h,010h,010h,010h,010h; 0B5
 db 014h,014h,014h,014h,014h,014h,014h,014h,0F4h,014h,014h,014h,014h,014h,014h,014h; 0B6
 db 000h,000h,000h,000h,000h,000h,000h,000h,0FCh,014h,014h,014h,014h,014h,014h,014h; 0B7
 db 000h,000h,000h,000h,000h,000h,0F0h,010h,0F0h,010h,010h,010h,010h,010h,010h,010h; 0B8
 db 014h,014h,014h,014h,014h,014h,0F4h,004h,0F4h,014h,014h,014h,014h,014h,014h,014h; 0B9
 db 014h,014h,014h,014h,014h,014h,014h,014h,014h,014h,014h,014h,014h,014h,014h,014h; 0BA
 db 000h,000h,000h,000h,000h,000h,0FCh,004h,0F4h,014h,014h,014h,014h,014h,014h,014h; 0BB
 db 014h,014h,014h,014h,014h,014h,0F4h,004h,0FCh,000h,000h,000h,000h,000h,000h,000h; 0BC
 db 014h,014h,014h,014h,014h,014h,014h,014h,0FCh,000h,000h,000h,000h,000h,000h,000h; 0BD
 db 010h,010h,010h,010h,010h,010h,0F0h,010h,0F0h,000h,000h,000h,000h,000h,000h,000h; 0BE
 db 000h,000h,000h,000h,000h,000h,000h,000h,0F0h,010h,010h,010h,010h,010h,010h,010h; 0BF
 db 010h,010h,010h,010h,010h,010h,010h,010h,01Fh,000h,000h,000h,000h,000h,000h,000h; 0C0
 db 010h,010h,010h,010h,010h,010h,010h,010h,0FFh,000h,000h,000h,000h,000h,000h,000h; 0C1
 db 000h,000h,000h,000h,000h,000h,000h,000h,0FFh,010h,010h,010h,010h,010h,010h,010h; 0C2
 db 010h,010h,010h,010h,010h,010h,010h,010h,01Fh,010h,010h,010h,010h,010h,010h,010h; 0C3
 db 000h,000h,000h,000h,000h,000h,000h,000h,0FFh,000h,000h,000h,000h,000h,000h,000h; 0C4
 db 010h,010h,010h,010h,010h,010h,010h,010h,0FFh,010h,010h,010h,010h,010h,010h,010h; 0C5
 db 010h,010h,010h,010h,010h,010h,01Fh,010h,01Fh,010h,010h,010h,010h,010h,010h,010h; 0C6
 db 014h,014h,014h,014h,014h,014h,014h,014h,017h,014h,014h,014h,014h,014h,014h,014h; 0C7
 db 014h,014h,014h,014h,014h,014h,017h,010h,01Fh,000h,000h,000h,000h,000h,000h,000h; 0C8
 db 000h,000h,000h,000h,000h,000h,01Fh,010h,017h,014h,014h,014h,014h,014h,014h,014h; 0C9
 db 014h,014h,014h,014h,014h,014h,0F7h,000h,0FFh,000h,000h,000h,000h,000h,000h,000h; 0CA
 db 000h,000h,000h,000h,000h,000h,0FFh,000h,0F7h,014h,014h,014h,014h,014h,014h,014h; 0CB
 db 014h,014h,014h,014h,014h,014h,017h,010h,017h,014h,014h,014h,014h,014h,014h,014h; 0CC
 db 000h,000h,000h,000h,000h,000h,0FFh,000h,0FFh,000h,000h,000h,000h,000h,000h,000h; 0CD
 db 014h,014h,014h,014h,014h,014h,0F7h,000h,0F7h,014h,014h,014h,014h,014h,014h,014h; 0CE
 db 010h,010h,010h,010h,010h,010h,0FFh,000h,0FFh,000h,000h,000h,000h,000h,000h,000h; 0CF
 db 014h,014h,014h,014h,014h,014h,014h,014h,0FFh,000h,000h,000h,000h,000h,000h,000h; 0D0
 db 000h,000h,000h,000h,000h,000h,0FFh,000h,0FFh,010h,010h,010h,010h,010h,010h,010h; 0D1
 db 000h,000h,000h,000h,000h,000h,000h,000h,0FFh,014h,014h,014h,014h,014h,014h,014h; 0D2
 db 014h,014h,014h,014h,014h,014h,014h,014h,01Fh,000h,000h,000h,000h,000h,000h,000h; 0D3
 db 010h,010h,010h,010h,010h,010h,01Fh,010h,01Fh,000h,000h,000h,000h,000h,000h,000h; 0D4
 db 000h,000h,000h,000h,000h,000h,01Fh,010h,01Fh,010h,010h,010h,010h,010h,010h,010h; 0D5
 db 000h,000h,000h,000h,000h,000h,000h,000h,01Fh,014h,014h,014h,014h,014h,014h,014h; 0D6
 db 014h,014h,014h,014h,014h,014h,014h,014h,0FFh,014h,014h,014h,014h,014h,014h,014h; 0D7
 db 010h,010h,010h,010h,010h,010h,0FFh,010h,0FFh,010h,010h,010h,010h,010h,010h,010h; 0D8
 db 010h,010h,010h,010h,010h,010h,010h,010h,0F0h,000h,000h,000h,000h,000h,000h,000h; 0D9
 db 000h,000h,000h,000h,000h,000h,000h,000h,01Fh,010h,010h,010h,010h,010h,010h,010h; 0DA
 db 0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh; 0DB
 db 000h,000h,000h,000h,000h,000h,000h,000h,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh; 0DC
 db 0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h; 0DD
 db 00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh,00Fh; 0DE
 db 0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,000h,000h,000h,000h,000h,000h,000h,000h; 0DF
 db 000h,000h,000h,000h,000h,0DCh,062h,042h,042h,042h,042h,07Ch,040h,0E0h,000h,000h; 0E0
 db 000h,000h,000h,000h,000h,03Ch,042h,040h,040h,040h,042h,03Ch,000h,000h,000h,000h; 0E1
 db 000h,000h,000h,000h,000h,0FEh,092h,010h,010h,010h,010h,038h,000h,000h,000h,000h; 0E2
 db 000h,000h,000h,000h,000h,0C6h,044h,044h,028h,028h,010h,010h,020h,0C0h,000h,000h; 0E3
 db 000h,000h,000h,038h,010h,07Ch,092h,092h,092h,092h,092h,07Ch,010h,038h,000h,000h; 0E4
 db 000h,000h,000h,000h,000h,0EEh,044h,028h,010h,028h,044h,0EEh,000h,000h,000h,000h; 0E5
 db 000h,000h,000h,000h,000h,0EEh,044h,044h,044h,044h,044h,0FEh,002h,000h,000h,000h; 0E6
 db 000h,000h,000h,000h,000h,0EEh,044h,044h,044h,03Ch,004h,00Eh,000h,000h,000h,000h; 0E7
 db 000h,000h,000h,000h,000h,0EEh,044h,044h,054h,054h,054h,0FEh,000h,000h,000h,000h; 0E8
 db 000h,000h,000h,000h,000h,0EEh,044h,044h,054h,054h,054h,0FEh,002h,000h,000h,000h; 0E9
 db 000h,000h,000h,000h,000h,0F0h,0A0h,0BCh,022h,022h,022h,07Ch,000h,000h,000h,000h; 0EA
 db 000h,000h,000h,000h,000h,0E6h,042h,072h,04Ah,04Ah,04Ah,0F6h,000h,000h,000h,000h; 0EB
 db 000h,000h,000h,000h,000h,0E0h,040h,07Ch,042h,042h,042h,0FCh,000h,000h,000h,000h; 0EC
 db 000h,000h,000h,000h,000h,038h,044h,002h,01Eh,002h,044h,038h,000h,000h,000h,000h; 0ED
 db 000h,000h,000h,000h,000h,0CCh,052h,052h,072h,052h,052h,0CCh,000h,000h,000h,000h; 0EE
 db 000h,000h,000h,000h,000h,07Eh,084h,084h,084h,07Ch,024h,0C6h,000h,000h,000h,000h; 0EF
 db 000h,000h,000h,0FEh,0FEh,000h,000h,0FEh,0FEh,000h,000h,0FEh,0FEh,000h,000h,000h; 0F0
 db 000h,000h,000h,010h,010h,010h,0FEh,010h,010h,010h,000h,0FEh,000h,000h,000h,000h; 0F1
 db 000h,000h,000h,0C0h,030h,00Ch,002h,00Ch,030h,0C0h,000h,0FEh,000h,000h,000h,000h; 0F2
 db 000h,000h,000h,006h,018h,060h,080h,060h,018h,006h,000h,0FEh,000h,000h,000h,000h; 0F3
 db 000h,00Ch,012h,010h,010h,010h,010h,010h,010h,010h,010h,010h,010h,010h,010h,010h; 0F4
 db 010h,010h,010h,010h,010h,010h,010h,010h,010h,010h,010h,090h,090h,060h,000h,000h; 0F5
 db 000h,000h,000h,000h,030h,000h,000h,0FEh,000h,000h,030h,000h,000h,000h,000h,000h; 0F6
 db 000h,000h,000h,000h,062h,092h,08Ch,000h,062h,092h,08Ch,000h,000h,000h,000h,000h; 0F7
 db 000h,018h,024h,024h,018h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h; 0F8
 db 000h,000h,000h,000h,000h,038h,038h,038h,038h,000h,000h,000h,000h,000h,000h,000h; 0F9
 db 000h,000h,000h,000h,000h,000h,038h,038h,000h,000h,000h,000h,000h,000h,000h,000h; 0FA
 db 000h,00Fh,008h,008h,008h,088h,088h,048h,048h,028h,028h,018h,000h,000h,000h,000h; 0FB
 db 000h,058h,068h,048h,048h,048h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h; 0FC
 db 000h,030h,048h,010h,020h,078h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h; 0FD
 db 000h,000h,000h,000h,03Ch,03Ch,03Ch,03Ch,03Ch,03Ch,000h,000h,000h,000h,000h,000h; 0FE
 db 000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h; 0FF
; ***************************************************************************

InitRTL         proc    near
                push    bp
                mov     bp,sp
                push    si
                mov     ax,word ptr [bp+4]
                or      ax,ax
                jnz     Test4F
                mov     ax,01a00h
                int     10h
                cmp     al,1ah
                jnz     InitFalse
                cmp     bl,7
                jz      InitTrue
                cmp     bl,8
                jz      InitTrue
InitFalse:      xor     ax,ax
                jmp     short EndInit
InitTrue:       mov     ax,0ffffh
EndInit:        pop     si
                pop     bp
                pop     dx
                pop     cx
                push    ax
                jmp     dx
Test4F:         cmp     ax,word ptr [ProcCount]
                jnc     InitFalse
                add     ax,ax
                add     ax,offset ProcList
                mov     bx,ax
                cmp     word ptr [bx],0
                jz      InitFalse
                jmp     short InitTrue
InitRTL         endp

Set320x240Mode  proc    near
                push    bp              ; preserve caller's stack frame
                push    si              ; preserve C register vars
                push    di              ; (don't count on BIOS preserving anything)

                mov     ax,12h          ; let the BIOS set standard 256-color
                int     10h             ; mode (320x200 linear)

                pop     di              ; restore C register vars
                pop     si
                pop     bp              ; restore caller's stack frame
                ret
Set320x240Mode  endp

Reloc           proc    near
                push    bp
                mov     bp,sp
                mov     ax,word ptr [bp+4]
                mov     Y_LOC,ax
                mov     ax,word ptr [bp+6]
                mov     X_LOC,ax
                pop     bp
                ret     4
Reloc           endp

GetParas        proc    near
                pop     dx
                push    word ptr [X_SIZE]
                push    word ptr [Y_SIZE]
                push    word ptr [COLORS]
                jmp     dx
GetParas        endp

SetOriginOffset proc    near
                push    bp
                mov     bp,sp
                mov     ax,word ptr [bp+4]
                mov     ORIGIN_OFFSET,ax
                pop     bp
                ret     2
SetOriginOffset endp

RMWbits         EQU     18h             ; read-modify-write bits

WritePixelX     proc    near
                push    bp              ; preserve caller registers
                mov     bp,sp

                mov     ax,word ptr [bp+6]         ; AX := y
                add     ax,Y_LOC
                mov     bx,word ptr [bp+8]         ; BX := x
                add     bx,X_LOC
                call    PixelAddr10     ; AH := bit mask
                                        ; ES:BX -> buffer
                                        ; CL := # bits to shift left

; set Graphics Controller Bit Mask register

                shl     ah,cl           ; AH := bit mask in proper position
                mov     dx,3CEh         ; GC address register port
                mov     al,8            ; AL := Bit Mask register number
                out     dx,ax

; set Graphics Controller Mode register

                mov     ax,0005h        ; AL :=  Mode register number
                                        ; AH :=  Write Mode 0 (bits 0,1)
                                        ;        Read Mode 0 (bit 3)
                out     dx,ax

; set Data Rotate/Function Select register

                mov     ah,RMWbits      ; AH := Read-Modify-Write bits
                mov     al,3            ; AL := Data Rotate/Function Select reg
                out     dx,ax

; set Set/Reset and Enable Set/Reset registers

                mov     ah,byte ptr [bp+4]        ; AH := pixel value
                mov     al,0            ; AL := Set/Reset reg number
                out     dx,ax

                mov     ax,0F01h        ; AH := value for Enable Set/Reset (all
                                        ;  bit planes enabled)
                                        ; AL := Enable Set/Reset reg number
                out     dx,ax

; set the pixel value

                or      es:[bx],al      ; load latches during CPU read
                                        ; update latches and bit planes during
                                        ;  CPU write

; restore default Graphics Controller registers

                mov     ax,0FF08h       ; default Bit Mask
                out     dx,ax

                mov     ax,0005         ; default Mode register
                out     dx,ax

                mov     ax,0003         ; default Function Select
                out     dx,ax

                mov     ax,0001         ; default Enable Set/Reset
                out     dx,ax

                mov     sp,bp           ; restore caller registers and return
                pop     bp
                ret     6
WritePixelX     endp

ReadPixelX      proc    near
                push    bp              ; preserve caller registers
                mov     bp,sp
                push    si

                mov     ax,word ptr [bp+4]         ; AX := y
                add     ax,Y_LOC
                mov     bx,word ptr [bp+6]         ; BX := x
                add     bx,X_LOC
                call    PixelAddr10     ; AH := bit mask
                                        ; ES:BX -> buffer
                                        ; CL := #bits to shift

                mov     ch,ah
                shl     ch,cl           ; CH := bit mask in proper position

                mov     si,bx           ; ES:SI -> regen buffer byte
                xor     bl,bl           ; BL is used to accumulate the pixel value

                mov     dx,3CEh         ; DX := Graphics Controller port
                mov     ax,304h         ; AH := initial bit plane number
                                        ; AL := Read Map Select register number

R01:            out     dx,ax           ; select bit plane
                mov     bh,es:[si]      ; BH := byte from current bit plane
                and     bh,ch           ; mask one bit
                neg     bh              ; bit 7 of BH := 1 (if masked bit = 1)
                                        ; bit 7 of BH := 0 (if masked bit = 0)
                rol     bx,1            ; bit 0 of BL := next bit from pixel value
                dec     ah              ; AH := next bit plane number
                jge     R01

                mov     al,bl           ; AL := pixel value
                xor     ah,ah           ; AX := pixel value
                mov     word ptr [bp+6],ax

                pop     si              ; restore caller registers and return
                pop     bp
                ret     2
ReadPixelX      endp

FillRectangleX  proc    near
                push    bp
                mov     bp,sp
                push    si
                push    di

                mov     cx,word ptr [bp+6]
                mov     ax,word ptr [bp+10]
                sub     cx,ax
                inc     cx
                mov     word ptr [bp+6],ax

                Fill_R_Loop:
                push    cx
                push    word ptr [bp+12]
                push    word ptr [bp+10]
                push    word ptr [bp+8]
                push    word ptr [bp+6]
                push    word ptr [bp+4]
                call    Line

                inc     word ptr [bp+10]
                inc     word ptr [bp+6]
                pop     cx
                loop    Fill_R_Loop

FillDone:       pop     di
                pop     si
                pop     bp
                ret     10
FillRectangleX  endp

xSet320x240Mode proc    near
                push    bp              ; preserve caller's stack frame
                push    si              ; preserve C register vars
                push    di              ; (don't count on BIOS preserving anything)

                mov     ax,12h+80h      ; let the BIOS set standard 256-color
                int     10h             ; mode (320x200 linear)

                pop     di              ; restore C register vars
                pop     si
                pop     bp              ; restore caller's stack frame
                ret
xSet320x240Mode endp

; Caller:   AX = y-coordinate (0-239)
;       BX = x-coordinate (0-319)
;
; Returns:  AH = bit mask
;       BX = byte offset in buffer
;       ES = video buffer segment
;

Masks_04:       db      1,2,4,8

PixelAddr10     PROC       near
                mov     cl,bl           ; CL := low-order byte of x

                push    dx              ; preserve DX

                mov     dx,SCREEN_WIDTH ; AX := y * BytesPerLine
                mul     dx

                pop     dx
                shr     bx,1
                shr     bx,1
                shr     bx,1            ; BX := x/8
                add     bx,ax           ; BX := y*BytesPerLine + x/8
                add     bx,ORIGIN_OFFSET ; BX := byte offset in video buffer

                mov     es,SCREEN_SEG   ; ES:BX := byte address of pixel

                and     cl,7            ; CL := x & 7
                xor     cl,7            ; CL := number of bits to shift left
                mov     ah,1            ; AH := unshifted bit mask
                ret
PixelAddr10     ENDP

;
; Name:         Line04
;
; Function:     Draw a line in 320x200 4-color mode
;
; Caller:       Microsoft C:
;
;                       void Line04(x1,y1,x2,y2,n);
;
;                       int x1,y1,x2,y2;        /* pixel coordinates */
;
;                       int n;                  /* pixel value */
;

ARGx1           EQU     word ptr [bp+12] ; stack frame addressing
ARGy1           EQU     word ptr [bp+10]
ARGx2           EQU     word ptr [bp+8]
ARGy2           EQU     word ptr [bp+6]
ARGn            EQU     byte ptr [bp+4]
VARvertincr     EQU     word ptr [bp-2]
VARincr1        EQU     word ptr [bp-4]
VARincr2        EQU     word ptr [bp-6]
VARroutine      EQU     word ptr [bp-8]


Line            proc    near
                push    bp              ; preserve caller registers
                mov     bp,sp
                sub     sp,8            ; stack space for local variables
                push    si
                push    di

;                mov     ax,X_LOC
;                add     word ptr [bp+8],ax
;                add     word ptr [bp+12],ax
;
;                mov     ax,Y_LOC
;                add     word ptr [bp+6],ax
;                add     word ptr [bp+10],ax

                mov     ax,ARGx1
                test    ah,128
                jnz     C_L
                mov     ax,ARGx2
                test    ah,128
                jnz     C_L
                mov     ax,ARGy1
                test    ah,128
                jnz     C_L
                mov     ax,ARGy2
                test    ah,128
                jnz     C_L
                jmp     short S_L

C_L:            jmp     Cancel_Line

; configure the Graphics Controller

S_L:            mov     dx,3CEh         ; DX := Graphics Controller port addr

                mov     ah,ARGn         ; AH := pixel value
                xor     al,al           ; AL := Set/Reset Register number
                out     dx,ax

                mov     ax,0F01h        ; AH := 1111b (bit plane mask for
                                        ;  Enable Set/Reset
                out     dx,ax           ; AL := Enable Set/Reset Register #

                mov     ah,0            ; bits 3 and 4 of AH := function
                mov     al,3            ; AL := Data Rotate/Func Select reg #
                out     dx,ax

; check for vertical line

                mov     si,SCREEN_WIDTH ; increment for video buffer

                mov     cx,ARGx2
                sub     cx,ARGx1        ; CX := x2 - x1
                jz      VertLine10      ; jump if vertical line

; force x1 < x2

                jns     L01             ; jump if x2 > x1

                neg     cx              ; CX := x1 - x2

                mov     bx,ARGx2        ; exchange x1 and x2
                xchg    bx,ARGx1
                mov     ARGx2,bx

                mov     bx,ARGy2        ; exchange y1 and y2
                xchg    bx,ARGy1
                mov     ARGy2,bx

; calculate dy = ABS(y2-y1)

L01:            mov     bx,ARGy2
                sub     bx,ARGy1        ; BX := y2 - y1
                jz      HorizLine10     ; jump if horizontal line

                jns     L03             ; jump if slope is positive

                neg     bx              ; BX := y1 - y2
                neg     si              ; negate increment for buffer interleave

; select appropriate routine for slope of line

L03:            mov     VARvertincr,si  ; save vertical increment

                mov     VARroutine,offset LoSlopeLine10
                cmp     bx,cx
                jle     L04             ; jump if dy <= dx (slope <= 1)
                mov     VARroutine,offset HiSlopeLine10
                xchg    bx,cx           ; exchange dy and dx

; calculate initial decision variable and increments

L04:            shl     bx,1            ; BX := 2 * dy
                mov     VARincr1,bx     ; incr1 := 2 * dy
                sub     bx,cx
                mov     si,bx           ; SI := d = 2 * dy - dx
                sub     bx,cx
                mov     VARincr2,bx     ; incr2 := 2 * (dy - dx)

; calculate first pixel address

                push    cx              ; preserve this register
                mov     ax,ARGy1        ; AX := y
                mov     bx,ARGx1        ; BX := x
                call    PixelAddr10     ; AH := bit mask
                                        ; ES:BX -> buffer
                                        ; CL := # bits to shift left

                mov     di,bx           ; ES:DI -> buffer
                shl     ah,cl           ; AH := bit mask in proper position
                mov     bl,ah           ; AH,BL := bit mask
                mov     al,8            ; AL := Bit Mask Register number

                pop     cx              ; restore this register
                inc     cx              ; CX := # of pixels to draw

                jmp     VARroutine      ; jump to appropriate routine for slope


; routine for vertical lines

VertLine10:     mov     ax,ARGy1        ; AX := y1
                mov     bx,ARGy2        ; BX := y2
                mov     cx,bx
                sub     cx,ax           ; CX := dy
                jge     L31             ; jump if dy >= 0

                neg     cx              ; force dy >= 0
                mov     ax,bx           ; AX := y2

L31:            inc     cx              ; CX := # of pixels to draw
                mov     bx,ARGx1        ; BX := x
                push    cx              ; preserve this register
                call    PixelAddr10     ; AH := bit mask
                                        ; ES:BX -> video buffer
                                        ; CL := # bits to shift left
; set up Graphics Controller

                shl     ah,cl           ; AH := bit mask in proper position
                mov     al,8            ; AL := Bit Mask reg number
                out     dx,ax

                pop     cx              ; restore this register

; draw the line

L32:            or      es:[bx],al      ; set pixel
                add     bx,si           ; increment to next line
                loop    L32

                jmp     Lexit



; routine for horizontal lines (slope = 0)

HorizLine10:
                push    ds              ; preserve DS

                mov     ax,ARGy1
                mov     bx,ARGx1
                call    PixelAddr10     ; AH := bit mask
                                        ; ES:BX -> video buffer
                                        ; CL := # bits to shift left
                mov     di,bx           ; ES:DI -> buffer

                mov     dh,ah           ; DH := unshifted bit mask for leftmost
                                        ;        byte
                not     dh
                shl     dh,cl           ; DH := reverse bit mask for first byte
                not     dh              ; DH := bit mask for first byte

                mov     cx,ARGx2
                and     cl,7
                xor     cl,7            ; CL := number of bits to shift left
                mov     dl,0FFh         ; DL := unshifted bit mask for
                                        ;        rightmost byte
                shl     dl,cl           ; DL := bit mask for last byte

; determine byte offset of first and last pixel in the line

                mov     ax,ARGx2        ; AX := x2
                mov     bx,ARGx1        ; BX := x1

                mov     cl,3            ; number of bits to shift to
                                                ;  convert pixels to bytes

                shr     ax,cl           ; AX := byte offset of x2
                shr     bx,cl           ; BX := byte offset of x1
                mov     cx,ax
                sub     cx,bx           ; CX := (# bytes in line) - 1

; get Graphics Controller port address into DX

                mov     bx,dx           ; BH := bit mask for first byte
                                        ; BL := bit mask for last byte
                mov     dx,3CEh         ; DX := Graphics Controller port
                mov     al,8            ; AL := Bit Mask Register number

; make video buffer addressible through DS:SI

                push    es
                pop     ds
                mov     si,di           ; DS:SI -> video buffer

; set pixels in leftmost byte of the line

                or      bh,bh
                js      L43             ; jump if byte-aligned (x1 is leftmost
                                        ;  pixel in byte)
                or      cx,cx
                jnz     L42             ; jump if more than one byte in the line

                and     bl,bh           ; BL := bit mask for the line
                jmp     short L44

L42:            mov     ah,bh           ; AH := bit mask for 1st byte
                out     dx,ax           ; update Graphics Controller

                movsb                   ; update bit planes
                dec     cx

; use a fast 8086 machine instruction to draw the remainder of the line

L43:            mov     ah,11111111b    ; AH := bit mask
                out     dx,ax           ; update Bit Mask Register

                rep     movsb           ; update all pixels in the line

; set pixels in the rightmost byte of the line

L44:            mov     ah,bl           ; AH := bit mask for last byte
                out     dx,ax           ; update Graphics Controller

                movsb                   ; update bit planes

                pop     ds              ; restore DS
                jmp     short Lexit


; routine for dy <= dx (slope <= 1)     ; ES:DI -> video buffer
                                        ; AL = Bit Mask Register number
                                        ; BL = bit mask for 1st pixel
                                        ; CX = #pixels to draw
                                        ; DX = Graphics Controller port addr
                                        ; SI = decision variable
LoSlopeLine10:

L10:            mov     ah,bl           ; AH := bit mask for next pixel

L11:            or      ah,bl           ; mask current pixel position
                ror     bl,1            ; rotate pixel value
                jc      L14             ; jump if bit mask rotated to
                                        ;  leftmost pixel position

; bit mask not shifted out

                or      si,si           ; test sign of d
                jns     L12             ; jump if d >= 0

                add     si,VARincr1     ; d := d + incr1
                loop    L11

                out     dx,ax           ; update Bit Mask Register
                or      es:[di],al      ; set remaining pixel(s)
                jmp     short Lexit

L12:            add     si,VARincr2     ; d := d + incr2
                out     dx,ax           ; update Bit Mask Register

                or      es:[di],al      ; update bit planes

                add     di,VARvertincr  ; increment y
                loop    L10
                jmp     short Lexit

; bit mask shifted out

L14:            out     dx,ax           ; update Bit Mask Register ...

                or      es:[di],al      ; update bit planes
                inc     di              ; increment x

                or      si,si           ; test sign of d
                jns     L15             ; jump if non-negative

                add     si,VARincr1     ; d := d + incr1
                loop    L10
                jmp     short Lexit

L15:            add     si,VARincr2     ; d := d + incr2
                add     di,VARvertincr  ; vertical increment
                loop    L10
                jmp     short Lexit


; routine for dy > dx (slope > 1)       ; ES:DI -> video buffer
                                        ; AH = bit mask for 1st pixel
                                        ; AL = Bit Mask Register number
                                        ; CX = #pixels to draw
                                        ; DX = Graphics Controller port addr
                                        ; SI = decision variable
HiSlopeLine10:
                mov     bx,VARvertincr  ; BX := y-increment

L21:            out     dx,ax           ; update Bit Mask Register
                or      es:[di],al      ; update bit planes

                add     di,bx           ; increment y

L22:            or      si,si           ; test sign of d
                jns     L23             ; jump if d >= 0

                add     si,VARincr1     ; d := d + incr1
                loop    L21
                jmp     short Lexit


L23:            add     si,VARincr2     ; d := d + incr2

                ror     ah,1            ; rotate bit mask
                adc     di,0            ; increment DI if when mask rotated to
                                        ;  leftmost pixel position

                loop    L21


; restore default Graphics Controller state and return to caller

Lexit:          xor     ax,ax           ; AH := 0, AL := 0
                out     dx,ax           ; restore Set/Reset Register

                inc     ax              ; AH := 0, AL := 1
                out     dx,ax           ; restore Enable Set/Reset Register

                mov     al,3            ; AH := 0, AL := 3
                out     dx,ax           ; AL := Data Rotate/Func Select reg #

                mov     ax,0FF08h       ; AH := 1111111b, AL := 8
                out     dx,ax           ; restore Bit Mask Register
Cancel_Line:
                pop     di              ; restore registers and return
                pop     si
                mov     sp,bp
                pop     bp
                ret     10
Line            endp

time_x:         dw      0
time_y:         dw      0
time_z:         dw      0
time_t:         dw      0
ret_adr:        dw      0

; ( ScrX ScrY BytesPerLine CharOff CharSeg CharXSize CharYSize CharColor --> )
DrawHighChar:   pop     word ptr [ret_adr]
                mov     ax,0a000h
                mov     es,ax
                mov     word ptr [time_t],si
                pop     word ptr [time_y]
                mov     ax,205h
                mov     dx,3ceh
                out     dx,ax
                pop     cx
                pop     word ptr [time_x]
                pop     ds
                pop     si
                pop     word ptr cs:[time_z]    ; Bytes per line
                pop     ax
                mul     word ptr cs:[time_z]
                pop     dx
                add     dx,ax
                mov     di,dx
                mov     ax,word ptr cs:[time_x]
                sub     word ptr cs:[time_z],ax
                mov     dx,3ceh
                mov     al,8
                out     dx,al
                inc     dx
                mov     bl,byte ptr cs:[time_y]
                lchr1:
                push    cx
                mov     cx,word ptr cs:[time_x]
                lchr2:
                lodsb
                out     dx,al
                mov     al,byte ptr es:[di]
                mov     al,bl
                stosb
                loop    lchr2
                add     di,word ptr cs:[time_z]
                pop     cx
                loop    lchr1

                mov     ax,5
                mov     dx,3ceh
                out     dx,ax
                push    cs
                pop     ds
                mov     si,word ptr [time_t]
                jmp     word ptr [ret_adr]

; ( LineOff LineSeg X Y Col --> )
Text8x16        proc    near
                push    bp
                mov     bp,sp
                mov     di,word ptr [bp+12]
                mov     es,word ptr [bp+10]
                mov     cl,3
                shr     word ptr [bp+8],cl
                tx816loop:
                cmp     byte ptr es:[di],0
                jz      stop_816
                push    es
                push    di
                cmp     byte ptr es:[di],bs_char
                jz      bs_printed
                push    word ptr [bp+8]
                push    word ptr [bp+6]
                push    word ptr [SCREEN_WIDTH]
                mov     al,byte ptr es:[di]
                mov     ah,0
                mov     cl,4
                shl     ax,cl
                add     ax,offset Font_8x16
                push    ax
                push    cs
                mov     ax,1
                push    ax
                mov     ax,16
                push    ax
                push    word ptr [bp+4]
                call    DrawHighChar
                inc     word ptr [bp+8]
                next_char_printed:
                pop     di
                pop     es
                inc     di
                jmp     tx816loop
                stop_816:
                pop     bp
                ret     10
                bs_printed:
                dec     word ptr [bp+8]
                jmp     next_char_printed
Text8x16        endp

file_handle:    dw      0
file_name:      db      'rtlsaved.scr',0

save_plane:     push    ds
                mov     bx,word ptr [file_handle]
                mov     ax,0a000h
                mov     ds,ax
                xor     dx,dx
                mov     cx,80*480
                mov     ah,40h
                int     21h
                pop     ds
                ret

load_plane:     push    ds
                mov     bx,word ptr [file_handle]
                mov     ax,0a000h
                mov     ds,ax
                xor     dx,dx
                mov     cx,80*480
                mov     ah,3fh
                int     21h
                pop     ds
                ret

SaveScreen      proc    near
                mov     ah,3ch
                mov     dx,offset file_name
                xor     cx,cx
                int     21h
                jc      end_save
                mov     word ptr [file_handle],ax
                mov     cx,4
                mov     ax,4
                save_scr_loop:
                push    ax
                push    cx
                mov     dx,3ceh
                out     dx,ax
                call    save_plane
                pop     cx
                pop     ax
                inc     ah
                loop    save_scr_loop
                mov     bx,word ptr [file_handle]
                mov     ah,3eh
                int     21h
                end_save:
                ret
SaveScreen      endp

RestoreScreen   proc    near
                mov     ax,3d00h
                mov     dx,offset file_name
                int     21h
                jc      end_load
                mov     word ptr [file_handle],ax
                mov     cx,4
                mov     ax,102h
                load_scr_loop:
                push    ax
                push    cx
                mov     dx,3c4h
                out     dx,ax
                call    load_plane
                pop     cx
                pop     ax
                shl     ah,1
                loop    load_scr_loop
                mov     ax,0f02h
                mov     dx,3c4h
                out     dx,ax
                mov     bx,word ptr [file_handle]
                mov     ah,3eh
                int     21h
                mov     ah,41h
                mov     dx,offset file_name
                int     21h
                end_load:
                ret
RestoreScreen   endp

cross_start     equ     65535-((3*480)+(80*17))

; ( X Y --> )
SaveCross       proc    near
                pop     word ptr [time_z]
                pop     word ptr [time_y]
                pop     word ptr [time_x]
                push    bp
                push    si
                mov     dx,3ceh
                mov     al,5
                out     dx,al
                inc     dx
                mov     al,1
                out     dx,al

                mov     ax,0a000h
                mov     es,ax
                mov     ds,ax
                mov     di,cross_start

                mov     si,word ptr cs:[time_x]
                shr     si,1
                shr     si,1
                shr     si,1
                mov     cx,480
                cld
sc_loop:        movsb
                add     si,80-1
                loop    sc_loop

                mov     si,word ptr cs:[time_y]
                sub     si,8
                mov     ax,80
                mul     si
                mov     si,ax
                mov     cx,80*17
                rep     movsb

                mov     si,word ptr cs:[time_y]
                sub     si,8
                mov     ax,80
                mul     si
                mov     si,word ptr cs:[time_x]
                shr     si,1
                shr     si,1
                shr     si,1
                dec     si
                add     si,ax
                mov     cx,17
sc_loop2:       movsb
                movsb
                movsb
                add     si,80-3
                loop    sc_loop2

                pop     si
                pop     bp
                push    cs
                pop     ds
                mov     dx,3ceh
                mov     al,5
                out     dx,al
                inc     dx
                mov     al,0
                out     dx,al
                jmp     word ptr [time_z]
SaveCross       endp

; ( X Y --> )
RestoreCross    proc    near
                pop     word ptr [time_z]
                pop     word ptr [time_y]
                pop     word ptr [time_x]
                push    bp
                push    si
                mov     dx,3ceh
                mov     al,5
                out     dx,al
                inc     dx
                mov     al,1
                out     dx,al

                mov     ax,0a000h
                mov     es,ax
                mov     ds,ax
                mov     si,cross_start

                mov     di,word ptr cs:[time_x]
                shr     di,1
                shr     di,1
                shr     di,1
                mov     cx,480
                cld
rc_loop:        movsb
                add     di,80-1
                loop    rc_loop

                mov     di,word ptr cs:[time_y]
                sub     di,8
                mov     ax,80
                mul     di
                mov     di,ax
                mov     cx,80*17
                rep     movsb

                mov     di,word ptr cs:[time_y]
                sub     di,8
                mov     ax,80
                mul     di
                mov     di,word ptr cs:[time_x]
                shr     di,1
                shr     di,1
                shr     di,1
                dec     di
                add     di,ax
                mov     cx,17
rc_loop2:       movsb
                movsb
                movsb
                add     di,80-3
                loop    rc_loop2

                pop     si
                pop     bp
                push    cs
                pop     ds
                mov     dx,3ceh
                mov     al,5
                out     dx,al
                inc     dx
                mov     al,0
                out     dx,al
                jmp     word ptr [time_z]
RestoreCross    endp

                end     EntryTable
