
                include forthasm.inc

hivideo:        db      11,'SETHIGHMODE',0
                dw      0
                push    bp
                push    si
                mov     ax,12h
                int     10h
                pop     si
                pop     bp
                next

; ( x y Color --> )
sethipixel:     db      8,'PUTPIXEL',0
                dj      hivideo
                pop     word ptr [time_x]
                pop     ax
                pop     bx
                call    xPixelAddr10
                shl     ah,cl
                mov     dx,3ceh
                mov     al,8
                out     dx,ax
                mov     al,es:[bx]
                mov     byte ptr es:[bx],0
                mov     dl,0c4h
                mov     ah,byte ptr [time_x]
                mov     al,2
                out     dx,ax
                mov     byte ptr es:[bx],0ffh
                mov     ah,0fh
                out     dx,ax
                mov     dl,0ceh
                mov     ax,0ff08h
                out     dx,ax
                next
                xPixelAddr10:
                mov     cl,bl
                push    dx
                mov     dx,80                   ; Bytes per line
                mul     dx
                pop     dx
                shr     bx,1
                shr     bx,1
                shr     bx,1
                add     bx,ax
                add     bx,OriginOffset
                mov     ax,VideoBufferSeg
                mov     es,ax
                and     cl,7
                xor     cl,7
                mov     ah,1
                ret

settext:        db      11,'SETTEXTMODE',0
                dj      sethipixel
                push    bp
                push    si
                mov     ax,3
                int     10h
                pop     si
                pop     bp
                next

ARGx1           equ     word ptr [bp+10]
ARGy1           equ     word ptr [bp+8]
ARGx2           equ     word ptr [bp+6]
ARGy2           equ     word ptr [bp+4]
ARGn            equ     byte ptr [bp+2]
VARvertincr     equ     word ptr [bp-2]
VARincr1        equ     word ptr [bp-4]
VARincr2        equ     word ptr [bp-6]
VARroutine      equ     word ptr [bp-8]

ByteOffsetShift equ     3
RMWbits         equ     0
OriginOffset    equ     0
VideoBufferSeg  equ     0a000h

; ( X1 Y1 X2 Y2 Color --> )
drhiline:       db      4,'LINE',0
                dj      settext
                push    bp
                mov     bp,sp
                sub     sp,8
                push    si
; *****************************************************************************
                mov     dx,3ceh
                mov     ah,ARGn
                xor     al,al

                out     dx,ax
                mov     ax,0f01h
                out     dx,ax
                mov     ah,RMWbits
                mov     al,3
                out     dx,ax

                mov     si,80
                mov     cx,ARGx2
                sub     cx,ARGx1
                jnz     LL02
                jmp     VertLine10
                LL02:
                jns     L01

                neg     cx

                mov     bx,ARGx2
                xchg    bx,ARGx1
                mov     ARGx2,bx

                mov     bx,ARGy2
                xchg    bx,ARGy1
                mov     ARGy2,bx

                L01:
                mov     bx,ARGy2
                sub     bx,ARGy1
                jnz     LL01
                jmp     HorizLine10
                LL01:
                jns     L03
                neg     bx
                neg     si

                L03:
                mov     VARvertincr,si

                call    LLL01

                LoSlopeLine10:
                L10:
                mov     ah,bl

                L11:
                or      ah,bl
                ror     bl,1
                jc      L14

                or      si,si
                jns     L12
                add     si,VARincr1
                loop    L11

                out     dx,ax
                or      es:[di],al
                jmp     Lexit

                L12:
                add     si,VARincr2
                out     dx,ax
                or      es:[di],al
                add     di,VARvertincr
                loop    L10
                jmp     Lexit

                L14:
                out     dx,ax
                or      es:[di],al
                inc     di
                or      si,si
                jns     L15
                add     si,VARincr1
                loop    L10
                jmp     Lexit

                L15:
                add     si,VARincr2
                add     di,VARvertincr
                loop    L10
                jmp     Lexit

                LLL01:
                pop     VARroutine
                cmp     bx,cx
                jle     L04
                call    LLL02

                HiSlopeLine10:
                mov     bx,VARvertincr

                L21:
                out     dx,ax
                or      es:[di],al
                add     di,bx

                L22:
                or      si,si
                jns     L23
                add     si,VARincr1
                loop    L21
                jmp     Lexit

                L23:
                add     si,VARincr2
                ror     ah,1
                adc     di,0
                loop    L21
                jmp     Lexit

                LLL02:
                pop     VARroutine
                xchg    bx,cx

                L04:
                shl     bx,1
                mov     VARincr1,bx
                sub     bx,cx
                mov     si,bx
                sub     bx,cx
                mov     VARincr2,bx

                push    cx
                mov     ax,ARGy1
                mov     bx,ARGx1
                call    PixelAddr10
                mov     di,bx
                shl     ah,cl
                mov     bl,ah
                mov     al,8
                pop     cx
                inc     cx
                jmp     VARroutine

                VertLine10:
                mov     ax,ARGy1
                mov     bx,ARGy2
                mov     cx,bx
                sub     cx,ax
                jge     L31

                neg     cx
                mov     ax,bx

                L31:
                inc     cx
                mov     bx,ARGx1
                push    cx
                call    PixelAddr10
                shl     ah,cl
                mov     al,8
                out     dx,ax
                pop     cx

                L32:
                or      es:[bx],al
                add     bx,si
                loop    L32
                jmp     Lexit

                HorizLine10:
                push    ds
                mov     ax,ARGy1
                mov     bx,ARGx1
                call    PixelAddr10
                mov     di,bx
                mov     dh,ah
                not     dh
                shl     dh,cl
                not     dh
                mov     cx,ARGx2
                and     cl,7
                xor     cl,7
                mov     dl,0ffh
                shl     dl,cl

                mov     ax,ARGx2
                mov     bx,ARGx1
                mov     cl,ByteOffsetShift

                shr     ax,cl
                shr     bx,cl
                mov     cx,ax
                sub     cx,bx

                mov     bx,dx
                mov     dx,3ceh
                mov     al,8

                push    es
                pop     ds
                mov     si,di

                or      bh,bh
                js      L43
                or      cx,cx
                jnz     L42
                and     bl,bh
                jmp     short L44

                L42:
                mov     ah,bh
                out     dx,ax
                movsb
                dec     cx

                L43:
                mov     ah,11111111b
                out     dx,ax
                rep     movsb

                L44:
                mov     ah,bl
                out     dx,ax
                movsb
                pop     ds

                Lexit:
                xor     ax,ax
                out     dx,ax
                inc     ax
                out     dx,ax
                mov     al,3
                out     dx,ax
                mov     ax,0ff08h
                out     dx,ax
; *****************************************************************************
                push    cs
                pop     ds
                pop     si
                add     sp,8
                pop     bp
                add     sp,10
                next

                PixelAddr10:
                mov     cl,bl
                push    dx
                mov     dx,80
                mul     dx
                pop     dx
                shr     bx,1
                shr     bx,1
                shr     bx,1
                add     bx,ax
                add     bx,OriginOffset
                mov     ax,VideoBufferSeg
                mov     es,ax
                and     cl,7
                xor     cl,7
                mov     ah,1
                ret

; ( ScrX ScrY BytesPerLine CharOff CharSeg CharXSize CharYSize CharColor --> )
drhichar:       db      8,'DRAWCHAR',0
                dj      drhiline
                mov     ax,0a000h
                mov     es,ax
                mov     word ptr [err_si],si
                pop     word ptr [time_y]
                mov     ax,205h
                mov     dx,3ceh
                out     dx,ax
                pop     cx
                pop     word ptr [time_x]
                pop     ds
                pop     si
                pop     word ptr cs:[time_z]    ; Bytes per line
                pop     ax
                mul     word ptr cs:[time_z]
                pop     dx
                add     dx,ax
                mov     di,dx
                mov     ax,word ptr cs:[time_x]
                sub     word ptr cs:[time_z],ax
                mov     dx,3ceh
                mov     al,8
                out     dx,al
                inc     dx
                mov     bl,byte ptr cs:[time_y]
                lchr1:
                push    cx
                mov     cx,word ptr cs:[time_x]
                lchr2:
                lodsb
                out     dx,al
                mov     al,byte ptr es:[di]
                mov     al,bl
                stosb
                loop    lchr2
                add     di,word ptr cs:[time_z]
                pop     cx
                loop    lchr1

                mov     ax,5
                mov     dx,3ceh
                out     dx,ax
                push    cs
                pop     ds
                mov     si,word ptr [err_si]
                next

; ( x y --> Color )
readpix:        db      8,'GETPIXEL',0
                dj      drhichar
                pop     ax
                pop     bx
                call    yPixelAddr10
                mov     ch,ah
                shl     ch,cl
                mov     di,bx
                xor     bl,bl
                mov     dx,3ceh
                mov     ax,304h
                lrp01:
                out     dx,ax
                mov     bh,es:[di]
                and     bh,ch
                neg     bh
                rol     bx,1
                dec     ah
                jge     lrp01
                mov     al,bl
                xor     ah,ah
                push    ax
                next
                yPixelAddr10:
                mov     cl,bl
                push    dx
                mov     dx,80                   ; Bytes per line
                mul     dx
                pop     dx
                shr     bx,1
                shr     bx,1
                shr     bx,1
                add     bx,ax
                add     bx,OriginOffset
                mov     ax,VideoBufferSeg
                mov     es,ax
                and     cl,7
                xor     cl,7
                mov     ah,1
                ret

; ( SourceSpriteOffset SourceSpriteSegment SourceX SourceY
;   DestSpriteOffset DestSpriteSegment DestX DestY
;   SourceSizeX DestSizeX BlockSizeX BlockSizeY --> )
copy256_:       db      9,'COPYIMAGE',0
                dj      readpix
                _copy256:
                mov     dx,3ceh
                mov     ax,105h
                out     dx,ax
                pop     word ptr [time_y]
                pop     ax
                mov     word ptr [time_x],ax
                pop     bx
                pop     cx
                mov     word ptr [time_t],bx
                mov     word ptr [time_z],cx
                sub     word ptr [time_t],ax
                sub     word ptr [time_z],ax
                pop     ax
                mul     bx
                pop     di
                add     di,ax
                pop     es
                pop     ax
                add     di,ax
                pop     ax
                mul     cx
                pop     dx
                add     dx,ax
                pop     ds
                pop     ax
                push    si
                push    bp
                add     ax,dx
                mov     si,ax
                mov     dx,word ptr cs:[time_t]
                mov     bx,word ptr cs:[time_z]
                mov     bp,word ptr cs:[time_x]
                copy1:
                mov     cx,bp
                rep     movsb
                add     si,bx
                add     di,dx
                dec     word ptr cs:[time_y]
                jnz     copy1
                pop     bp
                pop     si
                push    cs
                pop     ds
                mov     dx,3ceh
                mov     ax,100h
                out     dx,ax
                next

; ( SourceSpriteOffset SourceSpriteSegment SourceX SourceY
;   DestSpriteOffset DestSpriteSegment DestX DestY
;   SourceSizeX DestSizeX BlockSizeX BlockSizeY --> )
copy256h_:      db      10,'>COPYIMAGE',0
                dj      copy256_
                _copy256h:
                mov     dx,3ceh
                mov     ax,105h
                out     dx,ax
                pop     word ptr [time_y]
                pop     ax
                mov     word ptr [time_x],ax
                pop     bx
                pop     cx
                mov     word ptr [time_t],bx
                mov     word ptr [time_z],cx
                sub     word ptr [time_t],ax
                sub     word ptr [time_z],ax
                pop     ax
                add     ax,word ptr [time_y]
                mul     bx
                pop     di
                add     di,ax
                pop     es
                pop     ax
                add     di,ax
                pop     ax
                add     ax,word ptr [time_y]
                mul     cx
                pop     dx
                add     dx,ax
                pop     ds
                pop     ax
                push    si
                push    bp
                add     ax,dx
                mov     si,ax
                mov     dx,word ptr cs:[time_t]
                mov     bx,word ptr cs:[time_z]
                mov     bp,word ptr cs:[time_x]
                dec     si
                dec     di
                std
                copy12:
                mov     cx,bp
                sub     si,bx
                sub     di,dx
                rep     movsb
                dec     word ptr cs:[time_y]
                jnz     copy12
                pop     bp
                pop     si
                push    cs
                pop     ds
                mov     dx,3ceh
                mov     ax,100h
                out     dx,ax
                next

sound_:         db      5,'SOUND',0
                dj      copy256h_
                _sound:
                pop     bx
                cmp     bx,21
                jnc     sound_ok
                mov     bx,21
                sound_ok:
                mov     al,0b6h
                out     43h,al
                mov     dx,14h
                mov     ax,4f38h
                div     bx
                out     42h,al
                mov     al,ah
                out     42h,al
                in      al,61h
                or      al,3
                out     61h,al
                next

nosound_:       db      7,'NOSOUND',0
                dj      sound_
                _nosound:
                in      al,61h
                and     al,0fch
                out     61h,al
                next

ellipse_:       db      7,'ELLIPSE',0
                dj      nosound_
;
; Name:         Ellipse10
;
; Function:     Draw an ellipse in native EGA/VGA graphics modes.
;
; Caller:       Microsoft C:
;
;                       void Ellipse10(xc,yc,a,b,n);
;
;                       int xc,yc;              /* center of ellipse */
;
;                       int a,b;                /* major and minor axes */
;
;                       int n;                  /* pixel value */
;

eARGxc          EQU     word ptr [bp+10] ; stack frame addressing
eARGyc          EQU     word ptr [bp+8]
eARGa           EQU     word ptr [bp+6]
eARGb           EQU     word ptr [bp+4]
eARGn           EQU     byte ptr [bp+2]

eULAddr         EQU     word ptr [bp-2]
eURAddr         EQU     word ptr [bp-4]
eLLAddr         EQU     word ptr [bp-6]
eLRAddr         EQU     word ptr [bp-8]
eLMask          EQU     byte ptr [bp-10]
eRMask          EQU     byte ptr [bp-12]

eVARd           EQU     word ptr [bp-16]
eVARdx          EQU     word ptr [bp-20]
eVARdy          EQU     word ptr [bp-24]
eAsquared       EQU     word ptr [bp-28]
eBsquared       EQU     word ptr [bp-32]
eTwoAsquared    EQU     word ptr [bp-36]
eTwoBsquared    EQU     word ptr [bp-40]

eRMWbits_ell    EQU     0               ; read-modify-write bits
eBytesPerLine   EQU     80




                push    bp              ; preserve caller registers
                mov     bp,sp
                sub     sp,40           ; establish stack frame
                push    si
                push    di

; set Graphics Controller Mode register

                mov     dx,3CEh         ; DX := Graphics Controller I/O port
                mov     ax,0005h        ; AL := Mode register number
                                        ; AH := Write Mode 0 (bits 0,1)
                out     dx,ax           ;       Read Mode 0 (bit 4)

; set Data Rotate/Function Select register

                mov     ah,eRMWbits_ell  ; AH := Read-Modify-Write bits
                mov     al,3            ; AL := Data Rotate/Function Select reg
                out     dx,ax

; set Set/Reset and Enable Set/Reset registers

                mov     ah,eARGn         ; AH := pixel value
                mov     al,0            ; AL := Set/Reset reg number
                out     dx,ax

                mov     ax,0F01h        ; AH := value for Enable Set/Reset (all
                                        ;  bit planes enabled)
                out     dx,ax           ; AL := Enable Set/Reset reg number

; initial constants

                mov     ax,eARGa
                mul     ax
                mov     eAsquared,ax
                mov     eAsquared+2,dx   ; a^2
                shl     ax,1
                rcl     dx,1
                mov     eTwoAsquared,ax
                mov     eTwoAsquared+2,dx ; 2*a^2

                mov     ax,eARGb
                mul     ax
                mov     eBsquared,ax
                mov     eBsquared+2,dx   ; b^2
                shl     ax,1
                rcl     dx,1
                mov     eTwoBsquared,ax
                mov     eTwoBsquared+2,dx ; 2*b^2
;
; plot pixels from (0,b) until dy/dx = -1
;

; initial buffer address and bit mask

                mov     ax,eBytesPerLine ; AX := video buffer line length
                mul     eARGb            ; AX := relative byte offset of b
                mov     si,ax
                mov     di,ax

                mov     ax,eARGyc        ; AX := yc
                mov     bx,eARGxc        ; BX := xc
                call    ePixelAddr10     ; AH := bit mask
                                        ; ES:BX -> buffer
                                        ; CL := # bits to shift left
                mov     ah,1
                shl     ah,cl           ; AH := bit mask for first pixel
                mov     eLMask,ah
                mov     eRMask,ah

                add     si,bx           ; SI := offset of (0,b)
                mov     eULAddr,si
                mov     eURAddr,si
                sub     bx,di           ; AX := offset of (0,-b)
                mov     eLLAddr,bx
                mov     eLRAddr,bx

; initial decision variables

                xor     ax,ax
                mov     eVARdx,ax
                mov     eVARdx+2,ax      ; dx = 0

                mov     ax,eTwoAsquared
                mov     dx,eTwoAsquared+2
                mov     cx,eARGb
                call    eLongMultiply    ; perform 32-bit by 16-bit mulitply
                mov     eVARdy,ax
                mov     eVARdy+2,dx      ; dy = TwoAsquared * b

                mov     ax,eAsquared
                mov     dx,eAsquared+2   ; DX:AX = Asquared
                sar     dx,1
                rcr     ax,1
                sar     dx,1
                rcr     ax,1            ; DX:AX = Asquared/4

                add     ax,eBsquared
                adc     dx,eBsquared+2   ; DX:AX = Bsquared + Asquared/4
                mov     eVARd,ax
                mov     eVARd+2,dx

                mov     ax,eAsquared
                mov     dx,eAsquared+2
                mov     cx,eARGb
                call    eLongMultiply    ; DX:AX = Asquared*b
                sub     eVARd,ax
                sbb     eVARd+2,dx       ; d = Bsquared - Asquared*b + Asquared/4

; loop until dy/dx >= -1

                mov     bx,eARGb         ; BX := initial y-coordinate

                xor     cx,cx           ; CH := 0 (initial y-increment)
                                        ; CL := 0 (initial x-increment)
e_L10:          mov     ax,eVARdx
                mov     dx,eVARdx+2
                sub     ax,eVARdy
                sbb     dx,eVARdy+2
                jns     e_L20            ; jump if dx>=dy

                call    eSet4Pixels

                mov     cx,1            ; CH := 0 (y-increment)
                                        ; CL := 1 (x-increment)
                cmp     eVARd+2,0
                js      e_L11            ; jump if d < 0

                mov     ch,1            ; increment in y direction
                dec     bx              ; decrement current y-coordinate

                mov     ax,eVARdy
                mov     dx,eVARdy+2
                sub     ax,eTwoAsquared
                sbb     dx,eTwoAsquared+2 ; DX:AX := dy - TwoAsquared
                mov     eVARdy,ax
                mov     eVARdy+2,dx      ; dy -= TwoAsquared

                sub     eVARd,ax
                sbb     eVARd+2,dx       ; d -= dy

e_L11:          mov     ax,eVARdx
                mov     dx,eVARdx+2
                add     ax,eTwoBsquared
                adc     dx,eTwoBsquared+2 ; DX:AX := dx + TwoBsquared
                mov     eVARdx,ax
                mov     eVARdx+2,dx      ; dx += TwoBsquared

                add     ax,eBsquared
                adc     dx,eBsquared+2   ; DX:AX := dx + Bsquared
                add     eVARd,ax
                adc     eVARd+2,dx       ; d += dx + Bsquared

                jmp     e_L10
;
; plot pixels from current (x,y) until y < 0
;

; initial buffer address and bit mask

e_L20:          push    bx              ; preserve current y-coordinate
                push    cx              ; preserve x- and y-increments

                mov     ax,eAsquared
                mov     dx,eAsquared+2
                sub     ax,eBsquared
                sbb     dx,eBsquared+2   ; DX:AX := Asquared-Bsquared

                mov     bx,ax
                mov     cx,dx           ; CX:BX := (Asquared-Bsquared)

                sar     dx,1
                rcr     ax,1            ; DX:AX := (Asquared-Bsquared)/2
                add     ax,bx
                adc     dx,cx           ; DX:AX := 3*(Asquared-Bsquared)/2

                sub     ax,eVARdx
                sbb     dx,eVARdx+2
                sub     ax,eVARdy
                sbb     dx,eVARdy+2      ; DX:AX := 3*(Asquared-Bsquared)/2 - (dx+dy)

                sar     dx,1
                rcr     ax,1            ; DX:AX :=
                                        ;  ( 3*(Asquared-Bsquared)/2 - (dx+dy) )/2
                add     eVARd,ax
                adc     eVARd+2,dx       ; update d

; loop until y < 0

                pop     cx              ; CH,CL := y- and x-increments
                pop     bx              ; BX := y

e_L21:          call    eSet4Pixels

                mov     cx,100h         ; CH := 1 (y-increment)
                                        ; CL := 0 (x-increment)

                cmp     eVARd+2,0
                jns     e_L22            ; jump if d >= 0

                mov     cl,1            ; increment in x direction

                mov     ax,eVARdx
                mov     dx,eVARdx+2
                add     ax,eTwoBsquared
                adc     dx,eTwoBsquared+2 ; DX:AX := dx + TwoBsquared
                mov     eVARdx,ax
                mov     eVARdx+2,dx      ; dx += TwoBsquared

                add     eVARd,ax
                adc     eVARd+2,dx       ; d += dx

e_L22:          mov     ax,eVARdy
                mov     dx,eVARdy+2
                sub     ax,eTwoAsquared
                sbb     dx,eTwoAsquared+2 ; DX:AX := dy - TwoAsquared
                mov     eVARdy,ax
                mov     eVARdy+2,dx      ; dy -= TwoAsquared

                sub     ax,eAsquared
                sbb     dx,eAsquared+2   ; DX:AX := dy - Asquared
                sub     eVARd,ax
                sbb     eVARd+2,dx       ; d += Asquared - dy

                dec     bx              ; decrement y
                jns     e_L21            ; loop if y >= 0


; restore default Graphics Controller registers

e_Lexit:        mov     ax,0FF08h       ; default Bit Mask
                mov     dx,3CEh
                out     dx,ax

                mov     ax,0003         ; default Function Select
                out     dx,ax

                mov     ax,0001         ; default Enable Set/Reset
                out     dx,ax

                pop     di              ; restore registers and return
                pop     si
                mov     sp,bp
                pop     bp
                add     sp,10
                next

eSet4Pixels:    ; Call with:  CH := y-increment (0, -1)
                ;             CL := x-increment (0, 1)

                push    ax              ; preserve these regs
                push    bx
                push    dx

                mov     dx,3CEh         ; DX := Graphics Controller port

                xor     bx,bx           ; BX := 0
                test    ch,ch
                jz      eL30             ; jump if y-increment = 0

                mov     bx,eBytesPerLine ; BX := positive increment
                neg     bx              ; BX := negative increment

eL30:            mov     al,8            ; AL := Bit Mask reg number

; pixels at (xc-x,yc+y) and (xc-x,yc-y)

                xor     si,si           ; SI := 0
                mov     ah,eLMask

                rol     ah,cl           ; AH := bit mask rotated horizontally
                rcl     si,1            ; SI := 1 if bit mask rotated around
                neg     si              ; SI := 0 or -1

                mov     di,si           ; SI,DI := left horizontal increment

                add     si,eULAddr       ; SI := upper left addr + horiz incr
                add     si,bx           ; SI := new upper left addr
                add     di,eLLAddr
                sub     di,bx           ; DI := new lower left addr

                mov     eLMask,ah        ; update these variables
                mov     eULAddr,si
                mov     eLLAddr,di

                out     dx,ax           ; update Bit Mask register

                mov     ch,es:[si]      ; update upper left pixel
                mov     es:[si],ch
                mov     ch,es:[di]      ; update lower left pixel
                mov     es:[di],ch


; pixels at (xc+x,yc+y) and (xc+x,yc-y)

                xor     si,si           ; SI := 0
                mov     ah,eRMask

                ror     ah,cl           ; AH := bit mask rotated horizontally
                rcl     si,1            ; SI := 1 if bit mask rotated around

                mov     di,si           ; SI,DI := right horizontal increment

                add     si,eURAddr       ; SI := upper right addr + horiz incr
                add     si,bx           ; SI := new upper right addr
                add     di,eLRAddr
                sub     di,bx           ; DI := new lower right addr

                mov     eRMask,ah        ; update these variables
                mov     eURAddr,si
                mov     eLRAddr,di

                out     dx,ax           ; update Bit Mask register

                mov     ch,es:[si]      ; update upper right pixel
                mov     es:[si],ch
                mov     ch,es:[di]      ; update lower right pixel
                mov     es:[di],ch

                pop     dx              ; restore these regs
                pop     bx
                pop     ax
                ret

eLongMultiply:  ; Caller:       DX = u1 (hi-order word
                ;                of 32-bit number)
                ;               AX = u2 (lo-order word)
                ;               CX = v1 (16-bit number)
                ; Returns:      DX:AX = 32-bit result)

                push    ax              ; preserve u2
                mov     ax,dx           ; AX :=
                mul     cx              ; AX := high-order word of result
                xchg    ax,cx           ; AX := v1, CX := high-order word
                pop     dx              ; DX := u2
                mul     dx              ; AX := low-order word of result
                                        ; DX := carry
                add     dx,cx           ; CX := high-order word of result
                ret

ePixelAddr10:   mov     cl,bl
                push    dx
                mov     dx,eBytesPerLine
                mul     dx
                pop     dx
                shr     bx,1
                shr     bx,1
                shr     bx,1
                add     bx,ax
                mov     ax,0a000h
                mov     es,ax
                and     cl,7
                xor     cl,7
                mov     ah,1
                ret

; ( BufferOffset BufferSegment StartReg RegCount --> )
load_pals_:     db      11,'SETDACBLOCK',0
                dj      ellipse_
                mov     word ptr [err_si],si
                pop     cx
                pop     bx
                pop     ds
                pop     si
                mov     dx,3dah
                cld
lpr1:           in      al,dx
                and     al,8
                jnz     lpr1
lpr2:           in      al,dx
                and     al,8
                jz      lpr2
                mov     dl,0c8h
                mov     al,bl
                out     dx,al
                inc     dx
lpr3:           lodsb
                out     dx,al
                lodsb
                out     dx,al
                lodsb
                out     dx,al
                loop    lpr3
                push    cs
                pop     ds
                mov     si,word ptr [err_si]
                next

init:           db      1,' ',0
                dj      load_pals_
                next

                dw      100h
                dw      (offset init)-100h
                include vers.inc
                dw      1231h

                end     module
