
                .model  tiny
                .code
                org     100h

; ***************************************************************************
;                              Library header
; ***************************************************************************
EntryTable:
                db      'GPRTL'
ProcCount:      dw      16
ExecProc:       dw      ExecRTL
ListOff:        dw      ProcList
NameOff:        dw      RTLName
LibType:        db      'P'

                db      13,10
RTLName:        db      'VGA',27h,'s 256 colors Palette '
                db      'Run Time Library',0,13,10
;               db      '(C), 1993 by The Golden Porcupine Software',13,10,0

ProcList:
; ( Func# --> SupportFlag )                     --> 0
                dw      InitRTL

; ( PalOffset PalSegment --> )                  --> 1
                dw      SetAllPalette

; ( Color Red Green Blue --> )                  --> 2
                dw      SetOnePal

; ( PalOffset PalSegment StartColor Count --> ) --> 3
                dw      SetBlockPal

; ( PalOffset PalSegment --> )                  --> 4
                dw      GetAllPalette

; ( Color --> Red Green Blue )                  --> 5
                dw      GetOnePal

; ( PalOffset PalSegment StartColor Count --> ) --> 6
                dw      GetBlockPal

; ( DelayType --> )                             --> 7
                dw      SetDelayType

; ( UserDelayProcOff UserDelayProcSeg --> )     --> 8
                dw      SetUserDelay

; ( Ticks --> )                                 --> 9
                dw      Delay

; ( PalOff PalSeg ColCount r1 g1 b1 r2 g2 b2 --> ) --> 10
                dw      MakeShades

; ( SrcPalOff SrcPalSeg DestPalOff DestPalSeg StartReg RegCount StepCount --> ) --> 11
                dw      Explode

; ( StartColor --> )                            --> 12
                dw      SetBIOSpal

; ( StartColor --> )                            --> 13
                dw      SetGIS44pal

; ( StartColor --> )                            --> 14
                dw      SetEMPTYpal

; ( --> PaletteOss PaletteSeg )                 --> 15
                dw      GetPalAddr
; ***************************************************************************
DelayType       db      0               ; 0 - Timer tick
                                        ; 1 - Vertical VGA retrace
                                        ; 2 - Empty loop
                                        ; 3 - User Delay
TickProc        dd      0

BIOS_pal:       db      0,0,0
                db      0,0,42
                db      0,42,0
                db      0,42,42
                db      42,0,0
                db      42,0,42
                db      42,21,0
                db      42,42,42
                db      21,21,21
                db      21,21,63
                db      21,63,21
                db      21,63,63
                db      63,21,21
                db      63,21,63
                db      63,63,21
                db      63,63,63

GIS44_pal:      db      0,0,0
                db      11,11,11
                db      17,17,17
                db      24,24,24
                db      32,32,32
                db      40,40,40
                db      50,50,50
                db      63,63,63
                db      7,15,40
                db      40,46,63
                db      0,36,15
                db      0,50,20
                db      45,27,7
                db      0,42,42
                db      57,4,12
                db      63,63,10

Empty_pal:      db      0,0,0
                db      0,0,0
                db      0,0,0
                db      0,0,0
                db      0,0,0
                db      0,0,0
                db      0,0,0
                db      0,0,0
                db      0,0,0
                db      0,0,0
                db      0,0,0
                db      0,0,0
                db      0,0,0
                db      0,0,0
                db      0,0,0
                db      0,0,0
; ***************************************************************************

CallerIP:       dw      ?
CallerCS:       dw      ?
CallerDS:       dw      ?

ExecRTL:        pop     word ptr cs:[CallerIP]
                pop     word ptr cs:[CallerCS]
                mov     word ptr cs:[CallerDS],ds
                push    cs
                pop     ds
                pop     bx
                cmp     bx,word ptr [ProcCount]
                jnc     Restore
                add     bx,bx
                add     bx,offset ProcList
                cmp     word ptr [bx],0
                jz      Restore
                call    word ptr [bx]
Restore:        mov     ds,word ptr cs:[CallerDS]
                jmp     dword ptr cs:[CallerIP]

; ***************************************************************************

InitRTL         proc    near
                push    bp
                mov     bp,sp
                push    si
                mov     ax,word ptr [bp+4]
                or      ax,ax
                jnz     Test4F
                mov     ax,01a00h
                int     10h
                cmp     al,1ah
                jnz     InitFalse
                cmp     bl,7
                jz      InitTrue
                cmp     bl,8
                jz      InitTrue
InitFalse:      xor     ax,ax
                jmp     short EndInit
InitTrue:       mov     ax,0ffffh
EndInit:        pop     si
                pop     bp
                pop     dx
                pop     cx
                push    ax
                jmp     dx
Test4F:         cmp     ax,word ptr [ProcCount]
                jnc     InitFalse
                add     ax,ax
                add     ax,offset ProcList
                mov     bx,ax
                cmp     word ptr [bx],0
                jz      InitFalse
                jmp     short InitTrue
InitRTL         endp

time_f:         dw      0
time_x:         dw      0

SetAllPalette   proc    near
                pop     word ptr [time_f]
                pop     ds
                pop     di
                mov     dx,3dah

                push    si
                mov     si,di
                cld

WADSAP:         in      al,dx
                and     al,8
                jnz     WADSAP
WADSAP1:        in      al,dx
                and     al,8
                jz      WADSAP1

                mov     dx,3c8h
                mov     cx,256
                mov     al,0
                out     dx,al
                inc     dx

SAPL:
                lodsb
                out     dx,al
                lodsb
                out     dx,al
                lodsb
                out     dx,al
                inc     di
                loop    SAPL

                pop     si

                jmp     word ptr cs:[time_f]
SetAllPalette   endp

SetOnePal       proc    near
                pop     word ptr [time_f]
                pop     cx
                pop     ax
                mov     ch,al
                pop     ax
                mov     dh,al
                pop     bx
                mov     ax,1010h
                push    bp
                push    si
                int     10h
                pop     si
                pop     bp
                jmp     word ptr cs:[time_f]
SetOnePal       endp

SetBlockPal     proc    near
                pop     word ptr [time_f]
                pop     cx
                pop     bx
                pop     es
                pop     dx
                push    bp
                push    si
                mov     ax,1012h
                int     10h
                pop     si
                pop     bp
                jmp     word ptr cs:[time_f]
SetBlockPal     endp

GetAllPalette   proc    near
                pop     word ptr [time_f]
                pop     es
                pop     dx
                mov     ax,1017h
                xor     bx,bx
                mov     cx,256
                push    bp
                push    si
                int     10h
                pop     si
                pop     bp
                jmp     word ptr cs:[time_f]
GetAllPalette   endp

GetOnePal       proc    near
                pop     word ptr [time_f]
                pop     bx
                mov     ax,1015h
                push    bp
                push    si
                int     10h
                pop     si
                pop     bp
                xor     ah,ah
                mov     al,dh
                push    ax
                mov     al,ch
                push    ax
                mov     al,cl
                push    ax
                jmp     word ptr cs:[time_f]
GetOnePal       endp

GetBlockPal     proc    near
                pop     word ptr [time_f]
                pop     cx
                pop     bx
                pop     es
                pop     dx
                mov     ax,1017h
                push    bp
                push    si
                int     10h
                pop     si
                pop     bp
                jmp     word ptr cs:[time_f]
GetBlockPal     endp

SetDelayType    proc    near
                pop     word ptr [time_f]
                pop     ax
                and     al,3
                mov     byte ptr [DelayType],al
                jmp     word ptr cs:[time_f]
SetDelayType    endp

SetUserDelay    proc    near
                pop     word ptr [time_f]
                pop     word ptr [TickProc+2]
                pop     word ptr [TickProc]
                jmp     word ptr cs:[time_f]
SetUserDelay    endp

Delay           proc    near
                pop     word ptr [time_f]
                pop     cx
                mov     al,byte ptr [DelayType]
                and     al,3
                jnz     no_timer_delay
                xor     ax,ax
                mov     es,ax
next_timer:     mov     ax,es:[46ch]
timer_loop:     cmp     ax,es:[46ch]
                jz      timer_loop
                loop    next_timer
                jmp     EndDelay
no_timer_delay: dec     al
                jnz     no_retrace
                mov     dx,3dah
next_retrace:   in      al,dx
                and     al,8
                jnz     next_retrace
retrace_loop:   in      al,dx
                and     al,8
                jz      retrace_loop
                loop    next_retrace
                jmp     EndDelay
no_retrace:     dec     al
                jnz     no_emptyloop
no_retr:        mov     al,255
internal_delay: dec     al
                jnz     internal_delay
                loop    no_retr
                jmp     EndDelay
no_emptyloop:   push    bp
                push    si
user_delay:     push    cx
                call    dword ptr [TickProc]
                pop     cx
                loop    user_delay
                pop     si
                pop     bp
EndDelay:       jmp     word ptr cs:[time_f]
Delay           endp

r1              dw      0               ; Start/Current values of DAC registers
g1              dw      0
b1              dw      0
r2              dw      0               ; Final values of DAC registers
g2              dw      0
b2              dw      0
r3              dw      0               ; Step increnent of DAC registers
g3              dw      0
b3              dw      0
r4              dw      0               ; Steps for auxilliary increment
g4              dw      0
b4              dw      0
r5              dw      0               ; Steps count for auxilliary increment
g5              dw      0
b5              dw      0
r6              dw      0               ; Auxilliary increment
g6              dw      0
b6              dw      0
r7              dw      0               ; Max count of auxilliary increment
g7              dw      0
b7              dw      0

ffabs:          test    ah,128
                jz      endabs
                neg     ax
endabs:         ret

MakeShades      proc    near
                pop     word ptr [time_f]
                pop     word ptr [b2]
                pop     word ptr [g2]
                pop     word ptr [r2]
                pop     word ptr [b1]
                pop     word ptr [g1]
                pop     word ptr [r1]
                pop     cx
                pop     es
                pop     di
                cld
                cmp     cx,0
                jnz     $+5
                jmp     EndShades
                mov     al,byte ptr [r1]
                stosb
                mov     al,byte ptr [g1]
                stosb
                mov     al,byte ptr [b1]
                stosb
                dec     cx
                jnz     $+5
                jmp     EndShades
                cmp     cx,1
                jnz     $+5
                jmp     StopShades
                push    di
                push    cx
                mov     ax,r1
                mov     bx,r2
                call    CalcShades
                mov     r3,ax
                mov     r4,bx
                mov     r5,bx
                mov     r6,dx
                mov     r7,di
                pop     cx
                push    cx
                mov     ax,g1
                mov     bx,g2
                call    CalcShades
                mov     g3,ax
                mov     g4,bx
                mov     g5,bx
                mov     g6,dx
                mov     g7,di
                pop     cx
                push    cx
                mov     ax,b1
                mov     bx,b2
                call    CalcShades
                mov     b3,ax
                mov     b4,bx
                mov     b5,bx
                mov     b6,dx
                mov     b7,di
                pop     cx
                pop     di
                dec     cx
LoopShades:     mov     al,byte ptr [r1]
                add     al,byte ptr [r3]
                dec     byte ptr [r5]
                jnz     NoAddRed
                cmp     byte ptr [r7],0
                jz      NoAddRed
                dec     byte ptr [r7]
                add     al,byte ptr [r6]
                mov     bl,byte ptr [r4]
                mov     byte ptr [r5],bl
NoAddRed:       mov     byte ptr [r1],al
                stosb
                mov     al,byte ptr [g1]
                add     al,byte ptr [g3]
                dec     byte ptr [g5]
                jnz     NoAddGreen
                cmp     byte ptr [g7],0
                jz      NoAddGreen
                dec     byte ptr [g7]
                add     al,byte ptr [g6]
                mov     bl,byte ptr [g4]
                mov     byte ptr [g5],bl
NoAddGreen:     mov     byte ptr [g1],al
                stosb
                mov     al,byte ptr [b1]
                add     al,byte ptr [b3]
                dec     byte ptr [b5]
                jnz     NoAddBlue
                cmp     byte ptr [b7],0
                jz      NoAddBlue
                dec     byte ptr [b7]
                add     al,byte ptr [b6]
                mov     bl,byte ptr [b4]
                mov     byte ptr [b5],bl
NoAddBlue:      mov     byte ptr [b1],al
                stosb
                loop    LoopShades
StopShades:     mov     al,byte ptr [r2]
                stosb
                mov     al,byte ptr [g2]
                stosb
                mov     al,byte ptr [b2]
                stosb
EndShades:      jmp     word ptr cs:[time_f]
CalcShades:     jcxz    ZeroShades
                cmp     ax,bx
                jz      ZeroShades
                jc      AddShades
SubShades:      sub     ax,bx
                xor     dx,dx
                div     cx
                mov     bx,ax
                mov     ax,cx
                mov     cx,dx
                mov     di,dx
                xor     dx,dx
                jcxz    xZeroSteps
                div     cx
                xchg    ax,bx
                mov     dx,0ffffh
                neg     ax
                ret
AddShades:      xchg    ax,bx
                sub     ax,bx
                xor     dx,dx
                div     cx
                mov     bx,ax
                mov     ax,cx
                mov     cx,dx
                mov     di,dx
                xor     dx,dx
                jcxz    xZeroSteps
                div     cx
                xchg    ax,bx
                mov     dx,1
                ret
ZeroShades:     xor     ax,ax
                xor     bx,bx
                xor     dx,dx
                xor     di,di
                ret
xZeroSteps:     xor     dx,dx
                xor     di,di
                xchg    ax,bx
                ret
MakeShades      endp

LPR:            mov     dx,3dah
                cld
lpr1:           in      al,dx
                and     al,8
                jnz     lpr1
lpr2:           in      al,dx
                and     al,8
                jz      lpr2
                mov     dl,0c8h
                mov     al,bl
                out     dx,al
                inc     dx
lpr3:           lodsb
                out     dx,al
                lodsb
                out     dx,al
                lodsb
                out     dx,al
                loop    lpr3
                ret

LPRSTEP:        push    si
                mov     si,word ptr [STREG]
                mov     cx,word ptr [REGCN]
                mov     ax,si
                add     si,ax
                add     si,ax
                add     si,offset p1
                cld
lprst1:         lodsb
                dec     si
                add     al,byte ptr [si+(offset p3)-(offset p1)]
                cmp     byte ptr [si+(offset p7)-(offset p1)],0
                jz      no_red
                dec     byte ptr [si+(offset p5)-(offset p1)]
                jnz     no_red
                dec     byte ptr [si+(offset p7)-(offset p1)]
                add     al,byte ptr [si+(offset p6)-(offset p1)]
                mov     ah,byte ptr [si+(offset p4)-(offset p1)]
                mov     byte ptr [si+(offset p5)-(offset p1)],ah
no_red:         mov     byte ptr [si],al
                inc     si
                lodsb
                dec     si
                add     al,byte ptr [si+(offset p3)-(offset p1)]
                cmp     byte ptr [si+(offset p7)-(offset p1)],0
                jz      no_green
                dec     byte ptr [si+(offset p5)-(offset p1)]
                jnz     no_green
                dec     byte ptr [si+(offset p7)-(offset p1)]
                add     al,byte ptr [si+(offset p6)-(offset p1)]
                mov     ah,byte ptr [si+(offset p4)-(offset p1)]
                mov     byte ptr [si+(offset p5)-(offset p1)],ah
no_green:       mov     byte ptr [si],al
                inc     si
                lodsb
                dec     si
                add     al,byte ptr [si+(offset p3)-(offset p1)]
                cmp     byte ptr [si+(offset p7)-(offset p1)],0
                jz      no_blue
                dec     byte ptr [si+(offset p5)-(offset p1)]
                jnz     no_blue
                dec     byte ptr [si+(offset p7)-(offset p1)]
                add     al,byte ptr [si+(offset p6)-(offset p1)]
                mov     ah,byte ptr [si+(offset p4)-(offset p1)]
                mov     byte ptr [si+(offset p5)-(offset p1)],ah
no_blue:        mov     byte ptr [si],al
                inc     si
                loop    lprst1
                pop     si
                ret

LPRCALC:        push    si
                mov     si,offset p1
                add     si,word ptr [STREG]
                add     si,word ptr [STREG]
                add     si,word ptr [STREG]
                mov     cx,word ptr [REGCN]
lprcl1:         push    cx
                mov     al,byte ptr [si]
                xor     ah,ah
                mov     bl,byte ptr [si+(offset p2)-(offset p1)]
                xor     bh,bh
                mov     cx,word ptr [STEPCN]
                call    CalcShades
                mov     byte ptr [si+(offset p3)-(offset p1)],al
                mov     byte ptr [si+(offset p4)-(offset p1)],bl
                mov     byte ptr [si+(offset p5)-(offset p1)],bl
                mov     byte ptr [si+(offset p6)-(offset p1)],dl
                mov     ax,di
                mov     byte ptr [si+(offset p7)-(offset p1)],al

                inc     si
                mov     al,byte ptr [si]
                xor     ah,ah
                mov     bl,byte ptr [si+(offset p2)-(offset p1)]
                xor     bh,bh
                mov     cx,word ptr [STEPCN]
                call    CalcShades
                mov     byte ptr [si+(offset p3)-(offset p1)],al
                mov     byte ptr [si+(offset p4)-(offset p1)],bl
                mov     byte ptr [si+(offset p5)-(offset p1)],bl
                mov     byte ptr [si+(offset p6)-(offset p1)],dl
                mov     ax,di
                mov     byte ptr [si+(offset p7)-(offset p1)],al

                inc     si
                mov     al,byte ptr [si]
                xor     ah,ah
                mov     bl,byte ptr [si+(offset p2)-(offset p1)]
                xor     bh,bh
                mov     cx,word ptr [STEPCN]
                call    CalcShades
                mov     byte ptr [si+(offset p3)-(offset p1)],al
                mov     byte ptr [si+(offset p4)-(offset p1)],bl
                mov     byte ptr [si+(offset p5)-(offset p1)],bl
                mov     byte ptr [si+(offset p6)-(offset p1)],dl
                mov     ax,di
                mov     byte ptr [si+(offset p7)-(offset p1)],al

                inc     si
                pop     cx
                loop    lprcl1
                pop     si
                ret

Explode         proc    near
                pop     word ptr [time_f]
                pop     word ptr [STEPCN]
                pop     word ptr [REGCN]
                pop     word ptr [STREG]
                dec     word ptr cs:[STEPCN]
                mov     word ptr [time_x],si
                mov     ax,cs
                mov     es,ax
                pop     ds
                pop     si
                mov     di,offset p1
                add     di,word ptr cs:[STREG]
                add     di,word ptr cs:[STREG]
                add     di,word ptr cs:[STREG]
                mov     ax,word ptr cs:[REGCN]
                mov     cx,ax
                add     cx,ax
                add     cx,ax
                cld
                rep     movsb
                pop     ds
                pop     si
                mov     di,offset p2
                add     di,word ptr cs:[STREG]
                add     di,word ptr cs:[STREG]
                add     di,word ptr cs:[STREG]
                mov     ax,word ptr cs:[REGCN]
                mov     cx,ax
                add     cx,ax
                add     cx,ax
                cld
                rep     movsb
                mov     ax,cs
                mov     ds,ax
                call    LPRCALC
ExpLoop:        mov     si,offset p1
                mov     cx,word ptr [REGCN]
                mov     bx,word ptr [STREG]
                add     si,bx
                add     si,bx
                add     si,bx
                call    LPR
                call    LPRSTEP
                dec     word ptr [STEPCN]
                jnz     ExpLoop
                mov     si,offset p2
                mov     cx,word ptr [REGCN]
                mov     bx,word ptr [STREG]
                add     si,bx
                add     si,bx
                add     si,bx
                call    LPR
                mov     si,word ptr [time_x]
                jmp     word ptr [time_f]
Explode         endp

SetBIOSpal      proc    near
                pop     dx
                pop     bx
                push    dx
                push    bp
                push    si
                push    ds
                mov     ax,cs
                mov     es,ax
                mov     dx,offset BIOS_pal
                mov     cx,16
                mov     ax,1012h
                int     10h
                pop     ds
                pop     si
                pop     bp
                ret
SetBIOSpal      endp

SetGIS44pal     proc    near
                pop     dx
                pop     bx
                push    dx
                push    bp
                push    si
                push    ds
                mov     ax,cs
                mov     es,ax
                mov     dx,offset GIS44_pal
                mov     cx,16
                mov     ax,1012h
                int     10h
                pop     ds
                pop     si
                pop     bp
                ret
SetGIS44pal     endp

SetEMPTYpal     proc    near
                pop     dx
                pop     bx
                push    dx
                push    bp
                push    si
                push    ds
                mov     ax,cs
                mov     es,ax
                mov     dx,offset Empty_pal
                mov     cx,16
                mov     ax,1012h
                int     10h
                pop     ds
                pop     si
                pop     bp
                ret
SetEMPTYpal     endp

GetPalAddr      proc    near
                pop     ax
                mov     dx,offset BIOS_pal
                push    dx
                push    cs
                jmp     ax
GetPalAddr      endp

STREG:          dw      0
REGCN:          dw      256
STEPCN:         dw      2

p1:             db      768 dup (0)
p2:             db      768 dup (0)
p3:             db      768 dup (0)
p4:             db      768 dup (0)
p5:             db      768 dup (0)
p6:             db      768 dup (0)
p7:             db      768 dup (0)

                end     EntryTable
