
include fasm.inc

        .model  tiny
        .code
        org     100h

; ( OperSeg UpPnt TextSeg Length --> UpPnt )
toup_:  db      3,'>UP',0
        dw      0
        _toup:
        pop     cx
        mov     ax,cx
        pop     es
        pop     di
        pop     ds
        push    si
        xor     si,si
        jcxz    toup_1
        rep     movsb
        toup_1:
        stosb
        pop     si
        push    cs
        pop     ds
        push    di
        next

; ( OperSeg DnPnt TextSeg Length --> DnPnt )
todown_:        db      5,'>DOWN',0
        dk      toup_
        _todown:
        pop     cx
        pop     es
        pop     di
        mov     ax,cx
        pop     ds
        push    si
        mov     si,256*17-1
        add     si,cx
        std
        jcxz    todn_1
        rep     movsb
        todn_1:
        stosb
        pop     si
        push    cs
        pop     ds
        push    di
        next

; ( OperSeg UpPnt TextSeg --> UpPnt )
fromup_:        db      3,'UP>',0
        dk      todown_
        _fromup:
        pop     ds
        pop     ax
        pop     es
        push    si
        mov     si,ax
        dec     si
        std
        lodsb
        mov     dl,al
        mov     dh,0
        mov     di,255
        mov     cx,256
        sub     cx,dx
        mov     al,' '
        rep     stosb
        mov     cx,dx
        jcxz    frup_1
        rep     movsb
        frup_1:
        inc     si
        pop     ax
        push    si
        mov     si,ax
        push    cs
        pop     ds
        next

; ( OperSeg DnPnt TextSeg --> DnPnt )
fromdown_:      db      5,'DOWN>',0
        dk      fromup_
        _fromdown:
        pop     ds
        pop     ax
        pop     es
        push    si
        mov     si,ax
        mov     di,4352
        inc     si
        lodsb
        mov     cl,al
        mov     ch,0
        mov     dx,cx
        jcxz    frdn_1
        rep     movsb
        frdn_1:
        mov     cx,256
        sub     cx,dx
        mov     al,' '
        rep     stosb
        dec     si
        pop     ax
        push    si
        mov     si,ax
        push    cs
        pop     ds
        next

; ( Line# OperSeg --> )
operup_:        db      6,'OPERUP',0
        dk      fromdown_
        _operup:
        pop     es
        push    es
        pop     ds
        pop     di
        mov     ax,di
        mov     ah,al
        mov     al,0
        mov     di,ax
        inc     ah
        push    si
        mov     si,ax
        mov     cx,4352
        sub     cx,di
        jcxz    no_operup
        rep     movsb
        no_operup:
        pop     si
        push    cs
        pop     ds
        next

; ( Line# OperSeg --> )
operdown_:      db      8,'OPERDOWN',0
        dk      operup_
        _operdown:
        pop     es
        push    es
        pop     ds
        pop     ax
        mov     di,256*18-1
        mov     ah,al
        mov     al,0
        mov     cx,17*256
        sub     cx,ax
        push    si
        mov     si,di
        sub     si,256
        std
        jcxz    no_operdown
        rep     movsb
        no_operdown:
        mov     cx,256
        mov     al,' '
        rep     stosb
        pop     si
        push    cs
        pop     ds
        next

; ( LineOffset OperSeg --> Length )
strlen_:        db      4,'?LEN',0
        dk      operdown_
        _strlen:
        pop     es
        pop     di
        mov     bx,di
        add     di,255
        mov     cx,256
        mov     al,' '
        std
        repe    scasb
        inc     di
        sub     di,bx
        inc     di
        cmp     di,1
        jnz     no_one_char
        cmp     byte ptr es:[bx],' '
        jnz     no_one_char
        dec     di
        no_one_char:
        push    di
        next

; ( LineOff OperSeg Char# --> )
inschar_:       db      7,'INSCHAR',0
        dk      strlen_
        _inschar:
        pop     dx
        mov     cx,255
        pop     es
        pop     di
        push    es
        pop     ds
        push    si
        add     di,cx
        mov     si,di
        dec     si
        sub     cx,dx
        jcxz    no_ins
        std
        rep     movsb
        no_ins:
        push    cs
        pop     ds
        pop     si
        next

; ( TextSeg Length --> DnPnt StrDown )
format_:        db      6,'FORMAT',0
        dk      inschar_
        _format:
        std
        pop     cx
        pop     es
        push    es
        pop     ds
        push    si
        mov     si,cx
        mov     di,0ffffh
        xor     dx,dx
        jcxz    exit_form
        dec     si
        form_0:
        xor     bx,bx
        form_1:
        lodsb
        cmp     al,10
        jnz     no_lf_form
        loop    form_1
        jmp     short exit_form
        no_lf_form:
        cmp     al,9
        jnz     no_tab_form
        mov     al,' '
        no_tab_form:
        cmp     al,13
        jnz     no_end_str
        form_a:
        cmp     bx,256
        jnc     line_too_long
        mov     al,bl
        form_2:
        stosb
        inc     dx
        loop    form_0
        exit_form:
        pop     si
        push    cs
        pop     ds
        push    di
        push    dx
        next
        no_end_str:
        cmp     al,' '
        jnc     no_control_form
        add     al,64
        stosb
        inc     bx
        mov     al,'^'
        no_control_form:
        stosb
        inc     bx
        loop    form_1
        inc     cx
        jmp     form_a
        line_too_long:
        push    si
        mov     si,di
        add     si,255
        sub     di,bx
        push    cx
        mov     cx,255
        rep     movsb
        pop     cx
        pop     si
        mov     al,255
        jmp     form_2

; ( TextSeg DnPnt --> Length )
unformat_:      db      8,'UNFORMAT',0
        dk      format_
        _unformat:
        pop     ax
        pop     es
        push    es
        pop     ds
        push    si
        mov     si,ax
        inc     si
        xor     di,di
        unform_1:
        lodsb
        mov     cl,al
        mov     ch,0
        jcxz    unform_2
        rep     movsb
        unform_2:
        mov     ax,0a0dh
        stosw
        cmp     si,0ffffh
        jz      end_unform
        cmp     si,0
        jnz     unform_1
        end_unform:
        pop     si
        push    di
        push    cs
        pop     ds
        next

init_:  db      1,' ',0
        dk      unformat_
        _init:
        next

                dw              100h
                dw              init_-100h
                include         vers.inc
                dw              1231h

        end     toup_
