
                include forthasm.inc

; ( --> TableOff TableSeg True )
; ( --> False )
maketable_:     db      9,'LSTATINIT',0
                dw      0
                _maketable:
                mov     ah,48h
                mov     bx,16384
                push    si
                push    bp
                int     21h
                pop     bp
                pop     si
                jnc     mk0
                xor     ax,ax
                push    ax
                next
                mk0:
                xor     cx,cx
                push    cx
                push    ax
                dec     cx
                push    cx
                mov     es,ax
                mov     dl,4
                mk1:
                mov     cx,32768
                xor     ax,ax
                xor     di,di
                rep     stosw
                mov     ax,es
                add     ax,4096
                mov     es,ax
                dec     dl
                jnz     mk1
                next

; ( TableOff TableSeg  BufferOff BufferSeg BufferSize LastChar --> LastChar )
analyze_:       db      12,'LSTATANALYZE',0
                dj      maketable_
                _analyze:
                pop     dx
                pop     cx
                pop     ds
                pop     ax
                pop     es
                pop     di
                push    si
                push    bp
                mov     si,ax
                mov     bp,es

                an0:
                lodsb
                mov     bl,dl
                mov     bh,0
                add     bx,bx
                add     bx,bx
                add     bx,bx
                add     bx,bx
                add     bx,bx
                add     bx,bx
                add     bx,bp

                push    es
                push    di
                mov     es,bx
                mov     bl,al
                mov     bh,0
                add     bx,bx
                add     bx,bx
                add     di,bx

                add     word ptr es:[di],1
                adc     word ptr es:[di+2],0

                pop     di
                pop     es

                mov     dl,al
                loop    an0

                pop     bp
                pop     si
                mov     dh,0
                push    dx
                push    cs
                pop     ds
                next

; ( TableOff TableSeg TempBufAddr --> TransOff TransSeg )
maketrans_:     db      14,'LSTATMAKETRANS',0
                dj      analyze_
                _maketrans:
                pop     di
                pop     ds
                pop     ax                    ; si - ᬥ饭  ⠡ ஢
                push    ax
                push    ds                    ; es - ᥣ TransTable
                push    si
                push    bp
                mov     si,ax                 ; ds - ᥣ ⥪饣 ᨬ
                push    ds
                pop     es                    ; dh - ᨬ
                mov     dh,0
                tr0:                          ; di - ६ 
                mov     cx,512
                push    si                    ; bp - 㪠⥫  TransTable
                push    es
                push    cs
                pop     es
                push    di
                rep     movsw
                pop     di
                pop     es
                push    ds

                push    cs
                pop     ds
                mov     dl,0
                tr1:

                mov     bx,di
                mov     si,di
                mov     cx,256
                tr3a:

                mov     ax,word ptr [si+2]
                cmp     ax,word ptr [bx+2]
                jna     skiptr
                mov     bx,si
                jmp     short tr2
                skiptr:
                jnz     tr2
                mov     ax,word ptr [si]
                cmp     ax,word ptr [bx]
                jna     tr2
                mov     bx,si
                tr2:
                add     si,4
                loop    tr3a

                mov     word ptr [bx],0
                mov     word ptr [bx+2],0

                sub     bx,di
                shr     bx,1
                shr     bx,1
                xchg    bx,dx
                mov     byte ptr es:[bx],dl
                xchg    bx,dx

                inc     dl
                cmp     dl,0
                jnz     tr1

                pop     ds
                pop     si
                mov     ax,ds
                add     ax,64
                mov     ds,ax
                inc     dh
                cmp     dh,0
                jnz     tr0

                push    cs
                pop     ds
                mov     ah,4ah
                mov     bx,4096
                int     21h
                pop     bp
                pop     si
                next

; ( TransSeg  BufferOff BufferSeg BufferSize LastChar --> LastChar )
precomp_:       db      12,'LSTATPRECOMP',0
                dj      maketrans_
                _precomp:
                pop     dx
                pop     cx
                pop     ds
                pop     ax
                pop     es
                push    si
                push    bp
                mov     si,ax
                mov     bp,es
                mov     bh,dl

                pc0:
                lodsb
                mov     bl,al
                mov     al,byte ptr es:[bx]
                mov     byte ptr [si-1],al

                mov     bh,bl
                loop    pc0

                pop     bp
                pop     si
                mov     dh,0
                mov     dl,bh
                push    dx
                push    cs
                pop     ds
                next


; ( TransSeg  BufferOff BufferSeg BufferSize LastChar --> LastChar )
uncomp_:        db      11,'LSTATUNCOMP',0
                dj      precomp_
                _uncomp:
                pop     dx
                pop     cx
                pop     ds
                pop     ax
                pop     es
                push    si
                push    bp
                mov     si,ax
                mov     bp,es
                mov     bh,dl
                mov     bl,byte ptr [si]
                jmp     short un1

                un0:
                mov     bx,word ptr [si-1]
                xchg    bh,bl
                un1:
                mov     al,byte ptr es:[bx]
                mov     byte ptr [si],al
                inc     si

                loop    un0

                mov     dl,byte ptr [si-1]
                pop     bp
                pop     si
                mov     dh,0
                push    dx
                push    cs
                pop     ds
                next

; ( TableSeg BufferOff BufferSeg BufferSize --> )
huffanalyze_:   db      11,'HUFFANALYZE',0
                dj      uncomp_
                _huffanalyze:
                pop     cx
                pop     ds
                pop     ax
                pop     es
                push    si
                push    bp
                mov     si,ax

                hfan0:
                lodsb
                mov     bl,al
                mov     bh,0
                add     bx,bx
                add     bx,bx
                add     word ptr es:[bx],1
                adc     word ptr es:[bx+2],0

                loop    hfan0

                pop     bp
                pop     si
                push    cs
                pop     ds
                next

; ( BitFlag Offset --> )
left32_:        db      11,'32SHIFTLEFT',0
                dj      huffanalyze_
                _left32:
                pop     bx
                pop     ax
                and     ax,1
                or      ax,200h
                push    ax
                popf
                mov     cx,32
                l32:
                rcl     byte ptr [bx],1
                inc     bx
                loop    l32
                next


; ( Offset --> Bit )
right32_:       db      12,'32SHIFTRIGHT',0
                dj      left32_
                _right32:
                pop     bx
                mov     cx,32
                add     bx,31
                clc
                r32:
                rcr     byte ptr [bx],1
                dec     bx
                loop    r32
                jc      psht
                xor     ax,ax
                push    ax
                next
                psht:
                mov     ax,65535
                push    ax
                next


init_:          db      1,' ',0
                dj     right32_
                _init:
                next

                dw      100h
                dw      init_-100h
                include vers.inc
                dw      1231h

                end     module
